#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 1257
#define SYMBOL_COUNT 178
#define ALIAS_COUNT 0
#define TOKEN_COUNT 82
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym__lower_id = 1,
  anon_sym_module = 2,
  anon_sym_LBRACE = 3,
  anon_sym_RBRACE = 4,
  anon_sym_SEMI = 5,
  anon_sym_LPAREN = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  anon_sym_or = 9,
  anon_sym_from = 10,
  anon_sym_where = 11,
  anon_sym_select = 12,
  anon_sym_if = 13,
  anon_sym_then = 14,
  anon_sym_else = 15,
  anon_sym_and = 16,
  anon_sym_implies = 17,
  anon_sym_PIPE = 18,
  anon_sym_DOT = 19,
  anon_sym_LBRACK = 20,
  anon_sym_RBRACK = 21,
  anon_sym_DOT_DOT = 22,
  anon_sym_order = 23,
  anon_sym_by = 24,
  sym_qldoc = 25,
  anon_sym_COLON_COLON = 26,
  anon_sym_float = 27,
  anon_sym_int = 28,
  anon_sym_string = 29,
  sym__upper_id = 30,
  sym__at_lower_id = 31,
  sym_integer = 32,
  sym_float = 33,
  sym_string = 34,
  sym_line_comment = 35,
  sym_block_comment = 36,
  sym_any = 37,
  sym_as = 38,
  sym_asc = 39,
  sym_avg = 40,
  sym_boolean = 41,
  sym_class = 42,
  sym_newtype = 43,
  sym_count = 44,
  sym_date = 45,
  sym_desc = 46,
  sym_exists = 47,
  sym_extends = 48,
  sym_false = 49,
  sym_forall = 50,
  sym_forex = 51,
  sym_import = 52,
  sym_in = 53,
  sym_instanceof = 54,
  sym_max = 55,
  sym_min = 56,
  sym_not = 57,
  sym_none = 58,
  sym_predicate = 59,
  sym_rank = 60,
  sym_result = 61,
  sym_strictcount = 62,
  sym_strictsum = 63,
  sym_strictconcat = 64,
  sym_concat = 65,
  sym_sum = 66,
  sym_super = 67,
  sym_this = 68,
  sym_true = 69,
  sym_lt = 70,
  sym_le = 71,
  sym_eq = 72,
  sym_gt = 73,
  sym_ge = 74,
  sym_underscore = 75,
  sym_minus = 76,
  sym_ne = 77,
  sym_slash = 78,
  sym_star = 79,
  sym_mod = 80,
  sym_plus = 81,
  sym_ql = 82,
  sym_module = 83,
  sym_moduleMember = 84,
  sym_imprt = 85,
  sym_moduleAliasBody = 86,
  sym_predicateAliasBody = 87,
  sym_typeAliasBody = 88,
  sym_classlessPredicate = 89,
  sym_datatype = 90,
  sym_datatypeBranches = 91,
  sym_datatypeBranch = 92,
  sym_select = 93,
  sym_dataclass = 94,
  sym_classMember = 95,
  sym_charpred = 96,
  sym_memberPredicate = 97,
  sym_field = 98,
  sym__optbody = 99,
  sym_empty = 100,
  sym_body = 101,
  sym_higherOrderTerm = 102,
  sym_special_call = 103,
  sym_prefix_cast = 104,
  sym_unary_expr = 105,
  sym_mul_expr = 106,
  sym_add_expr = 107,
  sym_in_expr = 108,
  sym_comp_term = 109,
  sym_instance_of = 110,
  sym_negation = 111,
  sym_if_term = 112,
  sym_conjunction = 113,
  sym_disjunction = 114,
  sym_implication = 115,
  sym_quantified = 116,
  sym_specialId = 117,
  sym_quantifier = 118,
  sym__call_arg = 119,
  sym_qualifiedRhs = 120,
  sym_classless_predicate_call = 121,
  sym_qualified_expr = 122,
  sym_super_ref = 123,
  sym_full_aggregate_body = 124,
  sym_expr_aggregate_body = 125,
  sym_aggregate = 126,
  sym_range = 127,
  sym_par_expr = 128,
  sym__exprOrTerm = 129,
  sym__primary = 130,
  sym_literal = 131,
  sym_bool = 132,
  sym_variable = 133,
  sym_compop = 134,
  sym_unop = 135,
  sym_mulop = 136,
  sym_addop = 137,
  sym_closure = 138,
  sym_direction = 139,
  sym_varDecl = 140,
  sym_asExprs = 141,
  sym_asExpr = 142,
  sym_orderBys = 143,
  sym_orderBy = 144,
  sym_literalId = 145,
  sym_annotation = 146,
  sym_annotName = 147,
  sym_annotArg = 148,
  sym_moduleName = 149,
  sym_qualModuleExpr = 150,
  sym_importModuleExpr = 151,
  sym_moduleExpr = 152,
  sym_typeLiteral = 153,
  sym_simpleId = 154,
  sym_className = 155,
  sym_dbtype = 156,
  sym_returnType = 157,
  sym_typeExpr = 158,
  sym_predicateName = 159,
  sym_aritylessPredicateExpr = 160,
  sym_predicateExpr = 161,
  sym_varName = 162,
  sym_aggId = 163,
  aux_sym_ql_repeat1 = 164,
  aux_sym_moduleMember_repeat1 = 165,
  aux_sym_classlessPredicate_repeat1 = 166,
  aux_sym_datatypeBranches_repeat1 = 167,
  aux_sym_dataclass_repeat1 = 168,
  aux_sym_dataclass_repeat2 = 169,
  aux_sym_higherOrderTerm_repeat1 = 170,
  aux_sym_higherOrderTerm_repeat2 = 171,
  aux_sym_aggregate_repeat1 = 172,
  aux_sym_asExprs_repeat1 = 173,
  aux_sym_orderBys_repeat1 = 174,
  aux_sym_annotation_repeat1 = 175,
  aux_sym_qualModuleExpr_repeat1 = 176,
  aux_sym_importModuleExpr_repeat1 = 177,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__lower_id] = "_lower_id",
  [anon_sym_module] = "module",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SEMI] = ";",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_or] = "or",
  [anon_sym_from] = "from",
  [anon_sym_where] = "where",
  [anon_sym_select] = "select",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_and] = "and",
  [anon_sym_implies] = "implies",
  [anon_sym_PIPE] = "|",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_order] = "order",
  [anon_sym_by] = "by",
  [sym_qldoc] = "qldoc",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [sym__upper_id] = "_upper_id",
  [sym__at_lower_id] = "_at_lower_id",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_string] = "string",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_any] = "any",
  [sym_as] = "as",
  [sym_asc] = "asc",
  [sym_avg] = "avg",
  [sym_boolean] = "boolean",
  [sym_class] = "class",
  [sym_newtype] = "newtype",
  [sym_count] = "count",
  [sym_date] = "date",
  [sym_desc] = "desc",
  [sym_exists] = "exists",
  [sym_extends] = "extends",
  [sym_false] = "false",
  [sym_forall] = "forall",
  [sym_forex] = "forex",
  [sym_import] = "import",
  [sym_in] = "in",
  [sym_instanceof] = "instanceof",
  [sym_max] = "max",
  [sym_min] = "min",
  [sym_not] = "not",
  [sym_none] = "none",
  [sym_predicate] = "predicate",
  [sym_rank] = "rank",
  [sym_result] = "result",
  [sym_strictcount] = "strictcount",
  [sym_strictsum] = "strictsum",
  [sym_strictconcat] = "strictconcat",
  [sym_concat] = "concat",
  [sym_sum] = "sum",
  [sym_super] = "super",
  [sym_this] = "this",
  [sym_true] = "true",
  [sym_lt] = "lt",
  [sym_le] = "le",
  [sym_eq] = "eq",
  [sym_gt] = "gt",
  [sym_ge] = "ge",
  [sym_underscore] = "underscore",
  [sym_minus] = "minus",
  [sym_ne] = "ne",
  [sym_slash] = "slash",
  [sym_star] = "star",
  [sym_mod] = "mod",
  [sym_plus] = "plus",
  [sym_ql] = "ql",
  [sym_module] = "module",
  [sym_moduleMember] = "moduleMember",
  [sym_imprt] = "imprt",
  [sym_moduleAliasBody] = "moduleAliasBody",
  [sym_predicateAliasBody] = "predicateAliasBody",
  [sym_typeAliasBody] = "typeAliasBody",
  [sym_classlessPredicate] = "classlessPredicate",
  [sym_datatype] = "datatype",
  [sym_datatypeBranches] = "datatypeBranches",
  [sym_datatypeBranch] = "datatypeBranch",
  [sym_select] = "select",
  [sym_dataclass] = "dataclass",
  [sym_classMember] = "classMember",
  [sym_charpred] = "charpred",
  [sym_memberPredicate] = "memberPredicate",
  [sym_field] = "field",
  [sym__optbody] = "_optbody",
  [sym_empty] = "empty",
  [sym_body] = "body",
  [sym_higherOrderTerm] = "higherOrderTerm",
  [sym_special_call] = "special_call",
  [sym_prefix_cast] = "prefix_cast",
  [sym_unary_expr] = "unary_expr",
  [sym_mul_expr] = "mul_expr",
  [sym_add_expr] = "add_expr",
  [sym_in_expr] = "in_expr",
  [sym_comp_term] = "comp_term",
  [sym_instance_of] = "instance_of",
  [sym_negation] = "negation",
  [sym_if_term] = "if_term",
  [sym_conjunction] = "conjunction",
  [sym_disjunction] = "disjunction",
  [sym_implication] = "implication",
  [sym_quantified] = "quantified",
  [sym_specialId] = "specialId",
  [sym_quantifier] = "quantifier",
  [sym__call_arg] = "_call_arg",
  [sym_qualifiedRhs] = "qualifiedRhs",
  [sym_classless_predicate_call] = "classless_predicate_call",
  [sym_qualified_expr] = "qualified_expr",
  [sym_super_ref] = "super_ref",
  [sym_full_aggregate_body] = "full_aggregate_body",
  [sym_expr_aggregate_body] = "expr_aggregate_body",
  [sym_aggregate] = "aggregate",
  [sym_range] = "range",
  [sym_par_expr] = "par_expr",
  [sym__exprOrTerm] = "_exprOrTerm",
  [sym__primary] = "_primary",
  [sym_literal] = "literal",
  [sym_bool] = "bool",
  [sym_variable] = "variable",
  [sym_compop] = "compop",
  [sym_unop] = "unop",
  [sym_mulop] = "mulop",
  [sym_addop] = "addop",
  [sym_closure] = "closure",
  [sym_direction] = "direction",
  [sym_varDecl] = "varDecl",
  [sym_asExprs] = "asExprs",
  [sym_asExpr] = "asExpr",
  [sym_orderBys] = "orderBys",
  [sym_orderBy] = "orderBy",
  [sym_literalId] = "literalId",
  [sym_annotation] = "annotation",
  [sym_annotName] = "annotName",
  [sym_annotArg] = "annotArg",
  [sym_moduleName] = "moduleName",
  [sym_qualModuleExpr] = "qualModuleExpr",
  [sym_importModuleExpr] = "importModuleExpr",
  [sym_moduleExpr] = "moduleExpr",
  [sym_typeLiteral] = "typeLiteral",
  [sym_simpleId] = "simpleId",
  [sym_className] = "className",
  [sym_dbtype] = "dbtype",
  [sym_returnType] = "returnType",
  [sym_typeExpr] = "typeExpr",
  [sym_predicateName] = "predicateName",
  [sym_aritylessPredicateExpr] = "aritylessPredicateExpr",
  [sym_predicateExpr] = "predicateExpr",
  [sym_varName] = "varName",
  [sym_aggId] = "aggId",
  [aux_sym_ql_repeat1] = "ql_repeat1",
  [aux_sym_moduleMember_repeat1] = "moduleMember_repeat1",
  [aux_sym_classlessPredicate_repeat1] = "classlessPredicate_repeat1",
  [aux_sym_datatypeBranches_repeat1] = "datatypeBranches_repeat1",
  [aux_sym_dataclass_repeat1] = "dataclass_repeat1",
  [aux_sym_dataclass_repeat2] = "dataclass_repeat2",
  [aux_sym_higherOrderTerm_repeat1] = "higherOrderTerm_repeat1",
  [aux_sym_higherOrderTerm_repeat2] = "higherOrderTerm_repeat2",
  [aux_sym_aggregate_repeat1] = "aggregate_repeat1",
  [aux_sym_asExprs_repeat1] = "asExprs_repeat1",
  [aux_sym_orderBys_repeat1] = "orderBys_repeat1",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_qualModuleExpr_repeat1] = "qualModuleExpr_repeat1",
  [aux_sym_importModuleExpr_repeat1] = "importModuleExpr_repeat1",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__lower_id] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_order] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [sym_qldoc] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [sym__upper_id] = {
    .visible = false,
    .named = true,
  },
  [sym__at_lower_id] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_any] = {
    .visible = true,
    .named = true,
  },
  [sym_as] = {
    .visible = true,
    .named = true,
  },
  [sym_asc] = {
    .visible = true,
    .named = true,
  },
  [sym_avg] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym_count] = {
    .visible = true,
    .named = true,
  },
  [sym_date] = {
    .visible = true,
    .named = true,
  },
  [sym_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_extends] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_forex] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof] = {
    .visible = true,
    .named = true,
  },
  [sym_max] = {
    .visible = true,
    .named = true,
  },
  [sym_min] = {
    .visible = true,
    .named = true,
  },
  [sym_not] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_rank] = {
    .visible = true,
    .named = true,
  },
  [sym_result] = {
    .visible = true,
    .named = true,
  },
  [sym_strictcount] = {
    .visible = true,
    .named = true,
  },
  [sym_strictsum] = {
    .visible = true,
    .named = true,
  },
  [sym_strictconcat] = {
    .visible = true,
    .named = true,
  },
  [sym_concat] = {
    .visible = true,
    .named = true,
  },
  [sym_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_lt] = {
    .visible = true,
    .named = true,
  },
  [sym_le] = {
    .visible = true,
    .named = true,
  },
  [sym_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_gt] = {
    .visible = true,
    .named = true,
  },
  [sym_ge] = {
    .visible = true,
    .named = true,
  },
  [sym_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym_minus] = {
    .visible = true,
    .named = true,
  },
  [sym_ne] = {
    .visible = true,
    .named = true,
  },
  [sym_slash] = {
    .visible = true,
    .named = true,
  },
  [sym_star] = {
    .visible = true,
    .named = true,
  },
  [sym_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_ql] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleMember] = {
    .visible = true,
    .named = true,
  },
  [sym_imprt] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_typeAliasBody] = {
    .visible = true,
    .named = true,
  },
  [sym_classlessPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_datatype] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranches] = {
    .visible = true,
    .named = true,
  },
  [sym_datatypeBranch] = {
    .visible = true,
    .named = true,
  },
  [sym_select] = {
    .visible = true,
    .named = true,
  },
  [sym_dataclass] = {
    .visible = true,
    .named = true,
  },
  [sym_classMember] = {
    .visible = true,
    .named = true,
  },
  [sym_charpred] = {
    .visible = true,
    .named = true,
  },
  [sym_memberPredicate] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym__optbody] = {
    .visible = false,
    .named = true,
  },
  [sym_empty] = {
    .visible = true,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym_higherOrderTerm] = {
    .visible = true,
    .named = true,
  },
  [sym_special_call] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_mul_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_add_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_in_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_comp_term] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_of] = {
    .visible = true,
    .named = true,
  },
  [sym_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_if_term] = {
    .visible = true,
    .named = true,
  },
  [sym_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_implication] = {
    .visible = true,
    .named = true,
  },
  [sym_quantified] = {
    .visible = true,
    .named = true,
  },
  [sym_specialId] = {
    .visible = true,
    .named = true,
  },
  [sym_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_qualifiedRhs] = {
    .visible = true,
    .named = true,
  },
  [sym_classless_predicate_call] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_super_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_full_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_aggregate] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_par_expr] = {
    .visible = true,
    .named = true,
  },
  [sym__exprOrTerm] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_compop] = {
    .visible = true,
    .named = true,
  },
  [sym_unop] = {
    .visible = true,
    .named = true,
  },
  [sym_mulop] = {
    .visible = true,
    .named = true,
  },
  [sym_addop] = {
    .visible = true,
    .named = true,
  },
  [sym_closure] = {
    .visible = true,
    .named = true,
  },
  [sym_direction] = {
    .visible = true,
    .named = true,
  },
  [sym_varDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_asExprs] = {
    .visible = true,
    .named = true,
  },
  [sym_asExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBys] = {
    .visible = true,
    .named = true,
  },
  [sym_orderBy] = {
    .visible = true,
    .named = true,
  },
  [sym_literalId] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotName] = {
    .visible = true,
    .named = true,
  },
  [sym_annotArg] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleName] = {
    .visible = true,
    .named = true,
  },
  [sym_qualModuleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_importModuleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_moduleExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_typeLiteral] = {
    .visible = true,
    .named = true,
  },
  [sym_simpleId] = {
    .visible = true,
    .named = true,
  },
  [sym_className] = {
    .visible = true,
    .named = true,
  },
  [sym_dbtype] = {
    .visible = true,
    .named = true,
  },
  [sym_returnType] = {
    .visible = true,
    .named = true,
  },
  [sym_typeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateName] = {
    .visible = true,
    .named = true,
  },
  [sym_aritylessPredicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_predicateExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_varName] = {
    .visible = true,
    .named = true,
  },
  [sym_aggId] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_ql_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_moduleMember_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_classlessPredicate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_datatypeBranches_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dataclass_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_higherOrderTerm_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_aggregate_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asExprs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_orderBys_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_qualModuleExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_importModuleExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_args = 1,
  field_cond = 2,
  field_first = 3,
  field_left = 4,
  field_lower = 5,
  field_name = 6,
  field_right = 7,
  field_second = 8,
  field_upper = 9,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_args] = "args",
  [field_cond] = "cond",
  [field_first] = "first",
  [field_left] = "left",
  [field_lower] = "lower",
  [field_name] = "name",
  [field_right] = "right",
  [field_second] = "second",
  [field_upper] = "upper",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 2},
  [4] = {.index = 5, .length = 3},
  [5] = {.index = 8, .length = 2},
  [6] = {.index = 10, .length = 3},
  [7] = {.index = 13, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_left, 0},
    {field_right, 2},
  [3] =
    {field_args, 2},
    {field_name, 0},
  [5] =
    {field_args, 2},
    {field_args, 3},
    {field_name, 0},
  [8] =
    {field_lower, 1},
    {field_upper, 3},
  [10] =
    {field_cond, 1},
    {field_first, 3},
    {field_second, 5},
  [13] =
    {field_name, 1},
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '"') ADVANCE(1);
      if (lookahead == '%') ADVANCE(53);
      if (lookahead == '(') ADVANCE(22);
      if (lookahead == ')') ADVANCE(24);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(23);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(50);
      if (lookahead == ':') ADVANCE(12);
      if (lookahead == ';') ADVANCE(21);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(45);
      if (lookahead == '@') ADVANCE(16);
      if (lookahead == '[') ADVANCE(27);
      if (lookahead == ']') ADVANCE(28);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(25);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(32);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(1);
      END_STATE();
    case 2:
      if (lookahead == '*') ADVANCE(5);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 3:
      if (lookahead == '*') ADVANCE(10);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 4:
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 5:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(41);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 6:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead == '/') ADVANCE(40);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == '*') ADVANCE(8);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '/') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == '/') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 12:
      if (lookahead == ':') ADVANCE(31);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(49);
      END_STATE();
    case 14:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(1);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 16:
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 17:
      if (eof) ADVANCE(18);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '"') ADVANCE(1);
      if (lookahead == '%') ADVANCE(53);
      if (lookahead == '(') ADVANCE(22);
      if (lookahead == ')') ADVANCE(24);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(23);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == ':') ADVANCE(12);
      if (lookahead == ';') ADVANCE(21);
      if (lookahead == '<') ADVANCE(42);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(45);
      if (lookahead == '@') ADVANCE(16);
      if (lookahead == '[') ADVANCE(27);
      if (lookahead == ']') ADVANCE(28);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == '{') ADVANCE(19);
      if (lookahead == '|') ADVANCE(25);
      if (lookahead == '}') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(32);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_qldoc);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(sym__upper_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym__lower_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(33);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym__at_lower_id);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_block_comment);
      if (lookahead == '*') ADVANCE(6);
      if (lookahead != 0) ADVANCE(7);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_lt);
      if (lookahead == '=') ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_le);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_eq);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_gt);
      if (lookahead == '=') ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_ge);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_underscore);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_minus);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_ne);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_slash);
      if (lookahead == '*') ADVANCE(2);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_slash);
      if (lookahead == '*') ADVANCE(3);
      if (lookahead == '/') ADVANCE(39);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_star);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_mod);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_plus);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(9);
      if (lookahead == 'o') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'w') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'v') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'y') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'x') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(31);
      if (lookahead == 'm') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(41);
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 't') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 16:
      if (lookahead == 'd') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_as);
      if (lookahead == 'c') ADVANCE(51);
      END_STATE();
    case 18:
      if (lookahead == 'g') ADVANCE(52);
      END_STATE();
    case 19:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_by);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(59);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 32:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_in);
      if (lookahead == 's') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      END_STATE();
    case 34:
      if (lookahead == 'x') ADVANCE(69);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(71);
      END_STATE();
    case 37:
      if (lookahead == 'w') ADVANCE(72);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 44:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 45:
      if (lookahead == 'm') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(82);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(83);
      if (lookahead == 'i') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(85);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_any);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym_asc);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_avg);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(89);
      END_STATE();
    case 56:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(92);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 60:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(98);
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 65:
      if (lookahead == 'm') ADVANCE(100);
      END_STATE();
    case 66:
      if (lookahead == 'l') ADVANCE(101);
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 67:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_max);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_min);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_not);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(108);
      END_STATE();
    case 77:
      if (lookahead == 'k') ADVANCE(109);
      END_STATE();
    case 78:
      if (lookahead == 'u') ADVANCE(110);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_sum);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_date);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_desc);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 99:
      if (lookahead == 'x') ADVANCE(127);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 102:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(131);
      END_STATE();
    case 105:
      if (lookahead == 'y') ADVANCE(132);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_rank);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(136);
      END_STATE();
    case 112:
      if (lookahead == 'c') ADVANCE(137);
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_class);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_count);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 123:
      if (lookahead == 'd') ADVANCE(144);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_forex);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 132:
      if (lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_order);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(153);
      END_STATE();
    case 137:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 138:
      if (lookahead == 'g') ADVANCE(155);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(156);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_concat);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_exists);
      END_STATE();
    case 144:
      if (lookahead == 's') ADVANCE(157);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_forall);
      END_STATE();
    case 146:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_import);
      END_STATE();
    case 148:
      if (lookahead == 'c') ADVANCE(159);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_result);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 154:
      if (lookahead == 'c') ADVANCE(162);
      if (lookahead == 's') ADVANCE(163);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_boolean);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_extends);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_implies);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_newtype);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 162:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 163:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 164:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 165:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(170);
      if (lookahead == 'u') ADVANCE(171);
      END_STATE();
    case 167:
      if (lookahead == 'm') ADVANCE(172);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(173);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_predicate);
      END_STATE();
    case 170:
      if (lookahead == 'c') ADVANCE(174);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_strictsum);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_instanceof);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(176);
      END_STATE();
    case 175:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_strictcount);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_strictconcat);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 17},
  [3] = {.lex_state = 17},
  [4] = {.lex_state = 17},
  [5] = {.lex_state = 17},
  [6] = {.lex_state = 17},
  [7] = {.lex_state = 17},
  [8] = {.lex_state = 17},
  [9] = {.lex_state = 17},
  [10] = {.lex_state = 17},
  [11] = {.lex_state = 17},
  [12] = {.lex_state = 17},
  [13] = {.lex_state = 17},
  [14] = {.lex_state = 17},
  [15] = {.lex_state = 17},
  [16] = {.lex_state = 17},
  [17] = {.lex_state = 17},
  [18] = {.lex_state = 17},
  [19] = {.lex_state = 17},
  [20] = {.lex_state = 17},
  [21] = {.lex_state = 17},
  [22] = {.lex_state = 17},
  [23] = {.lex_state = 17},
  [24] = {.lex_state = 17},
  [25] = {.lex_state = 17},
  [26] = {.lex_state = 17},
  [27] = {.lex_state = 17},
  [28] = {.lex_state = 17},
  [29] = {.lex_state = 17},
  [30] = {.lex_state = 17},
  [31] = {.lex_state = 17},
  [32] = {.lex_state = 17},
  [33] = {.lex_state = 17},
  [34] = {.lex_state = 17},
  [35] = {.lex_state = 17},
  [36] = {.lex_state = 17},
  [37] = {.lex_state = 17},
  [38] = {.lex_state = 17},
  [39] = {.lex_state = 17},
  [40] = {.lex_state = 17},
  [41] = {.lex_state = 17},
  [42] = {.lex_state = 17},
  [43] = {.lex_state = 17},
  [44] = {.lex_state = 17},
  [45] = {.lex_state = 17},
  [46] = {.lex_state = 17},
  [47] = {.lex_state = 17},
  [48] = {.lex_state = 17},
  [49] = {.lex_state = 17},
  [50] = {.lex_state = 17},
  [51] = {.lex_state = 17},
  [52] = {.lex_state = 17},
  [53] = {.lex_state = 17},
  [54] = {.lex_state = 17},
  [55] = {.lex_state = 17},
  [56] = {.lex_state = 17},
  [57] = {.lex_state = 17},
  [58] = {.lex_state = 17},
  [59] = {.lex_state = 17},
  [60] = {.lex_state = 17},
  [61] = {.lex_state = 17},
  [62] = {.lex_state = 17},
  [63] = {.lex_state = 17},
  [64] = {.lex_state = 17},
  [65] = {.lex_state = 17},
  [66] = {.lex_state = 17},
  [67] = {.lex_state = 17},
  [68] = {.lex_state = 17},
  [69] = {.lex_state = 17},
  [70] = {.lex_state = 17},
  [71] = {.lex_state = 17},
  [72] = {.lex_state = 17},
  [73] = {.lex_state = 17},
  [74] = {.lex_state = 17},
  [75] = {.lex_state = 17},
  [76] = {.lex_state = 17},
  [77] = {.lex_state = 17},
  [78] = {.lex_state = 17},
  [79] = {.lex_state = 17},
  [80] = {.lex_state = 17},
  [81] = {.lex_state = 17},
  [82] = {.lex_state = 17},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 17},
  [86] = {.lex_state = 17},
  [87] = {.lex_state = 17},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 17},
  [90] = {.lex_state = 17},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 17},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 17},
  [99] = {.lex_state = 17},
  [100] = {.lex_state = 17},
  [101] = {.lex_state = 17},
  [102] = {.lex_state = 17},
  [103] = {.lex_state = 17},
  [104] = {.lex_state = 17},
  [105] = {.lex_state = 17},
  [106] = {.lex_state = 17},
  [107] = {.lex_state = 17},
  [108] = {.lex_state = 17},
  [109] = {.lex_state = 17},
  [110] = {.lex_state = 17},
  [111] = {.lex_state = 17},
  [112] = {.lex_state = 17},
  [113] = {.lex_state = 17},
  [114] = {.lex_state = 17},
  [115] = {.lex_state = 17},
  [116] = {.lex_state = 17},
  [117] = {.lex_state = 17},
  [118] = {.lex_state = 17},
  [119] = {.lex_state = 17},
  [120] = {.lex_state = 17},
  [121] = {.lex_state = 17},
  [122] = {.lex_state = 17},
  [123] = {.lex_state = 17},
  [124] = {.lex_state = 17},
  [125] = {.lex_state = 17},
  [126] = {.lex_state = 17},
  [127] = {.lex_state = 17},
  [128] = {.lex_state = 17},
  [129] = {.lex_state = 17},
  [130] = {.lex_state = 17},
  [131] = {.lex_state = 17},
  [132] = {.lex_state = 17},
  [133] = {.lex_state = 17},
  [134] = {.lex_state = 17},
  [135] = {.lex_state = 17},
  [136] = {.lex_state = 17},
  [137] = {.lex_state = 17},
  [138] = {.lex_state = 17},
  [139] = {.lex_state = 17},
  [140] = {.lex_state = 17},
  [141] = {.lex_state = 17},
  [142] = {.lex_state = 17},
  [143] = {.lex_state = 17},
  [144] = {.lex_state = 17},
  [145] = {.lex_state = 17},
  [146] = {.lex_state = 17},
  [147] = {.lex_state = 17},
  [148] = {.lex_state = 17},
  [149] = {.lex_state = 17},
  [150] = {.lex_state = 17},
  [151] = {.lex_state = 17},
  [152] = {.lex_state = 17},
  [153] = {.lex_state = 17},
  [154] = {.lex_state = 17},
  [155] = {.lex_state = 17},
  [156] = {.lex_state = 17},
  [157] = {.lex_state = 17},
  [158] = {.lex_state = 17},
  [159] = {.lex_state = 17},
  [160] = {.lex_state = 17},
  [161] = {.lex_state = 17},
  [162] = {.lex_state = 17},
  [163] = {.lex_state = 17},
  [164] = {.lex_state = 17},
  [165] = {.lex_state = 17},
  [166] = {.lex_state = 17},
  [167] = {.lex_state = 17},
  [168] = {.lex_state = 17},
  [169] = {.lex_state = 17},
  [170] = {.lex_state = 17},
  [171] = {.lex_state = 17},
  [172] = {.lex_state = 17},
  [173] = {.lex_state = 17},
  [174] = {.lex_state = 17},
  [175] = {.lex_state = 17},
  [176] = {.lex_state = 17},
  [177] = {.lex_state = 17},
  [178] = {.lex_state = 17},
  [179] = {.lex_state = 17},
  [180] = {.lex_state = 17},
  [181] = {.lex_state = 17},
  [182] = {.lex_state = 17},
  [183] = {.lex_state = 17},
  [184] = {.lex_state = 17},
  [185] = {.lex_state = 17},
  [186] = {.lex_state = 17},
  [187] = {.lex_state = 17},
  [188] = {.lex_state = 17},
  [189] = {.lex_state = 17},
  [190] = {.lex_state = 17},
  [191] = {.lex_state = 17},
  [192] = {.lex_state = 17},
  [193] = {.lex_state = 17},
  [194] = {.lex_state = 17},
  [195] = {.lex_state = 17},
  [196] = {.lex_state = 17},
  [197] = {.lex_state = 17},
  [198] = {.lex_state = 17},
  [199] = {.lex_state = 17},
  [200] = {.lex_state = 17},
  [201] = {.lex_state = 17},
  [202] = {.lex_state = 17},
  [203] = {.lex_state = 17},
  [204] = {.lex_state = 17},
  [205] = {.lex_state = 17},
  [206] = {.lex_state = 17},
  [207] = {.lex_state = 17},
  [208] = {.lex_state = 17},
  [209] = {.lex_state = 17},
  [210] = {.lex_state = 17},
  [211] = {.lex_state = 17},
  [212] = {.lex_state = 17},
  [213] = {.lex_state = 17},
  [214] = {.lex_state = 17},
  [215] = {.lex_state = 17},
  [216] = {.lex_state = 17},
  [217] = {.lex_state = 17},
  [218] = {.lex_state = 17},
  [219] = {.lex_state = 17},
  [220] = {.lex_state = 17},
  [221] = {.lex_state = 17},
  [222] = {.lex_state = 17},
  [223] = {.lex_state = 17},
  [224] = {.lex_state = 17},
  [225] = {.lex_state = 17},
  [226] = {.lex_state = 17},
  [227] = {.lex_state = 17},
  [228] = {.lex_state = 17},
  [229] = {.lex_state = 17},
  [230] = {.lex_state = 17},
  [231] = {.lex_state = 17},
  [232] = {.lex_state = 17},
  [233] = {.lex_state = 17},
  [234] = {.lex_state = 17},
  [235] = {.lex_state = 17},
  [236] = {.lex_state = 17},
  [237] = {.lex_state = 17},
  [238] = {.lex_state = 17},
  [239] = {.lex_state = 17},
  [240] = {.lex_state = 17},
  [241] = {.lex_state = 17},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 0},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 0},
  [271] = {.lex_state = 0},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 0},
  [275] = {.lex_state = 0},
  [276] = {.lex_state = 0},
  [277] = {.lex_state = 0},
  [278] = {.lex_state = 0},
  [279] = {.lex_state = 0},
  [280] = {.lex_state = 0},
  [281] = {.lex_state = 0},
  [282] = {.lex_state = 0},
  [283] = {.lex_state = 0},
  [284] = {.lex_state = 0},
  [285] = {.lex_state = 0},
  [286] = {.lex_state = 0},
  [287] = {.lex_state = 0},
  [288] = {.lex_state = 0},
  [289] = {.lex_state = 0},
  [290] = {.lex_state = 0},
  [291] = {.lex_state = 0},
  [292] = {.lex_state = 0},
  [293] = {.lex_state = 0},
  [294] = {.lex_state = 0},
  [295] = {.lex_state = 0},
  [296] = {.lex_state = 0},
  [297] = {.lex_state = 0},
  [298] = {.lex_state = 0},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 0},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 0},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 0},
  [313] = {.lex_state = 0},
  [314] = {.lex_state = 0},
  [315] = {.lex_state = 0},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 0},
  [320] = {.lex_state = 0},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 0},
  [323] = {.lex_state = 0},
  [324] = {.lex_state = 0},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 0},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 0},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 0},
  [336] = {.lex_state = 0},
  [337] = {.lex_state = 0},
  [338] = {.lex_state = 0},
  [339] = {.lex_state = 0},
  [340] = {.lex_state = 0},
  [341] = {.lex_state = 0},
  [342] = {.lex_state = 0},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 0},
  [345] = {.lex_state = 0},
  [346] = {.lex_state = 0},
  [347] = {.lex_state = 0},
  [348] = {.lex_state = 0},
  [349] = {.lex_state = 0},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 0},
  [352] = {.lex_state = 0},
  [353] = {.lex_state = 0},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 0},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 0},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 0},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 0},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 0},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 0},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 17},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 17},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 17},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 17},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 17},
  [458] = {.lex_state = 17},
  [459] = {.lex_state = 17},
  [460] = {.lex_state = 17},
  [461] = {.lex_state = 17},
  [462] = {.lex_state = 17},
  [463] = {.lex_state = 17},
  [464] = {.lex_state = 17},
  [465] = {.lex_state = 17},
  [466] = {.lex_state = 17},
  [467] = {.lex_state = 17},
  [468] = {.lex_state = 17},
  [469] = {.lex_state = 17},
  [470] = {.lex_state = 17},
  [471] = {.lex_state = 17},
  [472] = {.lex_state = 17},
  [473] = {.lex_state = 17},
  [474] = {.lex_state = 17},
  [475] = {.lex_state = 17},
  [476] = {.lex_state = 17},
  [477] = {.lex_state = 17},
  [478] = {.lex_state = 17},
  [479] = {.lex_state = 17},
  [480] = {.lex_state = 17},
  [481] = {.lex_state = 17},
  [482] = {.lex_state = 17},
  [483] = {.lex_state = 17},
  [484] = {.lex_state = 17},
  [485] = {.lex_state = 17},
  [486] = {.lex_state = 17},
  [487] = {.lex_state = 17},
  [488] = {.lex_state = 17},
  [489] = {.lex_state = 17},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 17},
  [492] = {.lex_state = 17},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 17},
  [495] = {.lex_state = 17},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 17},
  [500] = {.lex_state = 17},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 17},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 17},
  [506] = {.lex_state = 0},
  [507] = {.lex_state = 17},
  [508] = {.lex_state = 17},
  [509] = {.lex_state = 17},
  [510] = {.lex_state = 17},
  [511] = {.lex_state = 17},
  [512] = {.lex_state = 17},
  [513] = {.lex_state = 17},
  [514] = {.lex_state = 17},
  [515] = {.lex_state = 17},
  [516] = {.lex_state = 17},
  [517] = {.lex_state = 17},
  [518] = {.lex_state = 17},
  [519] = {.lex_state = 17},
  [520] = {.lex_state = 17},
  [521] = {.lex_state = 17},
  [522] = {.lex_state = 17},
  [523] = {.lex_state = 17},
  [524] = {.lex_state = 17},
  [525] = {.lex_state = 17},
  [526] = {.lex_state = 17},
  [527] = {.lex_state = 17},
  [528] = {.lex_state = 17},
  [529] = {.lex_state = 17},
  [530] = {.lex_state = 17},
  [531] = {.lex_state = 17},
  [532] = {.lex_state = 17},
  [533] = {.lex_state = 17},
  [534] = {.lex_state = 17},
  [535] = {.lex_state = 17},
  [536] = {.lex_state = 17},
  [537] = {.lex_state = 17},
  [538] = {.lex_state = 17},
  [539] = {.lex_state = 17},
  [540] = {.lex_state = 17},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 17},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 17},
  [545] = {.lex_state = 17},
  [546] = {.lex_state = 17},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 17},
  [551] = {.lex_state = 17},
  [552] = {.lex_state = 17},
  [553] = {.lex_state = 17},
  [554] = {.lex_state = 17},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 17},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 17},
  [563] = {.lex_state = 17},
  [564] = {.lex_state = 17},
  [565] = {.lex_state = 17},
  [566] = {.lex_state = 17},
  [567] = {.lex_state = 17},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 17},
  [570] = {.lex_state = 17},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 17},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 17},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 17},
  [580] = {.lex_state = 17},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 17},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 17},
  [588] = {.lex_state = 17},
  [589] = {.lex_state = 17},
  [590] = {.lex_state = 17},
  [591] = {.lex_state = 17},
  [592] = {.lex_state = 17},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 17},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 17},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 17},
  [599] = {.lex_state = 17},
  [600] = {.lex_state = 17},
  [601] = {.lex_state = 17},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 17},
  [604] = {.lex_state = 17},
  [605] = {.lex_state = 17},
  [606] = {.lex_state = 17},
  [607] = {.lex_state = 17},
  [608] = {.lex_state = 17},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 17},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 17},
  [613] = {.lex_state = 17},
  [614] = {.lex_state = 17},
  [615] = {.lex_state = 17},
  [616] = {.lex_state = 17},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 17},
  [619] = {.lex_state = 17},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 17},
  [622] = {.lex_state = 17},
  [623] = {.lex_state = 17},
  [624] = {.lex_state = 17},
  [625] = {.lex_state = 17},
  [626] = {.lex_state = 17},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 17},
  [629] = {.lex_state = 17},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 17},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 17},
  [636] = {.lex_state = 17},
  [637] = {.lex_state = 17},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 17},
  [640] = {.lex_state = 17},
  [641] = {.lex_state = 17},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 17},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 17},
  [647] = {.lex_state = 17},
  [648] = {.lex_state = 17},
  [649] = {.lex_state = 17},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 17},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 17},
  [656] = {.lex_state = 17},
  [657] = {.lex_state = 17},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 17},
  [660] = {.lex_state = 17},
  [661] = {.lex_state = 17},
  [662] = {.lex_state = 17},
  [663] = {.lex_state = 17},
  [664] = {.lex_state = 17},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 17},
  [667] = {.lex_state = 17},
  [668] = {.lex_state = 17},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 17},
  [671] = {.lex_state = 17},
  [672] = {.lex_state = 17},
  [673] = {.lex_state = 17},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 17},
  [676] = {.lex_state = 17},
  [677] = {.lex_state = 17},
  [678] = {.lex_state = 17},
  [679] = {.lex_state = 17},
  [680] = {.lex_state = 17},
  [681] = {.lex_state = 17},
  [682] = {.lex_state = 17},
  [683] = {.lex_state = 17},
  [684] = {.lex_state = 17},
  [685] = {.lex_state = 17},
  [686] = {.lex_state = 17},
  [687] = {.lex_state = 17},
  [688] = {.lex_state = 17},
  [689] = {.lex_state = 17},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 17},
  [692] = {.lex_state = 17},
  [693] = {.lex_state = 17},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 17},
  [696] = {.lex_state = 17},
  [697] = {.lex_state = 17},
  [698] = {.lex_state = 17},
  [699] = {.lex_state = 17},
  [700] = {.lex_state = 17},
  [701] = {.lex_state = 17},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 17},
  [704] = {.lex_state = 17},
  [705] = {.lex_state = 17},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 17},
  [708] = {.lex_state = 17},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 17},
  [711] = {.lex_state = 17},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 17},
  [714] = {.lex_state = 17},
  [715] = {.lex_state = 17},
  [716] = {.lex_state = 17},
  [717] = {.lex_state = 17},
  [718] = {.lex_state = 17},
  [719] = {.lex_state = 17},
  [720] = {.lex_state = 17},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 17},
  [723] = {.lex_state = 17},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 17},
  [729] = {.lex_state = 17},
  [730] = {.lex_state = 17},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 17},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 17},
  [737] = {.lex_state = 17},
  [738] = {.lex_state = 17},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 17},
  [741] = {.lex_state = 17},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 17},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 17},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 17},
  [829] = {.lex_state = 17},
  [830] = {.lex_state = 17},
  [831] = {.lex_state = 17},
  [832] = {.lex_state = 17},
  [833] = {.lex_state = 17},
  [834] = {.lex_state = 17},
  [835] = {.lex_state = 17},
  [836] = {.lex_state = 17},
  [837] = {.lex_state = 17},
  [838] = {.lex_state = 17},
  [839] = {.lex_state = 17},
  [840] = {.lex_state = 17},
  [841] = {.lex_state = 17},
  [842] = {.lex_state = 17},
  [843] = {.lex_state = 17},
  [844] = {.lex_state = 17},
  [845] = {.lex_state = 17},
  [846] = {.lex_state = 17},
  [847] = {.lex_state = 17},
  [848] = {.lex_state = 17},
  [849] = {.lex_state = 17},
  [850] = {.lex_state = 17},
  [851] = {.lex_state = 17},
  [852] = {.lex_state = 17},
  [853] = {.lex_state = 17},
  [854] = {.lex_state = 17},
  [855] = {.lex_state = 17},
  [856] = {.lex_state = 17},
  [857] = {.lex_state = 17},
  [858] = {.lex_state = 17},
  [859] = {.lex_state = 17},
  [860] = {.lex_state = 17},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 17},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 17},
  [871] = {.lex_state = 17},
  [872] = {.lex_state = 17},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 17},
  [875] = {.lex_state = 17},
  [876] = {.lex_state = 17},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 17},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 17},
  [881] = {.lex_state = 17},
  [882] = {.lex_state = 17},
  [883] = {.lex_state = 17},
  [884] = {.lex_state = 17},
  [885] = {.lex_state = 17},
  [886] = {.lex_state = 17},
  [887] = {.lex_state = 17},
  [888] = {.lex_state = 17},
  [889] = {.lex_state = 17},
  [890] = {.lex_state = 17},
  [891] = {.lex_state = 17},
  [892] = {.lex_state = 17},
  [893] = {.lex_state = 17},
  [894] = {.lex_state = 17},
  [895] = {.lex_state = 17},
  [896] = {.lex_state = 17},
  [897] = {.lex_state = 17},
  [898] = {.lex_state = 17},
  [899] = {.lex_state = 17},
  [900] = {.lex_state = 17},
  [901] = {.lex_state = 17},
  [902] = {.lex_state = 17},
  [903] = {.lex_state = 17},
  [904] = {.lex_state = 17},
  [905] = {.lex_state = 17},
  [906] = {.lex_state = 17},
  [907] = {.lex_state = 17},
  [908] = {.lex_state = 17},
  [909] = {.lex_state = 17},
  [910] = {.lex_state = 17},
  [911] = {.lex_state = 17},
  [912] = {.lex_state = 17},
  [913] = {.lex_state = 17},
  [914] = {.lex_state = 17},
  [915] = {.lex_state = 17},
  [916] = {.lex_state = 17},
  [917] = {.lex_state = 17},
  [918] = {.lex_state = 17},
  [919] = {.lex_state = 17},
  [920] = {.lex_state = 17},
  [921] = {.lex_state = 17},
  [922] = {.lex_state = 17},
  [923] = {.lex_state = 17},
  [924] = {.lex_state = 17},
  [925] = {.lex_state = 17},
  [926] = {.lex_state = 17},
  [927] = {.lex_state = 17},
  [928] = {.lex_state = 17},
  [929] = {.lex_state = 17},
  [930] = {.lex_state = 17},
  [931] = {.lex_state = 17},
  [932] = {.lex_state = 17},
  [933] = {.lex_state = 17},
  [934] = {.lex_state = 17},
  [935] = {.lex_state = 17},
  [936] = {.lex_state = 17},
  [937] = {.lex_state = 17},
  [938] = {.lex_state = 17},
  [939] = {.lex_state = 17},
  [940] = {.lex_state = 17},
  [941] = {.lex_state = 17},
  [942] = {.lex_state = 17},
  [943] = {.lex_state = 17},
  [944] = {.lex_state = 17},
  [945] = {.lex_state = 17},
  [946] = {.lex_state = 17},
  [947] = {.lex_state = 17},
  [948] = {.lex_state = 17},
  [949] = {.lex_state = 17},
  [950] = {.lex_state = 17},
  [951] = {.lex_state = 17},
  [952] = {.lex_state = 17},
  [953] = {.lex_state = 17},
  [954] = {.lex_state = 17},
  [955] = {.lex_state = 17},
  [956] = {.lex_state = 17},
  [957] = {.lex_state = 17},
  [958] = {.lex_state = 17},
  [959] = {.lex_state = 17},
  [960] = {.lex_state = 17},
  [961] = {.lex_state = 17},
  [962] = {.lex_state = 17},
  [963] = {.lex_state = 17},
  [964] = {.lex_state = 17},
  [965] = {.lex_state = 17},
  [966] = {.lex_state = 17},
  [967] = {.lex_state = 17},
  [968] = {.lex_state = 17},
  [969] = {.lex_state = 17},
  [970] = {.lex_state = 17},
  [971] = {.lex_state = 17},
  [972] = {.lex_state = 17},
  [973] = {.lex_state = 17},
  [974] = {.lex_state = 17},
  [975] = {.lex_state = 17},
  [976] = {.lex_state = 17},
  [977] = {.lex_state = 17},
  [978] = {.lex_state = 17},
  [979] = {.lex_state = 17},
  [980] = {.lex_state = 17},
  [981] = {.lex_state = 17},
  [982] = {.lex_state = 17},
  [983] = {.lex_state = 17},
  [984] = {.lex_state = 17},
  [985] = {.lex_state = 17},
  [986] = {.lex_state = 17},
  [987] = {.lex_state = 17},
  [988] = {.lex_state = 17},
  [989] = {.lex_state = 17},
  [990] = {.lex_state = 17},
  [991] = {.lex_state = 17},
  [992] = {.lex_state = 17},
  [993] = {.lex_state = 17},
  [994] = {.lex_state = 17},
  [995] = {.lex_state = 17},
  [996] = {.lex_state = 17},
  [997] = {.lex_state = 17},
  [998] = {.lex_state = 17},
  [999] = {.lex_state = 17},
  [1000] = {.lex_state = 17},
  [1001] = {.lex_state = 17},
  [1002] = {.lex_state = 17},
  [1003] = {.lex_state = 17},
  [1004] = {.lex_state = 17},
  [1005] = {.lex_state = 17},
  [1006] = {.lex_state = 17},
  [1007] = {.lex_state = 17},
  [1008] = {.lex_state = 17},
  [1009] = {.lex_state = 17},
  [1010] = {.lex_state = 17},
  [1011] = {.lex_state = 17},
  [1012] = {.lex_state = 17},
  [1013] = {.lex_state = 17},
  [1014] = {.lex_state = 17},
  [1015] = {.lex_state = 17},
  [1016] = {.lex_state = 17},
  [1017] = {.lex_state = 17},
  [1018] = {.lex_state = 17},
  [1019] = {.lex_state = 17},
  [1020] = {.lex_state = 17},
  [1021] = {.lex_state = 17},
  [1022] = {.lex_state = 17},
  [1023] = {.lex_state = 17},
  [1024] = {.lex_state = 17},
  [1025] = {.lex_state = 17},
  [1026] = {.lex_state = 17},
  [1027] = {.lex_state = 17},
  [1028] = {.lex_state = 17},
  [1029] = {.lex_state = 17},
  [1030] = {.lex_state = 17},
  [1031] = {.lex_state = 17},
  [1032] = {.lex_state = 17},
  [1033] = {.lex_state = 17},
  [1034] = {.lex_state = 17},
  [1035] = {.lex_state = 17},
  [1036] = {.lex_state = 17},
  [1037] = {.lex_state = 17},
  [1038] = {.lex_state = 17},
  [1039] = {.lex_state = 17},
  [1040] = {.lex_state = 17},
  [1041] = {.lex_state = 17},
  [1042] = {.lex_state = 17},
  [1043] = {.lex_state = 17},
  [1044] = {.lex_state = 17},
  [1045] = {.lex_state = 17},
  [1046] = {.lex_state = 17},
  [1047] = {.lex_state = 17},
  [1048] = {.lex_state = 17},
  [1049] = {.lex_state = 17},
  [1050] = {.lex_state = 17},
  [1051] = {.lex_state = 17},
  [1052] = {.lex_state = 17},
  [1053] = {.lex_state = 17},
  [1054] = {.lex_state = 17},
  [1055] = {.lex_state = 17},
  [1056] = {.lex_state = 17},
  [1057] = {.lex_state = 17},
  [1058] = {.lex_state = 17},
  [1059] = {.lex_state = 17},
  [1060] = {.lex_state = 17},
  [1061] = {.lex_state = 17},
  [1062] = {.lex_state = 17},
  [1063] = {.lex_state = 17},
  [1064] = {.lex_state = 17},
  [1065] = {.lex_state = 17},
  [1066] = {.lex_state = 17},
  [1067] = {.lex_state = 17},
  [1068] = {.lex_state = 17},
  [1069] = {.lex_state = 17},
  [1070] = {.lex_state = 17},
  [1071] = {.lex_state = 17},
  [1072] = {.lex_state = 17},
  [1073] = {.lex_state = 17},
  [1074] = {.lex_state = 17},
  [1075] = {.lex_state = 17},
  [1076] = {.lex_state = 17},
  [1077] = {.lex_state = 17},
  [1078] = {.lex_state = 17},
  [1079] = {.lex_state = 17},
  [1080] = {.lex_state = 17},
  [1081] = {.lex_state = 17},
  [1082] = {.lex_state = 17},
  [1083] = {.lex_state = 17},
  [1084] = {.lex_state = 17},
  [1085] = {.lex_state = 17},
  [1086] = {.lex_state = 17},
  [1087] = {.lex_state = 17},
  [1088] = {.lex_state = 17},
  [1089] = {.lex_state = 17},
  [1090] = {.lex_state = 17},
  [1091] = {.lex_state = 17},
  [1092] = {.lex_state = 17},
  [1093] = {.lex_state = 17},
  [1094] = {.lex_state = 17},
  [1095] = {.lex_state = 17},
  [1096] = {.lex_state = 17},
  [1097] = {.lex_state = 17},
  [1098] = {.lex_state = 17},
  [1099] = {.lex_state = 17},
  [1100] = {.lex_state = 17},
  [1101] = {.lex_state = 17},
  [1102] = {.lex_state = 17},
  [1103] = {.lex_state = 17},
  [1104] = {.lex_state = 17},
  [1105] = {.lex_state = 17},
  [1106] = {.lex_state = 17},
  [1107] = {.lex_state = 17},
  [1108] = {.lex_state = 17},
  [1109] = {.lex_state = 17},
  [1110] = {.lex_state = 17},
  [1111] = {.lex_state = 17},
  [1112] = {.lex_state = 17},
  [1113] = {.lex_state = 17},
  [1114] = {.lex_state = 17},
  [1115] = {.lex_state = 17},
  [1116] = {.lex_state = 17},
  [1117] = {.lex_state = 17},
  [1118] = {.lex_state = 17},
  [1119] = {.lex_state = 17},
  [1120] = {.lex_state = 17},
  [1121] = {.lex_state = 17},
  [1122] = {.lex_state = 17},
  [1123] = {.lex_state = 17},
  [1124] = {.lex_state = 17},
  [1125] = {.lex_state = 17},
  [1126] = {.lex_state = 17},
  [1127] = {.lex_state = 17},
  [1128] = {.lex_state = 17},
  [1129] = {.lex_state = 17},
  [1130] = {.lex_state = 17},
  [1131] = {.lex_state = 17},
  [1132] = {.lex_state = 17},
  [1133] = {.lex_state = 17},
  [1134] = {.lex_state = 17},
  [1135] = {.lex_state = 17},
  [1136] = {.lex_state = 17},
  [1137] = {.lex_state = 17},
  [1138] = {.lex_state = 17},
  [1139] = {.lex_state = 17},
  [1140] = {.lex_state = 17},
  [1141] = {.lex_state = 17},
  [1142] = {.lex_state = 17},
  [1143] = {.lex_state = 17},
  [1144] = {.lex_state = 17},
  [1145] = {.lex_state = 17},
  [1146] = {.lex_state = 17},
  [1147] = {.lex_state = 17},
  [1148] = {.lex_state = 11},
  [1149] = {.lex_state = 17},
  [1150] = {.lex_state = 17},
  [1151] = {.lex_state = 17},
  [1152] = {.lex_state = 17},
  [1153] = {.lex_state = 17},
  [1154] = {.lex_state = 17},
  [1155] = {.lex_state = 17},
  [1156] = {.lex_state = 17},
  [1157] = {.lex_state = 17},
  [1158] = {.lex_state = 17},
  [1159] = {.lex_state = 17},
  [1160] = {.lex_state = 17},
  [1161] = {.lex_state = 17},
  [1162] = {.lex_state = 17},
  [1163] = {.lex_state = 17},
  [1164] = {.lex_state = 17},
  [1165] = {.lex_state = 17},
  [1166] = {.lex_state = 17},
  [1167] = {.lex_state = 17},
  [1168] = {.lex_state = 17},
  [1169] = {.lex_state = 17},
  [1170] = {.lex_state = 17},
  [1171] = {.lex_state = 17},
  [1172] = {.lex_state = 17},
  [1173] = {.lex_state = 17},
  [1174] = {.lex_state = 17},
  [1175] = {.lex_state = 17},
  [1176] = {.lex_state = 17},
  [1177] = {.lex_state = 17},
  [1178] = {.lex_state = 17},
  [1179] = {.lex_state = 17},
  [1180] = {.lex_state = 17},
  [1181] = {.lex_state = 17},
  [1182] = {.lex_state = 17},
  [1183] = {.lex_state = 17},
  [1184] = {.lex_state = 17},
  [1185] = {.lex_state = 17},
  [1186] = {.lex_state = 17},
  [1187] = {.lex_state = 17},
  [1188] = {.lex_state = 17},
  [1189] = {.lex_state = 17},
  [1190] = {.lex_state = 17},
  [1191] = {.lex_state = 17},
  [1192] = {.lex_state = 17},
  [1193] = {.lex_state = 17},
  [1194] = {.lex_state = 17},
  [1195] = {.lex_state = 17},
  [1196] = {.lex_state = 17},
  [1197] = {.lex_state = 17},
  [1198] = {.lex_state = 17},
  [1199] = {.lex_state = 17},
  [1200] = {.lex_state = 17},
  [1201] = {.lex_state = 17},
  [1202] = {.lex_state = 17},
  [1203] = {.lex_state = 17},
  [1204] = {.lex_state = 17},
  [1205] = {.lex_state = 17},
  [1206] = {.lex_state = 17},
  [1207] = {.lex_state = 17},
  [1208] = {.lex_state = 17},
  [1209] = {.lex_state = 17},
  [1210] = {.lex_state = 17},
  [1211] = {.lex_state = 17},
  [1212] = {.lex_state = 17},
  [1213] = {.lex_state = 17},
  [1214] = {.lex_state = 17},
  [1215] = {.lex_state = 17},
  [1216] = {.lex_state = 17},
  [1217] = {.lex_state = 17},
  [1218] = {.lex_state = 17},
  [1219] = {.lex_state = 17},
  [1220] = {.lex_state = 17},
  [1221] = {.lex_state = 17},
  [1222] = {.lex_state = 17},
  [1223] = {.lex_state = 17},
  [1224] = {.lex_state = 17},
  [1225] = {.lex_state = 17},
  [1226] = {.lex_state = 17},
  [1227] = {.lex_state = 17},
  [1228] = {.lex_state = 17},
  [1229] = {.lex_state = 17},
  [1230] = {.lex_state = 17},
  [1231] = {.lex_state = 17},
  [1232] = {.lex_state = 17},
  [1233] = {.lex_state = 17},
  [1234] = {.lex_state = 17},
  [1235] = {.lex_state = 17},
  [1236] = {.lex_state = 17},
  [1237] = {.lex_state = 17},
  [1238] = {.lex_state = 17},
  [1239] = {.lex_state = 17},
  [1240] = {.lex_state = 17},
  [1241] = {.lex_state = 17},
  [1242] = {.lex_state = 17},
  [1243] = {.lex_state = 17},
  [1244] = {.lex_state = 17},
  [1245] = {.lex_state = 17},
  [1246] = {.lex_state = 17},
  [1247] = {.lex_state = 17},
  [1248] = {.lex_state = 17},
  [1249] = {.lex_state = 17},
  [1250] = {.lex_state = 17},
  [1251] = {.lex_state = 17},
  [1252] = {.lex_state = 17},
  [1253] = {.lex_state = 17},
  [1254] = {.lex_state = 17},
  [1255] = {.lex_state = 17},
  [1256] = {.lex_state = 17},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__lower_id] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_implies] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_order] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [sym_qldoc] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [sym__upper_id] = ACTIONS(1),
    [sym__at_lower_id] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_any] = ACTIONS(1),
    [sym_as] = ACTIONS(1),
    [sym_asc] = ACTIONS(1),
    [sym_avg] = ACTIONS(1),
    [sym_boolean] = ACTIONS(1),
    [sym_class] = ACTIONS(1),
    [sym_newtype] = ACTIONS(1),
    [sym_count] = ACTIONS(1),
    [sym_date] = ACTIONS(1),
    [sym_desc] = ACTIONS(1),
    [sym_exists] = ACTIONS(1),
    [sym_extends] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_forall] = ACTIONS(1),
    [sym_forex] = ACTIONS(1),
    [sym_import] = ACTIONS(1),
    [sym_in] = ACTIONS(1),
    [sym_instanceof] = ACTIONS(1),
    [sym_max] = ACTIONS(1),
    [sym_min] = ACTIONS(1),
    [sym_not] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_predicate] = ACTIONS(1),
    [sym_rank] = ACTIONS(1),
    [sym_result] = ACTIONS(1),
    [sym_strictcount] = ACTIONS(1),
    [sym_strictsum] = ACTIONS(1),
    [sym_strictconcat] = ACTIONS(1),
    [sym_concat] = ACTIONS(1),
    [sym_sum] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_lt] = ACTIONS(1),
    [sym_le] = ACTIONS(1),
    [sym_eq] = ACTIONS(1),
    [sym_gt] = ACTIONS(1),
    [sym_ge] = ACTIONS(1),
    [sym_underscore] = ACTIONS(1),
    [sym_minus] = ACTIONS(1),
    [sym_ne] = ACTIONS(1),
    [sym_slash] = ACTIONS(1),
    [sym_star] = ACTIONS(1),
    [sym_mod] = ACTIONS(1),
    [sym_plus] = ACTIONS(1),
  },
  [1] = {
    [sym_ql] = STATE(1252),
    [sym_module] = STATE(825),
    [sym_moduleMember] = STATE(454),
    [sym_imprt] = STATE(825),
    [sym_classlessPredicate] = STATE(825),
    [sym_datatype] = STATE(825),
    [sym_select] = STATE(825),
    [sym_dataclass] = STATE(825),
    [sym_annotation] = STATE(463),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1092),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(454),
    [aux_sym_moduleMember_repeat1] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_where] = ACTIONS(15),
    [anon_sym_select] = ACTIONS(17),
    [sym_qldoc] = ACTIONS(19),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(27),
    [sym_newtype] = ACTIONS(29),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(31),
    [sym_predicate] = ACTIONS(33),
  },
  [2] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1156),
    [sym_expr_aggregate_body] = STATE(1156),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [3] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1238),
    [sym_expr_aggregate_body] = STATE(1238),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(69),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [4] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1191),
    [sym_expr_aggregate_body] = STATE(1191),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [5] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1193),
    [sym_expr_aggregate_body] = STATE(1193),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(73),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [6] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1192),
    [sym_expr_aggregate_body] = STATE(1192),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [7] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1231),
    [sym_expr_aggregate_body] = STATE(1231),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [8] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1255),
    [sym_expr_aggregate_body] = STATE(1255),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [9] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1199),
    [sym_expr_aggregate_body] = STATE(1199),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [10] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1227),
    [sym_expr_aggregate_body] = STATE(1227),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(83),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [11] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1222),
    [sym_expr_aggregate_body] = STATE(1222),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [12] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1174),
    [sym_expr_aggregate_body] = STATE(1174),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [13] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1224),
    [sym_expr_aggregate_body] = STATE(1224),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [14] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1245),
    [sym_expr_aggregate_body] = STATE(1245),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [15] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1133),
    [sym_expr_aggregate_body] = STATE(1133),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [16] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1155),
    [sym_expr_aggregate_body] = STATE(1155),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [17] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1248),
    [sym_expr_aggregate_body] = STATE(1248),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [18] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1244),
    [sym_expr_aggregate_body] = STATE(1244),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [19] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_full_aggregate_body] = STATE(1154),
    [sym_expr_aggregate_body] = STATE(1154),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_varDecl] = STATE(938),
    [sym_asExprs] = STATE(1003),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(898),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_PIPE] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [20] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1019),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(107),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(127),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [21] = {
    [sym_special_call] = STATE(677),
    [sym_prefix_cast] = STATE(677),
    [sym_unary_expr] = STATE(677),
    [sym_mul_expr] = STATE(677),
    [sym_add_expr] = STATE(677),
    [sym_in_expr] = STATE(677),
    [sym_comp_term] = STATE(677),
    [sym_instance_of] = STATE(677),
    [sym_negation] = STATE(677),
    [sym_if_term] = STATE(677),
    [sym_conjunction] = STATE(677),
    [sym_disjunction] = STATE(677),
    [sym_implication] = STATE(677),
    [sym_quantified] = STATE(677),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(677),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(946),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [22] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1070),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(135),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [23] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(963),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(139),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [24] = {
    [sym_special_call] = STATE(701),
    [sym_prefix_cast] = STATE(701),
    [sym_unary_expr] = STATE(701),
    [sym_mul_expr] = STATE(701),
    [sym_add_expr] = STATE(701),
    [sym_in_expr] = STATE(701),
    [sym_comp_term] = STATE(701),
    [sym_instance_of] = STATE(701),
    [sym_negation] = STATE(701),
    [sym_if_term] = STATE(701),
    [sym_conjunction] = STATE(701),
    [sym_disjunction] = STATE(701),
    [sym_implication] = STATE(701),
    [sym_quantified] = STATE(701),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(701),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(947),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(141),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [25] = {
    [sym_special_call] = STATE(703),
    [sym_prefix_cast] = STATE(703),
    [sym_unary_expr] = STATE(703),
    [sym_mul_expr] = STATE(703),
    [sym_add_expr] = STATE(703),
    [sym_in_expr] = STATE(703),
    [sym_comp_term] = STATE(703),
    [sym_instance_of] = STATE(703),
    [sym_negation] = STATE(703),
    [sym_if_term] = STATE(703),
    [sym_conjunction] = STATE(703),
    [sym_disjunction] = STATE(703),
    [sym_implication] = STATE(703),
    [sym_quantified] = STATE(703),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(703),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(915),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(145),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [26] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1026),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(151),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [27] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1035),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(155),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [28] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1051),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(159),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [29] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1063),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(163),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [30] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(988),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(167),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [31] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1032),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(171),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [32] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1061),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(175),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [33] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(962),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(179),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [34] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1028),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(183),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [35] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1010),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(187),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [36] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1007),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(191),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [37] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(965),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(195),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [38] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1014),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(199),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [39] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1021),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(203),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [40] = {
    [sym_special_call] = STATE(676),
    [sym_prefix_cast] = STATE(676),
    [sym_unary_expr] = STATE(676),
    [sym_mul_expr] = STATE(676),
    [sym_add_expr] = STATE(676),
    [sym_in_expr] = STATE(676),
    [sym_comp_term] = STATE(676),
    [sym_instance_of] = STATE(676),
    [sym_negation] = STATE(676),
    [sym_if_term] = STATE(676),
    [sym_conjunction] = STATE(676),
    [sym_disjunction] = STATE(676),
    [sym_implication] = STATE(676),
    [sym_quantified] = STATE(676),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(676),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(934),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [41] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1023),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(209),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(211),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [42] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(995),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(215),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [43] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(966),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(219),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [44] = {
    [sym_special_call] = STATE(720),
    [sym_prefix_cast] = STATE(720),
    [sym_unary_expr] = STATE(720),
    [sym_mul_expr] = STATE(720),
    [sym_add_expr] = STATE(720),
    [sym_in_expr] = STATE(720),
    [sym_comp_term] = STATE(720),
    [sym_instance_of] = STATE(720),
    [sym_negation] = STATE(720),
    [sym_if_term] = STATE(720),
    [sym_conjunction] = STATE(720),
    [sym_disjunction] = STATE(720),
    [sym_implication] = STATE(720),
    [sym_quantified] = STATE(720),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(720),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(930),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(221),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(223),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [45] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1013),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(225),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(227),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [46] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(972),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(231),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [47] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(986),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(233),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(235),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [48] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1045),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(239),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [49] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(982),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(241),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(243),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [50] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1017),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(245),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(247),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [51] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1053),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(249),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(251),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [52] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1025),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(255),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [53] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1062),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(257),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(259),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [54] = {
    [sym_special_call] = STATE(693),
    [sym_prefix_cast] = STATE(693),
    [sym_unary_expr] = STATE(693),
    [sym_mul_expr] = STATE(693),
    [sym_add_expr] = STATE(693),
    [sym_in_expr] = STATE(693),
    [sym_comp_term] = STATE(693),
    [sym_instance_of] = STATE(693),
    [sym_negation] = STATE(693),
    [sym_if_term] = STATE(693),
    [sym_conjunction] = STATE(693),
    [sym_disjunction] = STATE(693),
    [sym_implication] = STATE(693),
    [sym_quantified] = STATE(693),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(693),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_varDecl] = STATE(959),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(901),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [55] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1080),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(267),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [56] = {
    [sym_special_call] = STATE(567),
    [sym_prefix_cast] = STATE(567),
    [sym_unary_expr] = STATE(567),
    [sym_mul_expr] = STATE(567),
    [sym_add_expr] = STATE(567),
    [sym_in_expr] = STATE(567),
    [sym_comp_term] = STATE(567),
    [sym_instance_of] = STATE(567),
    [sym_negation] = STATE(567),
    [sym_if_term] = STATE(567),
    [sym_conjunction] = STATE(567),
    [sym_disjunction] = STATE(567),
    [sym_implication] = STATE(567),
    [sym_quantified] = STATE(567),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(567),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [57] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1043),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [58] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1059),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [59] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(733),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [60] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(645),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [61] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(724),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [62] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(669),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [63] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(721),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [64] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1076),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [65] = {
    [sym_special_call] = STATE(601),
    [sym_prefix_cast] = STATE(601),
    [sym_unary_expr] = STATE(601),
    [sym_mul_expr] = STATE(601),
    [sym_add_expr] = STATE(601),
    [sym_in_expr] = STATE(601),
    [sym_comp_term] = STATE(601),
    [sym_instance_of] = STATE(601),
    [sym_negation] = STATE(601),
    [sym_if_term] = STATE(601),
    [sym_conjunction] = STATE(601),
    [sym_disjunction] = STATE(601),
    [sym_implication] = STATE(601),
    [sym_quantified] = STATE(601),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(601),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(319),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [66] = {
    [sym_special_call] = STATE(625),
    [sym_prefix_cast] = STATE(625),
    [sym_unary_expr] = STATE(625),
    [sym_mul_expr] = STATE(625),
    [sym_add_expr] = STATE(625),
    [sym_in_expr] = STATE(625),
    [sym_comp_term] = STATE(625),
    [sym_instance_of] = STATE(625),
    [sym_negation] = STATE(625),
    [sym_if_term] = STATE(625),
    [sym_conjunction] = STATE(625),
    [sym_disjunction] = STATE(625),
    [sym_implication] = STATE(625),
    [sym_quantified] = STATE(625),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(625),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(323),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [67] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExprs] = STATE(1081),
    [sym_asExpr] = STATE(931),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [68] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(690),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [69] = {
    [sym_special_call] = STATE(607),
    [sym_prefix_cast] = STATE(607),
    [sym_unary_expr] = STATE(607),
    [sym_mul_expr] = STATE(607),
    [sym_add_expr] = STATE(607),
    [sym_in_expr] = STATE(607),
    [sym_comp_term] = STATE(607),
    [sym_instance_of] = STATE(607),
    [sym_negation] = STATE(607),
    [sym_if_term] = STATE(607),
    [sym_conjunction] = STATE(607),
    [sym_disjunction] = STATE(607),
    [sym_implication] = STATE(607),
    [sym_quantified] = STATE(607),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym__call_arg] = STATE(1121),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(607),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_underscore] = ACTIONS(325),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [70] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(735),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [71] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExprs] = STATE(702),
    [sym_asExpr] = STATE(568),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [72] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(630),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [73] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(725),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [74] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(709),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [75] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExprs] = STATE(706),
    [sym_asExpr] = STATE(561),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [76] = {
    [sym_special_call] = STATE(243),
    [sym_prefix_cast] = STATE(243),
    [sym_unary_expr] = STATE(243),
    [sym_mul_expr] = STATE(243),
    [sym_add_expr] = STATE(243),
    [sym_in_expr] = STATE(243),
    [sym_comp_term] = STATE(243),
    [sym_instance_of] = STATE(243),
    [sym_negation] = STATE(243),
    [sym_if_term] = STATE(243),
    [sym_conjunction] = STATE(243),
    [sym_disjunction] = STATE(243),
    [sym_implication] = STATE(243),
    [sym_quantified] = STATE(243),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(243),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_orderBy] = STATE(650),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [77] = {
    [sym_special_call] = STATE(242),
    [sym_prefix_cast] = STATE(242),
    [sym_unary_expr] = STATE(242),
    [sym_mul_expr] = STATE(242),
    [sym_add_expr] = STATE(242),
    [sym_in_expr] = STATE(242),
    [sym_comp_term] = STATE(242),
    [sym_instance_of] = STATE(242),
    [sym_negation] = STATE(242),
    [sym_if_term] = STATE(242),
    [sym_conjunction] = STATE(242),
    [sym_disjunction] = STATE(242),
    [sym_implication] = STATE(242),
    [sym_quantified] = STATE(242),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(242),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_orderBy] = STATE(731),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [78] = {
    [sym_special_call] = STATE(242),
    [sym_prefix_cast] = STATE(242),
    [sym_unary_expr] = STATE(242),
    [sym_mul_expr] = STATE(242),
    [sym_add_expr] = STATE(242),
    [sym_in_expr] = STATE(242),
    [sym_comp_term] = STATE(242),
    [sym_instance_of] = STATE(242),
    [sym_negation] = STATE(242),
    [sym_if_term] = STATE(242),
    [sym_conjunction] = STATE(242),
    [sym_disjunction] = STATE(242),
    [sym_implication] = STATE(242),
    [sym_quantified] = STATE(242),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(242),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_orderBy] = STATE(763),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [79] = {
    [sym_special_call] = STATE(528),
    [sym_prefix_cast] = STATE(528),
    [sym_unary_expr] = STATE(528),
    [sym_mul_expr] = STATE(528),
    [sym_add_expr] = STATE(528),
    [sym_in_expr] = STATE(528),
    [sym_comp_term] = STATE(528),
    [sym_instance_of] = STATE(528),
    [sym_negation] = STATE(528),
    [sym_if_term] = STATE(528),
    [sym_conjunction] = STATE(528),
    [sym_disjunction] = STATE(528),
    [sym_implication] = STATE(528),
    [sym_quantified] = STATE(528),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(528),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_orderBy] = STATE(1115),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [80] = {
    [sym_special_call] = STATE(542),
    [sym_prefix_cast] = STATE(542),
    [sym_unary_expr] = STATE(542),
    [sym_mul_expr] = STATE(542),
    [sym_add_expr] = STATE(542),
    [sym_in_expr] = STATE(542),
    [sym_comp_term] = STATE(542),
    [sym_instance_of] = STATE(542),
    [sym_negation] = STATE(542),
    [sym_if_term] = STATE(542),
    [sym_conjunction] = STATE(542),
    [sym_disjunction] = STATE(542),
    [sym_implication] = STATE(542),
    [sym_quantified] = STATE(542),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(542),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_asExpr] = STATE(997),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [81] = {
    [sym_special_call] = STATE(528),
    [sym_prefix_cast] = STATE(528),
    [sym_unary_expr] = STATE(528),
    [sym_mul_expr] = STATE(528),
    [sym_add_expr] = STATE(528),
    [sym_in_expr] = STATE(528),
    [sym_comp_term] = STATE(528),
    [sym_instance_of] = STATE(528),
    [sym_negation] = STATE(528),
    [sym_if_term] = STATE(528),
    [sym_conjunction] = STATE(528),
    [sym_disjunction] = STATE(528),
    [sym_implication] = STATE(528),
    [sym_quantified] = STATE(528),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(528),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_orderBy] = STATE(992),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [82] = {
    [sym_special_call] = STATE(261),
    [sym_prefix_cast] = STATE(261),
    [sym_unary_expr] = STATE(261),
    [sym_mul_expr] = STATE(261),
    [sym_add_expr] = STATE(261),
    [sym_in_expr] = STATE(261),
    [sym_comp_term] = STATE(261),
    [sym_instance_of] = STATE(261),
    [sym_negation] = STATE(261),
    [sym_if_term] = STATE(261),
    [sym_conjunction] = STATE(261),
    [sym_disjunction] = STATE(261),
    [sym_implication] = STATE(261),
    [sym_quantified] = STATE(261),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(261),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_asExpr] = STATE(653),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [83] = {
    [sym_special_call] = STATE(264),
    [sym_prefix_cast] = STATE(264),
    [sym_unary_expr] = STATE(264),
    [sym_mul_expr] = STATE(264),
    [sym_add_expr] = STATE(264),
    [sym_in_expr] = STATE(264),
    [sym_comp_term] = STATE(264),
    [sym_instance_of] = STATE(264),
    [sym_negation] = STATE(264),
    [sym_if_term] = STATE(264),
    [sym_conjunction] = STATE(264),
    [sym_disjunction] = STATE(264),
    [sym_implication] = STATE(264),
    [sym_quantified] = STATE(264),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(264),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_asExpr] = STATE(642),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [84] = {
    [sym_special_call] = STATE(243),
    [sym_prefix_cast] = STATE(243),
    [sym_unary_expr] = STATE(243),
    [sym_mul_expr] = STATE(243),
    [sym_add_expr] = STATE(243),
    [sym_in_expr] = STATE(243),
    [sym_comp_term] = STATE(243),
    [sym_instance_of] = STATE(243),
    [sym_negation] = STATE(243),
    [sym_if_term] = STATE(243),
    [sym_conjunction] = STATE(243),
    [sym_disjunction] = STATE(243),
    [sym_implication] = STATE(243),
    [sym_quantified] = STATE(243),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(243),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_orderBy] = STATE(747),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [85] = {
    [sym_special_call] = STATE(666),
    [sym_prefix_cast] = STATE(666),
    [sym_unary_expr] = STATE(666),
    [sym_mul_expr] = STATE(666),
    [sym_add_expr] = STATE(666),
    [sym_in_expr] = STATE(666),
    [sym_comp_term] = STATE(666),
    [sym_instance_of] = STATE(666),
    [sym_negation] = STATE(666),
    [sym_if_term] = STATE(666),
    [sym_conjunction] = STATE(666),
    [sym_disjunction] = STATE(666),
    [sym_implication] = STATE(666),
    [sym_quantified] = STATE(666),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(666),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [86] = {
    [sym_special_call] = STATE(623),
    [sym_prefix_cast] = STATE(623),
    [sym_unary_expr] = STATE(623),
    [sym_mul_expr] = STATE(623),
    [sym_add_expr] = STATE(623),
    [sym_in_expr] = STATE(623),
    [sym_comp_term] = STATE(623),
    [sym_instance_of] = STATE(623),
    [sym_negation] = STATE(623),
    [sym_if_term] = STATE(623),
    [sym_conjunction] = STATE(623),
    [sym_disjunction] = STATE(623),
    [sym_implication] = STATE(623),
    [sym_quantified] = STATE(623),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(623),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [87] = {
    [sym_special_call] = STATE(678),
    [sym_prefix_cast] = STATE(678),
    [sym_unary_expr] = STATE(678),
    [sym_mul_expr] = STATE(678),
    [sym_add_expr] = STATE(678),
    [sym_in_expr] = STATE(678),
    [sym_comp_term] = STATE(678),
    [sym_instance_of] = STATE(678),
    [sym_negation] = STATE(678),
    [sym_if_term] = STATE(678),
    [sym_conjunction] = STATE(678),
    [sym_disjunction] = STATE(678),
    [sym_implication] = STATE(678),
    [sym_quantified] = STATE(678),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(678),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [88] = {
    [sym_special_call] = STATE(550),
    [sym_prefix_cast] = STATE(550),
    [sym_unary_expr] = STATE(550),
    [sym_mul_expr] = STATE(550),
    [sym_add_expr] = STATE(550),
    [sym_in_expr] = STATE(550),
    [sym_comp_term] = STATE(550),
    [sym_instance_of] = STATE(550),
    [sym_negation] = STATE(550),
    [sym_if_term] = STATE(550),
    [sym_conjunction] = STATE(550),
    [sym_disjunction] = STATE(550),
    [sym_implication] = STATE(550),
    [sym_quantified] = STATE(550),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(550),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [89] = {
    [sym_special_call] = STATE(681),
    [sym_prefix_cast] = STATE(681),
    [sym_unary_expr] = STATE(681),
    [sym_mul_expr] = STATE(681),
    [sym_add_expr] = STATE(681),
    [sym_in_expr] = STATE(681),
    [sym_comp_term] = STATE(681),
    [sym_instance_of] = STATE(681),
    [sym_negation] = STATE(681),
    [sym_if_term] = STATE(681),
    [sym_conjunction] = STATE(681),
    [sym_disjunction] = STATE(681),
    [sym_implication] = STATE(681),
    [sym_quantified] = STATE(681),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(681),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [90] = {
    [sym_special_call] = STATE(682),
    [sym_prefix_cast] = STATE(682),
    [sym_unary_expr] = STATE(682),
    [sym_mul_expr] = STATE(682),
    [sym_add_expr] = STATE(682),
    [sym_in_expr] = STATE(682),
    [sym_comp_term] = STATE(682),
    [sym_instance_of] = STATE(682),
    [sym_negation] = STATE(682),
    [sym_if_term] = STATE(682),
    [sym_conjunction] = STATE(682),
    [sym_disjunction] = STATE(682),
    [sym_implication] = STATE(682),
    [sym_quantified] = STATE(682),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(682),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [91] = {
    [sym_special_call] = STATE(551),
    [sym_prefix_cast] = STATE(551),
    [sym_unary_expr] = STATE(551),
    [sym_mul_expr] = STATE(551),
    [sym_add_expr] = STATE(551),
    [sym_in_expr] = STATE(551),
    [sym_comp_term] = STATE(551),
    [sym_instance_of] = STATE(551),
    [sym_negation] = STATE(551),
    [sym_if_term] = STATE(551),
    [sym_conjunction] = STATE(551),
    [sym_disjunction] = STATE(551),
    [sym_implication] = STATE(551),
    [sym_quantified] = STATE(551),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(551),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [92] = {
    [sym_special_call] = STATE(512),
    [sym_prefix_cast] = STATE(512),
    [sym_unary_expr] = STATE(512),
    [sym_mul_expr] = STATE(512),
    [sym_add_expr] = STATE(512),
    [sym_in_expr] = STATE(512),
    [sym_comp_term] = STATE(512),
    [sym_instance_of] = STATE(512),
    [sym_negation] = STATE(512),
    [sym_if_term] = STATE(512),
    [sym_conjunction] = STATE(512),
    [sym_disjunction] = STATE(512),
    [sym_implication] = STATE(512),
    [sym_quantified] = STATE(512),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(512),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [93] = {
    [sym_special_call] = STATE(511),
    [sym_prefix_cast] = STATE(511),
    [sym_unary_expr] = STATE(511),
    [sym_mul_expr] = STATE(511),
    [sym_add_expr] = STATE(511),
    [sym_in_expr] = STATE(511),
    [sym_comp_term] = STATE(511),
    [sym_instance_of] = STATE(511),
    [sym_negation] = STATE(511),
    [sym_if_term] = STATE(511),
    [sym_conjunction] = STATE(511),
    [sym_disjunction] = STATE(511),
    [sym_implication] = STATE(511),
    [sym_quantified] = STATE(511),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(511),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [94] = {
    [sym_special_call] = STATE(510),
    [sym_prefix_cast] = STATE(510),
    [sym_unary_expr] = STATE(510),
    [sym_mul_expr] = STATE(510),
    [sym_add_expr] = STATE(510),
    [sym_in_expr] = STATE(510),
    [sym_comp_term] = STATE(510),
    [sym_instance_of] = STATE(510),
    [sym_negation] = STATE(510),
    [sym_if_term] = STATE(510),
    [sym_conjunction] = STATE(510),
    [sym_disjunction] = STATE(510),
    [sym_implication] = STATE(510),
    [sym_quantified] = STATE(510),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(510),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [95] = {
    [sym_special_call] = STATE(737),
    [sym_prefix_cast] = STATE(737),
    [sym_unary_expr] = STATE(737),
    [sym_mul_expr] = STATE(737),
    [sym_add_expr] = STATE(737),
    [sym_in_expr] = STATE(737),
    [sym_comp_term] = STATE(737),
    [sym_instance_of] = STATE(737),
    [sym_negation] = STATE(737),
    [sym_if_term] = STATE(737),
    [sym_conjunction] = STATE(737),
    [sym_disjunction] = STATE(737),
    [sym_implication] = STATE(737),
    [sym_quantified] = STATE(737),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(737),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [96] = {
    [sym_special_call] = STATE(685),
    [sym_prefix_cast] = STATE(685),
    [sym_unary_expr] = STATE(685),
    [sym_mul_expr] = STATE(685),
    [sym_add_expr] = STATE(685),
    [sym_in_expr] = STATE(685),
    [sym_comp_term] = STATE(685),
    [sym_instance_of] = STATE(685),
    [sym_negation] = STATE(685),
    [sym_if_term] = STATE(685),
    [sym_conjunction] = STATE(685),
    [sym_disjunction] = STATE(685),
    [sym_implication] = STATE(685),
    [sym_quantified] = STATE(685),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(685),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [97] = {
    [sym_special_call] = STATE(262),
    [sym_prefix_cast] = STATE(262),
    [sym_unary_expr] = STATE(262),
    [sym_mul_expr] = STATE(262),
    [sym_add_expr] = STATE(262),
    [sym_in_expr] = STATE(262),
    [sym_comp_term] = STATE(262),
    [sym_instance_of] = STATE(262),
    [sym_negation] = STATE(262),
    [sym_if_term] = STATE(262),
    [sym_conjunction] = STATE(262),
    [sym_disjunction] = STATE(262),
    [sym_implication] = STATE(262),
    [sym_quantified] = STATE(262),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(262),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [98] = {
    [sym_special_call] = STATE(688),
    [sym_prefix_cast] = STATE(688),
    [sym_unary_expr] = STATE(688),
    [sym_mul_expr] = STATE(688),
    [sym_add_expr] = STATE(688),
    [sym_in_expr] = STATE(688),
    [sym_comp_term] = STATE(688),
    [sym_instance_of] = STATE(688),
    [sym_negation] = STATE(688),
    [sym_if_term] = STATE(688),
    [sym_conjunction] = STATE(688),
    [sym_disjunction] = STATE(688),
    [sym_implication] = STATE(688),
    [sym_quantified] = STATE(688),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(688),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [99] = {
    [sym_special_call] = STATE(284),
    [sym_prefix_cast] = STATE(284),
    [sym_unary_expr] = STATE(284),
    [sym_mul_expr] = STATE(284),
    [sym_add_expr] = STATE(284),
    [sym_in_expr] = STATE(284),
    [sym_comp_term] = STATE(284),
    [sym_instance_of] = STATE(284),
    [sym_negation] = STATE(284),
    [sym_if_term] = STATE(284),
    [sym_conjunction] = STATE(284),
    [sym_disjunction] = STATE(284),
    [sym_implication] = STATE(284),
    [sym_quantified] = STATE(284),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(284),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [100] = {
    [sym_special_call] = STATE(518),
    [sym_prefix_cast] = STATE(518),
    [sym_unary_expr] = STATE(518),
    [sym_mul_expr] = STATE(518),
    [sym_add_expr] = STATE(518),
    [sym_in_expr] = STATE(518),
    [sym_comp_term] = STATE(518),
    [sym_instance_of] = STATE(518),
    [sym_negation] = STATE(518),
    [sym_if_term] = STATE(518),
    [sym_conjunction] = STATE(518),
    [sym_disjunction] = STATE(518),
    [sym_implication] = STATE(518),
    [sym_quantified] = STATE(518),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(518),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [101] = {
    [sym_special_call] = STATE(517),
    [sym_prefix_cast] = STATE(517),
    [sym_unary_expr] = STATE(517),
    [sym_mul_expr] = STATE(517),
    [sym_add_expr] = STATE(517),
    [sym_in_expr] = STATE(517),
    [sym_comp_term] = STATE(517),
    [sym_instance_of] = STATE(517),
    [sym_negation] = STATE(517),
    [sym_if_term] = STATE(517),
    [sym_conjunction] = STATE(517),
    [sym_disjunction] = STATE(517),
    [sym_implication] = STATE(517),
    [sym_quantified] = STATE(517),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(517),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [102] = {
    [sym_special_call] = STATE(515),
    [sym_prefix_cast] = STATE(515),
    [sym_unary_expr] = STATE(515),
    [sym_mul_expr] = STATE(515),
    [sym_add_expr] = STATE(515),
    [sym_in_expr] = STATE(515),
    [sym_comp_term] = STATE(515),
    [sym_instance_of] = STATE(515),
    [sym_negation] = STATE(515),
    [sym_if_term] = STATE(515),
    [sym_conjunction] = STATE(515),
    [sym_disjunction] = STATE(515),
    [sym_implication] = STATE(515),
    [sym_quantified] = STATE(515),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(515),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [103] = {
    [sym_special_call] = STATE(283),
    [sym_prefix_cast] = STATE(283),
    [sym_unary_expr] = STATE(283),
    [sym_mul_expr] = STATE(283),
    [sym_add_expr] = STATE(283),
    [sym_in_expr] = STATE(283),
    [sym_comp_term] = STATE(283),
    [sym_instance_of] = STATE(283),
    [sym_negation] = STATE(283),
    [sym_if_term] = STATE(283),
    [sym_conjunction] = STATE(283),
    [sym_disjunction] = STATE(283),
    [sym_implication] = STATE(283),
    [sym_quantified] = STATE(283),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(283),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [104] = {
    [sym_special_call] = STATE(245),
    [sym_prefix_cast] = STATE(245),
    [sym_unary_expr] = STATE(245),
    [sym_mul_expr] = STATE(245),
    [sym_add_expr] = STATE(245),
    [sym_in_expr] = STATE(245),
    [sym_comp_term] = STATE(245),
    [sym_instance_of] = STATE(245),
    [sym_negation] = STATE(245),
    [sym_if_term] = STATE(245),
    [sym_conjunction] = STATE(245),
    [sym_disjunction] = STATE(245),
    [sym_implication] = STATE(245),
    [sym_quantified] = STATE(245),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(245),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [105] = {
    [sym_special_call] = STATE(289),
    [sym_prefix_cast] = STATE(289),
    [sym_unary_expr] = STATE(289),
    [sym_mul_expr] = STATE(289),
    [sym_add_expr] = STATE(289),
    [sym_in_expr] = STATE(289),
    [sym_comp_term] = STATE(289),
    [sym_instance_of] = STATE(289),
    [sym_negation] = STATE(289),
    [sym_if_term] = STATE(289),
    [sym_conjunction] = STATE(289),
    [sym_disjunction] = STATE(289),
    [sym_implication] = STATE(289),
    [sym_quantified] = STATE(289),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(289),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [106] = {
    [sym_special_call] = STATE(280),
    [sym_prefix_cast] = STATE(280),
    [sym_unary_expr] = STATE(280),
    [sym_mul_expr] = STATE(280),
    [sym_add_expr] = STATE(280),
    [sym_in_expr] = STATE(280),
    [sym_comp_term] = STATE(280),
    [sym_instance_of] = STATE(280),
    [sym_negation] = STATE(280),
    [sym_if_term] = STATE(280),
    [sym_conjunction] = STATE(280),
    [sym_disjunction] = STATE(280),
    [sym_implication] = STATE(280),
    [sym_quantified] = STATE(280),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(280),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [107] = {
    [sym_special_call] = STATE(292),
    [sym_prefix_cast] = STATE(292),
    [sym_unary_expr] = STATE(292),
    [sym_mul_expr] = STATE(292),
    [sym_add_expr] = STATE(292),
    [sym_in_expr] = STATE(292),
    [sym_comp_term] = STATE(292),
    [sym_instance_of] = STATE(292),
    [sym_negation] = STATE(292),
    [sym_if_term] = STATE(292),
    [sym_conjunction] = STATE(292),
    [sym_disjunction] = STATE(292),
    [sym_implication] = STATE(292),
    [sym_quantified] = STATE(292),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(292),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [108] = {
    [sym_special_call] = STATE(646),
    [sym_prefix_cast] = STATE(646),
    [sym_unary_expr] = STATE(646),
    [sym_mul_expr] = STATE(646),
    [sym_add_expr] = STATE(646),
    [sym_in_expr] = STATE(646),
    [sym_comp_term] = STATE(646),
    [sym_instance_of] = STATE(646),
    [sym_negation] = STATE(646),
    [sym_if_term] = STATE(646),
    [sym_conjunction] = STATE(646),
    [sym_disjunction] = STATE(646),
    [sym_implication] = STATE(646),
    [sym_quantified] = STATE(646),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(646),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [109] = {
    [sym_special_call] = STATE(552),
    [sym_prefix_cast] = STATE(552),
    [sym_unary_expr] = STATE(552),
    [sym_mul_expr] = STATE(552),
    [sym_add_expr] = STATE(552),
    [sym_in_expr] = STATE(552),
    [sym_comp_term] = STATE(552),
    [sym_instance_of] = STATE(552),
    [sym_negation] = STATE(552),
    [sym_if_term] = STATE(552),
    [sym_conjunction] = STATE(552),
    [sym_disjunction] = STATE(552),
    [sym_implication] = STATE(552),
    [sym_quantified] = STATE(552),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(552),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [110] = {
    [sym_special_call] = STATE(661),
    [sym_prefix_cast] = STATE(661),
    [sym_unary_expr] = STATE(661),
    [sym_mul_expr] = STATE(661),
    [sym_add_expr] = STATE(661),
    [sym_in_expr] = STATE(661),
    [sym_comp_term] = STATE(661),
    [sym_instance_of] = STATE(661),
    [sym_negation] = STATE(661),
    [sym_if_term] = STATE(661),
    [sym_conjunction] = STATE(661),
    [sym_disjunction] = STATE(661),
    [sym_implication] = STATE(661),
    [sym_quantified] = STATE(661),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(661),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [111] = {
    [sym_special_call] = STATE(662),
    [sym_prefix_cast] = STATE(662),
    [sym_unary_expr] = STATE(662),
    [sym_mul_expr] = STATE(662),
    [sym_add_expr] = STATE(662),
    [sym_in_expr] = STATE(662),
    [sym_comp_term] = STATE(662),
    [sym_instance_of] = STATE(662),
    [sym_negation] = STATE(662),
    [sym_if_term] = STATE(662),
    [sym_conjunction] = STATE(662),
    [sym_disjunction] = STATE(662),
    [sym_implication] = STATE(662),
    [sym_quantified] = STATE(662),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(662),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [112] = {
    [sym_special_call] = STATE(554),
    [sym_prefix_cast] = STATE(554),
    [sym_unary_expr] = STATE(554),
    [sym_mul_expr] = STATE(554),
    [sym_add_expr] = STATE(554),
    [sym_in_expr] = STATE(554),
    [sym_comp_term] = STATE(554),
    [sym_instance_of] = STATE(554),
    [sym_negation] = STATE(554),
    [sym_if_term] = STATE(554),
    [sym_conjunction] = STATE(554),
    [sym_disjunction] = STATE(554),
    [sym_implication] = STATE(554),
    [sym_quantified] = STATE(554),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(554),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [113] = {
    [sym_special_call] = STATE(692),
    [sym_prefix_cast] = STATE(692),
    [sym_unary_expr] = STATE(692),
    [sym_mul_expr] = STATE(692),
    [sym_add_expr] = STATE(692),
    [sym_in_expr] = STATE(692),
    [sym_comp_term] = STATE(692),
    [sym_instance_of] = STATE(692),
    [sym_negation] = STATE(692),
    [sym_if_term] = STATE(692),
    [sym_conjunction] = STATE(692),
    [sym_disjunction] = STATE(692),
    [sym_implication] = STATE(692),
    [sym_quantified] = STATE(692),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(692),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [114] = {
    [sym_special_call] = STATE(291),
    [sym_prefix_cast] = STATE(291),
    [sym_unary_expr] = STATE(291),
    [sym_mul_expr] = STATE(291),
    [sym_add_expr] = STATE(291),
    [sym_in_expr] = STATE(291),
    [sym_comp_term] = STATE(291),
    [sym_instance_of] = STATE(291),
    [sym_negation] = STATE(291),
    [sym_if_term] = STATE(291),
    [sym_conjunction] = STATE(291),
    [sym_disjunction] = STATE(291),
    [sym_implication] = STATE(291),
    [sym_quantified] = STATE(291),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(291),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [115] = {
    [sym_special_call] = STATE(276),
    [sym_prefix_cast] = STATE(276),
    [sym_unary_expr] = STATE(276),
    [sym_mul_expr] = STATE(276),
    [sym_add_expr] = STATE(276),
    [sym_in_expr] = STATE(276),
    [sym_comp_term] = STATE(276),
    [sym_instance_of] = STATE(276),
    [sym_negation] = STATE(276),
    [sym_if_term] = STATE(276),
    [sym_conjunction] = STATE(276),
    [sym_disjunction] = STATE(276),
    [sym_implication] = STATE(276),
    [sym_quantified] = STATE(276),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(276),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [116] = {
    [sym_special_call] = STATE(699),
    [sym_prefix_cast] = STATE(699),
    [sym_unary_expr] = STATE(699),
    [sym_mul_expr] = STATE(699),
    [sym_add_expr] = STATE(699),
    [sym_in_expr] = STATE(699),
    [sym_comp_term] = STATE(699),
    [sym_instance_of] = STATE(699),
    [sym_negation] = STATE(699),
    [sym_if_term] = STATE(699),
    [sym_conjunction] = STATE(699),
    [sym_disjunction] = STATE(699),
    [sym_implication] = STATE(699),
    [sym_quantified] = STATE(699),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(699),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [117] = {
    [sym_special_call] = STATE(708),
    [sym_prefix_cast] = STATE(708),
    [sym_unary_expr] = STATE(708),
    [sym_mul_expr] = STATE(708),
    [sym_add_expr] = STATE(708),
    [sym_in_expr] = STATE(708),
    [sym_comp_term] = STATE(708),
    [sym_instance_of] = STATE(708),
    [sym_negation] = STATE(708),
    [sym_if_term] = STATE(708),
    [sym_conjunction] = STATE(708),
    [sym_disjunction] = STATE(708),
    [sym_implication] = STATE(708),
    [sym_quantified] = STATE(708),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(708),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [118] = {
    [sym_special_call] = STATE(671),
    [sym_prefix_cast] = STATE(671),
    [sym_unary_expr] = STATE(671),
    [sym_mul_expr] = STATE(671),
    [sym_add_expr] = STATE(671),
    [sym_in_expr] = STATE(671),
    [sym_comp_term] = STATE(671),
    [sym_instance_of] = STATE(671),
    [sym_negation] = STATE(671),
    [sym_if_term] = STATE(671),
    [sym_conjunction] = STATE(671),
    [sym_disjunction] = STATE(671),
    [sym_implication] = STATE(671),
    [sym_quantified] = STATE(671),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(671),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [119] = {
    [sym_special_call] = STATE(691),
    [sym_prefix_cast] = STATE(691),
    [sym_unary_expr] = STATE(691),
    [sym_mul_expr] = STATE(691),
    [sym_add_expr] = STATE(691),
    [sym_in_expr] = STATE(691),
    [sym_comp_term] = STATE(691),
    [sym_instance_of] = STATE(691),
    [sym_negation] = STATE(691),
    [sym_if_term] = STATE(691),
    [sym_conjunction] = STATE(691),
    [sym_disjunction] = STATE(691),
    [sym_implication] = STATE(691),
    [sym_quantified] = STATE(691),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(691),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [120] = {
    [sym_special_call] = STATE(710),
    [sym_prefix_cast] = STATE(710),
    [sym_unary_expr] = STATE(710),
    [sym_mul_expr] = STATE(710),
    [sym_add_expr] = STATE(710),
    [sym_in_expr] = STATE(710),
    [sym_comp_term] = STATE(710),
    [sym_instance_of] = STATE(710),
    [sym_negation] = STATE(710),
    [sym_if_term] = STATE(710),
    [sym_conjunction] = STATE(710),
    [sym_disjunction] = STATE(710),
    [sym_implication] = STATE(710),
    [sym_quantified] = STATE(710),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(710),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1097),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [121] = {
    [sym_special_call] = STATE(672),
    [sym_prefix_cast] = STATE(672),
    [sym_unary_expr] = STATE(672),
    [sym_mul_expr] = STATE(672),
    [sym_add_expr] = STATE(672),
    [sym_in_expr] = STATE(672),
    [sym_comp_term] = STATE(672),
    [sym_instance_of] = STATE(672),
    [sym_negation] = STATE(672),
    [sym_if_term] = STATE(672),
    [sym_conjunction] = STATE(672),
    [sym_disjunction] = STATE(672),
    [sym_implication] = STATE(672),
    [sym_quantified] = STATE(672),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(672),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [122] = {
    [sym_special_call] = STATE(287),
    [sym_prefix_cast] = STATE(287),
    [sym_unary_expr] = STATE(287),
    [sym_mul_expr] = STATE(287),
    [sym_add_expr] = STATE(287),
    [sym_in_expr] = STATE(287),
    [sym_comp_term] = STATE(287),
    [sym_instance_of] = STATE(287),
    [sym_negation] = STATE(287),
    [sym_if_term] = STATE(287),
    [sym_conjunction] = STATE(287),
    [sym_disjunction] = STATE(287),
    [sym_implication] = STATE(287),
    [sym_quantified] = STATE(287),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(287),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [123] = {
    [sym_special_call] = STATE(673),
    [sym_prefix_cast] = STATE(673),
    [sym_unary_expr] = STATE(673),
    [sym_mul_expr] = STATE(673),
    [sym_add_expr] = STATE(673),
    [sym_in_expr] = STATE(673),
    [sym_comp_term] = STATE(673),
    [sym_instance_of] = STATE(673),
    [sym_negation] = STATE(673),
    [sym_if_term] = STATE(673),
    [sym_conjunction] = STATE(673),
    [sym_disjunction] = STATE(673),
    [sym_implication] = STATE(673),
    [sym_quantified] = STATE(673),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(673),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [124] = {
    [sym_special_call] = STATE(587),
    [sym_prefix_cast] = STATE(587),
    [sym_unary_expr] = STATE(587),
    [sym_mul_expr] = STATE(587),
    [sym_add_expr] = STATE(587),
    [sym_in_expr] = STATE(587),
    [sym_comp_term] = STATE(587),
    [sym_instance_of] = STATE(587),
    [sym_negation] = STATE(587),
    [sym_if_term] = STATE(587),
    [sym_conjunction] = STATE(587),
    [sym_disjunction] = STATE(587),
    [sym_implication] = STATE(587),
    [sym_quantified] = STATE(587),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(587),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [125] = {
    [sym_special_call] = STATE(679),
    [sym_prefix_cast] = STATE(679),
    [sym_unary_expr] = STATE(679),
    [sym_mul_expr] = STATE(679),
    [sym_add_expr] = STATE(679),
    [sym_in_expr] = STATE(679),
    [sym_comp_term] = STATE(679),
    [sym_instance_of] = STATE(679),
    [sym_negation] = STATE(679),
    [sym_if_term] = STATE(679),
    [sym_conjunction] = STATE(679),
    [sym_disjunction] = STATE(679),
    [sym_implication] = STATE(679),
    [sym_quantified] = STATE(679),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(679),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [126] = {
    [sym_special_call] = STATE(546),
    [sym_prefix_cast] = STATE(546),
    [sym_unary_expr] = STATE(546),
    [sym_mul_expr] = STATE(546),
    [sym_add_expr] = STATE(546),
    [sym_in_expr] = STATE(546),
    [sym_comp_term] = STATE(546),
    [sym_instance_of] = STATE(546),
    [sym_negation] = STATE(546),
    [sym_if_term] = STATE(546),
    [sym_conjunction] = STATE(546),
    [sym_disjunction] = STATE(546),
    [sym_implication] = STATE(546),
    [sym_quantified] = STATE(546),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(546),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [127] = {
    [sym_special_call] = STATE(664),
    [sym_prefix_cast] = STATE(664),
    [sym_unary_expr] = STATE(664),
    [sym_mul_expr] = STATE(664),
    [sym_add_expr] = STATE(664),
    [sym_in_expr] = STATE(664),
    [sym_comp_term] = STATE(664),
    [sym_instance_of] = STATE(664),
    [sym_negation] = STATE(664),
    [sym_if_term] = STATE(664),
    [sym_conjunction] = STATE(664),
    [sym_disjunction] = STATE(664),
    [sym_implication] = STATE(664),
    [sym_quantified] = STATE(664),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(664),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [128] = {
    [sym_special_call] = STATE(663),
    [sym_prefix_cast] = STATE(663),
    [sym_unary_expr] = STATE(663),
    [sym_mul_expr] = STATE(663),
    [sym_add_expr] = STATE(663),
    [sym_in_expr] = STATE(663),
    [sym_comp_term] = STATE(663),
    [sym_instance_of] = STATE(663),
    [sym_negation] = STATE(663),
    [sym_if_term] = STATE(663),
    [sym_conjunction] = STATE(663),
    [sym_disjunction] = STATE(663),
    [sym_implication] = STATE(663),
    [sym_quantified] = STATE(663),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(663),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [129] = {
    [sym_special_call] = STATE(596),
    [sym_prefix_cast] = STATE(596),
    [sym_unary_expr] = STATE(596),
    [sym_mul_expr] = STATE(596),
    [sym_add_expr] = STATE(596),
    [sym_in_expr] = STATE(596),
    [sym_comp_term] = STATE(596),
    [sym_instance_of] = STATE(596),
    [sym_negation] = STATE(596),
    [sym_if_term] = STATE(596),
    [sym_conjunction] = STATE(596),
    [sym_disjunction] = STATE(596),
    [sym_implication] = STATE(596),
    [sym_quantified] = STATE(596),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(596),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [130] = {
    [sym_special_call] = STATE(700),
    [sym_prefix_cast] = STATE(700),
    [sym_unary_expr] = STATE(700),
    [sym_mul_expr] = STATE(700),
    [sym_add_expr] = STATE(700),
    [sym_in_expr] = STATE(700),
    [sym_comp_term] = STATE(700),
    [sym_instance_of] = STATE(700),
    [sym_negation] = STATE(700),
    [sym_if_term] = STATE(700),
    [sym_conjunction] = STATE(700),
    [sym_disjunction] = STATE(700),
    [sym_implication] = STATE(700),
    [sym_quantified] = STATE(700),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(700),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [131] = {
    [sym_special_call] = STATE(704),
    [sym_prefix_cast] = STATE(704),
    [sym_unary_expr] = STATE(704),
    [sym_mul_expr] = STATE(704),
    [sym_add_expr] = STATE(704),
    [sym_in_expr] = STATE(704),
    [sym_comp_term] = STATE(704),
    [sym_instance_of] = STATE(704),
    [sym_negation] = STATE(704),
    [sym_if_term] = STATE(704),
    [sym_conjunction] = STATE(704),
    [sym_disjunction] = STATE(704),
    [sym_implication] = STATE(704),
    [sym_quantified] = STATE(704),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(704),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [132] = {
    [sym_special_call] = STATE(715),
    [sym_prefix_cast] = STATE(715),
    [sym_unary_expr] = STATE(715),
    [sym_mul_expr] = STATE(715),
    [sym_add_expr] = STATE(715),
    [sym_in_expr] = STATE(715),
    [sym_comp_term] = STATE(715),
    [sym_instance_of] = STATE(715),
    [sym_negation] = STATE(715),
    [sym_if_term] = STATE(715),
    [sym_conjunction] = STATE(715),
    [sym_disjunction] = STATE(715),
    [sym_implication] = STATE(715),
    [sym_quantified] = STATE(715),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(715),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [133] = {
    [sym_special_call] = STATE(569),
    [sym_prefix_cast] = STATE(569),
    [sym_unary_expr] = STATE(569),
    [sym_mul_expr] = STATE(569),
    [sym_add_expr] = STATE(569),
    [sym_in_expr] = STATE(569),
    [sym_comp_term] = STATE(569),
    [sym_instance_of] = STATE(569),
    [sym_negation] = STATE(569),
    [sym_if_term] = STATE(569),
    [sym_conjunction] = STATE(569),
    [sym_disjunction] = STATE(569),
    [sym_implication] = STATE(569),
    [sym_quantified] = STATE(569),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(569),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [134] = {
    [sym_special_call] = STATE(717),
    [sym_prefix_cast] = STATE(717),
    [sym_unary_expr] = STATE(717),
    [sym_mul_expr] = STATE(717),
    [sym_add_expr] = STATE(717),
    [sym_in_expr] = STATE(717),
    [sym_comp_term] = STATE(717),
    [sym_instance_of] = STATE(717),
    [sym_negation] = STATE(717),
    [sym_if_term] = STATE(717),
    [sym_conjunction] = STATE(717),
    [sym_disjunction] = STATE(717),
    [sym_implication] = STATE(717),
    [sym_quantified] = STATE(717),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(717),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1102),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [135] = {
    [sym_special_call] = STATE(285),
    [sym_prefix_cast] = STATE(285),
    [sym_unary_expr] = STATE(285),
    [sym_mul_expr] = STATE(285),
    [sym_add_expr] = STATE(285),
    [sym_in_expr] = STATE(285),
    [sym_comp_term] = STATE(285),
    [sym_instance_of] = STATE(285),
    [sym_negation] = STATE(285),
    [sym_if_term] = STATE(285),
    [sym_conjunction] = STATE(285),
    [sym_disjunction] = STATE(285),
    [sym_implication] = STATE(285),
    [sym_quantified] = STATE(285),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(285),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [136] = {
    [sym_special_call] = STATE(722),
    [sym_prefix_cast] = STATE(722),
    [sym_unary_expr] = STATE(722),
    [sym_mul_expr] = STATE(722),
    [sym_add_expr] = STATE(722),
    [sym_in_expr] = STATE(722),
    [sym_comp_term] = STATE(722),
    [sym_instance_of] = STATE(722),
    [sym_negation] = STATE(722),
    [sym_if_term] = STATE(722),
    [sym_conjunction] = STATE(722),
    [sym_disjunction] = STATE(722),
    [sym_implication] = STATE(722),
    [sym_quantified] = STATE(722),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(722),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [137] = {
    [sym_special_call] = STATE(282),
    [sym_prefix_cast] = STATE(282),
    [sym_unary_expr] = STATE(282),
    [sym_mul_expr] = STATE(282),
    [sym_add_expr] = STATE(282),
    [sym_in_expr] = STATE(282),
    [sym_comp_term] = STATE(282),
    [sym_instance_of] = STATE(282),
    [sym_negation] = STATE(282),
    [sym_if_term] = STATE(282),
    [sym_conjunction] = STATE(282),
    [sym_disjunction] = STATE(282),
    [sym_implication] = STATE(282),
    [sym_quantified] = STATE(282),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(282),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [138] = {
    [sym_special_call] = STATE(244),
    [sym_prefix_cast] = STATE(244),
    [sym_unary_expr] = STATE(244),
    [sym_mul_expr] = STATE(244),
    [sym_add_expr] = STATE(244),
    [sym_in_expr] = STATE(244),
    [sym_comp_term] = STATE(244),
    [sym_instance_of] = STATE(244),
    [sym_negation] = STATE(244),
    [sym_if_term] = STATE(244),
    [sym_conjunction] = STATE(244),
    [sym_disjunction] = STATE(244),
    [sym_implication] = STATE(244),
    [sym_quantified] = STATE(244),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(244),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [139] = {
    [sym_special_call] = STATE(689),
    [sym_prefix_cast] = STATE(689),
    [sym_unary_expr] = STATE(689),
    [sym_mul_expr] = STATE(689),
    [sym_add_expr] = STATE(689),
    [sym_in_expr] = STATE(689),
    [sym_comp_term] = STATE(689),
    [sym_instance_of] = STATE(689),
    [sym_negation] = STATE(689),
    [sym_if_term] = STATE(689),
    [sym_conjunction] = STATE(689),
    [sym_disjunction] = STATE(689),
    [sym_implication] = STATE(689),
    [sym_quantified] = STATE(689),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(689),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [140] = {
    [sym_special_call] = STATE(269),
    [sym_prefix_cast] = STATE(269),
    [sym_unary_expr] = STATE(269),
    [sym_mul_expr] = STATE(269),
    [sym_add_expr] = STATE(269),
    [sym_in_expr] = STATE(269),
    [sym_comp_term] = STATE(269),
    [sym_instance_of] = STATE(269),
    [sym_negation] = STATE(269),
    [sym_if_term] = STATE(269),
    [sym_conjunction] = STATE(269),
    [sym_disjunction] = STATE(269),
    [sym_implication] = STATE(269),
    [sym_quantified] = STATE(269),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(269),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [141] = {
    [sym_special_call] = STATE(281),
    [sym_prefix_cast] = STATE(281),
    [sym_unary_expr] = STATE(281),
    [sym_mul_expr] = STATE(281),
    [sym_add_expr] = STATE(281),
    [sym_in_expr] = STATE(281),
    [sym_comp_term] = STATE(281),
    [sym_instance_of] = STATE(281),
    [sym_negation] = STATE(281),
    [sym_if_term] = STATE(281),
    [sym_conjunction] = STATE(281),
    [sym_disjunction] = STATE(281),
    [sym_implication] = STATE(281),
    [sym_quantified] = STATE(281),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(281),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [142] = {
    [sym_special_call] = STATE(508),
    [sym_prefix_cast] = STATE(508),
    [sym_unary_expr] = STATE(508),
    [sym_mul_expr] = STATE(508),
    [sym_add_expr] = STATE(508),
    [sym_in_expr] = STATE(508),
    [sym_comp_term] = STATE(508),
    [sym_instance_of] = STATE(508),
    [sym_negation] = STATE(508),
    [sym_if_term] = STATE(508),
    [sym_conjunction] = STATE(508),
    [sym_disjunction] = STATE(508),
    [sym_implication] = STATE(508),
    [sym_quantified] = STATE(508),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(508),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [143] = {
    [sym_special_call] = STATE(697),
    [sym_prefix_cast] = STATE(697),
    [sym_unary_expr] = STATE(697),
    [sym_mul_expr] = STATE(697),
    [sym_add_expr] = STATE(697),
    [sym_in_expr] = STATE(697),
    [sym_comp_term] = STATE(697),
    [sym_instance_of] = STATE(697),
    [sym_negation] = STATE(697),
    [sym_if_term] = STATE(697),
    [sym_conjunction] = STATE(697),
    [sym_disjunction] = STATE(697),
    [sym_implication] = STATE(697),
    [sym_quantified] = STATE(697),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(697),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [144] = {
    [sym_special_call] = STATE(698),
    [sym_prefix_cast] = STATE(698),
    [sym_unary_expr] = STATE(698),
    [sym_mul_expr] = STATE(698),
    [sym_add_expr] = STATE(698),
    [sym_in_expr] = STATE(698),
    [sym_comp_term] = STATE(698),
    [sym_instance_of] = STATE(698),
    [sym_negation] = STATE(698),
    [sym_if_term] = STATE(698),
    [sym_conjunction] = STATE(698),
    [sym_disjunction] = STATE(698),
    [sym_implication] = STATE(698),
    [sym_quantified] = STATE(698),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(698),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [145] = {
    [sym_special_call] = STATE(268),
    [sym_prefix_cast] = STATE(268),
    [sym_unary_expr] = STATE(268),
    [sym_mul_expr] = STATE(268),
    [sym_add_expr] = STATE(268),
    [sym_in_expr] = STATE(268),
    [sym_comp_term] = STATE(268),
    [sym_instance_of] = STATE(268),
    [sym_negation] = STATE(268),
    [sym_if_term] = STATE(268),
    [sym_conjunction] = STATE(268),
    [sym_disjunction] = STATE(268),
    [sym_implication] = STATE(268),
    [sym_quantified] = STATE(268),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(268),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [146] = {
    [sym_special_call] = STATE(279),
    [sym_prefix_cast] = STATE(279),
    [sym_unary_expr] = STATE(279),
    [sym_mul_expr] = STATE(279),
    [sym_add_expr] = STATE(279),
    [sym_in_expr] = STATE(279),
    [sym_comp_term] = STATE(279),
    [sym_instance_of] = STATE(279),
    [sym_negation] = STATE(279),
    [sym_if_term] = STATE(279),
    [sym_conjunction] = STATE(279),
    [sym_disjunction] = STATE(279),
    [sym_implication] = STATE(279),
    [sym_quantified] = STATE(279),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(279),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [147] = {
    [sym_special_call] = STATE(588),
    [sym_prefix_cast] = STATE(588),
    [sym_unary_expr] = STATE(588),
    [sym_mul_expr] = STATE(588),
    [sym_add_expr] = STATE(588),
    [sym_in_expr] = STATE(588),
    [sym_comp_term] = STATE(588),
    [sym_instance_of] = STATE(588),
    [sym_negation] = STATE(588),
    [sym_if_term] = STATE(588),
    [sym_conjunction] = STATE(588),
    [sym_disjunction] = STATE(588),
    [sym_implication] = STATE(588),
    [sym_quantified] = STATE(588),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(588),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [148] = {
    [sym_special_call] = STATE(687),
    [sym_prefix_cast] = STATE(687),
    [sym_unary_expr] = STATE(687),
    [sym_mul_expr] = STATE(687),
    [sym_add_expr] = STATE(687),
    [sym_in_expr] = STATE(687),
    [sym_comp_term] = STATE(687),
    [sym_instance_of] = STATE(687),
    [sym_negation] = STATE(687),
    [sym_if_term] = STATE(687),
    [sym_conjunction] = STATE(687),
    [sym_disjunction] = STATE(687),
    [sym_implication] = STATE(687),
    [sym_quantified] = STATE(687),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(687),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1113),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [149] = {
    [sym_special_call] = STATE(723),
    [sym_prefix_cast] = STATE(723),
    [sym_unary_expr] = STATE(723),
    [sym_mul_expr] = STATE(723),
    [sym_add_expr] = STATE(723),
    [sym_in_expr] = STATE(723),
    [sym_comp_term] = STATE(723),
    [sym_instance_of] = STATE(723),
    [sym_negation] = STATE(723),
    [sym_if_term] = STATE(723),
    [sym_conjunction] = STATE(723),
    [sym_disjunction] = STATE(723),
    [sym_implication] = STATE(723),
    [sym_quantified] = STATE(723),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(723),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [150] = {
    [sym_special_call] = STATE(277),
    [sym_prefix_cast] = STATE(277),
    [sym_unary_expr] = STATE(277),
    [sym_mul_expr] = STATE(277),
    [sym_add_expr] = STATE(277),
    [sym_in_expr] = STATE(277),
    [sym_comp_term] = STATE(277),
    [sym_instance_of] = STATE(277),
    [sym_negation] = STATE(277),
    [sym_if_term] = STATE(277),
    [sym_conjunction] = STATE(277),
    [sym_disjunction] = STATE(277),
    [sym_implication] = STATE(277),
    [sym_quantified] = STATE(277),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(277),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [151] = {
    [sym_special_call] = STATE(266),
    [sym_prefix_cast] = STATE(266),
    [sym_unary_expr] = STATE(266),
    [sym_mul_expr] = STATE(266),
    [sym_add_expr] = STATE(266),
    [sym_in_expr] = STATE(266),
    [sym_comp_term] = STATE(266),
    [sym_instance_of] = STATE(266),
    [sym_negation] = STATE(266),
    [sym_if_term] = STATE(266),
    [sym_conjunction] = STATE(266),
    [sym_disjunction] = STATE(266),
    [sym_implication] = STATE(266),
    [sym_quantified] = STATE(266),
    [sym_specialId] = STATE(1145),
    [sym_quantifier] = STATE(1146),
    [sym_classless_predicate_call] = STATE(301),
    [sym_qualified_expr] = STATE(301),
    [sym_super_ref] = STATE(301),
    [sym_aggregate] = STATE(301),
    [sym_range] = STATE(301),
    [sym_par_expr] = STATE(301),
    [sym__exprOrTerm] = STATE(266),
    [sym__primary] = STATE(301),
    [sym_literal] = STATE(301),
    [sym_bool] = STATE(305),
    [sym_variable] = STATE(301),
    [sym_unop] = STATE(150),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(296),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1139),
    [sym_aritylessPredicateExpr] = STATE(918),
    [sym_varName] = STATE(303),
    [sym_aggId] = STATE(1124),
    [sym__lower_id] = ACTIONS(273),
    [anon_sym_LPAREN] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(277),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(281),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(283),
    [sym_float] = ACTIONS(285),
    [sym_string] = ACTIONS(285),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(287),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(289),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(291),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(293),
    [sym_this] = ACTIONS(291),
    [sym_true] = ACTIONS(287),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [152] = {
    [sym_special_call] = STATE(705),
    [sym_prefix_cast] = STATE(705),
    [sym_unary_expr] = STATE(705),
    [sym_mul_expr] = STATE(705),
    [sym_add_expr] = STATE(705),
    [sym_in_expr] = STATE(705),
    [sym_comp_term] = STATE(705),
    [sym_instance_of] = STATE(705),
    [sym_negation] = STATE(705),
    [sym_if_term] = STATE(705),
    [sym_conjunction] = STATE(705),
    [sym_disjunction] = STATE(705),
    [sym_implication] = STATE(705),
    [sym_quantified] = STATE(705),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(705),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [153] = {
    [sym_special_call] = STATE(579),
    [sym_prefix_cast] = STATE(579),
    [sym_unary_expr] = STATE(579),
    [sym_mul_expr] = STATE(579),
    [sym_add_expr] = STATE(579),
    [sym_in_expr] = STATE(579),
    [sym_comp_term] = STATE(579),
    [sym_instance_of] = STATE(579),
    [sym_negation] = STATE(579),
    [sym_if_term] = STATE(579),
    [sym_conjunction] = STATE(579),
    [sym_disjunction] = STATE(579),
    [sym_implication] = STATE(579),
    [sym_quantified] = STATE(579),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(579),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [154] = {
    [sym_special_call] = STATE(556),
    [sym_prefix_cast] = STATE(556),
    [sym_unary_expr] = STATE(556),
    [sym_mul_expr] = STATE(556),
    [sym_add_expr] = STATE(556),
    [sym_in_expr] = STATE(556),
    [sym_comp_term] = STATE(556),
    [sym_instance_of] = STATE(556),
    [sym_negation] = STATE(556),
    [sym_if_term] = STATE(556),
    [sym_conjunction] = STATE(556),
    [sym_disjunction] = STATE(556),
    [sym_implication] = STATE(556),
    [sym_quantified] = STATE(556),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(556),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [155] = {
    [sym_special_call] = STATE(545),
    [sym_prefix_cast] = STATE(545),
    [sym_unary_expr] = STATE(545),
    [sym_mul_expr] = STATE(545),
    [sym_add_expr] = STATE(545),
    [sym_in_expr] = STATE(545),
    [sym_comp_term] = STATE(545),
    [sym_instance_of] = STATE(545),
    [sym_negation] = STATE(545),
    [sym_if_term] = STATE(545),
    [sym_conjunction] = STATE(545),
    [sym_disjunction] = STATE(545),
    [sym_implication] = STATE(545),
    [sym_quantified] = STATE(545),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(545),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [156] = {
    [sym_special_call] = STATE(514),
    [sym_prefix_cast] = STATE(514),
    [sym_unary_expr] = STATE(514),
    [sym_mul_expr] = STATE(514),
    [sym_add_expr] = STATE(514),
    [sym_in_expr] = STATE(514),
    [sym_comp_term] = STATE(514),
    [sym_instance_of] = STATE(514),
    [sym_negation] = STATE(514),
    [sym_if_term] = STATE(514),
    [sym_conjunction] = STATE(514),
    [sym_disjunction] = STATE(514),
    [sym_implication] = STATE(514),
    [sym_quantified] = STATE(514),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(514),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [157] = {
    [sym_special_call] = STATE(729),
    [sym_prefix_cast] = STATE(729),
    [sym_unary_expr] = STATE(729),
    [sym_mul_expr] = STATE(729),
    [sym_add_expr] = STATE(729),
    [sym_in_expr] = STATE(729),
    [sym_comp_term] = STATE(729),
    [sym_instance_of] = STATE(729),
    [sym_negation] = STATE(729),
    [sym_if_term] = STATE(729),
    [sym_conjunction] = STATE(729),
    [sym_disjunction] = STATE(729),
    [sym_implication] = STATE(729),
    [sym_quantified] = STATE(729),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(729),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [158] = {
    [sym_special_call] = STATE(732),
    [sym_prefix_cast] = STATE(732),
    [sym_unary_expr] = STATE(732),
    [sym_mul_expr] = STATE(732),
    [sym_add_expr] = STATE(732),
    [sym_in_expr] = STATE(732),
    [sym_comp_term] = STATE(732),
    [sym_instance_of] = STATE(732),
    [sym_negation] = STATE(732),
    [sym_if_term] = STATE(732),
    [sym_conjunction] = STATE(732),
    [sym_disjunction] = STATE(732),
    [sym_implication] = STATE(732),
    [sym_quantified] = STATE(732),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(732),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [159] = {
    [sym_special_call] = STATE(513),
    [sym_prefix_cast] = STATE(513),
    [sym_unary_expr] = STATE(513),
    [sym_mul_expr] = STATE(513),
    [sym_add_expr] = STATE(513),
    [sym_in_expr] = STATE(513),
    [sym_comp_term] = STATE(513),
    [sym_instance_of] = STATE(513),
    [sym_negation] = STATE(513),
    [sym_if_term] = STATE(513),
    [sym_conjunction] = STATE(513),
    [sym_disjunction] = STATE(513),
    [sym_implication] = STATE(513),
    [sym_quantified] = STATE(513),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(513),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [160] = {
    [sym_special_call] = STATE(534),
    [sym_prefix_cast] = STATE(534),
    [sym_unary_expr] = STATE(534),
    [sym_mul_expr] = STATE(534),
    [sym_add_expr] = STATE(534),
    [sym_in_expr] = STATE(534),
    [sym_comp_term] = STATE(534),
    [sym_instance_of] = STATE(534),
    [sym_negation] = STATE(534),
    [sym_if_term] = STATE(534),
    [sym_conjunction] = STATE(534),
    [sym_disjunction] = STATE(534),
    [sym_implication] = STATE(534),
    [sym_quantified] = STATE(534),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(534),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [161] = {
    [sym_special_call] = STATE(570),
    [sym_prefix_cast] = STATE(570),
    [sym_unary_expr] = STATE(570),
    [sym_mul_expr] = STATE(570),
    [sym_add_expr] = STATE(570),
    [sym_in_expr] = STATE(570),
    [sym_comp_term] = STATE(570),
    [sym_instance_of] = STATE(570),
    [sym_negation] = STATE(570),
    [sym_if_term] = STATE(570),
    [sym_conjunction] = STATE(570),
    [sym_disjunction] = STATE(570),
    [sym_implication] = STATE(570),
    [sym_quantified] = STATE(570),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(570),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [162] = {
    [sym_special_call] = STATE(695),
    [sym_prefix_cast] = STATE(695),
    [sym_unary_expr] = STATE(695),
    [sym_mul_expr] = STATE(695),
    [sym_add_expr] = STATE(695),
    [sym_in_expr] = STATE(695),
    [sym_comp_term] = STATE(695),
    [sym_instance_of] = STATE(695),
    [sym_negation] = STATE(695),
    [sym_if_term] = STATE(695),
    [sym_conjunction] = STATE(695),
    [sym_disjunction] = STATE(695),
    [sym_implication] = STATE(695),
    [sym_quantified] = STATE(695),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(695),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [163] = {
    [sym_special_call] = STATE(536),
    [sym_prefix_cast] = STATE(536),
    [sym_unary_expr] = STATE(536),
    [sym_mul_expr] = STATE(536),
    [sym_add_expr] = STATE(536),
    [sym_in_expr] = STATE(536),
    [sym_comp_term] = STATE(536),
    [sym_instance_of] = STATE(536),
    [sym_negation] = STATE(536),
    [sym_if_term] = STATE(536),
    [sym_conjunction] = STATE(536),
    [sym_disjunction] = STATE(536),
    [sym_implication] = STATE(536),
    [sym_quantified] = STATE(536),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(536),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [164] = {
    [sym_special_call] = STATE(537),
    [sym_prefix_cast] = STATE(537),
    [sym_unary_expr] = STATE(537),
    [sym_mul_expr] = STATE(537),
    [sym_add_expr] = STATE(537),
    [sym_in_expr] = STATE(537),
    [sym_comp_term] = STATE(537),
    [sym_instance_of] = STATE(537),
    [sym_negation] = STATE(537),
    [sym_if_term] = STATE(537),
    [sym_conjunction] = STATE(537),
    [sym_disjunction] = STATE(537),
    [sym_implication] = STATE(537),
    [sym_quantified] = STATE(537),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(537),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [165] = {
    [sym_special_call] = STATE(696),
    [sym_prefix_cast] = STATE(696),
    [sym_unary_expr] = STATE(696),
    [sym_mul_expr] = STATE(696),
    [sym_add_expr] = STATE(696),
    [sym_in_expr] = STATE(696),
    [sym_comp_term] = STATE(696),
    [sym_instance_of] = STATE(696),
    [sym_negation] = STATE(696),
    [sym_if_term] = STATE(696),
    [sym_conjunction] = STATE(696),
    [sym_disjunction] = STATE(696),
    [sym_implication] = STATE(696),
    [sym_quantified] = STATE(696),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(696),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [166] = {
    [sym_special_call] = STATE(538),
    [sym_prefix_cast] = STATE(538),
    [sym_unary_expr] = STATE(538),
    [sym_mul_expr] = STATE(538),
    [sym_add_expr] = STATE(538),
    [sym_in_expr] = STATE(538),
    [sym_comp_term] = STATE(538),
    [sym_instance_of] = STATE(538),
    [sym_negation] = STATE(538),
    [sym_if_term] = STATE(538),
    [sym_conjunction] = STATE(538),
    [sym_disjunction] = STATE(538),
    [sym_implication] = STATE(538),
    [sym_quantified] = STATE(538),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(538),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [167] = {
    [sym_special_call] = STATE(286),
    [sym_prefix_cast] = STATE(286),
    [sym_unary_expr] = STATE(286),
    [sym_mul_expr] = STATE(286),
    [sym_add_expr] = STATE(286),
    [sym_in_expr] = STATE(286),
    [sym_comp_term] = STATE(286),
    [sym_instance_of] = STATE(286),
    [sym_negation] = STATE(286),
    [sym_if_term] = STATE(286),
    [sym_conjunction] = STATE(286),
    [sym_disjunction] = STATE(286),
    [sym_implication] = STATE(286),
    [sym_quantified] = STATE(286),
    [sym_specialId] = STATE(1165),
    [sym_quantifier] = STATE(1166),
    [sym_classless_predicate_call] = STATE(335),
    [sym_qualified_expr] = STATE(335),
    [sym_super_ref] = STATE(335),
    [sym_aggregate] = STATE(335),
    [sym_range] = STATE(335),
    [sym_par_expr] = STATE(335),
    [sym__exprOrTerm] = STATE(286),
    [sym__primary] = STATE(335),
    [sym_literal] = STATE(335),
    [sym_bool] = STATE(331),
    [sym_variable] = STATE(335),
    [sym_unop] = STATE(114),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(295),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1167),
    [sym_aritylessPredicateExpr] = STATE(923),
    [sym_varName] = STATE(333),
    [sym_aggId] = STATE(1122),
    [sym__lower_id] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(355),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(357),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(359),
    [sym_float] = ACTIONS(361),
    [sym_string] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(363),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(365),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(367),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(369),
    [sym_this] = ACTIONS(367),
    [sym_true] = ACTIONS(363),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [168] = {
    [sym_special_call] = STATE(539),
    [sym_prefix_cast] = STATE(539),
    [sym_unary_expr] = STATE(539),
    [sym_mul_expr] = STATE(539),
    [sym_add_expr] = STATE(539),
    [sym_in_expr] = STATE(539),
    [sym_comp_term] = STATE(539),
    [sym_instance_of] = STATE(539),
    [sym_negation] = STATE(539),
    [sym_if_term] = STATE(539),
    [sym_conjunction] = STATE(539),
    [sym_disjunction] = STATE(539),
    [sym_implication] = STATE(539),
    [sym_quantified] = STATE(539),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(539),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [169] = {
    [sym_special_call] = STATE(649),
    [sym_prefix_cast] = STATE(649),
    [sym_unary_expr] = STATE(649),
    [sym_mul_expr] = STATE(649),
    [sym_add_expr] = STATE(649),
    [sym_in_expr] = STATE(649),
    [sym_comp_term] = STATE(649),
    [sym_instance_of] = STATE(649),
    [sym_negation] = STATE(649),
    [sym_if_term] = STATE(649),
    [sym_conjunction] = STATE(649),
    [sym_disjunction] = STATE(649),
    [sym_implication] = STATE(649),
    [sym_quantified] = STATE(649),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(649),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [170] = {
    [sym_special_call] = STATE(741),
    [sym_prefix_cast] = STATE(741),
    [sym_unary_expr] = STATE(741),
    [sym_mul_expr] = STATE(741),
    [sym_add_expr] = STATE(741),
    [sym_in_expr] = STATE(741),
    [sym_comp_term] = STATE(741),
    [sym_instance_of] = STATE(741),
    [sym_negation] = STATE(741),
    [sym_if_term] = STATE(741),
    [sym_conjunction] = STATE(741),
    [sym_disjunction] = STATE(741),
    [sym_implication] = STATE(741),
    [sym_quantified] = STATE(741),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(741),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1125),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [171] = {
    [sym_special_call] = STATE(711),
    [sym_prefix_cast] = STATE(711),
    [sym_unary_expr] = STATE(711),
    [sym_mul_expr] = STATE(711),
    [sym_add_expr] = STATE(711),
    [sym_in_expr] = STATE(711),
    [sym_comp_term] = STATE(711),
    [sym_instance_of] = STATE(711),
    [sym_negation] = STATE(711),
    [sym_if_term] = STATE(711),
    [sym_conjunction] = STATE(711),
    [sym_disjunction] = STATE(711),
    [sym_implication] = STATE(711),
    [sym_quantified] = STATE(711),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(711),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [172] = {
    [sym_special_call] = STATE(713),
    [sym_prefix_cast] = STATE(713),
    [sym_unary_expr] = STATE(713),
    [sym_mul_expr] = STATE(713),
    [sym_add_expr] = STATE(713),
    [sym_in_expr] = STATE(713),
    [sym_comp_term] = STATE(713),
    [sym_instance_of] = STATE(713),
    [sym_negation] = STATE(713),
    [sym_if_term] = STATE(713),
    [sym_conjunction] = STATE(713),
    [sym_disjunction] = STATE(713),
    [sym_implication] = STATE(713),
    [sym_quantified] = STATE(713),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(713),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [173] = {
    [sym_special_call] = STATE(532),
    [sym_prefix_cast] = STATE(532),
    [sym_unary_expr] = STATE(532),
    [sym_mul_expr] = STATE(532),
    [sym_add_expr] = STATE(532),
    [sym_in_expr] = STATE(532),
    [sym_comp_term] = STATE(532),
    [sym_instance_of] = STATE(532),
    [sym_negation] = STATE(532),
    [sym_if_term] = STATE(532),
    [sym_conjunction] = STATE(532),
    [sym_disjunction] = STATE(532),
    [sym_implication] = STATE(532),
    [sym_quantified] = STATE(532),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(532),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [174] = {
    [sym_special_call] = STATE(535),
    [sym_prefix_cast] = STATE(535),
    [sym_unary_expr] = STATE(535),
    [sym_mul_expr] = STATE(535),
    [sym_add_expr] = STATE(535),
    [sym_in_expr] = STATE(535),
    [sym_comp_term] = STATE(535),
    [sym_instance_of] = STATE(535),
    [sym_negation] = STATE(535),
    [sym_if_term] = STATE(535),
    [sym_conjunction] = STATE(535),
    [sym_disjunction] = STATE(535),
    [sym_implication] = STATE(535),
    [sym_quantified] = STATE(535),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(535),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [175] = {
    [sym_special_call] = STATE(675),
    [sym_prefix_cast] = STATE(675),
    [sym_unary_expr] = STATE(675),
    [sym_mul_expr] = STATE(675),
    [sym_add_expr] = STATE(675),
    [sym_in_expr] = STATE(675),
    [sym_comp_term] = STATE(675),
    [sym_instance_of] = STATE(675),
    [sym_negation] = STATE(675),
    [sym_if_term] = STATE(675),
    [sym_conjunction] = STATE(675),
    [sym_disjunction] = STATE(675),
    [sym_implication] = STATE(675),
    [sym_quantified] = STATE(675),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(675),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [176] = {
    [sym_special_call] = STATE(647),
    [sym_prefix_cast] = STATE(647),
    [sym_unary_expr] = STATE(647),
    [sym_mul_expr] = STATE(647),
    [sym_add_expr] = STATE(647),
    [sym_in_expr] = STATE(647),
    [sym_comp_term] = STATE(647),
    [sym_instance_of] = STATE(647),
    [sym_negation] = STATE(647),
    [sym_if_term] = STATE(647),
    [sym_conjunction] = STATE(647),
    [sym_disjunction] = STATE(647),
    [sym_implication] = STATE(647),
    [sym_quantified] = STATE(647),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(647),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [177] = {
    [sym_special_call] = STATE(608),
    [sym_prefix_cast] = STATE(608),
    [sym_unary_expr] = STATE(608),
    [sym_mul_expr] = STATE(608),
    [sym_add_expr] = STATE(608),
    [sym_in_expr] = STATE(608),
    [sym_comp_term] = STATE(608),
    [sym_instance_of] = STATE(608),
    [sym_negation] = STATE(608),
    [sym_if_term] = STATE(608),
    [sym_conjunction] = STATE(608),
    [sym_disjunction] = STATE(608),
    [sym_implication] = STATE(608),
    [sym_quantified] = STATE(608),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(608),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [178] = {
    [sym_special_call] = STATE(616),
    [sym_prefix_cast] = STATE(616),
    [sym_unary_expr] = STATE(616),
    [sym_mul_expr] = STATE(616),
    [sym_add_expr] = STATE(616),
    [sym_in_expr] = STATE(616),
    [sym_comp_term] = STATE(616),
    [sym_instance_of] = STATE(616),
    [sym_negation] = STATE(616),
    [sym_if_term] = STATE(616),
    [sym_conjunction] = STATE(616),
    [sym_disjunction] = STATE(616),
    [sym_implication] = STATE(616),
    [sym_quantified] = STATE(616),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(616),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [179] = {
    [sym_special_call] = STATE(714),
    [sym_prefix_cast] = STATE(714),
    [sym_unary_expr] = STATE(714),
    [sym_mul_expr] = STATE(714),
    [sym_add_expr] = STATE(714),
    [sym_in_expr] = STATE(714),
    [sym_comp_term] = STATE(714),
    [sym_instance_of] = STATE(714),
    [sym_negation] = STATE(714),
    [sym_if_term] = STATE(714),
    [sym_conjunction] = STATE(714),
    [sym_disjunction] = STATE(714),
    [sym_implication] = STATE(714),
    [sym_quantified] = STATE(714),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(714),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [180] = {
    [sym_special_call] = STATE(531),
    [sym_prefix_cast] = STATE(531),
    [sym_unary_expr] = STATE(531),
    [sym_mul_expr] = STATE(531),
    [sym_add_expr] = STATE(531),
    [sym_in_expr] = STATE(531),
    [sym_comp_term] = STATE(531),
    [sym_instance_of] = STATE(531),
    [sym_negation] = STATE(531),
    [sym_if_term] = STATE(531),
    [sym_conjunction] = STATE(531),
    [sym_disjunction] = STATE(531),
    [sym_implication] = STATE(531),
    [sym_quantified] = STATE(531),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(531),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [181] = {
    [sym_special_call] = STATE(544),
    [sym_prefix_cast] = STATE(544),
    [sym_unary_expr] = STATE(544),
    [sym_mul_expr] = STATE(544),
    [sym_add_expr] = STATE(544),
    [sym_in_expr] = STATE(544),
    [sym_comp_term] = STATE(544),
    [sym_instance_of] = STATE(544),
    [sym_negation] = STATE(544),
    [sym_if_term] = STATE(544),
    [sym_conjunction] = STATE(544),
    [sym_disjunction] = STATE(544),
    [sym_implication] = STATE(544),
    [sym_quantified] = STATE(544),
    [sym_specialId] = STATE(1143),
    [sym_quantifier] = STATE(1142),
    [sym_classless_predicate_call] = STATE(566),
    [sym_qualified_expr] = STATE(566),
    [sym_super_ref] = STATE(566),
    [sym_aggregate] = STATE(566),
    [sym_range] = STATE(566),
    [sym_par_expr] = STATE(566),
    [sym__exprOrTerm] = STATE(544),
    [sym__primary] = STATE(566),
    [sym_literal] = STATE(566),
    [sym_bool] = STATE(562),
    [sym_variable] = STATE(566),
    [sym_unop] = STATE(180),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(553),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1147),
    [sym_aritylessPredicateExpr] = STATE(907),
    [sym_varName] = STATE(564),
    [sym_aggId] = STATE(1129),
    [sym__lower_id] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(47),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(49),
    [sym_float] = ACTIONS(51),
    [sym_string] = ACTIONS(51),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(57),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(59),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(63),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(65),
    [sym_this] = ACTIONS(63),
    [sym_true] = ACTIONS(57),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [182] = {
    [sym_special_call] = STATE(520),
    [sym_prefix_cast] = STATE(520),
    [sym_unary_expr] = STATE(520),
    [sym_mul_expr] = STATE(520),
    [sym_add_expr] = STATE(520),
    [sym_in_expr] = STATE(520),
    [sym_comp_term] = STATE(520),
    [sym_instance_of] = STATE(520),
    [sym_negation] = STATE(520),
    [sym_if_term] = STATE(520),
    [sym_conjunction] = STATE(520),
    [sym_disjunction] = STATE(520),
    [sym_implication] = STATE(520),
    [sym_quantified] = STATE(520),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(520),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [183] = {
    [sym_special_call] = STATE(628),
    [sym_prefix_cast] = STATE(628),
    [sym_unary_expr] = STATE(628),
    [sym_mul_expr] = STATE(628),
    [sym_add_expr] = STATE(628),
    [sym_in_expr] = STATE(628),
    [sym_comp_term] = STATE(628),
    [sym_instance_of] = STATE(628),
    [sym_negation] = STATE(628),
    [sym_if_term] = STATE(628),
    [sym_conjunction] = STATE(628),
    [sym_disjunction] = STATE(628),
    [sym_implication] = STATE(628),
    [sym_quantified] = STATE(628),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(628),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [184] = {
    [sym_special_call] = STATE(644),
    [sym_prefix_cast] = STATE(644),
    [sym_unary_expr] = STATE(644),
    [sym_mul_expr] = STATE(644),
    [sym_add_expr] = STATE(644),
    [sym_in_expr] = STATE(644),
    [sym_comp_term] = STATE(644),
    [sym_instance_of] = STATE(644),
    [sym_negation] = STATE(644),
    [sym_if_term] = STATE(644),
    [sym_conjunction] = STATE(644),
    [sym_disjunction] = STATE(644),
    [sym_implication] = STATE(644),
    [sym_quantified] = STATE(644),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(644),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [185] = {
    [sym_special_call] = STATE(530),
    [sym_prefix_cast] = STATE(530),
    [sym_unary_expr] = STATE(530),
    [sym_mul_expr] = STATE(530),
    [sym_add_expr] = STATE(530),
    [sym_in_expr] = STATE(530),
    [sym_comp_term] = STATE(530),
    [sym_instance_of] = STATE(530),
    [sym_negation] = STATE(530),
    [sym_if_term] = STATE(530),
    [sym_conjunction] = STATE(530),
    [sym_disjunction] = STATE(530),
    [sym_implication] = STATE(530),
    [sym_quantified] = STATE(530),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(530),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [186] = {
    [sym_special_call] = STATE(522),
    [sym_prefix_cast] = STATE(522),
    [sym_unary_expr] = STATE(522),
    [sym_mul_expr] = STATE(522),
    [sym_add_expr] = STATE(522),
    [sym_in_expr] = STATE(522),
    [sym_comp_term] = STATE(522),
    [sym_instance_of] = STATE(522),
    [sym_negation] = STATE(522),
    [sym_if_term] = STATE(522),
    [sym_conjunction] = STATE(522),
    [sym_disjunction] = STATE(522),
    [sym_implication] = STATE(522),
    [sym_quantified] = STATE(522),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(522),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [187] = {
    [sym_special_call] = STATE(527),
    [sym_prefix_cast] = STATE(527),
    [sym_unary_expr] = STATE(527),
    [sym_mul_expr] = STATE(527),
    [sym_add_expr] = STATE(527),
    [sym_in_expr] = STATE(527),
    [sym_comp_term] = STATE(527),
    [sym_instance_of] = STATE(527),
    [sym_negation] = STATE(527),
    [sym_if_term] = STATE(527),
    [sym_conjunction] = STATE(527),
    [sym_disjunction] = STATE(527),
    [sym_implication] = STATE(527),
    [sym_quantified] = STATE(527),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(527),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [188] = {
    [sym_special_call] = STATE(529),
    [sym_prefix_cast] = STATE(529),
    [sym_unary_expr] = STATE(529),
    [sym_mul_expr] = STATE(529),
    [sym_add_expr] = STATE(529),
    [sym_in_expr] = STATE(529),
    [sym_comp_term] = STATE(529),
    [sym_instance_of] = STATE(529),
    [sym_negation] = STATE(529),
    [sym_if_term] = STATE(529),
    [sym_conjunction] = STATE(529),
    [sym_disjunction] = STATE(529),
    [sym_implication] = STATE(529),
    [sym_quantified] = STATE(529),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(529),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [189] = {
    [sym_special_call] = STATE(526),
    [sym_prefix_cast] = STATE(526),
    [sym_unary_expr] = STATE(526),
    [sym_mul_expr] = STATE(526),
    [sym_add_expr] = STATE(526),
    [sym_in_expr] = STATE(526),
    [sym_comp_term] = STATE(526),
    [sym_instance_of] = STATE(526),
    [sym_negation] = STATE(526),
    [sym_if_term] = STATE(526),
    [sym_conjunction] = STATE(526),
    [sym_disjunction] = STATE(526),
    [sym_implication] = STATE(526),
    [sym_quantified] = STATE(526),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(526),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [190] = {
    [sym_special_call] = STATE(521),
    [sym_prefix_cast] = STATE(521),
    [sym_unary_expr] = STATE(521),
    [sym_mul_expr] = STATE(521),
    [sym_add_expr] = STATE(521),
    [sym_in_expr] = STATE(521),
    [sym_comp_term] = STATE(521),
    [sym_instance_of] = STATE(521),
    [sym_negation] = STATE(521),
    [sym_if_term] = STATE(521),
    [sym_conjunction] = STATE(521),
    [sym_disjunction] = STATE(521),
    [sym_implication] = STATE(521),
    [sym_quantified] = STATE(521),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(521),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [191] = {
    [sym_special_call] = STATE(525),
    [sym_prefix_cast] = STATE(525),
    [sym_unary_expr] = STATE(525),
    [sym_mul_expr] = STATE(525),
    [sym_add_expr] = STATE(525),
    [sym_in_expr] = STATE(525),
    [sym_comp_term] = STATE(525),
    [sym_instance_of] = STATE(525),
    [sym_negation] = STATE(525),
    [sym_if_term] = STATE(525),
    [sym_conjunction] = STATE(525),
    [sym_disjunction] = STATE(525),
    [sym_implication] = STATE(525),
    [sym_quantified] = STATE(525),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(525),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [192] = {
    [sym_special_call] = STATE(267),
    [sym_prefix_cast] = STATE(267),
    [sym_unary_expr] = STATE(267),
    [sym_mul_expr] = STATE(267),
    [sym_add_expr] = STATE(267),
    [sym_in_expr] = STATE(267),
    [sym_comp_term] = STATE(267),
    [sym_instance_of] = STATE(267),
    [sym_negation] = STATE(267),
    [sym_if_term] = STATE(267),
    [sym_conjunction] = STATE(267),
    [sym_disjunction] = STATE(267),
    [sym_implication] = STATE(267),
    [sym_quantified] = STATE(267),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(267),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [193] = {
    [sym_special_call] = STATE(640),
    [sym_prefix_cast] = STATE(640),
    [sym_unary_expr] = STATE(640),
    [sym_mul_expr] = STATE(640),
    [sym_add_expr] = STATE(640),
    [sym_in_expr] = STATE(640),
    [sym_comp_term] = STATE(640),
    [sym_instance_of] = STATE(640),
    [sym_negation] = STATE(640),
    [sym_if_term] = STATE(640),
    [sym_conjunction] = STATE(640),
    [sym_disjunction] = STATE(640),
    [sym_implication] = STATE(640),
    [sym_quantified] = STATE(640),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(640),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [194] = {
    [sym_special_call] = STATE(718),
    [sym_prefix_cast] = STATE(718),
    [sym_unary_expr] = STATE(718),
    [sym_mul_expr] = STATE(718),
    [sym_add_expr] = STATE(718),
    [sym_in_expr] = STATE(718),
    [sym_comp_term] = STATE(718),
    [sym_instance_of] = STATE(718),
    [sym_negation] = STATE(718),
    [sym_if_term] = STATE(718),
    [sym_conjunction] = STATE(718),
    [sym_disjunction] = STATE(718),
    [sym_implication] = STATE(718),
    [sym_quantified] = STATE(718),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(718),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [195] = {
    [sym_special_call] = STATE(719),
    [sym_prefix_cast] = STATE(719),
    [sym_unary_expr] = STATE(719),
    [sym_mul_expr] = STATE(719),
    [sym_add_expr] = STATE(719),
    [sym_in_expr] = STATE(719),
    [sym_comp_term] = STATE(719),
    [sym_instance_of] = STATE(719),
    [sym_negation] = STATE(719),
    [sym_if_term] = STATE(719),
    [sym_conjunction] = STATE(719),
    [sym_disjunction] = STATE(719),
    [sym_implication] = STATE(719),
    [sym_quantified] = STATE(719),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(719),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [196] = {
    [sym_special_call] = STATE(686),
    [sym_prefix_cast] = STATE(686),
    [sym_unary_expr] = STATE(686),
    [sym_mul_expr] = STATE(686),
    [sym_add_expr] = STATE(686),
    [sym_in_expr] = STATE(686),
    [sym_comp_term] = STATE(686),
    [sym_instance_of] = STATE(686),
    [sym_negation] = STATE(686),
    [sym_if_term] = STATE(686),
    [sym_conjunction] = STATE(686),
    [sym_disjunction] = STATE(686),
    [sym_implication] = STATE(686),
    [sym_quantified] = STATE(686),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(686),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1118),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [197] = {
    [sym_special_call] = STATE(740),
    [sym_prefix_cast] = STATE(740),
    [sym_unary_expr] = STATE(740),
    [sym_mul_expr] = STATE(740),
    [sym_add_expr] = STATE(740),
    [sym_in_expr] = STATE(740),
    [sym_comp_term] = STATE(740),
    [sym_instance_of] = STATE(740),
    [sym_negation] = STATE(740),
    [sym_if_term] = STATE(740),
    [sym_conjunction] = STATE(740),
    [sym_disjunction] = STATE(740),
    [sym_implication] = STATE(740),
    [sym_quantified] = STATE(740),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(740),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [198] = {
    [sym_special_call] = STATE(524),
    [sym_prefix_cast] = STATE(524),
    [sym_unary_expr] = STATE(524),
    [sym_mul_expr] = STATE(524),
    [sym_add_expr] = STATE(524),
    [sym_in_expr] = STATE(524),
    [sym_comp_term] = STATE(524),
    [sym_instance_of] = STATE(524),
    [sym_negation] = STATE(524),
    [sym_if_term] = STATE(524),
    [sym_conjunction] = STATE(524),
    [sym_disjunction] = STATE(524),
    [sym_implication] = STATE(524),
    [sym_quantified] = STATE(524),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(524),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [199] = {
    [sym_special_call] = STATE(523),
    [sym_prefix_cast] = STATE(523),
    [sym_unary_expr] = STATE(523),
    [sym_mul_expr] = STATE(523),
    [sym_add_expr] = STATE(523),
    [sym_in_expr] = STATE(523),
    [sym_comp_term] = STATE(523),
    [sym_instance_of] = STATE(523),
    [sym_negation] = STATE(523),
    [sym_if_term] = STATE(523),
    [sym_conjunction] = STATE(523),
    [sym_disjunction] = STATE(523),
    [sym_implication] = STATE(523),
    [sym_quantified] = STATE(523),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(523),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [200] = {
    [sym_special_call] = STATE(730),
    [sym_prefix_cast] = STATE(730),
    [sym_unary_expr] = STATE(730),
    [sym_mul_expr] = STATE(730),
    [sym_add_expr] = STATE(730),
    [sym_in_expr] = STATE(730),
    [sym_comp_term] = STATE(730),
    [sym_instance_of] = STATE(730),
    [sym_negation] = STATE(730),
    [sym_if_term] = STATE(730),
    [sym_conjunction] = STATE(730),
    [sym_disjunction] = STATE(730),
    [sym_implication] = STATE(730),
    [sym_quantified] = STATE(730),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(730),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [201] = {
    [sym_special_call] = STATE(707),
    [sym_prefix_cast] = STATE(707),
    [sym_unary_expr] = STATE(707),
    [sym_mul_expr] = STATE(707),
    [sym_add_expr] = STATE(707),
    [sym_in_expr] = STATE(707),
    [sym_comp_term] = STATE(707),
    [sym_instance_of] = STATE(707),
    [sym_negation] = STATE(707),
    [sym_if_term] = STATE(707),
    [sym_conjunction] = STATE(707),
    [sym_disjunction] = STATE(707),
    [sym_implication] = STATE(707),
    [sym_quantified] = STATE(707),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(707),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [202] = {
    [sym_special_call] = STATE(624),
    [sym_prefix_cast] = STATE(624),
    [sym_unary_expr] = STATE(624),
    [sym_mul_expr] = STATE(624),
    [sym_add_expr] = STATE(624),
    [sym_in_expr] = STATE(624),
    [sym_comp_term] = STATE(624),
    [sym_instance_of] = STATE(624),
    [sym_negation] = STATE(624),
    [sym_if_term] = STATE(624),
    [sym_conjunction] = STATE(624),
    [sym_disjunction] = STATE(624),
    [sym_implication] = STATE(624),
    [sym_quantified] = STATE(624),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(624),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [203] = {
    [sym_special_call] = STATE(670),
    [sym_prefix_cast] = STATE(670),
    [sym_unary_expr] = STATE(670),
    [sym_mul_expr] = STATE(670),
    [sym_add_expr] = STATE(670),
    [sym_in_expr] = STATE(670),
    [sym_comp_term] = STATE(670),
    [sym_instance_of] = STATE(670),
    [sym_negation] = STATE(670),
    [sym_if_term] = STATE(670),
    [sym_conjunction] = STATE(670),
    [sym_disjunction] = STATE(670),
    [sym_implication] = STATE(670),
    [sym_quantified] = STATE(670),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(670),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [204] = {
    [sym_special_call] = STATE(290),
    [sym_prefix_cast] = STATE(290),
    [sym_unary_expr] = STATE(290),
    [sym_mul_expr] = STATE(290),
    [sym_add_expr] = STATE(290),
    [sym_in_expr] = STATE(290),
    [sym_comp_term] = STATE(290),
    [sym_instance_of] = STATE(290),
    [sym_negation] = STATE(290),
    [sym_if_term] = STATE(290),
    [sym_conjunction] = STATE(290),
    [sym_disjunction] = STATE(290),
    [sym_implication] = STATE(290),
    [sym_quantified] = STATE(290),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(290),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [205] = {
    [sym_special_call] = STATE(248),
    [sym_prefix_cast] = STATE(248),
    [sym_unary_expr] = STATE(248),
    [sym_mul_expr] = STATE(248),
    [sym_add_expr] = STATE(248),
    [sym_in_expr] = STATE(248),
    [sym_comp_term] = STATE(248),
    [sym_instance_of] = STATE(248),
    [sym_negation] = STATE(248),
    [sym_if_term] = STATE(248),
    [sym_conjunction] = STATE(248),
    [sym_disjunction] = STATE(248),
    [sym_implication] = STATE(248),
    [sym_quantified] = STATE(248),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(248),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [206] = {
    [sym_special_call] = STATE(250),
    [sym_prefix_cast] = STATE(250),
    [sym_unary_expr] = STATE(250),
    [sym_mul_expr] = STATE(250),
    [sym_add_expr] = STATE(250),
    [sym_in_expr] = STATE(250),
    [sym_comp_term] = STATE(250),
    [sym_instance_of] = STATE(250),
    [sym_negation] = STATE(250),
    [sym_if_term] = STATE(250),
    [sym_conjunction] = STATE(250),
    [sym_disjunction] = STATE(250),
    [sym_implication] = STATE(250),
    [sym_quantified] = STATE(250),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(250),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [207] = {
    [sym_special_call] = STATE(257),
    [sym_prefix_cast] = STATE(257),
    [sym_unary_expr] = STATE(257),
    [sym_mul_expr] = STATE(257),
    [sym_add_expr] = STATE(257),
    [sym_in_expr] = STATE(257),
    [sym_comp_term] = STATE(257),
    [sym_instance_of] = STATE(257),
    [sym_negation] = STATE(257),
    [sym_if_term] = STATE(257),
    [sym_conjunction] = STATE(257),
    [sym_disjunction] = STATE(257),
    [sym_implication] = STATE(257),
    [sym_quantified] = STATE(257),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(257),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [208] = {
    [sym_special_call] = STATE(247),
    [sym_prefix_cast] = STATE(247),
    [sym_unary_expr] = STATE(247),
    [sym_mul_expr] = STATE(247),
    [sym_add_expr] = STATE(247),
    [sym_in_expr] = STATE(247),
    [sym_comp_term] = STATE(247),
    [sym_instance_of] = STATE(247),
    [sym_negation] = STATE(247),
    [sym_if_term] = STATE(247),
    [sym_conjunction] = STATE(247),
    [sym_disjunction] = STATE(247),
    [sym_implication] = STATE(247),
    [sym_quantified] = STATE(247),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(247),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [209] = {
    [sym_special_call] = STATE(270),
    [sym_prefix_cast] = STATE(270),
    [sym_unary_expr] = STATE(270),
    [sym_mul_expr] = STATE(270),
    [sym_add_expr] = STATE(270),
    [sym_in_expr] = STATE(270),
    [sym_comp_term] = STATE(270),
    [sym_instance_of] = STATE(270),
    [sym_negation] = STATE(270),
    [sym_if_term] = STATE(270),
    [sym_conjunction] = STATE(270),
    [sym_disjunction] = STATE(270),
    [sym_implication] = STATE(270),
    [sym_quantified] = STATE(270),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(270),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [210] = {
    [sym_special_call] = STATE(615),
    [sym_prefix_cast] = STATE(615),
    [sym_unary_expr] = STATE(615),
    [sym_mul_expr] = STATE(615),
    [sym_add_expr] = STATE(615),
    [sym_in_expr] = STATE(615),
    [sym_comp_term] = STATE(615),
    [sym_instance_of] = STATE(615),
    [sym_negation] = STATE(615),
    [sym_if_term] = STATE(615),
    [sym_conjunction] = STATE(615),
    [sym_disjunction] = STATE(615),
    [sym_implication] = STATE(615),
    [sym_quantified] = STATE(615),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(615),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [211] = {
    [sym_special_call] = STATE(594),
    [sym_prefix_cast] = STATE(594),
    [sym_unary_expr] = STATE(594),
    [sym_mul_expr] = STATE(594),
    [sym_add_expr] = STATE(594),
    [sym_in_expr] = STATE(594),
    [sym_comp_term] = STATE(594),
    [sym_instance_of] = STATE(594),
    [sym_negation] = STATE(594),
    [sym_if_term] = STATE(594),
    [sym_conjunction] = STATE(594),
    [sym_disjunction] = STATE(594),
    [sym_implication] = STATE(594),
    [sym_quantified] = STATE(594),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(594),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [212] = {
    [sym_special_call] = STATE(716),
    [sym_prefix_cast] = STATE(716),
    [sym_unary_expr] = STATE(716),
    [sym_mul_expr] = STATE(716),
    [sym_add_expr] = STATE(716),
    [sym_in_expr] = STATE(716),
    [sym_comp_term] = STATE(716),
    [sym_instance_of] = STATE(716),
    [sym_negation] = STATE(716),
    [sym_if_term] = STATE(716),
    [sym_conjunction] = STATE(716),
    [sym_disjunction] = STATE(716),
    [sym_implication] = STATE(716),
    [sym_quantified] = STATE(716),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(716),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [213] = {
    [sym_special_call] = STATE(251),
    [sym_prefix_cast] = STATE(251),
    [sym_unary_expr] = STATE(251),
    [sym_mul_expr] = STATE(251),
    [sym_add_expr] = STATE(251),
    [sym_in_expr] = STATE(251),
    [sym_comp_term] = STATE(251),
    [sym_instance_of] = STATE(251),
    [sym_negation] = STATE(251),
    [sym_if_term] = STATE(251),
    [sym_conjunction] = STATE(251),
    [sym_disjunction] = STATE(251),
    [sym_implication] = STATE(251),
    [sym_quantified] = STATE(251),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(251),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [214] = {
    [sym_special_call] = STATE(604),
    [sym_prefix_cast] = STATE(604),
    [sym_unary_expr] = STATE(604),
    [sym_mul_expr] = STATE(604),
    [sym_add_expr] = STATE(604),
    [sym_in_expr] = STATE(604),
    [sym_comp_term] = STATE(604),
    [sym_instance_of] = STATE(604),
    [sym_negation] = STATE(604),
    [sym_if_term] = STATE(604),
    [sym_conjunction] = STATE(604),
    [sym_disjunction] = STATE(604),
    [sym_implication] = STATE(604),
    [sym_quantified] = STATE(604),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(604),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [215] = {
    [sym_special_call] = STATE(275),
    [sym_prefix_cast] = STATE(275),
    [sym_unary_expr] = STATE(275),
    [sym_mul_expr] = STATE(275),
    [sym_add_expr] = STATE(275),
    [sym_in_expr] = STATE(275),
    [sym_comp_term] = STATE(275),
    [sym_instance_of] = STATE(275),
    [sym_negation] = STATE(275),
    [sym_if_term] = STATE(275),
    [sym_conjunction] = STATE(275),
    [sym_disjunction] = STATE(275),
    [sym_implication] = STATE(275),
    [sym_quantified] = STATE(275),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(275),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [216] = {
    [sym_special_call] = STATE(265),
    [sym_prefix_cast] = STATE(265),
    [sym_unary_expr] = STATE(265),
    [sym_mul_expr] = STATE(265),
    [sym_add_expr] = STATE(265),
    [sym_in_expr] = STATE(265),
    [sym_comp_term] = STATE(265),
    [sym_instance_of] = STATE(265),
    [sym_negation] = STATE(265),
    [sym_if_term] = STATE(265),
    [sym_conjunction] = STATE(265),
    [sym_disjunction] = STATE(265),
    [sym_implication] = STATE(265),
    [sym_quantified] = STATE(265),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(265),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [217] = {
    [sym_special_call] = STATE(293),
    [sym_prefix_cast] = STATE(293),
    [sym_unary_expr] = STATE(293),
    [sym_mul_expr] = STATE(293),
    [sym_add_expr] = STATE(293),
    [sym_in_expr] = STATE(293),
    [sym_comp_term] = STATE(293),
    [sym_instance_of] = STATE(293),
    [sym_negation] = STATE(293),
    [sym_if_term] = STATE(293),
    [sym_conjunction] = STATE(293),
    [sym_disjunction] = STATE(293),
    [sym_implication] = STATE(293),
    [sym_quantified] = STATE(293),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(293),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [218] = {
    [sym_special_call] = STATE(574),
    [sym_prefix_cast] = STATE(574),
    [sym_unary_expr] = STATE(574),
    [sym_mul_expr] = STATE(574),
    [sym_add_expr] = STATE(574),
    [sym_in_expr] = STATE(574),
    [sym_comp_term] = STATE(574),
    [sym_instance_of] = STATE(574),
    [sym_negation] = STATE(574),
    [sym_if_term] = STATE(574),
    [sym_conjunction] = STATE(574),
    [sym_disjunction] = STATE(574),
    [sym_implication] = STATE(574),
    [sym_quantified] = STATE(574),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(574),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [219] = {
    [sym_special_call] = STATE(252),
    [sym_prefix_cast] = STATE(252),
    [sym_unary_expr] = STATE(252),
    [sym_mul_expr] = STATE(252),
    [sym_add_expr] = STATE(252),
    [sym_in_expr] = STATE(252),
    [sym_comp_term] = STATE(252),
    [sym_instance_of] = STATE(252),
    [sym_negation] = STATE(252),
    [sym_if_term] = STATE(252),
    [sym_conjunction] = STATE(252),
    [sym_disjunction] = STATE(252),
    [sym_implication] = STATE(252),
    [sym_quantified] = STATE(252),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(252),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [220] = {
    [sym_special_call] = STATE(509),
    [sym_prefix_cast] = STATE(509),
    [sym_unary_expr] = STATE(509),
    [sym_mul_expr] = STATE(509),
    [sym_add_expr] = STATE(509),
    [sym_in_expr] = STATE(509),
    [sym_comp_term] = STATE(509),
    [sym_instance_of] = STATE(509),
    [sym_negation] = STATE(509),
    [sym_if_term] = STATE(509),
    [sym_conjunction] = STATE(509),
    [sym_disjunction] = STATE(509),
    [sym_implication] = STATE(509),
    [sym_quantified] = STATE(509),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(509),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [221] = {
    [sym_special_call] = STATE(717),
    [sym_prefix_cast] = STATE(717),
    [sym_unary_expr] = STATE(717),
    [sym_mul_expr] = STATE(717),
    [sym_add_expr] = STATE(717),
    [sym_in_expr] = STATE(717),
    [sym_comp_term] = STATE(717),
    [sym_instance_of] = STATE(717),
    [sym_negation] = STATE(717),
    [sym_if_term] = STATE(717),
    [sym_conjunction] = STATE(717),
    [sym_disjunction] = STATE(717),
    [sym_implication] = STATE(717),
    [sym_quantified] = STATE(717),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(717),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1093),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [222] = {
    [sym_special_call] = STATE(667),
    [sym_prefix_cast] = STATE(667),
    [sym_unary_expr] = STATE(667),
    [sym_mul_expr] = STATE(667),
    [sym_add_expr] = STATE(667),
    [sym_in_expr] = STATE(667),
    [sym_comp_term] = STATE(667),
    [sym_instance_of] = STATE(667),
    [sym_negation] = STATE(667),
    [sym_if_term] = STATE(667),
    [sym_conjunction] = STATE(667),
    [sym_disjunction] = STATE(667),
    [sym_implication] = STATE(667),
    [sym_quantified] = STATE(667),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(667),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [223] = {
    [sym_special_call] = STATE(253),
    [sym_prefix_cast] = STATE(253),
    [sym_unary_expr] = STATE(253),
    [sym_mul_expr] = STATE(253),
    [sym_add_expr] = STATE(253),
    [sym_in_expr] = STATE(253),
    [sym_comp_term] = STATE(253),
    [sym_instance_of] = STATE(253),
    [sym_negation] = STATE(253),
    [sym_if_term] = STATE(253),
    [sym_conjunction] = STATE(253),
    [sym_disjunction] = STATE(253),
    [sym_implication] = STATE(253),
    [sym_quantified] = STATE(253),
    [sym_specialId] = STATE(1185),
    [sym_quantifier] = STATE(1186),
    [sym_classless_predicate_call] = STATE(366),
    [sym_qualified_expr] = STATE(366),
    [sym_super_ref] = STATE(366),
    [sym_aggregate] = STATE(366),
    [sym_range] = STATE(366),
    [sym_par_expr] = STATE(366),
    [sym__exprOrTerm] = STATE(253),
    [sym__primary] = STATE(366),
    [sym_literal] = STATE(366),
    [sym_bool] = STATE(362),
    [sym_variable] = STATE(366),
    [sym_unop] = STATE(205),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(294),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1187),
    [sym_aritylessPredicateExpr] = STATE(939),
    [sym_varName] = STATE(364),
    [sym_aggId] = STATE(1117),
    [sym__lower_id] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_if] = ACTIONS(331),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(335),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(337),
    [sym_float] = ACTIONS(339),
    [sym_string] = ACTIONS(339),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(341),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(343),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(345),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(347),
    [sym_this] = ACTIONS(345),
    [sym_true] = ACTIONS(341),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [224] = {
    [sym_special_call] = STATE(641),
    [sym_prefix_cast] = STATE(641),
    [sym_unary_expr] = STATE(641),
    [sym_mul_expr] = STATE(641),
    [sym_add_expr] = STATE(641),
    [sym_in_expr] = STATE(641),
    [sym_comp_term] = STATE(641),
    [sym_instance_of] = STATE(641),
    [sym_negation] = STATE(641),
    [sym_if_term] = STATE(641),
    [sym_conjunction] = STATE(641),
    [sym_disjunction] = STATE(641),
    [sym_implication] = STATE(641),
    [sym_quantified] = STATE(641),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(641),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [225] = {
    [sym_special_call] = STATE(626),
    [sym_prefix_cast] = STATE(626),
    [sym_unary_expr] = STATE(626),
    [sym_mul_expr] = STATE(626),
    [sym_add_expr] = STATE(626),
    [sym_in_expr] = STATE(626),
    [sym_comp_term] = STATE(626),
    [sym_instance_of] = STATE(626),
    [sym_negation] = STATE(626),
    [sym_if_term] = STATE(626),
    [sym_conjunction] = STATE(626),
    [sym_disjunction] = STATE(626),
    [sym_implication] = STATE(626),
    [sym_quantified] = STATE(626),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(626),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [226] = {
    [sym_special_call] = STATE(639),
    [sym_prefix_cast] = STATE(639),
    [sym_unary_expr] = STATE(639),
    [sym_mul_expr] = STATE(639),
    [sym_add_expr] = STATE(639),
    [sym_in_expr] = STATE(639),
    [sym_comp_term] = STATE(639),
    [sym_instance_of] = STATE(639),
    [sym_negation] = STATE(639),
    [sym_if_term] = STATE(639),
    [sym_conjunction] = STATE(639),
    [sym_disjunction] = STATE(639),
    [sym_implication] = STATE(639),
    [sym_quantified] = STATE(639),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(639),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1107),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [227] = {
    [sym_special_call] = STATE(684),
    [sym_prefix_cast] = STATE(684),
    [sym_unary_expr] = STATE(684),
    [sym_mul_expr] = STATE(684),
    [sym_add_expr] = STATE(684),
    [sym_in_expr] = STATE(684),
    [sym_comp_term] = STATE(684),
    [sym_instance_of] = STATE(684),
    [sym_negation] = STATE(684),
    [sym_if_term] = STATE(684),
    [sym_conjunction] = STATE(684),
    [sym_disjunction] = STATE(684),
    [sym_implication] = STATE(684),
    [sym_quantified] = STATE(684),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(684),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [228] = {
    [sym_special_call] = STATE(668),
    [sym_prefix_cast] = STATE(668),
    [sym_unary_expr] = STATE(668),
    [sym_mul_expr] = STATE(668),
    [sym_add_expr] = STATE(668),
    [sym_in_expr] = STATE(668),
    [sym_comp_term] = STATE(668),
    [sym_instance_of] = STATE(668),
    [sym_negation] = STATE(668),
    [sym_if_term] = STATE(668),
    [sym_conjunction] = STATE(668),
    [sym_disjunction] = STATE(668),
    [sym_implication] = STATE(668),
    [sym_quantified] = STATE(668),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(668),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [229] = {
    [sym_special_call] = STATE(263),
    [sym_prefix_cast] = STATE(263),
    [sym_unary_expr] = STATE(263),
    [sym_mul_expr] = STATE(263),
    [sym_add_expr] = STATE(263),
    [sym_in_expr] = STATE(263),
    [sym_comp_term] = STATE(263),
    [sym_instance_of] = STATE(263),
    [sym_negation] = STATE(263),
    [sym_if_term] = STATE(263),
    [sym_conjunction] = STATE(263),
    [sym_disjunction] = STATE(263),
    [sym_implication] = STATE(263),
    [sym_quantified] = STATE(263),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(263),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [230] = {
    [sym_special_call] = STATE(610),
    [sym_prefix_cast] = STATE(610),
    [sym_unary_expr] = STATE(610),
    [sym_mul_expr] = STATE(610),
    [sym_add_expr] = STATE(610),
    [sym_in_expr] = STATE(610),
    [sym_comp_term] = STATE(610),
    [sym_instance_of] = STATE(610),
    [sym_negation] = STATE(610),
    [sym_if_term] = STATE(610),
    [sym_conjunction] = STATE(610),
    [sym_disjunction] = STATE(610),
    [sym_implication] = STATE(610),
    [sym_quantified] = STATE(610),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(610),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [231] = {
    [sym_special_call] = STATE(271),
    [sym_prefix_cast] = STATE(271),
    [sym_unary_expr] = STATE(271),
    [sym_mul_expr] = STATE(271),
    [sym_add_expr] = STATE(271),
    [sym_in_expr] = STATE(271),
    [sym_comp_term] = STATE(271),
    [sym_instance_of] = STATE(271),
    [sym_negation] = STATE(271),
    [sym_if_term] = STATE(271),
    [sym_conjunction] = STATE(271),
    [sym_disjunction] = STATE(271),
    [sym_implication] = STATE(271),
    [sym_quantified] = STATE(271),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(271),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [232] = {
    [sym_special_call] = STATE(683),
    [sym_prefix_cast] = STATE(683),
    [sym_unary_expr] = STATE(683),
    [sym_mul_expr] = STATE(683),
    [sym_add_expr] = STATE(683),
    [sym_in_expr] = STATE(683),
    [sym_comp_term] = STATE(683),
    [sym_instance_of] = STATE(683),
    [sym_negation] = STATE(683),
    [sym_if_term] = STATE(683),
    [sym_conjunction] = STATE(683),
    [sym_disjunction] = STATE(683),
    [sym_implication] = STATE(683),
    [sym_quantified] = STATE(683),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(683),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [233] = {
    [sym_special_call] = STATE(256),
    [sym_prefix_cast] = STATE(256),
    [sym_unary_expr] = STATE(256),
    [sym_mul_expr] = STATE(256),
    [sym_add_expr] = STATE(256),
    [sym_in_expr] = STATE(256),
    [sym_comp_term] = STATE(256),
    [sym_instance_of] = STATE(256),
    [sym_negation] = STATE(256),
    [sym_if_term] = STATE(256),
    [sym_conjunction] = STATE(256),
    [sym_disjunction] = STATE(256),
    [sym_implication] = STATE(256),
    [sym_quantified] = STATE(256),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(256),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [234] = {
    [sym_special_call] = STATE(584),
    [sym_prefix_cast] = STATE(584),
    [sym_unary_expr] = STATE(584),
    [sym_mul_expr] = STATE(584),
    [sym_add_expr] = STATE(584),
    [sym_in_expr] = STATE(584),
    [sym_comp_term] = STATE(584),
    [sym_instance_of] = STATE(584),
    [sym_negation] = STATE(584),
    [sym_if_term] = STATE(584),
    [sym_conjunction] = STATE(584),
    [sym_disjunction] = STATE(584),
    [sym_implication] = STATE(584),
    [sym_quantified] = STATE(584),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(584),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [235] = {
    [sym_special_call] = STATE(680),
    [sym_prefix_cast] = STATE(680),
    [sym_unary_expr] = STATE(680),
    [sym_mul_expr] = STATE(680),
    [sym_add_expr] = STATE(680),
    [sym_in_expr] = STATE(680),
    [sym_comp_term] = STATE(680),
    [sym_instance_of] = STATE(680),
    [sym_negation] = STATE(680),
    [sym_if_term] = STATE(680),
    [sym_conjunction] = STATE(680),
    [sym_disjunction] = STATE(680),
    [sym_implication] = STATE(680),
    [sym_quantified] = STATE(680),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(680),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [236] = {
    [sym_special_call] = STATE(660),
    [sym_prefix_cast] = STATE(660),
    [sym_unary_expr] = STATE(660),
    [sym_mul_expr] = STATE(660),
    [sym_add_expr] = STATE(660),
    [sym_in_expr] = STATE(660),
    [sym_comp_term] = STATE(660),
    [sym_instance_of] = STATE(660),
    [sym_negation] = STATE(660),
    [sym_if_term] = STATE(660),
    [sym_conjunction] = STATE(660),
    [sym_disjunction] = STATE(660),
    [sym_implication] = STATE(660),
    [sym_quantified] = STATE(660),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(660),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(159),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(375),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(377),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [237] = {
    [sym_special_call] = STATE(255),
    [sym_prefix_cast] = STATE(255),
    [sym_unary_expr] = STATE(255),
    [sym_mul_expr] = STATE(255),
    [sym_add_expr] = STATE(255),
    [sym_in_expr] = STATE(255),
    [sym_comp_term] = STATE(255),
    [sym_instance_of] = STATE(255),
    [sym_negation] = STATE(255),
    [sym_if_term] = STATE(255),
    [sym_conjunction] = STATE(255),
    [sym_disjunction] = STATE(255),
    [sym_implication] = STATE(255),
    [sym_quantified] = STATE(255),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(255),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [238] = {
    [sym_special_call] = STATE(254),
    [sym_prefix_cast] = STATE(254),
    [sym_unary_expr] = STATE(254),
    [sym_mul_expr] = STATE(254),
    [sym_add_expr] = STATE(254),
    [sym_in_expr] = STATE(254),
    [sym_comp_term] = STATE(254),
    [sym_instance_of] = STATE(254),
    [sym_negation] = STATE(254),
    [sym_if_term] = STATE(254),
    [sym_conjunction] = STATE(254),
    [sym_disjunction] = STATE(254),
    [sym_implication] = STATE(254),
    [sym_quantified] = STATE(254),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(254),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [239] = {
    [sym_special_call] = STATE(600),
    [sym_prefix_cast] = STATE(600),
    [sym_unary_expr] = STATE(600),
    [sym_mul_expr] = STATE(600),
    [sym_add_expr] = STATE(600),
    [sym_in_expr] = STATE(600),
    [sym_comp_term] = STATE(600),
    [sym_instance_of] = STATE(600),
    [sym_negation] = STATE(600),
    [sym_if_term] = STATE(600),
    [sym_conjunction] = STATE(600),
    [sym_disjunction] = STATE(600),
    [sym_implication] = STATE(600),
    [sym_quantified] = STATE(600),
    [sym_specialId] = STATE(1240),
    [sym_quantifier] = STATE(1239),
    [sym_classless_predicate_call] = STATE(466),
    [sym_qualified_expr] = STATE(466),
    [sym_super_ref] = STATE(466),
    [sym_aggregate] = STATE(466),
    [sym_range] = STATE(466),
    [sym_par_expr] = STATE(466),
    [sym__exprOrTerm] = STATE(600),
    [sym__primary] = STATE(466),
    [sym_literal] = STATE(466),
    [sym_bool] = STATE(483),
    [sym_variable] = STATE(466),
    [sym_unop] = STATE(198),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(465),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1235),
    [sym_aritylessPredicateExpr] = STATE(929),
    [sym_varName] = STATE(479),
    [sym_aggId] = STATE(1098),
    [sym__lower_id] = ACTIONS(103),
    [anon_sym_LPAREN] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(113),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(117),
    [sym_string] = ACTIONS(117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(119),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(121),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(123),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(125),
    [sym_this] = ACTIONS(123),
    [sym_true] = ACTIONS(119),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [240] = {
    [sym_special_call] = STATE(249),
    [sym_prefix_cast] = STATE(249),
    [sym_unary_expr] = STATE(249),
    [sym_mul_expr] = STATE(249),
    [sym_add_expr] = STATE(249),
    [sym_in_expr] = STATE(249),
    [sym_comp_term] = STATE(249),
    [sym_instance_of] = STATE(249),
    [sym_negation] = STATE(249),
    [sym_if_term] = STATE(249),
    [sym_conjunction] = STATE(249),
    [sym_disjunction] = STATE(249),
    [sym_implication] = STATE(249),
    [sym_quantified] = STATE(249),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(249),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [241] = {
    [sym_special_call] = STATE(246),
    [sym_prefix_cast] = STATE(246),
    [sym_unary_expr] = STATE(246),
    [sym_mul_expr] = STATE(246),
    [sym_add_expr] = STATE(246),
    [sym_in_expr] = STATE(246),
    [sym_comp_term] = STATE(246),
    [sym_instance_of] = STATE(246),
    [sym_negation] = STATE(246),
    [sym_if_term] = STATE(246),
    [sym_conjunction] = STATE(246),
    [sym_disjunction] = STATE(246),
    [sym_implication] = STATE(246),
    [sym_quantified] = STATE(246),
    [sym_specialId] = STATE(1225),
    [sym_quantifier] = STATE(1219),
    [sym_classless_predicate_call] = STATE(369),
    [sym_qualified_expr] = STATE(369),
    [sym_super_ref] = STATE(369),
    [sym_aggregate] = STATE(369),
    [sym_range] = STATE(369),
    [sym_par_expr] = STATE(369),
    [sym__exprOrTerm] = STATE(246),
    [sym__primary] = STATE(369),
    [sym_literal] = STATE(369),
    [sym_bool] = STATE(376),
    [sym_variable] = STATE(369),
    [sym_unop] = STATE(217),
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1236),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(297),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1218),
    [sym_aritylessPredicateExpr] = STATE(913),
    [sym_varName] = STATE(373),
    [sym_aggId] = STATE(1104),
    [sym__lower_id] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_if] = ACTIONS(299),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(303),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_integer] = ACTIONS(305),
    [sym_float] = ACTIONS(307),
    [sym_string] = ACTIONS(307),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(53),
    [sym_avg] = ACTIONS(53),
    [sym_boolean] = ACTIONS(21),
    [sym_count] = ACTIONS(53),
    [sym_date] = ACTIONS(21),
    [sym_exists] = ACTIONS(55),
    [sym_false] = ACTIONS(309),
    [sym_forall] = ACTIONS(55),
    [sym_forex] = ACTIONS(55),
    [sym_max] = ACTIONS(53),
    [sym_min] = ACTIONS(53),
    [sym_not] = ACTIONS(311),
    [sym_none] = ACTIONS(61),
    [sym_rank] = ACTIONS(53),
    [sym_result] = ACTIONS(313),
    [sym_strictcount] = ACTIONS(53),
    [sym_strictsum] = ACTIONS(53),
    [sym_strictconcat] = ACTIONS(53),
    [sym_concat] = ACTIONS(53),
    [sym_sum] = ACTIONS(53),
    [sym_super] = ACTIONS(315),
    [sym_this] = ACTIONS(313),
    [sym_true] = ACTIONS(309),
    [sym_minus] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
  },
  [242] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [sym_direction] = STATE(745),
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym__lower_id] = ACTIONS(381),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_from] = ACTIONS(381),
    [anon_sym_where] = ACTIONS(381),
    [anon_sym_select] = ACTIONS(381),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_implies] = ACTIONS(387),
    [sym_qldoc] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(381),
    [anon_sym_int] = ACTIONS(381),
    [anon_sym_string] = ACTIONS(381),
    [sym__upper_id] = ACTIONS(379),
    [sym__at_lower_id] = ACTIONS(379),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(389),
    [sym_boolean] = ACTIONS(381),
    [sym_class] = ACTIONS(381),
    [sym_newtype] = ACTIONS(381),
    [sym_date] = ACTIONS(381),
    [sym_desc] = ACTIONS(389),
    [sym_import] = ACTIONS(381),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(381),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [243] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym_direction] = STATE(749),
    [sym__lower_id] = ACTIONS(381),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(405),
    [anon_sym_from] = ACTIONS(381),
    [anon_sym_where] = ACTIONS(381),
    [anon_sym_select] = ACTIONS(381),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_implies] = ACTIONS(409),
    [sym_qldoc] = ACTIONS(379),
    [anon_sym_float] = ACTIONS(381),
    [anon_sym_int] = ACTIONS(381),
    [anon_sym_string] = ACTIONS(381),
    [sym__upper_id] = ACTIONS(379),
    [sym__at_lower_id] = ACTIONS(379),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(411),
    [sym_boolean] = ACTIONS(381),
    [sym_class] = ACTIONS(381),
    [sym_newtype] = ACTIONS(381),
    [sym_date] = ACTIONS(381),
    [sym_desc] = ACTIONS(411),
    [sym_import] = ACTIONS(381),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(381),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [244] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_from] = ACTIONS(417),
    [anon_sym_where] = ACTIONS(417),
    [anon_sym_select] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_implies] = ACTIONS(417),
    [anon_sym_order] = ACTIONS(417),
    [sym_qldoc] = ACTIONS(419),
    [anon_sym_float] = ACTIONS(417),
    [anon_sym_int] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [sym__upper_id] = ACTIONS(419),
    [sym__at_lower_id] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(417),
    [sym_boolean] = ACTIONS(417),
    [sym_class] = ACTIONS(417),
    [sym_newtype] = ACTIONS(417),
    [sym_date] = ACTIONS(417),
    [sym_import] = ACTIONS(417),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(417),
    [sym_predicate] = ACTIONS(417),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [245] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(421),
    [sym__lower_id] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(423),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_from] = ACTIONS(423),
    [anon_sym_where] = ACTIONS(423),
    [anon_sym_select] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_implies] = ACTIONS(423),
    [sym_qldoc] = ACTIONS(421),
    [anon_sym_float] = ACTIONS(423),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_string] = ACTIONS(423),
    [sym__upper_id] = ACTIONS(421),
    [sym__at_lower_id] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(423),
    [sym_boolean] = ACTIONS(423),
    [sym_class] = ACTIONS(423),
    [sym_newtype] = ACTIONS(423),
    [sym_date] = ACTIONS(423),
    [sym_desc] = ACTIONS(423),
    [sym_import] = ACTIONS(423),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(423),
    [sym_predicate] = ACTIONS(423),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [246] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(425),
    [sym__lower_id] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(427),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_from] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(427),
    [anon_sym_select] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_implies] = ACTIONS(427),
    [anon_sym_order] = ACTIONS(427),
    [sym_qldoc] = ACTIONS(425),
    [anon_sym_float] = ACTIONS(427),
    [anon_sym_int] = ACTIONS(427),
    [anon_sym_string] = ACTIONS(427),
    [sym__upper_id] = ACTIONS(425),
    [sym__at_lower_id] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(427),
    [sym_boolean] = ACTIONS(427),
    [sym_class] = ACTIONS(427),
    [sym_newtype] = ACTIONS(427),
    [sym_date] = ACTIONS(427),
    [sym_import] = ACTIONS(427),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(427),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [247] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym__lower_id] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_from] = ACTIONS(439),
    [anon_sym_where] = ACTIONS(439),
    [anon_sym_select] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(439),
    [anon_sym_implies] = ACTIONS(439),
    [anon_sym_order] = ACTIONS(439),
    [sym_qldoc] = ACTIONS(437),
    [anon_sym_float] = ACTIONS(439),
    [anon_sym_int] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [sym__upper_id] = ACTIONS(437),
    [sym__at_lower_id] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(439),
    [sym_boolean] = ACTIONS(439),
    [sym_class] = ACTIONS(439),
    [sym_newtype] = ACTIONS(439),
    [sym_date] = ACTIONS(439),
    [sym_import] = ACTIONS(439),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(439),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [248] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(441),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(405),
    [anon_sym_from] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(441),
    [anon_sym_select] = ACTIONS(441),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_implies] = ACTIONS(409),
    [sym_qldoc] = ACTIONS(443),
    [anon_sym_float] = ACTIONS(441),
    [anon_sym_int] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [sym__upper_id] = ACTIONS(443),
    [sym__at_lower_id] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(441),
    [sym_boolean] = ACTIONS(441),
    [sym_class] = ACTIONS(441),
    [sym_newtype] = ACTIONS(441),
    [sym_date] = ACTIONS(441),
    [sym_desc] = ACTIONS(441),
    [sym_import] = ACTIONS(441),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(441),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [249] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(421),
    [sym__lower_id] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(423),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_from] = ACTIONS(423),
    [anon_sym_where] = ACTIONS(423),
    [anon_sym_select] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_implies] = ACTIONS(423),
    [anon_sym_order] = ACTIONS(423),
    [sym_qldoc] = ACTIONS(421),
    [anon_sym_float] = ACTIONS(423),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_string] = ACTIONS(423),
    [sym__upper_id] = ACTIONS(421),
    [sym__at_lower_id] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(423),
    [sym_boolean] = ACTIONS(423),
    [sym_class] = ACTIONS(423),
    [sym_newtype] = ACTIONS(423),
    [sym_date] = ACTIONS(423),
    [sym_import] = ACTIONS(423),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(423),
    [sym_predicate] = ACTIONS(423),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [250] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(445),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_from] = ACTIONS(445),
    [anon_sym_where] = ACTIONS(445),
    [anon_sym_select] = ACTIONS(445),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_implies] = ACTIONS(445),
    [sym_qldoc] = ACTIONS(447),
    [anon_sym_float] = ACTIONS(445),
    [anon_sym_int] = ACTIONS(445),
    [anon_sym_string] = ACTIONS(445),
    [sym__upper_id] = ACTIONS(447),
    [sym__at_lower_id] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(445),
    [sym_boolean] = ACTIONS(445),
    [sym_class] = ACTIONS(445),
    [sym_newtype] = ACTIONS(445),
    [sym_date] = ACTIONS(445),
    [sym_desc] = ACTIONS(445),
    [sym_import] = ACTIONS(445),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(445),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [251] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(405),
    [anon_sym_from] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(427),
    [anon_sym_select] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_implies] = ACTIONS(427),
    [sym_qldoc] = ACTIONS(425),
    [anon_sym_float] = ACTIONS(427),
    [anon_sym_int] = ACTIONS(427),
    [anon_sym_string] = ACTIONS(427),
    [sym__upper_id] = ACTIONS(425),
    [sym__at_lower_id] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(427),
    [sym_boolean] = ACTIONS(427),
    [sym_class] = ACTIONS(427),
    [sym_newtype] = ACTIONS(427),
    [sym_date] = ACTIONS(427),
    [sym_desc] = ACTIONS(427),
    [sym_import] = ACTIONS(427),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(427),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [252] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(449),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_from] = ACTIONS(449),
    [anon_sym_where] = ACTIONS(449),
    [anon_sym_select] = ACTIONS(449),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_implies] = ACTIONS(449),
    [sym_qldoc] = ACTIONS(451),
    [anon_sym_float] = ACTIONS(449),
    [anon_sym_int] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [sym__upper_id] = ACTIONS(451),
    [sym__at_lower_id] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(449),
    [sym_boolean] = ACTIONS(449),
    [sym_class] = ACTIONS(449),
    [sym_newtype] = ACTIONS(449),
    [sym_date] = ACTIONS(449),
    [sym_desc] = ACTIONS(449),
    [sym_import] = ACTIONS(449),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(449),
    [sym_predicate] = ACTIONS(449),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [253] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(405),
    [anon_sym_from] = ACTIONS(453),
    [anon_sym_where] = ACTIONS(453),
    [anon_sym_select] = ACTIONS(453),
    [anon_sym_and] = ACTIONS(407),
    [anon_sym_implies] = ACTIONS(409),
    [sym_qldoc] = ACTIONS(455),
    [anon_sym_float] = ACTIONS(453),
    [anon_sym_int] = ACTIONS(453),
    [anon_sym_string] = ACTIONS(453),
    [sym__upper_id] = ACTIONS(455),
    [sym__at_lower_id] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(453),
    [sym_boolean] = ACTIONS(453),
    [sym_class] = ACTIONS(453),
    [sym_newtype] = ACTIONS(453),
    [sym_date] = ACTIONS(453),
    [sym_desc] = ACTIONS(453),
    [sym_import] = ACTIONS(453),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(453),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [254] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym__lower_id] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_from] = ACTIONS(417),
    [anon_sym_where] = ACTIONS(417),
    [anon_sym_select] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_implies] = ACTIONS(417),
    [anon_sym_order] = ACTIONS(417),
    [sym_qldoc] = ACTIONS(419),
    [anon_sym_float] = ACTIONS(417),
    [anon_sym_int] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [sym__upper_id] = ACTIONS(419),
    [sym__at_lower_id] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(417),
    [sym_boolean] = ACTIONS(417),
    [sym_class] = ACTIONS(417),
    [sym_newtype] = ACTIONS(417),
    [sym_date] = ACTIONS(417),
    [sym_import] = ACTIONS(417),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(417),
    [sym_predicate] = ACTIONS(417),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [255] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(451),
    [sym__lower_id] = ACTIONS(449),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_from] = ACTIONS(449),
    [anon_sym_where] = ACTIONS(449),
    [anon_sym_select] = ACTIONS(449),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_implies] = ACTIONS(449),
    [anon_sym_order] = ACTIONS(449),
    [sym_qldoc] = ACTIONS(451),
    [anon_sym_float] = ACTIONS(449),
    [anon_sym_int] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [sym__upper_id] = ACTIONS(451),
    [sym__at_lower_id] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(449),
    [sym_boolean] = ACTIONS(449),
    [sym_class] = ACTIONS(449),
    [sym_newtype] = ACTIONS(449),
    [sym_date] = ACTIONS(449),
    [sym_import] = ACTIONS(449),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(449),
    [sym_predicate] = ACTIONS(449),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [256] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym__lower_id] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_from] = ACTIONS(453),
    [anon_sym_where] = ACTIONS(453),
    [anon_sym_select] = ACTIONS(453),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_implies] = ACTIONS(457),
    [anon_sym_order] = ACTIONS(453),
    [sym_qldoc] = ACTIONS(455),
    [anon_sym_float] = ACTIONS(453),
    [anon_sym_int] = ACTIONS(453),
    [anon_sym_string] = ACTIONS(453),
    [sym__upper_id] = ACTIONS(455),
    [sym__at_lower_id] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(453),
    [sym_boolean] = ACTIONS(453),
    [sym_class] = ACTIONS(453),
    [sym_newtype] = ACTIONS(453),
    [sym_date] = ACTIONS(453),
    [sym_import] = ACTIONS(453),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(453),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [257] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(459),
    [sym__lower_id] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(461),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_select] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_implies] = ACTIONS(461),
    [anon_sym_order] = ACTIONS(461),
    [sym_qldoc] = ACTIONS(459),
    [anon_sym_float] = ACTIONS(461),
    [anon_sym_int] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [sym__upper_id] = ACTIONS(459),
    [sym__at_lower_id] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(461),
    [sym_boolean] = ACTIONS(461),
    [sym_class] = ACTIONS(461),
    [sym_newtype] = ACTIONS(461),
    [sym_date] = ACTIONS(461),
    [sym_import] = ACTIONS(461),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(461),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [259] = {
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_desc] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(472),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [261] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(475),
    [anon_sym_module] = ACTIONS(475),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(477),
    [anon_sym_or] = ACTIONS(479),
    [anon_sym_from] = ACTIONS(475),
    [anon_sym_where] = ACTIONS(475),
    [anon_sym_select] = ACTIONS(475),
    [anon_sym_and] = ACTIONS(481),
    [anon_sym_implies] = ACTIONS(483),
    [anon_sym_order] = ACTIONS(475),
    [sym_qldoc] = ACTIONS(477),
    [anon_sym_float] = ACTIONS(475),
    [anon_sym_int] = ACTIONS(475),
    [anon_sym_string] = ACTIONS(475),
    [sym__upper_id] = ACTIONS(477),
    [sym__at_lower_id] = ACTIONS(477),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(485),
    [sym_boolean] = ACTIONS(475),
    [sym_class] = ACTIONS(475),
    [sym_newtype] = ACTIONS(475),
    [sym_date] = ACTIONS(475),
    [sym_import] = ACTIONS(475),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(475),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [262] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym__lower_id] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_from] = ACTIONS(453),
    [anon_sym_where] = ACTIONS(453),
    [anon_sym_select] = ACTIONS(453),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_implies] = ACTIONS(387),
    [sym_qldoc] = ACTIONS(455),
    [anon_sym_float] = ACTIONS(453),
    [anon_sym_int] = ACTIONS(453),
    [anon_sym_string] = ACTIONS(453),
    [sym__upper_id] = ACTIONS(455),
    [sym__at_lower_id] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(453),
    [sym_boolean] = ACTIONS(453),
    [sym_class] = ACTIONS(453),
    [sym_newtype] = ACTIONS(453),
    [sym_date] = ACTIONS(453),
    [sym_desc] = ACTIONS(453),
    [sym_import] = ACTIONS(453),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(453),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [263] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(447),
    [sym__lower_id] = ACTIONS(445),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_from] = ACTIONS(445),
    [anon_sym_where] = ACTIONS(445),
    [anon_sym_select] = ACTIONS(445),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_implies] = ACTIONS(445),
    [anon_sym_order] = ACTIONS(445),
    [sym_qldoc] = ACTIONS(447),
    [anon_sym_float] = ACTIONS(445),
    [anon_sym_int] = ACTIONS(445),
    [anon_sym_string] = ACTIONS(445),
    [sym__upper_id] = ACTIONS(447),
    [sym__at_lower_id] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(445),
    [sym_boolean] = ACTIONS(445),
    [sym_class] = ACTIONS(445),
    [sym_newtype] = ACTIONS(445),
    [sym_date] = ACTIONS(445),
    [sym_import] = ACTIONS(445),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(445),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [264] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(477),
    [sym__lower_id] = ACTIONS(475),
    [anon_sym_module] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(477),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_from] = ACTIONS(475),
    [anon_sym_where] = ACTIONS(475),
    [anon_sym_select] = ACTIONS(475),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_implies] = ACTIONS(457),
    [anon_sym_order] = ACTIONS(475),
    [sym_qldoc] = ACTIONS(477),
    [anon_sym_float] = ACTIONS(475),
    [anon_sym_int] = ACTIONS(475),
    [anon_sym_string] = ACTIONS(475),
    [sym__upper_id] = ACTIONS(477),
    [sym__at_lower_id] = ACTIONS(477),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(491),
    [sym_boolean] = ACTIONS(475),
    [sym_class] = ACTIONS(475),
    [sym_newtype] = ACTIONS(475),
    [sym_date] = ACTIONS(475),
    [sym_import] = ACTIONS(475),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(475),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [265] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_from] = ACTIONS(417),
    [anon_sym_where] = ACTIONS(417),
    [anon_sym_select] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_implies] = ACTIONS(417),
    [sym_qldoc] = ACTIONS(419),
    [anon_sym_float] = ACTIONS(417),
    [anon_sym_int] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [sym__upper_id] = ACTIONS(419),
    [sym__at_lower_id] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(417),
    [sym_boolean] = ACTIONS(417),
    [sym_class] = ACTIONS(417),
    [sym_newtype] = ACTIONS(417),
    [sym_date] = ACTIONS(417),
    [sym_desc] = ACTIONS(417),
    [sym_import] = ACTIONS(417),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(417),
    [sym_predicate] = ACTIONS(417),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [266] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_from] = ACTIONS(439),
    [anon_sym_where] = ACTIONS(439),
    [anon_sym_select] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(439),
    [anon_sym_implies] = ACTIONS(439),
    [anon_sym_order] = ACTIONS(439),
    [sym_qldoc] = ACTIONS(437),
    [anon_sym_float] = ACTIONS(439),
    [anon_sym_int] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [sym__upper_id] = ACTIONS(437),
    [sym__at_lower_id] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(439),
    [sym_boolean] = ACTIONS(439),
    [sym_class] = ACTIONS(439),
    [sym_newtype] = ACTIONS(439),
    [sym_date] = ACTIONS(439),
    [sym_import] = ACTIONS(439),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(439),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [267] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_select] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_implies] = ACTIONS(461),
    [sym_qldoc] = ACTIONS(459),
    [anon_sym_float] = ACTIONS(461),
    [anon_sym_int] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [sym__upper_id] = ACTIONS(459),
    [sym__at_lower_id] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(461),
    [sym_boolean] = ACTIONS(461),
    [sym_class] = ACTIONS(461),
    [sym_newtype] = ACTIONS(461),
    [sym_date] = ACTIONS(461),
    [sym_desc] = ACTIONS(461),
    [sym_import] = ACTIONS(461),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(461),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [268] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(493),
    [anon_sym_from] = ACTIONS(493),
    [anon_sym_where] = ACTIONS(493),
    [anon_sym_select] = ACTIONS(493),
    [anon_sym_and] = ACTIONS(493),
    [anon_sym_implies] = ACTIONS(493),
    [anon_sym_order] = ACTIONS(493),
    [sym_qldoc] = ACTIONS(495),
    [anon_sym_float] = ACTIONS(493),
    [anon_sym_int] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [sym__upper_id] = ACTIONS(495),
    [sym__at_lower_id] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(493),
    [sym_boolean] = ACTIONS(493),
    [sym_class] = ACTIONS(493),
    [sym_newtype] = ACTIONS(493),
    [sym_date] = ACTIONS(493),
    [sym_import] = ACTIONS(493),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(493),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [269] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_from] = ACTIONS(423),
    [anon_sym_where] = ACTIONS(423),
    [anon_sym_select] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_implies] = ACTIONS(423),
    [anon_sym_order] = ACTIONS(423),
    [sym_qldoc] = ACTIONS(421),
    [anon_sym_float] = ACTIONS(423),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_string] = ACTIONS(423),
    [sym__upper_id] = ACTIONS(421),
    [sym__at_lower_id] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(423),
    [sym_boolean] = ACTIONS(423),
    [sym_class] = ACTIONS(423),
    [sym_newtype] = ACTIONS(423),
    [sym_date] = ACTIONS(423),
    [sym_import] = ACTIONS(423),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(423),
    [sym_predicate] = ACTIONS(423),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [270] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(493),
    [anon_sym_from] = ACTIONS(493),
    [anon_sym_where] = ACTIONS(493),
    [anon_sym_select] = ACTIONS(493),
    [anon_sym_and] = ACTIONS(493),
    [anon_sym_implies] = ACTIONS(493),
    [sym_qldoc] = ACTIONS(495),
    [anon_sym_float] = ACTIONS(493),
    [anon_sym_int] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [sym__upper_id] = ACTIONS(495),
    [sym__at_lower_id] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(493),
    [sym_boolean] = ACTIONS(493),
    [sym_class] = ACTIONS(493),
    [sym_newtype] = ACTIONS(493),
    [sym_date] = ACTIONS(493),
    [sym_desc] = ACTIONS(493),
    [sym_import] = ACTIONS(493),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(493),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [271] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(495),
    [sym__lower_id] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(493),
    [anon_sym_from] = ACTIONS(493),
    [anon_sym_where] = ACTIONS(493),
    [anon_sym_select] = ACTIONS(493),
    [anon_sym_and] = ACTIONS(493),
    [anon_sym_implies] = ACTIONS(493),
    [anon_sym_order] = ACTIONS(493),
    [sym_qldoc] = ACTIONS(495),
    [anon_sym_float] = ACTIONS(493),
    [anon_sym_int] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [sym__upper_id] = ACTIONS(495),
    [sym__at_lower_id] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(493),
    [sym_boolean] = ACTIONS(493),
    [sym_class] = ACTIONS(493),
    [sym_newtype] = ACTIONS(493),
    [sym_date] = ACTIONS(493),
    [sym_import] = ACTIONS(493),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(493),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(472),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_desc] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [273] = {
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(472),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [274] = {
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [275] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_from] = ACTIONS(423),
    [anon_sym_where] = ACTIONS(423),
    [anon_sym_select] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(423),
    [anon_sym_implies] = ACTIONS(423),
    [sym_qldoc] = ACTIONS(421),
    [anon_sym_float] = ACTIONS(423),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_string] = ACTIONS(423),
    [sym__upper_id] = ACTIONS(421),
    [sym__at_lower_id] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(423),
    [sym_boolean] = ACTIONS(423),
    [sym_class] = ACTIONS(423),
    [sym_newtype] = ACTIONS(423),
    [sym_date] = ACTIONS(423),
    [sym_desc] = ACTIONS(423),
    [sym_import] = ACTIONS(423),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(423),
    [sym_predicate] = ACTIONS(423),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [276] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym__lower_id] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_from] = ACTIONS(439),
    [anon_sym_where] = ACTIONS(439),
    [anon_sym_select] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(439),
    [anon_sym_implies] = ACTIONS(439),
    [sym_qldoc] = ACTIONS(437),
    [anon_sym_float] = ACTIONS(439),
    [anon_sym_int] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [sym__upper_id] = ACTIONS(437),
    [sym__at_lower_id] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(439),
    [sym_boolean] = ACTIONS(439),
    [sym_class] = ACTIONS(439),
    [sym_newtype] = ACTIONS(439),
    [sym_date] = ACTIONS(439),
    [sym_desc] = ACTIONS(439),
    [sym_import] = ACTIONS(439),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(439),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [277] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(441),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(479),
    [anon_sym_from] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(441),
    [anon_sym_select] = ACTIONS(441),
    [anon_sym_and] = ACTIONS(481),
    [anon_sym_implies] = ACTIONS(483),
    [anon_sym_order] = ACTIONS(441),
    [sym_qldoc] = ACTIONS(443),
    [anon_sym_float] = ACTIONS(441),
    [anon_sym_int] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [sym__upper_id] = ACTIONS(443),
    [sym__at_lower_id] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(441),
    [sym_boolean] = ACTIONS(441),
    [sym_class] = ACTIONS(441),
    [sym_newtype] = ACTIONS(441),
    [sym_date] = ACTIONS(441),
    [sym_import] = ACTIONS(441),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(441),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [278] = {
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(472),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_desc] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [279] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(445),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_from] = ACTIONS(445),
    [anon_sym_where] = ACTIONS(445),
    [anon_sym_select] = ACTIONS(445),
    [anon_sym_and] = ACTIONS(481),
    [anon_sym_implies] = ACTIONS(445),
    [anon_sym_order] = ACTIONS(445),
    [sym_qldoc] = ACTIONS(447),
    [anon_sym_float] = ACTIONS(445),
    [anon_sym_int] = ACTIONS(445),
    [anon_sym_string] = ACTIONS(445),
    [sym__upper_id] = ACTIONS(447),
    [sym__at_lower_id] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(445),
    [sym_boolean] = ACTIONS(445),
    [sym_class] = ACTIONS(445),
    [sym_newtype] = ACTIONS(445),
    [sym_date] = ACTIONS(445),
    [sym_import] = ACTIONS(445),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(445),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [280] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(495),
    [sym__lower_id] = ACTIONS(493),
    [anon_sym_module] = ACTIONS(493),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(493),
    [anon_sym_from] = ACTIONS(493),
    [anon_sym_where] = ACTIONS(493),
    [anon_sym_select] = ACTIONS(493),
    [anon_sym_and] = ACTIONS(493),
    [anon_sym_implies] = ACTIONS(493),
    [sym_qldoc] = ACTIONS(495),
    [anon_sym_float] = ACTIONS(493),
    [anon_sym_int] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [sym__upper_id] = ACTIONS(495),
    [sym__at_lower_id] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(493),
    [sym_boolean] = ACTIONS(493),
    [sym_class] = ACTIONS(493),
    [sym_newtype] = ACTIONS(493),
    [sym_date] = ACTIONS(493),
    [sym_desc] = ACTIONS(493),
    [sym_import] = ACTIONS(493),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(493),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [281] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(479),
    [anon_sym_from] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(427),
    [anon_sym_select] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(481),
    [anon_sym_implies] = ACTIONS(427),
    [anon_sym_order] = ACTIONS(427),
    [sym_qldoc] = ACTIONS(425),
    [anon_sym_float] = ACTIONS(427),
    [anon_sym_int] = ACTIONS(427),
    [anon_sym_string] = ACTIONS(427),
    [sym__upper_id] = ACTIONS(425),
    [sym__at_lower_id] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(427),
    [sym_boolean] = ACTIONS(427),
    [sym_class] = ACTIONS(427),
    [sym_newtype] = ACTIONS(427),
    [sym_date] = ACTIONS(427),
    [sym_import] = ACTIONS(427),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(427),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [282] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(449),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_from] = ACTIONS(449),
    [anon_sym_where] = ACTIONS(449),
    [anon_sym_select] = ACTIONS(449),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_implies] = ACTIONS(449),
    [anon_sym_order] = ACTIONS(449),
    [sym_qldoc] = ACTIONS(451),
    [anon_sym_float] = ACTIONS(449),
    [anon_sym_int] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [sym__upper_id] = ACTIONS(451),
    [sym__at_lower_id] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(449),
    [sym_boolean] = ACTIONS(449),
    [sym_class] = ACTIONS(449),
    [sym_newtype] = ACTIONS(449),
    [sym_date] = ACTIONS(449),
    [sym_import] = ACTIONS(449),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(449),
    [sym_predicate] = ACTIONS(449),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [283] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(419),
    [sym__lower_id] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_from] = ACTIONS(417),
    [anon_sym_where] = ACTIONS(417),
    [anon_sym_select] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_implies] = ACTIONS(417),
    [sym_qldoc] = ACTIONS(419),
    [anon_sym_float] = ACTIONS(417),
    [anon_sym_int] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [sym__upper_id] = ACTIONS(419),
    [sym__at_lower_id] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(417),
    [sym_boolean] = ACTIONS(417),
    [sym_class] = ACTIONS(417),
    [sym_newtype] = ACTIONS(417),
    [sym_date] = ACTIONS(417),
    [sym_desc] = ACTIONS(417),
    [sym_import] = ACTIONS(417),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(417),
    [sym_predicate] = ACTIONS(417),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [284] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(451),
    [sym__lower_id] = ACTIONS(449),
    [anon_sym_module] = ACTIONS(449),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_from] = ACTIONS(449),
    [anon_sym_where] = ACTIONS(449),
    [anon_sym_select] = ACTIONS(449),
    [anon_sym_and] = ACTIONS(449),
    [anon_sym_implies] = ACTIONS(449),
    [sym_qldoc] = ACTIONS(451),
    [anon_sym_float] = ACTIONS(449),
    [anon_sym_int] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [sym__upper_id] = ACTIONS(451),
    [sym__at_lower_id] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(449),
    [sym_boolean] = ACTIONS(449),
    [sym_class] = ACTIONS(449),
    [sym_newtype] = ACTIONS(449),
    [sym_date] = ACTIONS(449),
    [sym_desc] = ACTIONS(449),
    [sym_import] = ACTIONS(449),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(449),
    [sym_predicate] = ACTIONS(449),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [285] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(479),
    [anon_sym_from] = ACTIONS(453),
    [anon_sym_where] = ACTIONS(453),
    [anon_sym_select] = ACTIONS(453),
    [anon_sym_and] = ACTIONS(481),
    [anon_sym_implies] = ACTIONS(483),
    [anon_sym_order] = ACTIONS(453),
    [sym_qldoc] = ACTIONS(455),
    [anon_sym_float] = ACTIONS(453),
    [anon_sym_int] = ACTIONS(453),
    [anon_sym_string] = ACTIONS(453),
    [sym__upper_id] = ACTIONS(455),
    [sym__at_lower_id] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(453),
    [sym_boolean] = ACTIONS(453),
    [sym_class] = ACTIONS(453),
    [sym_newtype] = ACTIONS(453),
    [sym_date] = ACTIONS(453),
    [sym_import] = ACTIONS(453),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(453),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [286] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(459),
    [sym__lower_id] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(461),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_select] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_implies] = ACTIONS(461),
    [sym_qldoc] = ACTIONS(459),
    [anon_sym_float] = ACTIONS(461),
    [anon_sym_int] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [sym__upper_id] = ACTIONS(459),
    [sym__at_lower_id] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(461),
    [sym_boolean] = ACTIONS(461),
    [sym_class] = ACTIONS(461),
    [sym_newtype] = ACTIONS(461),
    [sym_date] = ACTIONS(461),
    [sym_desc] = ACTIONS(461),
    [sym_import] = ACTIONS(461),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(461),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [287] = {
    [sym_compop] = STATE(140),
    [sym_mulop] = STATE(138),
    [sym_addop] = STATE(137),
    [sym__lower_id] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_from] = ACTIONS(461),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_select] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(461),
    [anon_sym_implies] = ACTIONS(461),
    [anon_sym_order] = ACTIONS(461),
    [sym_qldoc] = ACTIONS(459),
    [anon_sym_float] = ACTIONS(461),
    [anon_sym_int] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [sym__upper_id] = ACTIONS(459),
    [sym__at_lower_id] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(461),
    [sym_boolean] = ACTIONS(461),
    [sym_class] = ACTIONS(461),
    [sym_newtype] = ACTIONS(461),
    [sym_date] = ACTIONS(461),
    [sym_import] = ACTIONS(461),
    [sym_in] = ACTIONS(487),
    [sym_instanceof] = ACTIONS(489),
    [sym_predicate] = ACTIONS(461),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [288] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_desc] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [289] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(425),
    [sym__lower_id] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(427),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_from] = ACTIONS(427),
    [anon_sym_where] = ACTIONS(427),
    [anon_sym_select] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_implies] = ACTIONS(427),
    [sym_qldoc] = ACTIONS(425),
    [anon_sym_float] = ACTIONS(427),
    [anon_sym_int] = ACTIONS(427),
    [anon_sym_string] = ACTIONS(427),
    [sym__upper_id] = ACTIONS(425),
    [sym__at_lower_id] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(427),
    [sym_boolean] = ACTIONS(427),
    [sym_class] = ACTIONS(427),
    [sym_newtype] = ACTIONS(427),
    [sym_date] = ACTIONS(427),
    [sym_desc] = ACTIONS(427),
    [sym_import] = ACTIONS(427),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(427),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [290] = {
    [sym_compop] = STATE(215),
    [sym_mulop] = STATE(216),
    [sym_addop] = STATE(219),
    [sym__lower_id] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_from] = ACTIONS(439),
    [anon_sym_where] = ACTIONS(439),
    [anon_sym_select] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(439),
    [anon_sym_implies] = ACTIONS(439),
    [sym_qldoc] = ACTIONS(437),
    [anon_sym_float] = ACTIONS(439),
    [anon_sym_int] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [sym__upper_id] = ACTIONS(437),
    [sym__at_lower_id] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(439),
    [sym_boolean] = ACTIONS(439),
    [sym_class] = ACTIONS(439),
    [sym_newtype] = ACTIONS(439),
    [sym_date] = ACTIONS(439),
    [sym_desc] = ACTIONS(439),
    [sym_import] = ACTIONS(439),
    [sym_in] = ACTIONS(413),
    [sym_instanceof] = ACTIONS(415),
    [sym_predicate] = ACTIONS(439),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [291] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(443),
    [sym__lower_id] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(441),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(383),
    [anon_sym_from] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(441),
    [anon_sym_select] = ACTIONS(441),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_implies] = ACTIONS(387),
    [sym_qldoc] = ACTIONS(443),
    [anon_sym_float] = ACTIONS(441),
    [anon_sym_int] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [sym__upper_id] = ACTIONS(443),
    [sym__at_lower_id] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(441),
    [sym_boolean] = ACTIONS(441),
    [sym_class] = ACTIONS(441),
    [sym_newtype] = ACTIONS(441),
    [sym_date] = ACTIONS(441),
    [sym_desc] = ACTIONS(441),
    [sym_import] = ACTIONS(441),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(441),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [292] = {
    [sym_compop] = STATE(104),
    [sym_mulop] = STATE(103),
    [sym_addop] = STATE(99),
    [ts_builtin_sym_end] = ACTIONS(447),
    [sym__lower_id] = ACTIONS(445),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_from] = ACTIONS(445),
    [anon_sym_where] = ACTIONS(445),
    [anon_sym_select] = ACTIONS(445),
    [anon_sym_and] = ACTIONS(385),
    [anon_sym_implies] = ACTIONS(445),
    [sym_qldoc] = ACTIONS(447),
    [anon_sym_float] = ACTIONS(445),
    [anon_sym_int] = ACTIONS(445),
    [anon_sym_string] = ACTIONS(445),
    [sym__upper_id] = ACTIONS(447),
    [sym__at_lower_id] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(445),
    [sym_boolean] = ACTIONS(445),
    [sym_class] = ACTIONS(445),
    [sym_newtype] = ACTIONS(445),
    [sym_date] = ACTIONS(445),
    [sym_desc] = ACTIONS(445),
    [sym_import] = ACTIONS(445),
    [sym_in] = ACTIONS(391),
    [sym_instanceof] = ACTIONS(393),
    [sym_predicate] = ACTIONS(445),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [293] = {
    [sym_compop] = STATE(240),
    [sym_mulop] = STATE(238),
    [sym_addop] = STATE(237),
    [ts_builtin_sym_end] = ACTIONS(443),
    [sym__lower_id] = ACTIONS(441),
    [anon_sym_module] = ACTIONS(441),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(429),
    [anon_sym_from] = ACTIONS(441),
    [anon_sym_where] = ACTIONS(441),
    [anon_sym_select] = ACTIONS(441),
    [anon_sym_and] = ACTIONS(431),
    [anon_sym_implies] = ACTIONS(457),
    [anon_sym_order] = ACTIONS(441),
    [sym_qldoc] = ACTIONS(443),
    [anon_sym_float] = ACTIONS(441),
    [anon_sym_int] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [sym__upper_id] = ACTIONS(443),
    [sym__at_lower_id] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(441),
    [sym_boolean] = ACTIONS(441),
    [sym_class] = ACTIONS(441),
    [sym_newtype] = ACTIONS(441),
    [sym_date] = ACTIONS(441),
    [sym_import] = ACTIONS(441),
    [sym_in] = ACTIONS(433),
    [sym_instanceof] = ACTIONS(435),
    [sym_predicate] = ACTIONS(441),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [294] = {
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(497),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_and] = ACTIONS(497),
    [anon_sym_implies] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(497),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_desc] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(499),
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(497),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_and] = ACTIONS(497),
    [anon_sym_implies] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(497),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_desc] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [296] = {
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(497),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_and] = ACTIONS(497),
    [anon_sym_implies] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [anon_sym_order] = ACTIONS(497),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(497),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(499),
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(497),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_and] = ACTIONS(497),
    [anon_sym_implies] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [anon_sym_order] = ACTIONS(497),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(497),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [298] = {
    [sym__lower_id] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_from] = ACTIONS(503),
    [anon_sym_where] = ACTIONS(503),
    [anon_sym_select] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_implies] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(505),
    [anon_sym_order] = ACTIONS(503),
    [sym_qldoc] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(503),
    [anon_sym_int] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [sym__upper_id] = ACTIONS(505),
    [sym__at_lower_id] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(503),
    [sym_boolean] = ACTIONS(503),
    [sym_class] = ACTIONS(503),
    [sym_newtype] = ACTIONS(503),
    [sym_date] = ACTIONS(503),
    [sym_import] = ACTIONS(503),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(503),
    [sym_predicate] = ACTIONS(503),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(507),
    [sym__lower_id] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(509),
    [anon_sym_from] = ACTIONS(509),
    [anon_sym_where] = ACTIONS(509),
    [anon_sym_select] = ACTIONS(509),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_implies] = ACTIONS(509),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_order] = ACTIONS(509),
    [sym_qldoc] = ACTIONS(507),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_string] = ACTIONS(509),
    [sym__upper_id] = ACTIONS(507),
    [sym__at_lower_id] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(509),
    [sym_boolean] = ACTIONS(509),
    [sym_class] = ACTIONS(509),
    [sym_newtype] = ACTIONS(509),
    [sym_date] = ACTIONS(509),
    [sym_import] = ACTIONS(509),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(509),
    [sym_predicate] = ACTIONS(509),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(511),
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(513),
    [anon_sym_where] = ACTIONS(513),
    [anon_sym_select] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(513),
    [anon_sym_implies] = ACTIONS(513),
    [sym_qldoc] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_int] = ACTIONS(513),
    [anon_sym_string] = ACTIONS(513),
    [sym__upper_id] = ACTIONS(511),
    [sym__at_lower_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(513),
    [sym_boolean] = ACTIONS(513),
    [sym_class] = ACTIONS(513),
    [sym_newtype] = ACTIONS(513),
    [sym_date] = ACTIONS(513),
    [sym_desc] = ACTIONS(513),
    [sym_import] = ACTIONS(513),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(513),
    [sym_predicate] = ACTIONS(513),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [301] = {
    [sym__lower_id] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_from] = ACTIONS(515),
    [anon_sym_where] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_implies] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_order] = ACTIONS(515),
    [sym_qldoc] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(515),
    [anon_sym_int] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [sym__upper_id] = ACTIONS(517),
    [sym__at_lower_id] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(515),
    [sym_boolean] = ACTIONS(515),
    [sym_class] = ACTIONS(515),
    [sym_newtype] = ACTIONS(515),
    [sym_date] = ACTIONS(515),
    [sym_import] = ACTIONS(515),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(515),
    [sym_predicate] = ACTIONS(515),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [302] = {
    [sym__lower_id] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(521),
    [anon_sym_from] = ACTIONS(521),
    [anon_sym_where] = ACTIONS(521),
    [anon_sym_select] = ACTIONS(521),
    [anon_sym_and] = ACTIONS(521),
    [anon_sym_implies] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(523),
    [anon_sym_order] = ACTIONS(521),
    [sym_qldoc] = ACTIONS(523),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_int] = ACTIONS(521),
    [anon_sym_string] = ACTIONS(521),
    [sym__upper_id] = ACTIONS(523),
    [sym__at_lower_id] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(521),
    [sym_boolean] = ACTIONS(521),
    [sym_class] = ACTIONS(521),
    [sym_newtype] = ACTIONS(521),
    [sym_date] = ACTIONS(521),
    [sym_import] = ACTIONS(521),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(521),
    [sym_predicate] = ACTIONS(521),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [303] = {
    [sym__lower_id] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(525),
    [anon_sym_from] = ACTIONS(525),
    [anon_sym_where] = ACTIONS(525),
    [anon_sym_select] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(525),
    [anon_sym_implies] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_order] = ACTIONS(525),
    [sym_qldoc] = ACTIONS(527),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_int] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [sym__upper_id] = ACTIONS(527),
    [sym__at_lower_id] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(525),
    [sym_boolean] = ACTIONS(525),
    [sym_class] = ACTIONS(525),
    [sym_newtype] = ACTIONS(525),
    [sym_date] = ACTIONS(525),
    [sym_import] = ACTIONS(525),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(525),
    [sym_predicate] = ACTIONS(525),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [304] = {
    [sym__lower_id] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(529),
    [anon_sym_from] = ACTIONS(529),
    [anon_sym_where] = ACTIONS(529),
    [anon_sym_select] = ACTIONS(529),
    [anon_sym_and] = ACTIONS(529),
    [anon_sym_implies] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_order] = ACTIONS(529),
    [sym_qldoc] = ACTIONS(531),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_int] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [sym__upper_id] = ACTIONS(531),
    [sym__at_lower_id] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(529),
    [sym_boolean] = ACTIONS(529),
    [sym_class] = ACTIONS(529),
    [sym_newtype] = ACTIONS(529),
    [sym_date] = ACTIONS(529),
    [sym_import] = ACTIONS(529),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(529),
    [sym_predicate] = ACTIONS(529),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [305] = {
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(533),
    [anon_sym_from] = ACTIONS(533),
    [anon_sym_where] = ACTIONS(533),
    [anon_sym_select] = ACTIONS(533),
    [anon_sym_and] = ACTIONS(533),
    [anon_sym_implies] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_order] = ACTIONS(533),
    [sym_qldoc] = ACTIONS(535),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_int] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [sym__upper_id] = ACTIONS(535),
    [sym__at_lower_id] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(533),
    [sym_boolean] = ACTIONS(533),
    [sym_class] = ACTIONS(533),
    [sym_newtype] = ACTIONS(533),
    [sym_date] = ACTIONS(533),
    [sym_import] = ACTIONS(533),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(533),
    [sym_predicate] = ACTIONS(533),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [306] = {
    [sym__lower_id] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(537),
    [anon_sym_from] = ACTIONS(537),
    [anon_sym_where] = ACTIONS(537),
    [anon_sym_select] = ACTIONS(537),
    [anon_sym_and] = ACTIONS(537),
    [anon_sym_implies] = ACTIONS(537),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_order] = ACTIONS(537),
    [sym_qldoc] = ACTIONS(539),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_int] = ACTIONS(537),
    [anon_sym_string] = ACTIONS(537),
    [sym__upper_id] = ACTIONS(539),
    [sym__at_lower_id] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(537),
    [sym_boolean] = ACTIONS(537),
    [sym_class] = ACTIONS(537),
    [sym_newtype] = ACTIONS(537),
    [sym_date] = ACTIONS(537),
    [sym_import] = ACTIONS(537),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(537),
    [sym_predicate] = ACTIONS(537),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [307] = {
    [sym__lower_id] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(541),
    [anon_sym_from] = ACTIONS(541),
    [anon_sym_where] = ACTIONS(541),
    [anon_sym_select] = ACTIONS(541),
    [anon_sym_and] = ACTIONS(541),
    [anon_sym_implies] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(543),
    [anon_sym_order] = ACTIONS(541),
    [sym_qldoc] = ACTIONS(543),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_int] = ACTIONS(541),
    [anon_sym_string] = ACTIONS(541),
    [sym__upper_id] = ACTIONS(543),
    [sym__at_lower_id] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(541),
    [sym_boolean] = ACTIONS(541),
    [sym_class] = ACTIONS(541),
    [sym_newtype] = ACTIONS(541),
    [sym_date] = ACTIONS(541),
    [sym_import] = ACTIONS(541),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(541),
    [sym_predicate] = ACTIONS(541),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [308] = {
    [sym__lower_id] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(509),
    [anon_sym_from] = ACTIONS(509),
    [anon_sym_where] = ACTIONS(509),
    [anon_sym_select] = ACTIONS(509),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_implies] = ACTIONS(509),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_order] = ACTIONS(509),
    [sym_qldoc] = ACTIONS(507),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_string] = ACTIONS(509),
    [sym__upper_id] = ACTIONS(507),
    [sym__at_lower_id] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(509),
    [sym_boolean] = ACTIONS(509),
    [sym_class] = ACTIONS(509),
    [sym_newtype] = ACTIONS(509),
    [sym_date] = ACTIONS(509),
    [sym_import] = ACTIONS(509),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(509),
    [sym_predicate] = ACTIONS(509),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [309] = {
    [sym__lower_id] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(545),
    [anon_sym_from] = ACTIONS(545),
    [anon_sym_where] = ACTIONS(545),
    [anon_sym_select] = ACTIONS(545),
    [anon_sym_and] = ACTIONS(545),
    [anon_sym_implies] = ACTIONS(545),
    [anon_sym_DOT] = ACTIONS(547),
    [anon_sym_order] = ACTIONS(545),
    [sym_qldoc] = ACTIONS(547),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_int] = ACTIONS(545),
    [anon_sym_string] = ACTIONS(545),
    [sym__upper_id] = ACTIONS(547),
    [sym__at_lower_id] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(545),
    [sym_boolean] = ACTIONS(545),
    [sym_class] = ACTIONS(545),
    [sym_newtype] = ACTIONS(545),
    [sym_date] = ACTIONS(545),
    [sym_import] = ACTIONS(545),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(545),
    [sym_predicate] = ACTIONS(545),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [310] = {
    [sym__lower_id] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(549),
    [anon_sym_from] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(549),
    [anon_sym_select] = ACTIONS(549),
    [anon_sym_and] = ACTIONS(549),
    [anon_sym_implies] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(551),
    [anon_sym_order] = ACTIONS(549),
    [sym_qldoc] = ACTIONS(551),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_int] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [sym__upper_id] = ACTIONS(551),
    [sym__at_lower_id] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(549),
    [sym_boolean] = ACTIONS(549),
    [sym_class] = ACTIONS(549),
    [sym_newtype] = ACTIONS(549),
    [sym_date] = ACTIONS(549),
    [sym_import] = ACTIONS(549),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(549),
    [sym_predicate] = ACTIONS(549),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [311] = {
    [sym__lower_id] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(553),
    [anon_sym_from] = ACTIONS(553),
    [anon_sym_where] = ACTIONS(553),
    [anon_sym_select] = ACTIONS(553),
    [anon_sym_and] = ACTIONS(553),
    [anon_sym_implies] = ACTIONS(553),
    [anon_sym_DOT] = ACTIONS(555),
    [anon_sym_order] = ACTIONS(553),
    [sym_qldoc] = ACTIONS(555),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_int] = ACTIONS(553),
    [anon_sym_string] = ACTIONS(553),
    [sym__upper_id] = ACTIONS(555),
    [sym__at_lower_id] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(553),
    [sym_boolean] = ACTIONS(553),
    [sym_class] = ACTIONS(553),
    [sym_newtype] = ACTIONS(553),
    [sym_date] = ACTIONS(553),
    [sym_import] = ACTIONS(553),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(553),
    [sym_predicate] = ACTIONS(553),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [312] = {
    [sym__lower_id] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(557),
    [anon_sym_from] = ACTIONS(557),
    [anon_sym_where] = ACTIONS(557),
    [anon_sym_select] = ACTIONS(557),
    [anon_sym_and] = ACTIONS(557),
    [anon_sym_implies] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_order] = ACTIONS(557),
    [sym_qldoc] = ACTIONS(559),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_int] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [sym__upper_id] = ACTIONS(559),
    [sym__at_lower_id] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(557),
    [sym_boolean] = ACTIONS(557),
    [sym_class] = ACTIONS(557),
    [sym_newtype] = ACTIONS(557),
    [sym_date] = ACTIONS(557),
    [sym_import] = ACTIONS(557),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(557),
    [sym_predicate] = ACTIONS(557),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [313] = {
    [sym__lower_id] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(561),
    [anon_sym_from] = ACTIONS(561),
    [anon_sym_where] = ACTIONS(561),
    [anon_sym_select] = ACTIONS(561),
    [anon_sym_and] = ACTIONS(561),
    [anon_sym_implies] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_order] = ACTIONS(561),
    [sym_qldoc] = ACTIONS(563),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [sym__upper_id] = ACTIONS(563),
    [sym__at_lower_id] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(561),
    [sym_boolean] = ACTIONS(561),
    [sym_class] = ACTIONS(561),
    [sym_newtype] = ACTIONS(561),
    [sym_date] = ACTIONS(561),
    [sym_import] = ACTIONS(561),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(561),
    [sym_predicate] = ACTIONS(561),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [314] = {
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(513),
    [anon_sym_where] = ACTIONS(513),
    [anon_sym_select] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(513),
    [anon_sym_implies] = ACTIONS(513),
    [anon_sym_order] = ACTIONS(513),
    [sym_qldoc] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_int] = ACTIONS(513),
    [anon_sym_string] = ACTIONS(513),
    [sym__upper_id] = ACTIONS(511),
    [sym__at_lower_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(513),
    [sym_boolean] = ACTIONS(513),
    [sym_class] = ACTIONS(513),
    [sym_newtype] = ACTIONS(513),
    [sym_date] = ACTIONS(513),
    [sym_import] = ACTIONS(513),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(513),
    [sym_predicate] = ACTIONS(513),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [315] = {
    [sym__lower_id] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_from] = ACTIONS(565),
    [anon_sym_where] = ACTIONS(565),
    [anon_sym_select] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_implies] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_order] = ACTIONS(565),
    [sym_qldoc] = ACTIONS(567),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_string] = ACTIONS(565),
    [sym__upper_id] = ACTIONS(567),
    [sym__at_lower_id] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(565),
    [sym_boolean] = ACTIONS(565),
    [sym_class] = ACTIONS(565),
    [sym_newtype] = ACTIONS(565),
    [sym_date] = ACTIONS(565),
    [sym_import] = ACTIONS(565),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(565),
    [sym_predicate] = ACTIONS(565),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [316] = {
    [sym__lower_id] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_from] = ACTIONS(569),
    [anon_sym_where] = ACTIONS(569),
    [anon_sym_select] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_implies] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_order] = ACTIONS(569),
    [sym_qldoc] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_int] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [sym__upper_id] = ACTIONS(571),
    [sym__at_lower_id] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(569),
    [sym_boolean] = ACTIONS(569),
    [sym_class] = ACTIONS(569),
    [sym_newtype] = ACTIONS(569),
    [sym_date] = ACTIONS(569),
    [sym_import] = ACTIONS(569),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(569),
    [sym_predicate] = ACTIONS(569),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [317] = {
    [sym__lower_id] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_from] = ACTIONS(573),
    [anon_sym_where] = ACTIONS(573),
    [anon_sym_select] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_implies] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_order] = ACTIONS(573),
    [sym_qldoc] = ACTIONS(575),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_string] = ACTIONS(573),
    [sym__upper_id] = ACTIONS(575),
    [sym__at_lower_id] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(573),
    [sym_boolean] = ACTIONS(573),
    [sym_class] = ACTIONS(573),
    [sym_newtype] = ACTIONS(573),
    [sym_date] = ACTIONS(573),
    [sym_import] = ACTIONS(573),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(573),
    [sym_predicate] = ACTIONS(573),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [318] = {
    [sym__lower_id] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(577),
    [anon_sym_from] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(577),
    [anon_sym_select] = ACTIONS(577),
    [anon_sym_and] = ACTIONS(577),
    [anon_sym_implies] = ACTIONS(577),
    [anon_sym_DOT] = ACTIONS(579),
    [anon_sym_order] = ACTIONS(577),
    [sym_qldoc] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_int] = ACTIONS(577),
    [anon_sym_string] = ACTIONS(577),
    [sym__upper_id] = ACTIONS(579),
    [sym__at_lower_id] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(577),
    [sym_boolean] = ACTIONS(577),
    [sym_class] = ACTIONS(577),
    [sym_newtype] = ACTIONS(577),
    [sym_date] = ACTIONS(577),
    [sym_import] = ACTIONS(577),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(577),
    [sym_predicate] = ACTIONS(577),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [319] = {
    [sym__lower_id] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_from] = ACTIONS(581),
    [anon_sym_where] = ACTIONS(581),
    [anon_sym_select] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_implies] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(583),
    [anon_sym_order] = ACTIONS(581),
    [sym_qldoc] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [sym__upper_id] = ACTIONS(583),
    [sym__at_lower_id] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(581),
    [sym_boolean] = ACTIONS(581),
    [sym_class] = ACTIONS(581),
    [sym_newtype] = ACTIONS(581),
    [sym_date] = ACTIONS(581),
    [sym_import] = ACTIONS(581),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(581),
    [sym_predicate] = ACTIONS(581),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(585),
    [sym__lower_id] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_from] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(587),
    [anon_sym_select] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(587),
    [anon_sym_implies] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(585),
    [anon_sym_order] = ACTIONS(587),
    [sym_qldoc] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_int] = ACTIONS(587),
    [anon_sym_string] = ACTIONS(587),
    [sym__upper_id] = ACTIONS(585),
    [sym__at_lower_id] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(587),
    [sym_boolean] = ACTIONS(587),
    [sym_class] = ACTIONS(587),
    [sym_newtype] = ACTIONS(587),
    [sym_date] = ACTIONS(587),
    [sym_import] = ACTIONS(587),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(587),
    [sym_predicate] = ACTIONS(587),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym__lower_id] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(591),
    [anon_sym_from] = ACTIONS(591),
    [anon_sym_where] = ACTIONS(591),
    [anon_sym_select] = ACTIONS(591),
    [anon_sym_and] = ACTIONS(591),
    [anon_sym_implies] = ACTIONS(591),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_order] = ACTIONS(591),
    [sym_qldoc] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_int] = ACTIONS(591),
    [anon_sym_string] = ACTIONS(591),
    [sym__upper_id] = ACTIONS(589),
    [sym__at_lower_id] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(591),
    [sym_boolean] = ACTIONS(591),
    [sym_class] = ACTIONS(591),
    [sym_newtype] = ACTIONS(591),
    [sym_date] = ACTIONS(591),
    [sym_import] = ACTIONS(591),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(591),
    [sym_predicate] = ACTIONS(591),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [322] = {
    [sym__lower_id] = ACTIONS(593),
    [anon_sym_module] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_from] = ACTIONS(593),
    [anon_sym_where] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_implies] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(595),
    [anon_sym_order] = ACTIONS(593),
    [sym_qldoc] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_string] = ACTIONS(593),
    [sym__upper_id] = ACTIONS(595),
    [sym__at_lower_id] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(593),
    [sym_boolean] = ACTIONS(593),
    [sym_class] = ACTIONS(593),
    [sym_newtype] = ACTIONS(593),
    [sym_date] = ACTIONS(593),
    [sym_import] = ACTIONS(593),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(593),
    [sym_predicate] = ACTIONS(593),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym__lower_id] = ACTIONS(593),
    [anon_sym_module] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_from] = ACTIONS(593),
    [anon_sym_where] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_implies] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(595),
    [anon_sym_order] = ACTIONS(593),
    [sym_qldoc] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_string] = ACTIONS(593),
    [sym__upper_id] = ACTIONS(595),
    [sym__at_lower_id] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(593),
    [sym_boolean] = ACTIONS(593),
    [sym_class] = ACTIONS(593),
    [sym_newtype] = ACTIONS(593),
    [sym_date] = ACTIONS(593),
    [sym_import] = ACTIONS(593),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(593),
    [sym_predicate] = ACTIONS(593),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(583),
    [sym__lower_id] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_from] = ACTIONS(581),
    [anon_sym_where] = ACTIONS(581),
    [anon_sym_select] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_implies] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(583),
    [anon_sym_order] = ACTIONS(581),
    [sym_qldoc] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [sym__upper_id] = ACTIONS(583),
    [sym__at_lower_id] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(581),
    [sym_boolean] = ACTIONS(581),
    [sym_class] = ACTIONS(581),
    [sym_newtype] = ACTIONS(581),
    [sym_date] = ACTIONS(581),
    [sym_import] = ACTIONS(581),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(581),
    [sym_predicate] = ACTIONS(581),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [325] = {
    [sym__lower_id] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(591),
    [anon_sym_from] = ACTIONS(591),
    [anon_sym_where] = ACTIONS(591),
    [anon_sym_select] = ACTIONS(591),
    [anon_sym_and] = ACTIONS(591),
    [anon_sym_implies] = ACTIONS(591),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_order] = ACTIONS(591),
    [sym_qldoc] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_int] = ACTIONS(591),
    [anon_sym_string] = ACTIONS(591),
    [sym__upper_id] = ACTIONS(589),
    [sym__at_lower_id] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(591),
    [sym_boolean] = ACTIONS(591),
    [sym_class] = ACTIONS(591),
    [sym_newtype] = ACTIONS(591),
    [sym_date] = ACTIONS(591),
    [sym_import] = ACTIONS(591),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(591),
    [sym_predicate] = ACTIONS(591),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [326] = {
    [sym__lower_id] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_from] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(587),
    [anon_sym_select] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(587),
    [anon_sym_implies] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(585),
    [anon_sym_order] = ACTIONS(587),
    [sym_qldoc] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_int] = ACTIONS(587),
    [anon_sym_string] = ACTIONS(587),
    [sym__upper_id] = ACTIONS(585),
    [sym__at_lower_id] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(587),
    [sym_boolean] = ACTIONS(587),
    [sym_class] = ACTIONS(587),
    [sym_newtype] = ACTIONS(587),
    [sym_date] = ACTIONS(587),
    [sym_import] = ACTIONS(587),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(587),
    [sym_predicate] = ACTIONS(587),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [327] = {
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(513),
    [anon_sym_where] = ACTIONS(513),
    [anon_sym_select] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(513),
    [anon_sym_implies] = ACTIONS(513),
    [sym_qldoc] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_int] = ACTIONS(513),
    [anon_sym_string] = ACTIONS(513),
    [sym__upper_id] = ACTIONS(511),
    [sym__at_lower_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(513),
    [sym_boolean] = ACTIONS(513),
    [sym_class] = ACTIONS(513),
    [sym_newtype] = ACTIONS(513),
    [sym_date] = ACTIONS(513),
    [sym_desc] = ACTIONS(513),
    [sym_import] = ACTIONS(513),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(513),
    [sym_predicate] = ACTIONS(513),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [sym__lower_id] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(577),
    [anon_sym_from] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(577),
    [anon_sym_select] = ACTIONS(577),
    [anon_sym_and] = ACTIONS(577),
    [anon_sym_implies] = ACTIONS(577),
    [anon_sym_DOT] = ACTIONS(579),
    [anon_sym_order] = ACTIONS(577),
    [sym_qldoc] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_int] = ACTIONS(577),
    [anon_sym_string] = ACTIONS(577),
    [sym__upper_id] = ACTIONS(579),
    [sym__at_lower_id] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(577),
    [sym_boolean] = ACTIONS(577),
    [sym_class] = ACTIONS(577),
    [sym_newtype] = ACTIONS(577),
    [sym_date] = ACTIONS(577),
    [sym_import] = ACTIONS(577),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(577),
    [sym_predicate] = ACTIONS(577),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(575),
    [sym__lower_id] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_from] = ACTIONS(573),
    [anon_sym_where] = ACTIONS(573),
    [anon_sym_select] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_implies] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_order] = ACTIONS(573),
    [sym_qldoc] = ACTIONS(575),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_string] = ACTIONS(573),
    [sym__upper_id] = ACTIONS(575),
    [sym__at_lower_id] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(573),
    [sym_boolean] = ACTIONS(573),
    [sym_class] = ACTIONS(573),
    [sym_newtype] = ACTIONS(573),
    [sym_date] = ACTIONS(573),
    [sym_import] = ACTIONS(573),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(573),
    [sym_predicate] = ACTIONS(573),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym__lower_id] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_from] = ACTIONS(503),
    [anon_sym_where] = ACTIONS(503),
    [anon_sym_select] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_implies] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(505),
    [anon_sym_order] = ACTIONS(503),
    [sym_qldoc] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(503),
    [anon_sym_int] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [sym__upper_id] = ACTIONS(505),
    [sym__at_lower_id] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(503),
    [sym_boolean] = ACTIONS(503),
    [sym_class] = ACTIONS(503),
    [sym_newtype] = ACTIONS(503),
    [sym_date] = ACTIONS(503),
    [sym_import] = ACTIONS(503),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(503),
    [sym_predicate] = ACTIONS(503),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(535),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(533),
    [anon_sym_from] = ACTIONS(533),
    [anon_sym_where] = ACTIONS(533),
    [anon_sym_select] = ACTIONS(533),
    [anon_sym_and] = ACTIONS(533),
    [anon_sym_implies] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(535),
    [sym_qldoc] = ACTIONS(535),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_int] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [sym__upper_id] = ACTIONS(535),
    [sym__at_lower_id] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(533),
    [sym_boolean] = ACTIONS(533),
    [sym_class] = ACTIONS(533),
    [sym_newtype] = ACTIONS(533),
    [sym_date] = ACTIONS(533),
    [sym_desc] = ACTIONS(533),
    [sym_import] = ACTIONS(533),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(533),
    [sym_predicate] = ACTIONS(533),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym__lower_id] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(529),
    [anon_sym_from] = ACTIONS(529),
    [anon_sym_where] = ACTIONS(529),
    [anon_sym_select] = ACTIONS(529),
    [anon_sym_and] = ACTIONS(529),
    [anon_sym_implies] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(531),
    [sym_qldoc] = ACTIONS(531),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_int] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [sym__upper_id] = ACTIONS(531),
    [sym__at_lower_id] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(529),
    [sym_boolean] = ACTIONS(529),
    [sym_class] = ACTIONS(529),
    [sym_newtype] = ACTIONS(529),
    [sym_date] = ACTIONS(529),
    [sym_desc] = ACTIONS(529),
    [sym_import] = ACTIONS(529),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(529),
    [sym_predicate] = ACTIONS(529),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(527),
    [sym__lower_id] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(525),
    [anon_sym_from] = ACTIONS(525),
    [anon_sym_where] = ACTIONS(525),
    [anon_sym_select] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(525),
    [anon_sym_implies] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [sym_qldoc] = ACTIONS(527),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_int] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [sym__upper_id] = ACTIONS(527),
    [sym__at_lower_id] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(525),
    [sym_boolean] = ACTIONS(525),
    [sym_class] = ACTIONS(525),
    [sym_newtype] = ACTIONS(525),
    [sym_date] = ACTIONS(525),
    [sym_desc] = ACTIONS(525),
    [sym_import] = ACTIONS(525),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(525),
    [sym_predicate] = ACTIONS(525),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [sym__lower_id] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(521),
    [anon_sym_from] = ACTIONS(521),
    [anon_sym_where] = ACTIONS(521),
    [anon_sym_select] = ACTIONS(521),
    [anon_sym_and] = ACTIONS(521),
    [anon_sym_implies] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(523),
    [sym_qldoc] = ACTIONS(523),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_int] = ACTIONS(521),
    [anon_sym_string] = ACTIONS(521),
    [sym__upper_id] = ACTIONS(523),
    [sym__at_lower_id] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(521),
    [sym_boolean] = ACTIONS(521),
    [sym_class] = ACTIONS(521),
    [sym_newtype] = ACTIONS(521),
    [sym_date] = ACTIONS(521),
    [sym_desc] = ACTIONS(521),
    [sym_import] = ACTIONS(521),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(521),
    [sym_predicate] = ACTIONS(521),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym__lower_id] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_from] = ACTIONS(515),
    [anon_sym_where] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_implies] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(597),
    [sym_qldoc] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(515),
    [anon_sym_int] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [sym__upper_id] = ACTIONS(517),
    [sym__at_lower_id] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(515),
    [sym_boolean] = ACTIONS(515),
    [sym_class] = ACTIONS(515),
    [sym_newtype] = ACTIONS(515),
    [sym_date] = ACTIONS(515),
    [sym_desc] = ACTIONS(515),
    [sym_import] = ACTIONS(515),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(515),
    [sym_predicate] = ACTIONS(515),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(571),
    [sym__lower_id] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_from] = ACTIONS(569),
    [anon_sym_where] = ACTIONS(569),
    [anon_sym_select] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_implies] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_order] = ACTIONS(569),
    [sym_qldoc] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_int] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [sym__upper_id] = ACTIONS(571),
    [sym__at_lower_id] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(569),
    [sym_boolean] = ACTIONS(569),
    [sym_class] = ACTIONS(569),
    [sym_newtype] = ACTIONS(569),
    [sym_date] = ACTIONS(569),
    [sym_import] = ACTIONS(569),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(569),
    [sym_predicate] = ACTIONS(569),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(567),
    [sym__lower_id] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_from] = ACTIONS(565),
    [anon_sym_where] = ACTIONS(565),
    [anon_sym_select] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_implies] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_order] = ACTIONS(565),
    [sym_qldoc] = ACTIONS(567),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_string] = ACTIONS(565),
    [sym__upper_id] = ACTIONS(567),
    [sym__at_lower_id] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(565),
    [sym_boolean] = ACTIONS(565),
    [sym_class] = ACTIONS(565),
    [sym_newtype] = ACTIONS(565),
    [sym_date] = ACTIONS(565),
    [sym_import] = ACTIONS(565),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(565),
    [sym_predicate] = ACTIONS(565),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(563),
    [sym__lower_id] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(561),
    [anon_sym_from] = ACTIONS(561),
    [anon_sym_where] = ACTIONS(561),
    [anon_sym_select] = ACTIONS(561),
    [anon_sym_and] = ACTIONS(561),
    [anon_sym_implies] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_order] = ACTIONS(561),
    [sym_qldoc] = ACTIONS(563),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [sym__upper_id] = ACTIONS(563),
    [sym__at_lower_id] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(561),
    [sym_boolean] = ACTIONS(561),
    [sym_class] = ACTIONS(561),
    [sym_newtype] = ACTIONS(561),
    [sym_date] = ACTIONS(561),
    [sym_import] = ACTIONS(561),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(561),
    [sym_predicate] = ACTIONS(561),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(539),
    [sym__lower_id] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(537),
    [anon_sym_from] = ACTIONS(537),
    [anon_sym_where] = ACTIONS(537),
    [anon_sym_select] = ACTIONS(537),
    [anon_sym_and] = ACTIONS(537),
    [anon_sym_implies] = ACTIONS(537),
    [anon_sym_DOT] = ACTIONS(539),
    [sym_qldoc] = ACTIONS(539),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_int] = ACTIONS(537),
    [anon_sym_string] = ACTIONS(537),
    [sym__upper_id] = ACTIONS(539),
    [sym__at_lower_id] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(537),
    [sym_boolean] = ACTIONS(537),
    [sym_class] = ACTIONS(537),
    [sym_newtype] = ACTIONS(537),
    [sym_date] = ACTIONS(537),
    [sym_desc] = ACTIONS(537),
    [sym_import] = ACTIONS(537),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(537),
    [sym_predicate] = ACTIONS(537),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(559),
    [sym__lower_id] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(557),
    [anon_sym_from] = ACTIONS(557),
    [anon_sym_where] = ACTIONS(557),
    [anon_sym_select] = ACTIONS(557),
    [anon_sym_and] = ACTIONS(557),
    [anon_sym_implies] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_order] = ACTIONS(557),
    [sym_qldoc] = ACTIONS(559),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_int] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [sym__upper_id] = ACTIONS(559),
    [sym__at_lower_id] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(557),
    [sym_boolean] = ACTIONS(557),
    [sym_class] = ACTIONS(557),
    [sym_newtype] = ACTIONS(557),
    [sym_date] = ACTIONS(557),
    [sym_import] = ACTIONS(557),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(557),
    [sym_predicate] = ACTIONS(557),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(555),
    [sym__lower_id] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(553),
    [anon_sym_from] = ACTIONS(553),
    [anon_sym_where] = ACTIONS(553),
    [anon_sym_select] = ACTIONS(553),
    [anon_sym_and] = ACTIONS(553),
    [anon_sym_implies] = ACTIONS(553),
    [anon_sym_DOT] = ACTIONS(555),
    [anon_sym_order] = ACTIONS(553),
    [sym_qldoc] = ACTIONS(555),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_int] = ACTIONS(553),
    [anon_sym_string] = ACTIONS(553),
    [sym__upper_id] = ACTIONS(555),
    [sym__at_lower_id] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(553),
    [sym_boolean] = ACTIONS(553),
    [sym_class] = ACTIONS(553),
    [sym_newtype] = ACTIONS(553),
    [sym_date] = ACTIONS(553),
    [sym_import] = ACTIONS(553),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(553),
    [sym_predicate] = ACTIONS(553),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(543),
    [sym__lower_id] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(541),
    [anon_sym_from] = ACTIONS(541),
    [anon_sym_where] = ACTIONS(541),
    [anon_sym_select] = ACTIONS(541),
    [anon_sym_and] = ACTIONS(541),
    [anon_sym_implies] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(543),
    [sym_qldoc] = ACTIONS(543),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_int] = ACTIONS(541),
    [anon_sym_string] = ACTIONS(541),
    [sym__upper_id] = ACTIONS(543),
    [sym__at_lower_id] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(541),
    [sym_boolean] = ACTIONS(541),
    [sym_class] = ACTIONS(541),
    [sym_newtype] = ACTIONS(541),
    [sym_date] = ACTIONS(541),
    [sym_desc] = ACTIONS(541),
    [sym_import] = ACTIONS(541),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(541),
    [sym_predicate] = ACTIONS(541),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(507),
    [sym__lower_id] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(509),
    [anon_sym_from] = ACTIONS(509),
    [anon_sym_where] = ACTIONS(509),
    [anon_sym_select] = ACTIONS(509),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_implies] = ACTIONS(509),
    [anon_sym_DOT] = ACTIONS(507),
    [sym_qldoc] = ACTIONS(507),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_string] = ACTIONS(509),
    [sym__upper_id] = ACTIONS(507),
    [sym__at_lower_id] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(509),
    [sym_boolean] = ACTIONS(509),
    [sym_class] = ACTIONS(509),
    [sym_newtype] = ACTIONS(509),
    [sym_date] = ACTIONS(509),
    [sym_desc] = ACTIONS(509),
    [sym_import] = ACTIONS(509),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(509),
    [sym_predicate] = ACTIONS(509),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(547),
    [sym__lower_id] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(545),
    [anon_sym_from] = ACTIONS(545),
    [anon_sym_where] = ACTIONS(545),
    [anon_sym_select] = ACTIONS(545),
    [anon_sym_and] = ACTIONS(545),
    [anon_sym_implies] = ACTIONS(545),
    [anon_sym_DOT] = ACTIONS(547),
    [sym_qldoc] = ACTIONS(547),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_int] = ACTIONS(545),
    [anon_sym_string] = ACTIONS(545),
    [sym__upper_id] = ACTIONS(547),
    [sym__at_lower_id] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(545),
    [sym_boolean] = ACTIONS(545),
    [sym_class] = ACTIONS(545),
    [sym_newtype] = ACTIONS(545),
    [sym_date] = ACTIONS(545),
    [sym_desc] = ACTIONS(545),
    [sym_import] = ACTIONS(545),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(545),
    [sym_predicate] = ACTIONS(545),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(551),
    [sym__lower_id] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(549),
    [anon_sym_from] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(549),
    [anon_sym_select] = ACTIONS(549),
    [anon_sym_and] = ACTIONS(549),
    [anon_sym_implies] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(551),
    [sym_qldoc] = ACTIONS(551),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_int] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [sym__upper_id] = ACTIONS(551),
    [sym__at_lower_id] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(549),
    [sym_boolean] = ACTIONS(549),
    [sym_class] = ACTIONS(549),
    [sym_newtype] = ACTIONS(549),
    [sym_date] = ACTIONS(549),
    [sym_desc] = ACTIONS(549),
    [sym_import] = ACTIONS(549),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(549),
    [sym_predicate] = ACTIONS(549),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(555),
    [sym__lower_id] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(553),
    [anon_sym_from] = ACTIONS(553),
    [anon_sym_where] = ACTIONS(553),
    [anon_sym_select] = ACTIONS(553),
    [anon_sym_and] = ACTIONS(553),
    [anon_sym_implies] = ACTIONS(553),
    [anon_sym_DOT] = ACTIONS(555),
    [sym_qldoc] = ACTIONS(555),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_int] = ACTIONS(553),
    [anon_sym_string] = ACTIONS(553),
    [sym__upper_id] = ACTIONS(555),
    [sym__at_lower_id] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(553),
    [sym_boolean] = ACTIONS(553),
    [sym_class] = ACTIONS(553),
    [sym_newtype] = ACTIONS(553),
    [sym_date] = ACTIONS(553),
    [sym_desc] = ACTIONS(553),
    [sym_import] = ACTIONS(553),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(553),
    [sym_predicate] = ACTIONS(553),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(559),
    [sym__lower_id] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(557),
    [anon_sym_from] = ACTIONS(557),
    [anon_sym_where] = ACTIONS(557),
    [anon_sym_select] = ACTIONS(557),
    [anon_sym_and] = ACTIONS(557),
    [anon_sym_implies] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(559),
    [sym_qldoc] = ACTIONS(559),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_int] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [sym__upper_id] = ACTIONS(559),
    [sym__at_lower_id] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(557),
    [sym_boolean] = ACTIONS(557),
    [sym_class] = ACTIONS(557),
    [sym_newtype] = ACTIONS(557),
    [sym_date] = ACTIONS(557),
    [sym_desc] = ACTIONS(557),
    [sym_import] = ACTIONS(557),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(557),
    [sym_predicate] = ACTIONS(557),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(551),
    [sym__lower_id] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(549),
    [anon_sym_from] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(549),
    [anon_sym_select] = ACTIONS(549),
    [anon_sym_and] = ACTIONS(549),
    [anon_sym_implies] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(551),
    [anon_sym_order] = ACTIONS(549),
    [sym_qldoc] = ACTIONS(551),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_int] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [sym__upper_id] = ACTIONS(551),
    [sym__at_lower_id] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(549),
    [sym_boolean] = ACTIONS(549),
    [sym_class] = ACTIONS(549),
    [sym_newtype] = ACTIONS(549),
    [sym_date] = ACTIONS(549),
    [sym_import] = ACTIONS(549),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(549),
    [sym_predicate] = ACTIONS(549),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(547),
    [sym__lower_id] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(545),
    [anon_sym_from] = ACTIONS(545),
    [anon_sym_where] = ACTIONS(545),
    [anon_sym_select] = ACTIONS(545),
    [anon_sym_and] = ACTIONS(545),
    [anon_sym_implies] = ACTIONS(545),
    [anon_sym_DOT] = ACTIONS(547),
    [anon_sym_order] = ACTIONS(545),
    [sym_qldoc] = ACTIONS(547),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_int] = ACTIONS(545),
    [anon_sym_string] = ACTIONS(545),
    [sym__upper_id] = ACTIONS(547),
    [sym__at_lower_id] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(545),
    [sym_boolean] = ACTIONS(545),
    [sym_class] = ACTIONS(545),
    [sym_newtype] = ACTIONS(545),
    [sym_date] = ACTIONS(545),
    [sym_import] = ACTIONS(545),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(545),
    [sym_predicate] = ACTIONS(545),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(543),
    [sym__lower_id] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(541),
    [anon_sym_from] = ACTIONS(541),
    [anon_sym_where] = ACTIONS(541),
    [anon_sym_select] = ACTIONS(541),
    [anon_sym_and] = ACTIONS(541),
    [anon_sym_implies] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(543),
    [anon_sym_order] = ACTIONS(541),
    [sym_qldoc] = ACTIONS(543),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_int] = ACTIONS(541),
    [anon_sym_string] = ACTIONS(541),
    [sym__upper_id] = ACTIONS(543),
    [sym__at_lower_id] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(541),
    [sym_boolean] = ACTIONS(541),
    [sym_class] = ACTIONS(541),
    [sym_newtype] = ACTIONS(541),
    [sym_date] = ACTIONS(541),
    [sym_import] = ACTIONS(541),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(541),
    [sym_predicate] = ACTIONS(541),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(563),
    [sym__lower_id] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(561),
    [anon_sym_from] = ACTIONS(561),
    [anon_sym_where] = ACTIONS(561),
    [anon_sym_select] = ACTIONS(561),
    [anon_sym_and] = ACTIONS(561),
    [anon_sym_implies] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(563),
    [sym_qldoc] = ACTIONS(563),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [sym__upper_id] = ACTIONS(563),
    [sym__at_lower_id] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(561),
    [sym_boolean] = ACTIONS(561),
    [sym_class] = ACTIONS(561),
    [sym_newtype] = ACTIONS(561),
    [sym_date] = ACTIONS(561),
    [sym_desc] = ACTIONS(561),
    [sym_import] = ACTIONS(561),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(561),
    [sym_predicate] = ACTIONS(561),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(567),
    [sym__lower_id] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_from] = ACTIONS(565),
    [anon_sym_where] = ACTIONS(565),
    [anon_sym_select] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_implies] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [sym_qldoc] = ACTIONS(567),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_string] = ACTIONS(565),
    [sym__upper_id] = ACTIONS(567),
    [sym__at_lower_id] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(565),
    [sym_boolean] = ACTIONS(565),
    [sym_class] = ACTIONS(565),
    [sym_newtype] = ACTIONS(565),
    [sym_date] = ACTIONS(565),
    [sym_desc] = ACTIONS(565),
    [sym_import] = ACTIONS(565),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(565),
    [sym_predicate] = ACTIONS(565),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(571),
    [sym__lower_id] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_from] = ACTIONS(569),
    [anon_sym_where] = ACTIONS(569),
    [anon_sym_select] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_implies] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [sym_qldoc] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_int] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [sym__upper_id] = ACTIONS(571),
    [sym__at_lower_id] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(569),
    [sym_boolean] = ACTIONS(569),
    [sym_class] = ACTIONS(569),
    [sym_newtype] = ACTIONS(569),
    [sym_date] = ACTIONS(569),
    [sym_desc] = ACTIONS(569),
    [sym_import] = ACTIONS(569),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(569),
    [sym_predicate] = ACTIONS(569),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(539),
    [sym__lower_id] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(537),
    [anon_sym_from] = ACTIONS(537),
    [anon_sym_where] = ACTIONS(537),
    [anon_sym_select] = ACTIONS(537),
    [anon_sym_and] = ACTIONS(537),
    [anon_sym_implies] = ACTIONS(537),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_order] = ACTIONS(537),
    [sym_qldoc] = ACTIONS(539),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_int] = ACTIONS(537),
    [anon_sym_string] = ACTIONS(537),
    [sym__upper_id] = ACTIONS(539),
    [sym__at_lower_id] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(537),
    [sym_boolean] = ACTIONS(537),
    [sym_class] = ACTIONS(537),
    [sym_newtype] = ACTIONS(537),
    [sym_date] = ACTIONS(537),
    [sym_import] = ACTIONS(537),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(537),
    [sym_predicate] = ACTIONS(537),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym__lower_id] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_from] = ACTIONS(503),
    [anon_sym_where] = ACTIONS(503),
    [anon_sym_select] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_implies] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(505),
    [sym_qldoc] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(503),
    [anon_sym_int] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [sym__upper_id] = ACTIONS(505),
    [sym__at_lower_id] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(503),
    [sym_boolean] = ACTIONS(503),
    [sym_class] = ACTIONS(503),
    [sym_newtype] = ACTIONS(503),
    [sym_date] = ACTIONS(503),
    [sym_desc] = ACTIONS(503),
    [sym_import] = ACTIONS(503),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(503),
    [sym_predicate] = ACTIONS(503),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(575),
    [sym__lower_id] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_from] = ACTIONS(573),
    [anon_sym_where] = ACTIONS(573),
    [anon_sym_select] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_implies] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [sym_qldoc] = ACTIONS(575),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_string] = ACTIONS(573),
    [sym__upper_id] = ACTIONS(575),
    [sym__at_lower_id] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(573),
    [sym_boolean] = ACTIONS(573),
    [sym_class] = ACTIONS(573),
    [sym_newtype] = ACTIONS(573),
    [sym_date] = ACTIONS(573),
    [sym_desc] = ACTIONS(573),
    [sym_import] = ACTIONS(573),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(573),
    [sym_predicate] = ACTIONS(573),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(579),
    [sym__lower_id] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(577),
    [anon_sym_from] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(577),
    [anon_sym_select] = ACTIONS(577),
    [anon_sym_and] = ACTIONS(577),
    [anon_sym_implies] = ACTIONS(577),
    [anon_sym_DOT] = ACTIONS(579),
    [sym_qldoc] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_int] = ACTIONS(577),
    [anon_sym_string] = ACTIONS(577),
    [sym__upper_id] = ACTIONS(579),
    [sym__at_lower_id] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(577),
    [sym_boolean] = ACTIONS(577),
    [sym_class] = ACTIONS(577),
    [sym_newtype] = ACTIONS(577),
    [sym_date] = ACTIONS(577),
    [sym_desc] = ACTIONS(577),
    [sym_import] = ACTIONS(577),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(577),
    [sym_predicate] = ACTIONS(577),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(583),
    [sym__lower_id] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_from] = ACTIONS(581),
    [anon_sym_where] = ACTIONS(581),
    [anon_sym_select] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_implies] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(583),
    [sym_qldoc] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [sym__upper_id] = ACTIONS(583),
    [sym__at_lower_id] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(581),
    [sym_boolean] = ACTIONS(581),
    [sym_class] = ACTIONS(581),
    [sym_newtype] = ACTIONS(581),
    [sym_date] = ACTIONS(581),
    [sym_desc] = ACTIONS(581),
    [sym_import] = ACTIONS(581),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(581),
    [sym_predicate] = ACTIONS(581),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(595),
    [sym__lower_id] = ACTIONS(593),
    [anon_sym_module] = ACTIONS(593),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_from] = ACTIONS(593),
    [anon_sym_where] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_implies] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(595),
    [sym_qldoc] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_string] = ACTIONS(593),
    [sym__upper_id] = ACTIONS(595),
    [sym__at_lower_id] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(593),
    [sym_boolean] = ACTIONS(593),
    [sym_class] = ACTIONS(593),
    [sym_newtype] = ACTIONS(593),
    [sym_date] = ACTIONS(593),
    [sym_desc] = ACTIONS(593),
    [sym_import] = ACTIONS(593),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(593),
    [sym_predicate] = ACTIONS(593),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym__lower_id] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(591),
    [anon_sym_from] = ACTIONS(591),
    [anon_sym_where] = ACTIONS(591),
    [anon_sym_select] = ACTIONS(591),
    [anon_sym_and] = ACTIONS(591),
    [anon_sym_implies] = ACTIONS(591),
    [anon_sym_DOT] = ACTIONS(589),
    [sym_qldoc] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_int] = ACTIONS(591),
    [anon_sym_string] = ACTIONS(591),
    [sym__upper_id] = ACTIONS(589),
    [sym__at_lower_id] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(591),
    [sym_boolean] = ACTIONS(591),
    [sym_class] = ACTIONS(591),
    [sym_newtype] = ACTIONS(591),
    [sym_date] = ACTIONS(591),
    [sym_desc] = ACTIONS(591),
    [sym_import] = ACTIONS(591),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(591),
    [sym_predicate] = ACTIONS(591),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(585),
    [sym__lower_id] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_from] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(587),
    [anon_sym_select] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(587),
    [anon_sym_implies] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(585),
    [sym_qldoc] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_int] = ACTIONS(587),
    [anon_sym_string] = ACTIONS(587),
    [sym__upper_id] = ACTIONS(585),
    [sym__at_lower_id] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(587),
    [sym_boolean] = ACTIONS(587),
    [sym_class] = ACTIONS(587),
    [sym_newtype] = ACTIONS(587),
    [sym_date] = ACTIONS(587),
    [sym_desc] = ACTIONS(587),
    [sym_import] = ACTIONS(587),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(587),
    [sym_predicate] = ACTIONS(587),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [362] = {
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(533),
    [anon_sym_from] = ACTIONS(533),
    [anon_sym_where] = ACTIONS(533),
    [anon_sym_select] = ACTIONS(533),
    [anon_sym_and] = ACTIONS(533),
    [anon_sym_implies] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(535),
    [sym_qldoc] = ACTIONS(535),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_int] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [sym__upper_id] = ACTIONS(535),
    [sym__at_lower_id] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(533),
    [sym_boolean] = ACTIONS(533),
    [sym_class] = ACTIONS(533),
    [sym_newtype] = ACTIONS(533),
    [sym_date] = ACTIONS(533),
    [sym_desc] = ACTIONS(533),
    [sym_import] = ACTIONS(533),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(533),
    [sym_predicate] = ACTIONS(533),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [363] = {
    [sym__lower_id] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(529),
    [anon_sym_from] = ACTIONS(529),
    [anon_sym_where] = ACTIONS(529),
    [anon_sym_select] = ACTIONS(529),
    [anon_sym_and] = ACTIONS(529),
    [anon_sym_implies] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(531),
    [sym_qldoc] = ACTIONS(531),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_int] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [sym__upper_id] = ACTIONS(531),
    [sym__at_lower_id] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(529),
    [sym_boolean] = ACTIONS(529),
    [sym_class] = ACTIONS(529),
    [sym_newtype] = ACTIONS(529),
    [sym_date] = ACTIONS(529),
    [sym_desc] = ACTIONS(529),
    [sym_import] = ACTIONS(529),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(529),
    [sym_predicate] = ACTIONS(529),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [364] = {
    [sym__lower_id] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(525),
    [anon_sym_from] = ACTIONS(525),
    [anon_sym_where] = ACTIONS(525),
    [anon_sym_select] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(525),
    [anon_sym_implies] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [sym_qldoc] = ACTIONS(527),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_int] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [sym__upper_id] = ACTIONS(527),
    [sym__at_lower_id] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(525),
    [sym_boolean] = ACTIONS(525),
    [sym_class] = ACTIONS(525),
    [sym_newtype] = ACTIONS(525),
    [sym_date] = ACTIONS(525),
    [sym_desc] = ACTIONS(525),
    [sym_import] = ACTIONS(525),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(525),
    [sym_predicate] = ACTIONS(525),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [365] = {
    [sym__lower_id] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(521),
    [anon_sym_from] = ACTIONS(521),
    [anon_sym_where] = ACTIONS(521),
    [anon_sym_select] = ACTIONS(521),
    [anon_sym_and] = ACTIONS(521),
    [anon_sym_implies] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(523),
    [sym_qldoc] = ACTIONS(523),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_int] = ACTIONS(521),
    [anon_sym_string] = ACTIONS(521),
    [sym__upper_id] = ACTIONS(523),
    [sym__at_lower_id] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(521),
    [sym_boolean] = ACTIONS(521),
    [sym_class] = ACTIONS(521),
    [sym_newtype] = ACTIONS(521),
    [sym_date] = ACTIONS(521),
    [sym_desc] = ACTIONS(521),
    [sym_import] = ACTIONS(521),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(521),
    [sym_predicate] = ACTIONS(521),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [366] = {
    [sym__lower_id] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_from] = ACTIONS(515),
    [anon_sym_where] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_implies] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(599),
    [sym_qldoc] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(515),
    [anon_sym_int] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [sym__upper_id] = ACTIONS(517),
    [sym__at_lower_id] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(515),
    [sym_boolean] = ACTIONS(515),
    [sym_class] = ACTIONS(515),
    [sym_newtype] = ACTIONS(515),
    [sym_date] = ACTIONS(515),
    [sym_desc] = ACTIONS(515),
    [sym_import] = ACTIONS(515),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(515),
    [sym_predicate] = ACTIONS(515),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [367] = {
    [sym__lower_id] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(537),
    [anon_sym_from] = ACTIONS(537),
    [anon_sym_where] = ACTIONS(537),
    [anon_sym_select] = ACTIONS(537),
    [anon_sym_and] = ACTIONS(537),
    [anon_sym_implies] = ACTIONS(537),
    [anon_sym_DOT] = ACTIONS(539),
    [sym_qldoc] = ACTIONS(539),
    [anon_sym_float] = ACTIONS(537),
    [anon_sym_int] = ACTIONS(537),
    [anon_sym_string] = ACTIONS(537),
    [sym__upper_id] = ACTIONS(539),
    [sym__at_lower_id] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(537),
    [sym_boolean] = ACTIONS(537),
    [sym_class] = ACTIONS(537),
    [sym_newtype] = ACTIONS(537),
    [sym_date] = ACTIONS(537),
    [sym_desc] = ACTIONS(537),
    [sym_import] = ACTIONS(537),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(537),
    [sym_predicate] = ACTIONS(537),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [368] = {
    [sym__lower_id] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_from] = ACTIONS(587),
    [anon_sym_where] = ACTIONS(587),
    [anon_sym_select] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(587),
    [anon_sym_implies] = ACTIONS(587),
    [anon_sym_DOT] = ACTIONS(585),
    [sym_qldoc] = ACTIONS(585),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_int] = ACTIONS(587),
    [anon_sym_string] = ACTIONS(587),
    [sym__upper_id] = ACTIONS(585),
    [sym__at_lower_id] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(587),
    [sym_boolean] = ACTIONS(587),
    [sym_class] = ACTIONS(587),
    [sym_newtype] = ACTIONS(587),
    [sym_date] = ACTIONS(587),
    [sym_desc] = ACTIONS(587),
    [sym_import] = ACTIONS(587),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(587),
    [sym_predicate] = ACTIONS(587),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [sym__lower_id] = ACTIONS(515),
    [anon_sym_module] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_from] = ACTIONS(515),
    [anon_sym_where] = ACTIONS(515),
    [anon_sym_select] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(515),
    [anon_sym_implies] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(601),
    [anon_sym_order] = ACTIONS(515),
    [sym_qldoc] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(515),
    [anon_sym_int] = ACTIONS(515),
    [anon_sym_string] = ACTIONS(515),
    [sym__upper_id] = ACTIONS(517),
    [sym__at_lower_id] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(515),
    [sym_boolean] = ACTIONS(515),
    [sym_class] = ACTIONS(515),
    [sym_newtype] = ACTIONS(515),
    [sym_date] = ACTIONS(515),
    [sym_import] = ACTIONS(515),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(515),
    [sym_predicate] = ACTIONS(515),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [370] = {
    [sym__lower_id] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(591),
    [anon_sym_from] = ACTIONS(591),
    [anon_sym_where] = ACTIONS(591),
    [anon_sym_select] = ACTIONS(591),
    [anon_sym_and] = ACTIONS(591),
    [anon_sym_implies] = ACTIONS(591),
    [anon_sym_DOT] = ACTIONS(589),
    [sym_qldoc] = ACTIONS(589),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_int] = ACTIONS(591),
    [anon_sym_string] = ACTIONS(591),
    [sym__upper_id] = ACTIONS(589),
    [sym__at_lower_id] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(591),
    [sym_boolean] = ACTIONS(591),
    [sym_class] = ACTIONS(591),
    [sym_newtype] = ACTIONS(591),
    [sym_date] = ACTIONS(591),
    [sym_desc] = ACTIONS(591),
    [sym_import] = ACTIONS(591),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(591),
    [sym_predicate] = ACTIONS(591),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [371] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [sym__lower_id] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(521),
    [anon_sym_from] = ACTIONS(521),
    [anon_sym_where] = ACTIONS(521),
    [anon_sym_select] = ACTIONS(521),
    [anon_sym_and] = ACTIONS(521),
    [anon_sym_implies] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(523),
    [anon_sym_order] = ACTIONS(521),
    [sym_qldoc] = ACTIONS(523),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_int] = ACTIONS(521),
    [anon_sym_string] = ACTIONS(521),
    [sym__upper_id] = ACTIONS(523),
    [sym__at_lower_id] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(521),
    [sym_boolean] = ACTIONS(521),
    [sym_class] = ACTIONS(521),
    [sym_newtype] = ACTIONS(521),
    [sym_date] = ACTIONS(521),
    [sym_import] = ACTIONS(521),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(521),
    [sym_predicate] = ACTIONS(521),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [372] = {
    [sym__lower_id] = ACTIONS(593),
    [anon_sym_module] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_from] = ACTIONS(593),
    [anon_sym_where] = ACTIONS(593),
    [anon_sym_select] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(593),
    [anon_sym_implies] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(595),
    [sym_qldoc] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(593),
    [anon_sym_int] = ACTIONS(593),
    [anon_sym_string] = ACTIONS(593),
    [sym__upper_id] = ACTIONS(595),
    [sym__at_lower_id] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(593),
    [sym_boolean] = ACTIONS(593),
    [sym_class] = ACTIONS(593),
    [sym_newtype] = ACTIONS(593),
    [sym_date] = ACTIONS(593),
    [sym_desc] = ACTIONS(593),
    [sym_import] = ACTIONS(593),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(593),
    [sym_predicate] = ACTIONS(593),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(527),
    [sym__lower_id] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(525),
    [anon_sym_from] = ACTIONS(525),
    [anon_sym_where] = ACTIONS(525),
    [anon_sym_select] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(525),
    [anon_sym_implies] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_order] = ACTIONS(525),
    [sym_qldoc] = ACTIONS(527),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_int] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [sym__upper_id] = ACTIONS(527),
    [sym__at_lower_id] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(525),
    [sym_boolean] = ACTIONS(525),
    [sym_class] = ACTIONS(525),
    [sym_newtype] = ACTIONS(525),
    [sym_date] = ACTIONS(525),
    [sym_import] = ACTIONS(525),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(525),
    [sym_predicate] = ACTIONS(525),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [374] = {
    [sym__lower_id] = ACTIONS(581),
    [anon_sym_module] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_from] = ACTIONS(581),
    [anon_sym_where] = ACTIONS(581),
    [anon_sym_select] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(581),
    [anon_sym_implies] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(583),
    [sym_qldoc] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(581),
    [anon_sym_int] = ACTIONS(581),
    [anon_sym_string] = ACTIONS(581),
    [sym__upper_id] = ACTIONS(583),
    [sym__at_lower_id] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(581),
    [sym_boolean] = ACTIONS(581),
    [sym_class] = ACTIONS(581),
    [sym_newtype] = ACTIONS(581),
    [sym_date] = ACTIONS(581),
    [sym_desc] = ACTIONS(581),
    [sym_import] = ACTIONS(581),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(581),
    [sym_predicate] = ACTIONS(581),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym__lower_id] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(529),
    [anon_sym_from] = ACTIONS(529),
    [anon_sym_where] = ACTIONS(529),
    [anon_sym_select] = ACTIONS(529),
    [anon_sym_and] = ACTIONS(529),
    [anon_sym_implies] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_order] = ACTIONS(529),
    [sym_qldoc] = ACTIONS(531),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_int] = ACTIONS(529),
    [anon_sym_string] = ACTIONS(529),
    [sym__upper_id] = ACTIONS(531),
    [sym__at_lower_id] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(529),
    [sym_boolean] = ACTIONS(529),
    [sym_class] = ACTIONS(529),
    [sym_newtype] = ACTIONS(529),
    [sym_date] = ACTIONS(529),
    [sym_import] = ACTIONS(529),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(529),
    [sym_predicate] = ACTIONS(529),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [376] = {
    [ts_builtin_sym_end] = ACTIONS(535),
    [sym__lower_id] = ACTIONS(533),
    [anon_sym_module] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(533),
    [anon_sym_from] = ACTIONS(533),
    [anon_sym_where] = ACTIONS(533),
    [anon_sym_select] = ACTIONS(533),
    [anon_sym_and] = ACTIONS(533),
    [anon_sym_implies] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_order] = ACTIONS(533),
    [sym_qldoc] = ACTIONS(535),
    [anon_sym_float] = ACTIONS(533),
    [anon_sym_int] = ACTIONS(533),
    [anon_sym_string] = ACTIONS(533),
    [sym__upper_id] = ACTIONS(535),
    [sym__at_lower_id] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(533),
    [sym_boolean] = ACTIONS(533),
    [sym_class] = ACTIONS(533),
    [sym_newtype] = ACTIONS(533),
    [sym_date] = ACTIONS(533),
    [sym_import] = ACTIONS(533),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(533),
    [sym_predicate] = ACTIONS(533),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(511),
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_from] = ACTIONS(513),
    [anon_sym_where] = ACTIONS(513),
    [anon_sym_select] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(513),
    [anon_sym_implies] = ACTIONS(513),
    [anon_sym_order] = ACTIONS(513),
    [sym_qldoc] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_int] = ACTIONS(513),
    [anon_sym_string] = ACTIONS(513),
    [sym__upper_id] = ACTIONS(511),
    [sym__at_lower_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(513),
    [sym_boolean] = ACTIONS(513),
    [sym_class] = ACTIONS(513),
    [sym_newtype] = ACTIONS(513),
    [sym_date] = ACTIONS(513),
    [sym_import] = ACTIONS(513),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(513),
    [sym_predicate] = ACTIONS(513),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [378] = {
    [sym__lower_id] = ACTIONS(577),
    [anon_sym_module] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(577),
    [anon_sym_from] = ACTIONS(577),
    [anon_sym_where] = ACTIONS(577),
    [anon_sym_select] = ACTIONS(577),
    [anon_sym_and] = ACTIONS(577),
    [anon_sym_implies] = ACTIONS(577),
    [anon_sym_DOT] = ACTIONS(579),
    [sym_qldoc] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(577),
    [anon_sym_int] = ACTIONS(577),
    [anon_sym_string] = ACTIONS(577),
    [sym__upper_id] = ACTIONS(579),
    [sym__at_lower_id] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(577),
    [sym_boolean] = ACTIONS(577),
    [sym_class] = ACTIONS(577),
    [sym_newtype] = ACTIONS(577),
    [sym_date] = ACTIONS(577),
    [sym_desc] = ACTIONS(577),
    [sym_import] = ACTIONS(577),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(577),
    [sym_predicate] = ACTIONS(577),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [379] = {
    [sym__lower_id] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_from] = ACTIONS(573),
    [anon_sym_where] = ACTIONS(573),
    [anon_sym_select] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_implies] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [sym_qldoc] = ACTIONS(575),
    [anon_sym_float] = ACTIONS(573),
    [anon_sym_int] = ACTIONS(573),
    [anon_sym_string] = ACTIONS(573),
    [sym__upper_id] = ACTIONS(575),
    [sym__at_lower_id] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(573),
    [sym_boolean] = ACTIONS(573),
    [sym_class] = ACTIONS(573),
    [sym_newtype] = ACTIONS(573),
    [sym_date] = ACTIONS(573),
    [sym_desc] = ACTIONS(573),
    [sym_import] = ACTIONS(573),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(573),
    [sym_predicate] = ACTIONS(573),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [380] = {
    [sym__lower_id] = ACTIONS(503),
    [anon_sym_module] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_from] = ACTIONS(503),
    [anon_sym_where] = ACTIONS(503),
    [anon_sym_select] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_implies] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(505),
    [sym_qldoc] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(503),
    [anon_sym_int] = ACTIONS(503),
    [anon_sym_string] = ACTIONS(503),
    [sym__upper_id] = ACTIONS(505),
    [sym__at_lower_id] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(503),
    [sym_boolean] = ACTIONS(503),
    [sym_class] = ACTIONS(503),
    [sym_newtype] = ACTIONS(503),
    [sym_date] = ACTIONS(503),
    [sym_desc] = ACTIONS(503),
    [sym_import] = ACTIONS(503),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(503),
    [sym_predicate] = ACTIONS(503),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [381] = {
    [sym__lower_id] = ACTIONS(541),
    [anon_sym_module] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(541),
    [anon_sym_from] = ACTIONS(541),
    [anon_sym_where] = ACTIONS(541),
    [anon_sym_select] = ACTIONS(541),
    [anon_sym_and] = ACTIONS(541),
    [anon_sym_implies] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(543),
    [sym_qldoc] = ACTIONS(543),
    [anon_sym_float] = ACTIONS(541),
    [anon_sym_int] = ACTIONS(541),
    [anon_sym_string] = ACTIONS(541),
    [sym__upper_id] = ACTIONS(543),
    [sym__at_lower_id] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(541),
    [sym_boolean] = ACTIONS(541),
    [sym_class] = ACTIONS(541),
    [sym_newtype] = ACTIONS(541),
    [sym_date] = ACTIONS(541),
    [sym_desc] = ACTIONS(541),
    [sym_import] = ACTIONS(541),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(541),
    [sym_predicate] = ACTIONS(541),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [382] = {
    [sym__lower_id] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_from] = ACTIONS(569),
    [anon_sym_where] = ACTIONS(569),
    [anon_sym_select] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_implies] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [sym_qldoc] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(569),
    [anon_sym_int] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [sym__upper_id] = ACTIONS(571),
    [sym__at_lower_id] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(569),
    [sym_boolean] = ACTIONS(569),
    [sym_class] = ACTIONS(569),
    [sym_newtype] = ACTIONS(569),
    [sym_date] = ACTIONS(569),
    [sym_desc] = ACTIONS(569),
    [sym_import] = ACTIONS(569),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(569),
    [sym_predicate] = ACTIONS(569),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [383] = {
    [sym__lower_id] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(509),
    [anon_sym_from] = ACTIONS(509),
    [anon_sym_where] = ACTIONS(509),
    [anon_sym_select] = ACTIONS(509),
    [anon_sym_and] = ACTIONS(509),
    [anon_sym_implies] = ACTIONS(509),
    [anon_sym_DOT] = ACTIONS(507),
    [sym_qldoc] = ACTIONS(507),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_string] = ACTIONS(509),
    [sym__upper_id] = ACTIONS(507),
    [sym__at_lower_id] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(509),
    [sym_boolean] = ACTIONS(509),
    [sym_class] = ACTIONS(509),
    [sym_newtype] = ACTIONS(509),
    [sym_date] = ACTIONS(509),
    [sym_desc] = ACTIONS(509),
    [sym_import] = ACTIONS(509),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(509),
    [sym_predicate] = ACTIONS(509),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [384] = {
    [sym__lower_id] = ACTIONS(565),
    [anon_sym_module] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_from] = ACTIONS(565),
    [anon_sym_where] = ACTIONS(565),
    [anon_sym_select] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_implies] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [sym_qldoc] = ACTIONS(567),
    [anon_sym_float] = ACTIONS(565),
    [anon_sym_int] = ACTIONS(565),
    [anon_sym_string] = ACTIONS(565),
    [sym__upper_id] = ACTIONS(567),
    [sym__at_lower_id] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(565),
    [sym_boolean] = ACTIONS(565),
    [sym_class] = ACTIONS(565),
    [sym_newtype] = ACTIONS(565),
    [sym_date] = ACTIONS(565),
    [sym_desc] = ACTIONS(565),
    [sym_import] = ACTIONS(565),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(565),
    [sym_predicate] = ACTIONS(565),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [385] = {
    [sym__lower_id] = ACTIONS(545),
    [anon_sym_module] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(545),
    [anon_sym_from] = ACTIONS(545),
    [anon_sym_where] = ACTIONS(545),
    [anon_sym_select] = ACTIONS(545),
    [anon_sym_and] = ACTIONS(545),
    [anon_sym_implies] = ACTIONS(545),
    [anon_sym_DOT] = ACTIONS(547),
    [sym_qldoc] = ACTIONS(547),
    [anon_sym_float] = ACTIONS(545),
    [anon_sym_int] = ACTIONS(545),
    [anon_sym_string] = ACTIONS(545),
    [sym__upper_id] = ACTIONS(547),
    [sym__at_lower_id] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(545),
    [sym_boolean] = ACTIONS(545),
    [sym_class] = ACTIONS(545),
    [sym_newtype] = ACTIONS(545),
    [sym_date] = ACTIONS(545),
    [sym_desc] = ACTIONS(545),
    [sym_import] = ACTIONS(545),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(545),
    [sym_predicate] = ACTIONS(545),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [386] = {
    [sym__lower_id] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(549),
    [anon_sym_from] = ACTIONS(549),
    [anon_sym_where] = ACTIONS(549),
    [anon_sym_select] = ACTIONS(549),
    [anon_sym_and] = ACTIONS(549),
    [anon_sym_implies] = ACTIONS(549),
    [anon_sym_DOT] = ACTIONS(551),
    [sym_qldoc] = ACTIONS(551),
    [anon_sym_float] = ACTIONS(549),
    [anon_sym_int] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [sym__upper_id] = ACTIONS(551),
    [sym__at_lower_id] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(549),
    [sym_boolean] = ACTIONS(549),
    [sym_class] = ACTIONS(549),
    [sym_newtype] = ACTIONS(549),
    [sym_date] = ACTIONS(549),
    [sym_desc] = ACTIONS(549),
    [sym_import] = ACTIONS(549),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(549),
    [sym_predicate] = ACTIONS(549),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [387] = {
    [sym__lower_id] = ACTIONS(553),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(553),
    [anon_sym_from] = ACTIONS(553),
    [anon_sym_where] = ACTIONS(553),
    [anon_sym_select] = ACTIONS(553),
    [anon_sym_and] = ACTIONS(553),
    [anon_sym_implies] = ACTIONS(553),
    [anon_sym_DOT] = ACTIONS(555),
    [sym_qldoc] = ACTIONS(555),
    [anon_sym_float] = ACTIONS(553),
    [anon_sym_int] = ACTIONS(553),
    [anon_sym_string] = ACTIONS(553),
    [sym__upper_id] = ACTIONS(555),
    [sym__at_lower_id] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(553),
    [sym_boolean] = ACTIONS(553),
    [sym_class] = ACTIONS(553),
    [sym_newtype] = ACTIONS(553),
    [sym_date] = ACTIONS(553),
    [sym_desc] = ACTIONS(553),
    [sym_import] = ACTIONS(553),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(553),
    [sym_predicate] = ACTIONS(553),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [388] = {
    [sym__lower_id] = ACTIONS(561),
    [anon_sym_module] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(561),
    [anon_sym_from] = ACTIONS(561),
    [anon_sym_where] = ACTIONS(561),
    [anon_sym_select] = ACTIONS(561),
    [anon_sym_and] = ACTIONS(561),
    [anon_sym_implies] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(563),
    [sym_qldoc] = ACTIONS(563),
    [anon_sym_float] = ACTIONS(561),
    [anon_sym_int] = ACTIONS(561),
    [anon_sym_string] = ACTIONS(561),
    [sym__upper_id] = ACTIONS(563),
    [sym__at_lower_id] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(561),
    [sym_boolean] = ACTIONS(561),
    [sym_class] = ACTIONS(561),
    [sym_newtype] = ACTIONS(561),
    [sym_date] = ACTIONS(561),
    [sym_desc] = ACTIONS(561),
    [sym_import] = ACTIONS(561),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(561),
    [sym_predicate] = ACTIONS(561),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [389] = {
    [sym__lower_id] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(557),
    [anon_sym_from] = ACTIONS(557),
    [anon_sym_where] = ACTIONS(557),
    [anon_sym_select] = ACTIONS(557),
    [anon_sym_and] = ACTIONS(557),
    [anon_sym_implies] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(559),
    [sym_qldoc] = ACTIONS(559),
    [anon_sym_float] = ACTIONS(557),
    [anon_sym_int] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [sym__upper_id] = ACTIONS(559),
    [sym__at_lower_id] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(557),
    [sym_boolean] = ACTIONS(557),
    [sym_class] = ACTIONS(557),
    [sym_newtype] = ACTIONS(557),
    [sym_date] = ACTIONS(557),
    [sym_desc] = ACTIONS(557),
    [sym_import] = ACTIONS(557),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(557),
    [sym_predicate] = ACTIONS(557),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [390] = {
    [sym__lower_id] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(603),
    [anon_sym_from] = ACTIONS(603),
    [anon_sym_where] = ACTIONS(603),
    [anon_sym_select] = ACTIONS(603),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_implies] = ACTIONS(603),
    [anon_sym_order] = ACTIONS(603),
    [sym_qldoc] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_string] = ACTIONS(603),
    [sym__upper_id] = ACTIONS(605),
    [sym__at_lower_id] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(603),
    [sym_boolean] = ACTIONS(603),
    [sym_class] = ACTIONS(603),
    [sym_newtype] = ACTIONS(603),
    [sym_date] = ACTIONS(603),
    [sym_import] = ACTIONS(603),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(603),
    [sym_predicate] = ACTIONS(603),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [391] = {
    [sym__lower_id] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(603),
    [anon_sym_from] = ACTIONS(603),
    [anon_sym_where] = ACTIONS(603),
    [anon_sym_select] = ACTIONS(603),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_implies] = ACTIONS(603),
    [sym_qldoc] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_string] = ACTIONS(603),
    [sym__upper_id] = ACTIONS(605),
    [sym__at_lower_id] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(603),
    [sym_boolean] = ACTIONS(603),
    [sym_class] = ACTIONS(603),
    [sym_newtype] = ACTIONS(603),
    [sym_date] = ACTIONS(603),
    [sym_desc] = ACTIONS(603),
    [sym_import] = ACTIONS(603),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(603),
    [sym_predicate] = ACTIONS(603),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [392] = {
    [sym__lower_id] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(607),
    [anon_sym_from] = ACTIONS(607),
    [anon_sym_where] = ACTIONS(607),
    [anon_sym_select] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(607),
    [anon_sym_implies] = ACTIONS(607),
    [anon_sym_order] = ACTIONS(607),
    [sym_qldoc] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [sym__upper_id] = ACTIONS(609),
    [sym__at_lower_id] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(607),
    [sym_boolean] = ACTIONS(607),
    [sym_class] = ACTIONS(607),
    [sym_newtype] = ACTIONS(607),
    [sym_date] = ACTIONS(607),
    [sym_import] = ACTIONS(607),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(607),
    [sym_predicate] = ACTIONS(607),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym__lower_id] = ACTIONS(613),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_from] = ACTIONS(613),
    [anon_sym_where] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_implies] = ACTIONS(613),
    [sym_qldoc] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_string] = ACTIONS(613),
    [sym__upper_id] = ACTIONS(611),
    [sym__at_lower_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(613),
    [sym_boolean] = ACTIONS(613),
    [sym_class] = ACTIONS(613),
    [sym_newtype] = ACTIONS(613),
    [sym_date] = ACTIONS(613),
    [sym_desc] = ACTIONS(613),
    [sym_import] = ACTIONS(613),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(613),
    [sym_predicate] = ACTIONS(613),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [394] = {
    [sym__lower_id] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_from] = ACTIONS(615),
    [anon_sym_where] = ACTIONS(615),
    [anon_sym_select] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(615),
    [anon_sym_implies] = ACTIONS(615),
    [sym_qldoc] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [sym__upper_id] = ACTIONS(617),
    [sym__at_lower_id] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(615),
    [sym_boolean] = ACTIONS(615),
    [sym_class] = ACTIONS(615),
    [sym_newtype] = ACTIONS(615),
    [sym_date] = ACTIONS(615),
    [sym_desc] = ACTIONS(615),
    [sym_import] = ACTIONS(615),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(615),
    [sym_predicate] = ACTIONS(615),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [395] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym__lower_id] = ACTIONS(621),
    [anon_sym_module] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_from] = ACTIONS(621),
    [anon_sym_where] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_implies] = ACTIONS(621),
    [sym_qldoc] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [sym__upper_id] = ACTIONS(619),
    [sym__at_lower_id] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(621),
    [sym_boolean] = ACTIONS(621),
    [sym_class] = ACTIONS(621),
    [sym_newtype] = ACTIONS(621),
    [sym_date] = ACTIONS(621),
    [sym_desc] = ACTIONS(621),
    [sym_import] = ACTIONS(621),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(621),
    [sym_predicate] = ACTIONS(621),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [396] = {
    [sym__lower_id] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_from] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_select] = ACTIONS(623),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_implies] = ACTIONS(623),
    [sym_qldoc] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_int] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [sym__upper_id] = ACTIONS(625),
    [sym__at_lower_id] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(623),
    [sym_boolean] = ACTIONS(623),
    [sym_class] = ACTIONS(623),
    [sym_newtype] = ACTIONS(623),
    [sym_date] = ACTIONS(623),
    [sym_desc] = ACTIONS(623),
    [sym_import] = ACTIONS(623),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(623),
    [sym_predicate] = ACTIONS(623),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [397] = {
    [sym__lower_id] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(629),
    [anon_sym_if] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(629),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_int] = ACTIONS(627),
    [anon_sym_string] = ACTIONS(627),
    [sym__upper_id] = ACTIONS(629),
    [sym__at_lower_id] = ACTIONS(629),
    [sym_integer] = ACTIONS(627),
    [sym_float] = ACTIONS(629),
    [sym_string] = ACTIONS(629),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(627),
    [sym_avg] = ACTIONS(627),
    [sym_boolean] = ACTIONS(627),
    [sym_count] = ACTIONS(627),
    [sym_date] = ACTIONS(627),
    [sym_exists] = ACTIONS(627),
    [sym_false] = ACTIONS(627),
    [sym_forall] = ACTIONS(627),
    [sym_forex] = ACTIONS(627),
    [sym_max] = ACTIONS(627),
    [sym_min] = ACTIONS(627),
    [sym_not] = ACTIONS(627),
    [sym_none] = ACTIONS(627),
    [sym_rank] = ACTIONS(627),
    [sym_result] = ACTIONS(627),
    [sym_strictcount] = ACTIONS(627),
    [sym_strictsum] = ACTIONS(627),
    [sym_strictconcat] = ACTIONS(627),
    [sym_concat] = ACTIONS(627),
    [sym_sum] = ACTIONS(627),
    [sym_super] = ACTIONS(627),
    [sym_this] = ACTIONS(627),
    [sym_true] = ACTIONS(627),
    [sym_minus] = ACTIONS(629),
    [sym_plus] = ACTIONS(629),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(625),
    [sym__lower_id] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_from] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_select] = ACTIONS(623),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_implies] = ACTIONS(623),
    [anon_sym_order] = ACTIONS(623),
    [sym_qldoc] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_int] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [sym__upper_id] = ACTIONS(625),
    [sym__at_lower_id] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(623),
    [sym_boolean] = ACTIONS(623),
    [sym_class] = ACTIONS(623),
    [sym_newtype] = ACTIONS(623),
    [sym_date] = ACTIONS(623),
    [sym_import] = ACTIONS(623),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(623),
    [sym_predicate] = ACTIONS(623),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [399] = {
    [sym__lower_id] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_from] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(631),
    [anon_sym_select] = ACTIONS(631),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_implies] = ACTIONS(631),
    [sym_qldoc] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [sym__upper_id] = ACTIONS(633),
    [sym__at_lower_id] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(631),
    [sym_boolean] = ACTIONS(631),
    [sym_class] = ACTIONS(631),
    [sym_newtype] = ACTIONS(631),
    [sym_date] = ACTIONS(631),
    [sym_desc] = ACTIONS(631),
    [sym_import] = ACTIONS(631),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(631),
    [sym_predicate] = ACTIONS(631),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym__lower_id] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_from] = ACTIONS(615),
    [anon_sym_where] = ACTIONS(615),
    [anon_sym_select] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(615),
    [anon_sym_implies] = ACTIONS(615),
    [sym_qldoc] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [sym__upper_id] = ACTIONS(617),
    [sym__at_lower_id] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(615),
    [sym_boolean] = ACTIONS(615),
    [sym_class] = ACTIONS(615),
    [sym_newtype] = ACTIONS(615),
    [sym_date] = ACTIONS(615),
    [sym_desc] = ACTIONS(615),
    [sym_import] = ACTIONS(615),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(615),
    [sym_predicate] = ACTIONS(615),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [401] = {
    [sym__lower_id] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(635),
    [anon_sym_from] = ACTIONS(635),
    [anon_sym_where] = ACTIONS(635),
    [anon_sym_select] = ACTIONS(635),
    [anon_sym_and] = ACTIONS(635),
    [anon_sym_implies] = ACTIONS(635),
    [sym_qldoc] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_string] = ACTIONS(635),
    [sym__upper_id] = ACTIONS(637),
    [sym__at_lower_id] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(635),
    [sym_boolean] = ACTIONS(635),
    [sym_class] = ACTIONS(635),
    [sym_newtype] = ACTIONS(635),
    [sym_date] = ACTIONS(635),
    [sym_desc] = ACTIONS(635),
    [sym_import] = ACTIONS(635),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(635),
    [sym_predicate] = ACTIONS(635),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [402] = {
    [sym__lower_id] = ACTIONS(621),
    [anon_sym_module] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_from] = ACTIONS(621),
    [anon_sym_where] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_implies] = ACTIONS(621),
    [sym_qldoc] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [sym__upper_id] = ACTIONS(619),
    [sym__at_lower_id] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(621),
    [sym_boolean] = ACTIONS(621),
    [sym_class] = ACTIONS(621),
    [sym_newtype] = ACTIONS(621),
    [sym_date] = ACTIONS(621),
    [sym_desc] = ACTIONS(621),
    [sym_import] = ACTIONS(621),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(621),
    [sym_predicate] = ACTIONS(621),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [403] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym__lower_id] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_from] = ACTIONS(615),
    [anon_sym_where] = ACTIONS(615),
    [anon_sym_select] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(615),
    [anon_sym_implies] = ACTIONS(615),
    [anon_sym_order] = ACTIONS(615),
    [sym_qldoc] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [sym__upper_id] = ACTIONS(617),
    [sym__at_lower_id] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(615),
    [sym_boolean] = ACTIONS(615),
    [sym_class] = ACTIONS(615),
    [sym_newtype] = ACTIONS(615),
    [sym_date] = ACTIONS(615),
    [sym_import] = ACTIONS(615),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(615),
    [sym_predicate] = ACTIONS(615),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [404] = {
    [sym__lower_id] = ACTIONS(613),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_from] = ACTIONS(613),
    [anon_sym_where] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_implies] = ACTIONS(613),
    [sym_qldoc] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_string] = ACTIONS(613),
    [sym__upper_id] = ACTIONS(611),
    [sym__at_lower_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(613),
    [sym_boolean] = ACTIONS(613),
    [sym_class] = ACTIONS(613),
    [sym_newtype] = ACTIONS(613),
    [sym_date] = ACTIONS(613),
    [sym_desc] = ACTIONS(613),
    [sym_import] = ACTIONS(613),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(613),
    [sym_predicate] = ACTIONS(613),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(619),
    [sym__lower_id] = ACTIONS(621),
    [anon_sym_module] = ACTIONS(621),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_from] = ACTIONS(621),
    [anon_sym_where] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_implies] = ACTIONS(621),
    [anon_sym_order] = ACTIONS(621),
    [sym_qldoc] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [sym__upper_id] = ACTIONS(619),
    [sym__at_lower_id] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(621),
    [sym_boolean] = ACTIONS(621),
    [sym_class] = ACTIONS(621),
    [sym_newtype] = ACTIONS(621),
    [sym_date] = ACTIONS(621),
    [sym_import] = ACTIONS(621),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(621),
    [sym_predicate] = ACTIONS(621),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(611),
    [sym__lower_id] = ACTIONS(613),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_from] = ACTIONS(613),
    [anon_sym_where] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_implies] = ACTIONS(613),
    [anon_sym_order] = ACTIONS(613),
    [sym_qldoc] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_string] = ACTIONS(613),
    [sym__upper_id] = ACTIONS(611),
    [sym__at_lower_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(613),
    [sym_boolean] = ACTIONS(613),
    [sym_class] = ACTIONS(613),
    [sym_newtype] = ACTIONS(613),
    [sym_date] = ACTIONS(613),
    [sym_import] = ACTIONS(613),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(613),
    [sym_predicate] = ACTIONS(613),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym__lower_id] = ACTIONS(641),
    [anon_sym_module] = ACTIONS(641),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_from] = ACTIONS(641),
    [anon_sym_where] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_implies] = ACTIONS(641),
    [anon_sym_order] = ACTIONS(641),
    [sym_qldoc] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [sym__upper_id] = ACTIONS(639),
    [sym__at_lower_id] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(641),
    [sym_boolean] = ACTIONS(641),
    [sym_class] = ACTIONS(641),
    [sym_newtype] = ACTIONS(641),
    [sym_date] = ACTIONS(641),
    [sym_import] = ACTIONS(641),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(641),
    [sym_predicate] = ACTIONS(641),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [408] = {
    [sym__lower_id] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(645),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_int] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [sym__upper_id] = ACTIONS(645),
    [sym__at_lower_id] = ACTIONS(645),
    [sym_integer] = ACTIONS(643),
    [sym_float] = ACTIONS(645),
    [sym_string] = ACTIONS(645),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(643),
    [sym_avg] = ACTIONS(643),
    [sym_boolean] = ACTIONS(643),
    [sym_count] = ACTIONS(643),
    [sym_date] = ACTIONS(643),
    [sym_exists] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_forall] = ACTIONS(643),
    [sym_forex] = ACTIONS(643),
    [sym_max] = ACTIONS(643),
    [sym_min] = ACTIONS(643),
    [sym_not] = ACTIONS(643),
    [sym_none] = ACTIONS(643),
    [sym_rank] = ACTIONS(643),
    [sym_result] = ACTIONS(643),
    [sym_strictcount] = ACTIONS(643),
    [sym_strictsum] = ACTIONS(643),
    [sym_strictconcat] = ACTIONS(643),
    [sym_concat] = ACTIONS(643),
    [sym_sum] = ACTIONS(643),
    [sym_super] = ACTIONS(643),
    [sym_this] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_minus] = ACTIONS(645),
    [sym_plus] = ACTIONS(645),
  },
  [409] = {
    [sym__lower_id] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(647),
    [anon_sym_from] = ACTIONS(647),
    [anon_sym_where] = ACTIONS(647),
    [anon_sym_select] = ACTIONS(647),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_implies] = ACTIONS(647),
    [anon_sym_order] = ACTIONS(647),
    [sym_qldoc] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [sym__upper_id] = ACTIONS(649),
    [sym__at_lower_id] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(647),
    [sym_boolean] = ACTIONS(647),
    [sym_class] = ACTIONS(647),
    [sym_newtype] = ACTIONS(647),
    [sym_date] = ACTIONS(647),
    [sym_import] = ACTIONS(647),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(647),
    [sym_predicate] = ACTIONS(647),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [410] = {
    [sym__lower_id] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(651),
    [anon_sym_from] = ACTIONS(651),
    [anon_sym_where] = ACTIONS(651),
    [anon_sym_select] = ACTIONS(651),
    [anon_sym_and] = ACTIONS(651),
    [anon_sym_implies] = ACTIONS(651),
    [sym_qldoc] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_string] = ACTIONS(651),
    [sym__upper_id] = ACTIONS(653),
    [sym__at_lower_id] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(651),
    [sym_boolean] = ACTIONS(651),
    [sym_class] = ACTIONS(651),
    [sym_newtype] = ACTIONS(651),
    [sym_date] = ACTIONS(651),
    [sym_desc] = ACTIONS(651),
    [sym_import] = ACTIONS(651),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(651),
    [sym_predicate] = ACTIONS(651),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym__lower_id] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(647),
    [anon_sym_from] = ACTIONS(647),
    [anon_sym_where] = ACTIONS(647),
    [anon_sym_select] = ACTIONS(647),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_implies] = ACTIONS(647),
    [anon_sym_order] = ACTIONS(647),
    [sym_qldoc] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [sym__upper_id] = ACTIONS(649),
    [sym__at_lower_id] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(647),
    [sym_boolean] = ACTIONS(647),
    [sym_class] = ACTIONS(647),
    [sym_newtype] = ACTIONS(647),
    [sym_date] = ACTIONS(647),
    [sym_import] = ACTIONS(647),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(647),
    [sym_predicate] = ACTIONS(647),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [412] = {
    [sym__lower_id] = ACTIONS(641),
    [anon_sym_module] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_from] = ACTIONS(641),
    [anon_sym_where] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_implies] = ACTIONS(641),
    [sym_qldoc] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [sym__upper_id] = ACTIONS(639),
    [sym__at_lower_id] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(641),
    [sym_boolean] = ACTIONS(641),
    [sym_class] = ACTIONS(641),
    [sym_newtype] = ACTIONS(641),
    [sym_date] = ACTIONS(641),
    [sym_desc] = ACTIONS(641),
    [sym_import] = ACTIONS(641),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(641),
    [sym_predicate] = ACTIONS(641),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym__lower_id] = ACTIONS(657),
    [anon_sym_module] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_from] = ACTIONS(657),
    [anon_sym_where] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_implies] = ACTIONS(657),
    [anon_sym_order] = ACTIONS(657),
    [sym_qldoc] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [sym__upper_id] = ACTIONS(655),
    [sym__at_lower_id] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(657),
    [sym_boolean] = ACTIONS(657),
    [sym_class] = ACTIONS(657),
    [sym_newtype] = ACTIONS(657),
    [sym_date] = ACTIONS(657),
    [sym_import] = ACTIONS(657),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(657),
    [sym_predicate] = ACTIONS(657),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [414] = {
    [sym__lower_id] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_from] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(659),
    [anon_sym_select] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(659),
    [anon_sym_implies] = ACTIONS(659),
    [sym_qldoc] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_string] = ACTIONS(659),
    [sym__upper_id] = ACTIONS(661),
    [sym__at_lower_id] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(659),
    [sym_boolean] = ACTIONS(659),
    [sym_class] = ACTIONS(659),
    [sym_newtype] = ACTIONS(659),
    [sym_date] = ACTIONS(659),
    [sym_desc] = ACTIONS(659),
    [sym_import] = ACTIONS(659),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(659),
    [sym_predicate] = ACTIONS(659),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [415] = {
    [sym__lower_id] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(647),
    [anon_sym_from] = ACTIONS(647),
    [anon_sym_where] = ACTIONS(647),
    [anon_sym_select] = ACTIONS(647),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_implies] = ACTIONS(647),
    [sym_qldoc] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [sym__upper_id] = ACTIONS(649),
    [sym__at_lower_id] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(647),
    [sym_boolean] = ACTIONS(647),
    [sym_class] = ACTIONS(647),
    [sym_newtype] = ACTIONS(647),
    [sym_date] = ACTIONS(647),
    [sym_desc] = ACTIONS(647),
    [sym_import] = ACTIONS(647),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(647),
    [sym_predicate] = ACTIONS(647),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(609),
    [sym__lower_id] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(607),
    [anon_sym_from] = ACTIONS(607),
    [anon_sym_where] = ACTIONS(607),
    [anon_sym_select] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(607),
    [anon_sym_implies] = ACTIONS(607),
    [anon_sym_order] = ACTIONS(607),
    [sym_qldoc] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [sym__upper_id] = ACTIONS(609),
    [sym__at_lower_id] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(607),
    [sym_boolean] = ACTIONS(607),
    [sym_class] = ACTIONS(607),
    [sym_newtype] = ACTIONS(607),
    [sym_date] = ACTIONS(607),
    [sym_import] = ACTIONS(607),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(607),
    [sym_predicate] = ACTIONS(607),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym__lower_id] = ACTIONS(665),
    [anon_sym_module] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_from] = ACTIONS(665),
    [anon_sym_where] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_implies] = ACTIONS(665),
    [sym_qldoc] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [sym__upper_id] = ACTIONS(663),
    [sym__at_lower_id] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(665),
    [sym_boolean] = ACTIONS(665),
    [sym_class] = ACTIONS(665),
    [sym_newtype] = ACTIONS(665),
    [sym_date] = ACTIONS(665),
    [sym_desc] = ACTIONS(665),
    [sym_import] = ACTIONS(665),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(665),
    [sym_predicate] = ACTIONS(665),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [sym__lower_id] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(651),
    [anon_sym_from] = ACTIONS(651),
    [anon_sym_where] = ACTIONS(651),
    [anon_sym_select] = ACTIONS(651),
    [anon_sym_and] = ACTIONS(651),
    [anon_sym_implies] = ACTIONS(651),
    [sym_qldoc] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_string] = ACTIONS(651),
    [sym__upper_id] = ACTIONS(653),
    [sym__at_lower_id] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(651),
    [sym_boolean] = ACTIONS(651),
    [sym_class] = ACTIONS(651),
    [sym_newtype] = ACTIONS(651),
    [sym_date] = ACTIONS(651),
    [sym_desc] = ACTIONS(651),
    [sym_import] = ACTIONS(651),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(651),
    [sym_predicate] = ACTIONS(651),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(661),
    [sym__lower_id] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_from] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(659),
    [anon_sym_select] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(659),
    [anon_sym_implies] = ACTIONS(659),
    [sym_qldoc] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_string] = ACTIONS(659),
    [sym__upper_id] = ACTIONS(661),
    [sym__at_lower_id] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(659),
    [sym_boolean] = ACTIONS(659),
    [sym_class] = ACTIONS(659),
    [sym_newtype] = ACTIONS(659),
    [sym_date] = ACTIONS(659),
    [sym_desc] = ACTIONS(659),
    [sym_import] = ACTIONS(659),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(659),
    [sym_predicate] = ACTIONS(659),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [420] = {
    [sym__lower_id] = ACTIONS(665),
    [anon_sym_module] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_from] = ACTIONS(665),
    [anon_sym_where] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_implies] = ACTIONS(665),
    [sym_qldoc] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [sym__upper_id] = ACTIONS(663),
    [sym__at_lower_id] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(665),
    [sym_boolean] = ACTIONS(665),
    [sym_class] = ACTIONS(665),
    [sym_newtype] = ACTIONS(665),
    [sym_date] = ACTIONS(665),
    [sym_desc] = ACTIONS(665),
    [sym_import] = ACTIONS(665),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(665),
    [sym_predicate] = ACTIONS(665),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [421] = {
    [sym__lower_id] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_int] = ACTIONS(667),
    [anon_sym_string] = ACTIONS(667),
    [sym__upper_id] = ACTIONS(669),
    [sym__at_lower_id] = ACTIONS(669),
    [sym_integer] = ACTIONS(667),
    [sym_float] = ACTIONS(669),
    [sym_string] = ACTIONS(669),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(667),
    [sym_avg] = ACTIONS(667),
    [sym_boolean] = ACTIONS(667),
    [sym_count] = ACTIONS(667),
    [sym_date] = ACTIONS(667),
    [sym_exists] = ACTIONS(667),
    [sym_false] = ACTIONS(667),
    [sym_forall] = ACTIONS(667),
    [sym_forex] = ACTIONS(667),
    [sym_max] = ACTIONS(667),
    [sym_min] = ACTIONS(667),
    [sym_not] = ACTIONS(667),
    [sym_none] = ACTIONS(667),
    [sym_rank] = ACTIONS(667),
    [sym_result] = ACTIONS(667),
    [sym_strictcount] = ACTIONS(667),
    [sym_strictsum] = ACTIONS(667),
    [sym_strictconcat] = ACTIONS(667),
    [sym_concat] = ACTIONS(667),
    [sym_sum] = ACTIONS(667),
    [sym_super] = ACTIONS(667),
    [sym_this] = ACTIONS(667),
    [sym_true] = ACTIONS(667),
    [sym_minus] = ACTIONS(669),
    [sym_plus] = ACTIONS(669),
  },
  [422] = {
    [sym__lower_id] = ACTIONS(641),
    [anon_sym_module] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_from] = ACTIONS(641),
    [anon_sym_where] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_implies] = ACTIONS(641),
    [anon_sym_order] = ACTIONS(641),
    [sym_qldoc] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [sym__upper_id] = ACTIONS(639),
    [sym__at_lower_id] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(641),
    [sym_boolean] = ACTIONS(641),
    [sym_class] = ACTIONS(641),
    [sym_newtype] = ACTIONS(641),
    [sym_date] = ACTIONS(641),
    [sym_import] = ACTIONS(641),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(641),
    [sym_predicate] = ACTIONS(641),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(605),
    [sym__lower_id] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(603),
    [anon_sym_from] = ACTIONS(603),
    [anon_sym_where] = ACTIONS(603),
    [anon_sym_select] = ACTIONS(603),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_implies] = ACTIONS(603),
    [anon_sym_order] = ACTIONS(603),
    [sym_qldoc] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_string] = ACTIONS(603),
    [sym__upper_id] = ACTIONS(605),
    [sym__at_lower_id] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(603),
    [sym_boolean] = ACTIONS(603),
    [sym_class] = ACTIONS(603),
    [sym_newtype] = ACTIONS(603),
    [sym_date] = ACTIONS(603),
    [sym_import] = ACTIONS(603),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(603),
    [sym_predicate] = ACTIONS(603),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [424] = {
    [sym__lower_id] = ACTIONS(665),
    [anon_sym_module] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_from] = ACTIONS(665),
    [anon_sym_where] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_implies] = ACTIONS(665),
    [anon_sym_order] = ACTIONS(665),
    [sym_qldoc] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [sym__upper_id] = ACTIONS(663),
    [sym__at_lower_id] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(665),
    [sym_boolean] = ACTIONS(665),
    [sym_class] = ACTIONS(665),
    [sym_newtype] = ACTIONS(665),
    [sym_date] = ACTIONS(665),
    [sym_import] = ACTIONS(665),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(665),
    [sym_predicate] = ACTIONS(665),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [425] = {
    [sym__lower_id] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_int] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [sym__upper_id] = ACTIONS(673),
    [sym__at_lower_id] = ACTIONS(673),
    [sym_integer] = ACTIONS(671),
    [sym_float] = ACTIONS(673),
    [sym_string] = ACTIONS(673),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_any] = ACTIONS(671),
    [sym_avg] = ACTIONS(671),
    [sym_boolean] = ACTIONS(671),
    [sym_count] = ACTIONS(671),
    [sym_date] = ACTIONS(671),
    [sym_exists] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_forall] = ACTIONS(671),
    [sym_forex] = ACTIONS(671),
    [sym_max] = ACTIONS(671),
    [sym_min] = ACTIONS(671),
    [sym_not] = ACTIONS(671),
    [sym_none] = ACTIONS(671),
    [sym_rank] = ACTIONS(671),
    [sym_result] = ACTIONS(671),
    [sym_strictcount] = ACTIONS(671),
    [sym_strictsum] = ACTIONS(671),
    [sym_strictconcat] = ACTIONS(671),
    [sym_concat] = ACTIONS(671),
    [sym_sum] = ACTIONS(671),
    [sym_super] = ACTIONS(671),
    [sym_this] = ACTIONS(671),
    [sym_true] = ACTIONS(671),
    [sym_minus] = ACTIONS(673),
    [sym_plus] = ACTIONS(673),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym__lower_id] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(635),
    [anon_sym_from] = ACTIONS(635),
    [anon_sym_where] = ACTIONS(635),
    [anon_sym_select] = ACTIONS(635),
    [anon_sym_and] = ACTIONS(635),
    [anon_sym_implies] = ACTIONS(635),
    [sym_qldoc] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_string] = ACTIONS(635),
    [sym__upper_id] = ACTIONS(637),
    [sym__at_lower_id] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(635),
    [sym_boolean] = ACTIONS(635),
    [sym_class] = ACTIONS(635),
    [sym_newtype] = ACTIONS(635),
    [sym_date] = ACTIONS(635),
    [sym_desc] = ACTIONS(635),
    [sym_import] = ACTIONS(635),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(635),
    [sym_predicate] = ACTIONS(635),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(633),
    [sym__lower_id] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_from] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(631),
    [anon_sym_select] = ACTIONS(631),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_implies] = ACTIONS(631),
    [sym_qldoc] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [sym__upper_id] = ACTIONS(633),
    [sym__at_lower_id] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(631),
    [sym_boolean] = ACTIONS(631),
    [sym_class] = ACTIONS(631),
    [sym_newtype] = ACTIONS(631),
    [sym_date] = ACTIONS(631),
    [sym_desc] = ACTIONS(631),
    [sym_import] = ACTIONS(631),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(631),
    [sym_predicate] = ACTIONS(631),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [428] = {
    [sym__lower_id] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(651),
    [anon_sym_from] = ACTIONS(651),
    [anon_sym_where] = ACTIONS(651),
    [anon_sym_select] = ACTIONS(651),
    [anon_sym_and] = ACTIONS(651),
    [anon_sym_implies] = ACTIONS(651),
    [anon_sym_order] = ACTIONS(651),
    [sym_qldoc] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_string] = ACTIONS(651),
    [sym__upper_id] = ACTIONS(653),
    [sym__at_lower_id] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(651),
    [sym_boolean] = ACTIONS(651),
    [sym_class] = ACTIONS(651),
    [sym_newtype] = ACTIONS(651),
    [sym_date] = ACTIONS(651),
    [sym_import] = ACTIONS(651),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(651),
    [sym_predicate] = ACTIONS(651),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [429] = {
    [sym__lower_id] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(607),
    [anon_sym_from] = ACTIONS(607),
    [anon_sym_where] = ACTIONS(607),
    [anon_sym_select] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(607),
    [anon_sym_implies] = ACTIONS(607),
    [sym_qldoc] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [sym__upper_id] = ACTIONS(609),
    [sym__at_lower_id] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(607),
    [sym_boolean] = ACTIONS(607),
    [sym_class] = ACTIONS(607),
    [sym_newtype] = ACTIONS(607),
    [sym_date] = ACTIONS(607),
    [sym_desc] = ACTIONS(607),
    [sym_import] = ACTIONS(607),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(607),
    [sym_predicate] = ACTIONS(607),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [430] = {
    [sym__lower_id] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_from] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_select] = ACTIONS(623),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_implies] = ACTIONS(623),
    [anon_sym_order] = ACTIONS(623),
    [sym_qldoc] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_int] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [sym__upper_id] = ACTIONS(625),
    [sym__at_lower_id] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(623),
    [sym_boolean] = ACTIONS(623),
    [sym_class] = ACTIONS(623),
    [sym_newtype] = ACTIONS(623),
    [sym_date] = ACTIONS(623),
    [sym_import] = ACTIONS(623),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(623),
    [sym_predicate] = ACTIONS(623),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(605),
    [sym__lower_id] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(603),
    [anon_sym_from] = ACTIONS(603),
    [anon_sym_where] = ACTIONS(603),
    [anon_sym_select] = ACTIONS(603),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_implies] = ACTIONS(603),
    [sym_qldoc] = ACTIONS(605),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_string] = ACTIONS(603),
    [sym__upper_id] = ACTIONS(605),
    [sym__at_lower_id] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(603),
    [sym_boolean] = ACTIONS(603),
    [sym_class] = ACTIONS(603),
    [sym_newtype] = ACTIONS(603),
    [sym_date] = ACTIONS(603),
    [sym_desc] = ACTIONS(603),
    [sym_import] = ACTIONS(603),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(603),
    [sym_predicate] = ACTIONS(603),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [432] = {
    [sym__lower_id] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_from] = ACTIONS(615),
    [anon_sym_where] = ACTIONS(615),
    [anon_sym_select] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(615),
    [anon_sym_implies] = ACTIONS(615),
    [anon_sym_order] = ACTIONS(615),
    [sym_qldoc] = ACTIONS(617),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_string] = ACTIONS(615),
    [sym__upper_id] = ACTIONS(617),
    [sym__at_lower_id] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(615),
    [sym_boolean] = ACTIONS(615),
    [sym_class] = ACTIONS(615),
    [sym_newtype] = ACTIONS(615),
    [sym_date] = ACTIONS(615),
    [sym_import] = ACTIONS(615),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(615),
    [sym_predicate] = ACTIONS(615),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [433] = {
    [sym__lower_id] = ACTIONS(621),
    [anon_sym_module] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_from] = ACTIONS(621),
    [anon_sym_where] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_implies] = ACTIONS(621),
    [anon_sym_order] = ACTIONS(621),
    [sym_qldoc] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(621),
    [anon_sym_int] = ACTIONS(621),
    [anon_sym_string] = ACTIONS(621),
    [sym__upper_id] = ACTIONS(619),
    [sym__at_lower_id] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(621),
    [sym_boolean] = ACTIONS(621),
    [sym_class] = ACTIONS(621),
    [sym_newtype] = ACTIONS(621),
    [sym_date] = ACTIONS(621),
    [sym_import] = ACTIONS(621),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(621),
    [sym_predicate] = ACTIONS(621),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [434] = {
    [sym__lower_id] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(635),
    [anon_sym_from] = ACTIONS(635),
    [anon_sym_where] = ACTIONS(635),
    [anon_sym_select] = ACTIONS(635),
    [anon_sym_and] = ACTIONS(635),
    [anon_sym_implies] = ACTIONS(635),
    [anon_sym_order] = ACTIONS(635),
    [sym_qldoc] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_string] = ACTIONS(635),
    [sym__upper_id] = ACTIONS(637),
    [sym__at_lower_id] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(635),
    [sym_boolean] = ACTIONS(635),
    [sym_class] = ACTIONS(635),
    [sym_newtype] = ACTIONS(635),
    [sym_date] = ACTIONS(635),
    [sym_import] = ACTIONS(635),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(635),
    [sym_predicate] = ACTIONS(635),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [435] = {
    [sym__lower_id] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_from] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(631),
    [anon_sym_select] = ACTIONS(631),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_implies] = ACTIONS(631),
    [anon_sym_order] = ACTIONS(631),
    [sym_qldoc] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [sym__upper_id] = ACTIONS(633),
    [sym__at_lower_id] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(631),
    [sym_boolean] = ACTIONS(631),
    [sym_class] = ACTIONS(631),
    [sym_newtype] = ACTIONS(631),
    [sym_date] = ACTIONS(631),
    [sym_import] = ACTIONS(631),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(631),
    [sym_predicate] = ACTIONS(631),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(609),
    [sym__lower_id] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(607),
    [anon_sym_from] = ACTIONS(607),
    [anon_sym_where] = ACTIONS(607),
    [anon_sym_select] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(607),
    [anon_sym_implies] = ACTIONS(607),
    [sym_qldoc] = ACTIONS(609),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_string] = ACTIONS(607),
    [sym__upper_id] = ACTIONS(609),
    [sym__at_lower_id] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(607),
    [sym_boolean] = ACTIONS(607),
    [sym_class] = ACTIONS(607),
    [sym_newtype] = ACTIONS(607),
    [sym_date] = ACTIONS(607),
    [sym_desc] = ACTIONS(607),
    [sym_import] = ACTIONS(607),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(607),
    [sym_predicate] = ACTIONS(607),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [437] = {
    [sym__lower_id] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_from] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(659),
    [anon_sym_select] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(659),
    [anon_sym_implies] = ACTIONS(659),
    [anon_sym_order] = ACTIONS(659),
    [sym_qldoc] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_string] = ACTIONS(659),
    [sym__upper_id] = ACTIONS(661),
    [sym__at_lower_id] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(659),
    [sym_boolean] = ACTIONS(659),
    [sym_class] = ACTIONS(659),
    [sym_newtype] = ACTIONS(659),
    [sym_date] = ACTIONS(659),
    [sym_import] = ACTIONS(659),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(659),
    [sym_predicate] = ACTIONS(659),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [438] = {
    [sym__lower_id] = ACTIONS(613),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_from] = ACTIONS(613),
    [anon_sym_where] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_implies] = ACTIONS(613),
    [anon_sym_order] = ACTIONS(613),
    [sym_qldoc] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(613),
    [anon_sym_int] = ACTIONS(613),
    [anon_sym_string] = ACTIONS(613),
    [sym__upper_id] = ACTIONS(611),
    [sym__at_lower_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(613),
    [sym_boolean] = ACTIONS(613),
    [sym_class] = ACTIONS(613),
    [sym_newtype] = ACTIONS(613),
    [sym_date] = ACTIONS(613),
    [sym_import] = ACTIONS(613),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(613),
    [sym_predicate] = ACTIONS(613),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym__lower_id] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(647),
    [anon_sym_from] = ACTIONS(647),
    [anon_sym_where] = ACTIONS(647),
    [anon_sym_select] = ACTIONS(647),
    [anon_sym_and] = ACTIONS(647),
    [anon_sym_implies] = ACTIONS(647),
    [sym_qldoc] = ACTIONS(649),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [sym__upper_id] = ACTIONS(649),
    [sym__at_lower_id] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(647),
    [sym_boolean] = ACTIONS(647),
    [sym_class] = ACTIONS(647),
    [sym_newtype] = ACTIONS(647),
    [sym_date] = ACTIONS(647),
    [sym_desc] = ACTIONS(647),
    [sym_import] = ACTIONS(647),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(647),
    [sym_predicate] = ACTIONS(647),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [440] = {
    [sym__lower_id] = ACTIONS(657),
    [anon_sym_module] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_from] = ACTIONS(657),
    [anon_sym_where] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_implies] = ACTIONS(657),
    [anon_sym_order] = ACTIONS(657),
    [sym_qldoc] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [sym__upper_id] = ACTIONS(655),
    [sym__at_lower_id] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(657),
    [sym_boolean] = ACTIONS(657),
    [sym_class] = ACTIONS(657),
    [sym_newtype] = ACTIONS(657),
    [sym_date] = ACTIONS(657),
    [sym_import] = ACTIONS(657),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(657),
    [sym_predicate] = ACTIONS(657),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(633),
    [sym__lower_id] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_from] = ACTIONS(631),
    [anon_sym_where] = ACTIONS(631),
    [anon_sym_select] = ACTIONS(631),
    [anon_sym_and] = ACTIONS(631),
    [anon_sym_implies] = ACTIONS(631),
    [anon_sym_order] = ACTIONS(631),
    [sym_qldoc] = ACTIONS(633),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [sym__upper_id] = ACTIONS(633),
    [sym__at_lower_id] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(631),
    [sym_boolean] = ACTIONS(631),
    [sym_class] = ACTIONS(631),
    [sym_newtype] = ACTIONS(631),
    [sym_date] = ACTIONS(631),
    [sym_import] = ACTIONS(631),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(631),
    [sym_predicate] = ACTIONS(631),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(639),
    [sym__lower_id] = ACTIONS(641),
    [anon_sym_module] = ACTIONS(641),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_from] = ACTIONS(641),
    [anon_sym_where] = ACTIONS(641),
    [anon_sym_select] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(641),
    [anon_sym_implies] = ACTIONS(641),
    [sym_qldoc] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(641),
    [anon_sym_int] = ACTIONS(641),
    [anon_sym_string] = ACTIONS(641),
    [sym__upper_id] = ACTIONS(639),
    [sym__at_lower_id] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(641),
    [sym_boolean] = ACTIONS(641),
    [sym_class] = ACTIONS(641),
    [sym_newtype] = ACTIONS(641),
    [sym_date] = ACTIONS(641),
    [sym_desc] = ACTIONS(641),
    [sym_import] = ACTIONS(641),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(641),
    [sym_predicate] = ACTIONS(641),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym__lower_id] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(635),
    [anon_sym_from] = ACTIONS(635),
    [anon_sym_where] = ACTIONS(635),
    [anon_sym_select] = ACTIONS(635),
    [anon_sym_and] = ACTIONS(635),
    [anon_sym_implies] = ACTIONS(635),
    [anon_sym_order] = ACTIONS(635),
    [sym_qldoc] = ACTIONS(637),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_string] = ACTIONS(635),
    [sym__upper_id] = ACTIONS(637),
    [sym__at_lower_id] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(635),
    [sym_boolean] = ACTIONS(635),
    [sym_class] = ACTIONS(635),
    [sym_newtype] = ACTIONS(635),
    [sym_date] = ACTIONS(635),
    [sym_import] = ACTIONS(635),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(635),
    [sym_predicate] = ACTIONS(635),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(655),
    [sym__lower_id] = ACTIONS(657),
    [anon_sym_module] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_from] = ACTIONS(657),
    [anon_sym_where] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_implies] = ACTIONS(657),
    [sym_qldoc] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [sym__upper_id] = ACTIONS(655),
    [sym__at_lower_id] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(657),
    [sym_boolean] = ACTIONS(657),
    [sym_class] = ACTIONS(657),
    [sym_newtype] = ACTIONS(657),
    [sym_date] = ACTIONS(657),
    [sym_desc] = ACTIONS(657),
    [sym_import] = ACTIONS(657),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(657),
    [sym_predicate] = ACTIONS(657),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [445] = {
    [sym__lower_id] = ACTIONS(657),
    [anon_sym_module] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_from] = ACTIONS(657),
    [anon_sym_where] = ACTIONS(657),
    [anon_sym_select] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(657),
    [anon_sym_implies] = ACTIONS(657),
    [sym_qldoc] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(657),
    [anon_sym_int] = ACTIONS(657),
    [anon_sym_string] = ACTIONS(657),
    [sym__upper_id] = ACTIONS(655),
    [sym__at_lower_id] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(657),
    [sym_boolean] = ACTIONS(657),
    [sym_class] = ACTIONS(657),
    [sym_newtype] = ACTIONS(657),
    [sym_date] = ACTIONS(657),
    [sym_desc] = ACTIONS(657),
    [sym_import] = ACTIONS(657),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(657),
    [sym_predicate] = ACTIONS(657),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(661),
    [sym__lower_id] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_from] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(659),
    [anon_sym_select] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(659),
    [anon_sym_implies] = ACTIONS(659),
    [anon_sym_order] = ACTIONS(659),
    [sym_qldoc] = ACTIONS(661),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_string] = ACTIONS(659),
    [sym__upper_id] = ACTIONS(661),
    [sym__at_lower_id] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(659),
    [sym_boolean] = ACTIONS(659),
    [sym_class] = ACTIONS(659),
    [sym_newtype] = ACTIONS(659),
    [sym_date] = ACTIONS(659),
    [sym_import] = ACTIONS(659),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(659),
    [sym_predicate] = ACTIONS(659),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(663),
    [sym__lower_id] = ACTIONS(665),
    [anon_sym_module] = ACTIONS(665),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_from] = ACTIONS(665),
    [anon_sym_where] = ACTIONS(665),
    [anon_sym_select] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(665),
    [anon_sym_implies] = ACTIONS(665),
    [anon_sym_order] = ACTIONS(665),
    [sym_qldoc] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(665),
    [anon_sym_int] = ACTIONS(665),
    [anon_sym_string] = ACTIONS(665),
    [sym__upper_id] = ACTIONS(663),
    [sym__at_lower_id] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(665),
    [sym_boolean] = ACTIONS(665),
    [sym_class] = ACTIONS(665),
    [sym_newtype] = ACTIONS(665),
    [sym_date] = ACTIONS(665),
    [sym_import] = ACTIONS(665),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(665),
    [sym_predicate] = ACTIONS(665),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [sym__lower_id] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(651),
    [anon_sym_from] = ACTIONS(651),
    [anon_sym_where] = ACTIONS(651),
    [anon_sym_select] = ACTIONS(651),
    [anon_sym_and] = ACTIONS(651),
    [anon_sym_implies] = ACTIONS(651),
    [anon_sym_order] = ACTIONS(651),
    [sym_qldoc] = ACTIONS(653),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_string] = ACTIONS(651),
    [sym__upper_id] = ACTIONS(653),
    [sym__at_lower_id] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(651),
    [sym_boolean] = ACTIONS(651),
    [sym_class] = ACTIONS(651),
    [sym_newtype] = ACTIONS(651),
    [sym_date] = ACTIONS(651),
    [sym_import] = ACTIONS(651),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(651),
    [sym_predicate] = ACTIONS(651),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(625),
    [sym__lower_id] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_from] = ACTIONS(623),
    [anon_sym_where] = ACTIONS(623),
    [anon_sym_select] = ACTIONS(623),
    [anon_sym_and] = ACTIONS(623),
    [anon_sym_implies] = ACTIONS(623),
    [sym_qldoc] = ACTIONS(625),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_int] = ACTIONS(623),
    [anon_sym_string] = ACTIONS(623),
    [sym__upper_id] = ACTIONS(625),
    [sym__at_lower_id] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_asc] = ACTIONS(623),
    [sym_boolean] = ACTIONS(623),
    [sym_class] = ACTIONS(623),
    [sym_newtype] = ACTIONS(623),
    [sym_date] = ACTIONS(623),
    [sym_desc] = ACTIONS(623),
    [sym_import] = ACTIONS(623),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(623),
    [sym_predicate] = ACTIONS(623),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [450] = {
    [sym_module] = STATE(776),
    [sym_moduleMember] = STATE(456),
    [sym_imprt] = STATE(776),
    [sym_classlessPredicate] = STATE(776),
    [sym_datatype] = STATE(776),
    [sym_select] = STATE(776),
    [sym_dataclass] = STATE(776),
    [sym_annotation] = STATE(459),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(456),
    [aux_sym_moduleMember_repeat1] = STATE(459),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(677),
    [anon_sym_from] = ACTIONS(679),
    [anon_sym_where] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(683),
    [sym_qldoc] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(687),
    [sym_newtype] = ACTIONS(689),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(691),
    [sym_predicate] = ACTIONS(33),
  },
  [451] = {
    [sym_module] = STATE(825),
    [sym_moduleMember] = STATE(451),
    [sym_imprt] = STATE(825),
    [sym_classlessPredicate] = STATE(825),
    [sym_datatype] = STATE(825),
    [sym_select] = STATE(825),
    [sym_dataclass] = STATE(825),
    [sym_annotation] = STATE(463),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1092),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(451),
    [aux_sym_moduleMember_repeat1] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym__lower_id] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_from] = ACTIONS(701),
    [anon_sym_where] = ACTIONS(704),
    [anon_sym_select] = ACTIONS(707),
    [sym_qldoc] = ACTIONS(710),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_int] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [sym__upper_id] = ACTIONS(716),
    [sym__at_lower_id] = ACTIONS(719),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(713),
    [sym_class] = ACTIONS(722),
    [sym_newtype] = ACTIONS(725),
    [sym_date] = ACTIONS(713),
    [sym_import] = ACTIONS(728),
    [sym_predicate] = ACTIONS(731),
  },
  [452] = {
    [sym_module] = STATE(776),
    [sym_moduleMember] = STATE(456),
    [sym_imprt] = STATE(776),
    [sym_classlessPredicate] = STATE(776),
    [sym_datatype] = STATE(776),
    [sym_select] = STATE(776),
    [sym_dataclass] = STATE(776),
    [sym_annotation] = STATE(459),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(456),
    [aux_sym_moduleMember_repeat1] = STATE(459),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_from] = ACTIONS(679),
    [anon_sym_where] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(683),
    [sym_qldoc] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(687),
    [sym_newtype] = ACTIONS(689),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(691),
    [sym_predicate] = ACTIONS(33),
  },
  [453] = {
    [sym_module] = STATE(776),
    [sym_moduleMember] = STATE(450),
    [sym_imprt] = STATE(776),
    [sym_classlessPredicate] = STATE(776),
    [sym_datatype] = STATE(776),
    [sym_select] = STATE(776),
    [sym_dataclass] = STATE(776),
    [sym_annotation] = STATE(459),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(450),
    [aux_sym_moduleMember_repeat1] = STATE(459),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_from] = ACTIONS(679),
    [anon_sym_where] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(683),
    [sym_qldoc] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(687),
    [sym_newtype] = ACTIONS(689),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(691),
    [sym_predicate] = ACTIONS(33),
  },
  [454] = {
    [sym_module] = STATE(825),
    [sym_moduleMember] = STATE(451),
    [sym_imprt] = STATE(825),
    [sym_classlessPredicate] = STATE(825),
    [sym_datatype] = STATE(825),
    [sym_select] = STATE(825),
    [sym_dataclass] = STATE(825),
    [sym_annotation] = STATE(463),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1092),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(451),
    [aux_sym_moduleMember_repeat1] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(738),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_where] = ACTIONS(15),
    [anon_sym_select] = ACTIONS(17),
    [sym_qldoc] = ACTIONS(19),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(27),
    [sym_newtype] = ACTIONS(29),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(31),
    [sym_predicate] = ACTIONS(33),
  },
  [455] = {
    [sym_module] = STATE(776),
    [sym_moduleMember] = STATE(452),
    [sym_imprt] = STATE(776),
    [sym_classlessPredicate] = STATE(776),
    [sym_datatype] = STATE(776),
    [sym_select] = STATE(776),
    [sym_dataclass] = STATE(776),
    [sym_annotation] = STATE(459),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(452),
    [aux_sym_moduleMember_repeat1] = STATE(459),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_from] = ACTIONS(679),
    [anon_sym_where] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(683),
    [sym_qldoc] = ACTIONS(685),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(687),
    [sym_newtype] = ACTIONS(689),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(691),
    [sym_predicate] = ACTIONS(33),
  },
  [456] = {
    [sym_module] = STATE(776),
    [sym_moduleMember] = STATE(456),
    [sym_imprt] = STATE(776),
    [sym_classlessPredicate] = STATE(776),
    [sym_datatype] = STATE(776),
    [sym_select] = STATE(776),
    [sym_dataclass] = STATE(776),
    [sym_annotation] = STATE(459),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_ql_repeat1] = STATE(456),
    [aux_sym_moduleMember_repeat1] = STATE(459),
    [sym__lower_id] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_from] = ACTIONS(745),
    [anon_sym_where] = ACTIONS(748),
    [anon_sym_select] = ACTIONS(751),
    [sym_qldoc] = ACTIONS(754),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_int] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [sym__upper_id] = ACTIONS(716),
    [sym__at_lower_id] = ACTIONS(719),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(713),
    [sym_class] = ACTIONS(757),
    [sym_newtype] = ACTIONS(760),
    [sym_date] = ACTIONS(713),
    [sym_import] = ACTIONS(763),
    [sym_predicate] = ACTIONS(731),
  },
  [457] = {
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_select] = ACTIONS(513),
    [anon_sym_then] = ACTIONS(513),
    [anon_sym_else] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(513),
    [anon_sym_implies] = ACTIONS(513),
    [anon_sym_PIPE] = ACTIONS(511),
    [anon_sym_RBRACK] = ACTIONS(511),
    [anon_sym_DOT_DOT] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym__upper_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(513),
    [sym_desc] = ACTIONS(513),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(513),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [458] = {
    [sym__lower_id] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_select] = ACTIONS(615),
    [anon_sym_then] = ACTIONS(615),
    [anon_sym_else] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(615),
    [anon_sym_implies] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_DOT] = ACTIONS(615),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_DOT_DOT] = ACTIONS(617),
    [sym__upper_id] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(615),
    [sym_desc] = ACTIONS(615),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(615),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [459] = {
    [sym_module] = STATE(769),
    [sym_imprt] = STATE(769),
    [sym_classlessPredicate] = STATE(769),
    [sym_datatype] = STATE(769),
    [sym_select] = STATE(769),
    [sym_dataclass] = STATE(769),
    [sym_annotation] = STATE(750),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1100),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_moduleMember_repeat1] = STATE(750),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_from] = ACTIONS(679),
    [anon_sym_where] = ACTIONS(681),
    [anon_sym_select] = ACTIONS(683),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(687),
    [sym_newtype] = ACTIONS(689),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(691),
    [sym_predicate] = ACTIONS(33),
  },
  [460] = {
    [sym__lower_id] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(619),
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_select] = ACTIONS(621),
    [anon_sym_then] = ACTIONS(621),
    [anon_sym_else] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(621),
    [anon_sym_implies] = ACTIONS(621),
    [anon_sym_PIPE] = ACTIONS(619),
    [anon_sym_DOT] = ACTIONS(621),
    [anon_sym_RBRACK] = ACTIONS(619),
    [anon_sym_DOT_DOT] = ACTIONS(619),
    [sym__upper_id] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(621),
    [sym_desc] = ACTIONS(621),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(621),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [461] = {
    [sym__lower_id] = ACTIONS(613),
    [anon_sym_LBRACE] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(611),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_select] = ACTIONS(613),
    [anon_sym_then] = ACTIONS(613),
    [anon_sym_else] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(613),
    [anon_sym_implies] = ACTIONS(613),
    [anon_sym_PIPE] = ACTIONS(611),
    [anon_sym_DOT] = ACTIONS(613),
    [anon_sym_RBRACK] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(611),
    [sym__upper_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(613),
    [sym_desc] = ACTIONS(613),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(613),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [462] = {
    [sym__lower_id] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_select] = ACTIONS(659),
    [anon_sym_then] = ACTIONS(659),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(659),
    [anon_sym_implies] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_DOT] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(661),
    [anon_sym_DOT_DOT] = ACTIONS(661),
    [sym__upper_id] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(659),
    [sym_desc] = ACTIONS(659),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(659),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [463] = {
    [sym_module] = STATE(815),
    [sym_imprt] = STATE(815),
    [sym_classlessPredicate] = STATE(815),
    [sym_datatype] = STATE(815),
    [sym_select] = STATE(815),
    [sym_dataclass] = STATE(815),
    [sym_annotation] = STATE(750),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1092),
    [sym_typeExpr] = STATE(1253),
    [aux_sym_moduleMember_repeat1] = STATE(750),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_where] = ACTIONS(15),
    [anon_sym_select] = ACTIONS(17),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_class] = ACTIONS(27),
    [sym_newtype] = ACTIONS(29),
    [sym_date] = ACTIONS(21),
    [sym_import] = ACTIONS(31),
    [sym_predicate] = ACTIONS(33),
  },
  [464] = {
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_select] = ACTIONS(463),
    [anon_sym_then] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(463),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_implies] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(465),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(463),
    [sym_desc] = ACTIONS(463),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(463),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [465] = {
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(499),
    [anon_sym_select] = ACTIONS(499),
    [anon_sym_then] = ACTIONS(499),
    [anon_sym_else] = ACTIONS(499),
    [anon_sym_and] = ACTIONS(499),
    [anon_sym_implies] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_DOT] = ACTIONS(497),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_DOT_DOT] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(499),
    [sym_desc] = ACTIONS(499),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(499),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [466] = {
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(517),
    [anon_sym_select] = ACTIONS(517),
    [anon_sym_then] = ACTIONS(517),
    [anon_sym_else] = ACTIONS(517),
    [anon_sym_and] = ACTIONS(517),
    [anon_sym_implies] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_DOT_DOT] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(517),
    [sym_desc] = ACTIONS(517),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(517),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [467] = {
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(507),
    [anon_sym_select] = ACTIONS(507),
    [anon_sym_then] = ACTIONS(507),
    [anon_sym_else] = ACTIONS(507),
    [anon_sym_and] = ACTIONS(507),
    [anon_sym_implies] = ACTIONS(507),
    [anon_sym_PIPE] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_RBRACK] = ACTIONS(507),
    [anon_sym_DOT_DOT] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(507),
    [sym_desc] = ACTIONS(507),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(507),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [468] = {
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(595),
    [anon_sym_select] = ACTIONS(595),
    [anon_sym_then] = ACTIONS(595),
    [anon_sym_else] = ACTIONS(595),
    [anon_sym_and] = ACTIONS(595),
    [anon_sym_implies] = ACTIONS(595),
    [anon_sym_PIPE] = ACTIONS(595),
    [anon_sym_DOT] = ACTIONS(593),
    [anon_sym_RBRACK] = ACTIONS(595),
    [anon_sym_DOT_DOT] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(595),
    [sym_desc] = ACTIONS(595),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(595),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [469] = {
    [anon_sym_RBRACE] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_RPAREN] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(567),
    [anon_sym_select] = ACTIONS(567),
    [anon_sym_then] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(567),
    [anon_sym_implies] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(567),
    [sym_desc] = ACTIONS(567),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(567),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [470] = {
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_select] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_implies] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(557),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(559),
    [sym_desc] = ACTIONS(559),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(559),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [471] = {
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(583),
    [anon_sym_select] = ACTIONS(583),
    [anon_sym_then] = ACTIONS(583),
    [anon_sym_else] = ACTIONS(583),
    [anon_sym_and] = ACTIONS(583),
    [anon_sym_implies] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_DOT] = ACTIONS(581),
    [anon_sym_RBRACK] = ACTIONS(583),
    [anon_sym_DOT_DOT] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(583),
    [sym_desc] = ACTIONS(583),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(583),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [472] = {
    [anon_sym_RBRACE] = ACTIONS(547),
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(547),
    [anon_sym_select] = ACTIONS(547),
    [anon_sym_then] = ACTIONS(547),
    [anon_sym_else] = ACTIONS(547),
    [anon_sym_and] = ACTIONS(547),
    [anon_sym_implies] = ACTIONS(547),
    [anon_sym_PIPE] = ACTIONS(547),
    [anon_sym_DOT] = ACTIONS(545),
    [anon_sym_RBRACK] = ACTIONS(547),
    [anon_sym_DOT_DOT] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(547),
    [sym_desc] = ACTIONS(547),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(547),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [473] = {
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(505),
    [anon_sym_select] = ACTIONS(505),
    [anon_sym_then] = ACTIONS(505),
    [anon_sym_else] = ACTIONS(505),
    [anon_sym_and] = ACTIONS(505),
    [anon_sym_implies] = ACTIONS(505),
    [anon_sym_PIPE] = ACTIONS(505),
    [anon_sym_DOT] = ACTIONS(503),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_DOT_DOT] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(505),
    [sym_desc] = ACTIONS(505),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(505),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [474] = {
    [anon_sym_RBRACE] = ACTIONS(555),
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(555),
    [anon_sym_select] = ACTIONS(555),
    [anon_sym_then] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_and] = ACTIONS(555),
    [anon_sym_implies] = ACTIONS(555),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(553),
    [anon_sym_RBRACK] = ACTIONS(555),
    [anon_sym_DOT_DOT] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(555),
    [sym_desc] = ACTIONS(555),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(555),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [475] = {
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RPAREN] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(575),
    [anon_sym_select] = ACTIONS(575),
    [anon_sym_then] = ACTIONS(575),
    [anon_sym_else] = ACTIONS(575),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_implies] = ACTIONS(575),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(575),
    [sym_desc] = ACTIONS(575),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(575),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [476] = {
    [anon_sym_RBRACE] = ACTIONS(543),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_RPAREN] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(543),
    [anon_sym_select] = ACTIONS(543),
    [anon_sym_then] = ACTIONS(543),
    [anon_sym_else] = ACTIONS(543),
    [anon_sym_and] = ACTIONS(543),
    [anon_sym_implies] = ACTIONS(543),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_DOT] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(543),
    [anon_sym_DOT_DOT] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(543),
    [sym_desc] = ACTIONS(543),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(543),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [477] = {
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(523),
    [anon_sym_select] = ACTIONS(523),
    [anon_sym_then] = ACTIONS(523),
    [anon_sym_else] = ACTIONS(523),
    [anon_sym_and] = ACTIONS(523),
    [anon_sym_implies] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(523),
    [anon_sym_DOT] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_DOT_DOT] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(523),
    [sym_desc] = ACTIONS(523),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(523),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [478] = {
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_RPAREN] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(571),
    [anon_sym_select] = ACTIONS(571),
    [anon_sym_then] = ACTIONS(571),
    [anon_sym_else] = ACTIONS(571),
    [anon_sym_and] = ACTIONS(571),
    [anon_sym_implies] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(571),
    [sym_desc] = ACTIONS(571),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(571),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [479] = {
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(527),
    [anon_sym_select] = ACTIONS(527),
    [anon_sym_then] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(527),
    [anon_sym_and] = ACTIONS(527),
    [anon_sym_implies] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(527),
    [anon_sym_DOT_DOT] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(527),
    [sym_desc] = ACTIONS(527),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(527),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [480] = {
    [anon_sym_RBRACE] = ACTIONS(579),
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(579),
    [anon_sym_select] = ACTIONS(579),
    [anon_sym_then] = ACTIONS(579),
    [anon_sym_else] = ACTIONS(579),
    [anon_sym_and] = ACTIONS(579),
    [anon_sym_implies] = ACTIONS(579),
    [anon_sym_PIPE] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(577),
    [anon_sym_RBRACK] = ACTIONS(579),
    [anon_sym_DOT_DOT] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(579),
    [sym_desc] = ACTIONS(579),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(579),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [481] = {
    [anon_sym_RBRACE] = ACTIONS(551),
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(551),
    [anon_sym_select] = ACTIONS(551),
    [anon_sym_then] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_and] = ACTIONS(551),
    [anon_sym_implies] = ACTIONS(551),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(551),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(551),
    [sym_desc] = ACTIONS(551),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(551),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [482] = {
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_RPAREN] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(531),
    [anon_sym_select] = ACTIONS(531),
    [anon_sym_then] = ACTIONS(531),
    [anon_sym_else] = ACTIONS(531),
    [anon_sym_and] = ACTIONS(531),
    [anon_sym_implies] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(531),
    [anon_sym_DOT_DOT] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(531),
    [sym_desc] = ACTIONS(531),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(531),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [483] = {
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(535),
    [anon_sym_select] = ACTIONS(535),
    [anon_sym_then] = ACTIONS(535),
    [anon_sym_else] = ACTIONS(535),
    [anon_sym_and] = ACTIONS(535),
    [anon_sym_implies] = ACTIONS(535),
    [anon_sym_PIPE] = ACTIONS(535),
    [anon_sym_DOT] = ACTIONS(533),
    [anon_sym_RBRACK] = ACTIONS(535),
    [anon_sym_DOT_DOT] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(535),
    [sym_desc] = ACTIONS(535),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(535),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [484] = {
    [anon_sym_RBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_RPAREN] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(563),
    [anon_sym_select] = ACTIONS(563),
    [anon_sym_then] = ACTIONS(563),
    [anon_sym_else] = ACTIONS(563),
    [anon_sym_and] = ACTIONS(563),
    [anon_sym_implies] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(563),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_RBRACK] = ACTIONS(563),
    [anon_sym_DOT_DOT] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(563),
    [sym_desc] = ACTIONS(563),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(563),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [485] = {
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(539),
    [anon_sym_select] = ACTIONS(539),
    [anon_sym_then] = ACTIONS(539),
    [anon_sym_else] = ACTIONS(539),
    [anon_sym_and] = ACTIONS(539),
    [anon_sym_implies] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(539),
    [anon_sym_DOT] = ACTIONS(537),
    [anon_sym_RBRACK] = ACTIONS(539),
    [anon_sym_DOT_DOT] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(539),
    [sym_desc] = ACTIONS(539),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(539),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [486] = {
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(589),
    [anon_sym_select] = ACTIONS(589),
    [anon_sym_then] = ACTIONS(589),
    [anon_sym_else] = ACTIONS(589),
    [anon_sym_and] = ACTIONS(589),
    [anon_sym_implies] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_DOT] = ACTIONS(591),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_DOT_DOT] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(589),
    [sym_desc] = ACTIONS(589),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(589),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [487] = {
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(585),
    [anon_sym_select] = ACTIONS(585),
    [anon_sym_then] = ACTIONS(585),
    [anon_sym_else] = ACTIONS(585),
    [anon_sym_and] = ACTIONS(585),
    [anon_sym_implies] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(585),
    [anon_sym_DOT] = ACTIONS(587),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_DOT_DOT] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(585),
    [sym_desc] = ACTIONS(585),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(585),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [488] = {
    [anon_sym_RBRACE] = ACTIONS(663),
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(663),
    [anon_sym_select] = ACTIONS(663),
    [anon_sym_then] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(663),
    [anon_sym_and] = ACTIONS(663),
    [anon_sym_implies] = ACTIONS(663),
    [anon_sym_PIPE] = ACTIONS(663),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_DOT_DOT] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(663),
    [sym_desc] = ACTIONS(663),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(663),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [489] = {
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_RPAREN] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(637),
    [anon_sym_select] = ACTIONS(637),
    [anon_sym_then] = ACTIONS(637),
    [anon_sym_else] = ACTIONS(637),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_implies] = ACTIONS(637),
    [anon_sym_PIPE] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_DOT_DOT] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(637),
    [sym_desc] = ACTIONS(637),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(637),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [490] = {
    [sym_classMember] = STATE(506),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(506),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(768),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [491] = {
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(625),
    [anon_sym_select] = ACTIONS(625),
    [anon_sym_then] = ACTIONS(625),
    [anon_sym_else] = ACTIONS(625),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_implies] = ACTIONS(625),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_RBRACK] = ACTIONS(625),
    [anon_sym_DOT_DOT] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(625),
    [sym_desc] = ACTIONS(625),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(625),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [492] = {
    [anon_sym_RBRACE] = ACTIONS(655),
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(655),
    [anon_sym_select] = ACTIONS(655),
    [anon_sym_then] = ACTIONS(655),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_and] = ACTIONS(655),
    [anon_sym_implies] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_DOT_DOT] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(655),
    [sym_desc] = ACTIONS(655),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(655),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [493] = {
    [sym_classMember] = STATE(502),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(502),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(768),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [494] = {
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(653),
    [anon_sym_select] = ACTIONS(653),
    [anon_sym_then] = ACTIONS(653),
    [anon_sym_else] = ACTIONS(653),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_implies] = ACTIONS(653),
    [anon_sym_PIPE] = ACTIONS(653),
    [anon_sym_RBRACK] = ACTIONS(653),
    [anon_sym_DOT_DOT] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(653),
    [sym_desc] = ACTIONS(653),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(653),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [495] = {
    [anon_sym_RBRACE] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(639),
    [anon_sym_select] = ACTIONS(639),
    [anon_sym_then] = ACTIONS(639),
    [anon_sym_else] = ACTIONS(639),
    [anon_sym_and] = ACTIONS(639),
    [anon_sym_implies] = ACTIONS(639),
    [anon_sym_PIPE] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(639),
    [sym_desc] = ACTIONS(639),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(639),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [496] = {
    [sym_classMember] = STATE(502),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(502),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(772),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [497] = {
    [sym_classMember] = STATE(504),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(504),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(772),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [498] = {
    [sym_classMember] = STATE(493),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(493),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(774),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [499] = {
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_RPAREN] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(609),
    [anon_sym_select] = ACTIONS(609),
    [anon_sym_then] = ACTIONS(609),
    [anon_sym_else] = ACTIONS(609),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_implies] = ACTIONS(609),
    [anon_sym_PIPE] = ACTIONS(609),
    [anon_sym_RBRACK] = ACTIONS(609),
    [anon_sym_DOT_DOT] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(609),
    [sym_desc] = ACTIONS(609),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(609),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [500] = {
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(649),
    [anon_sym_select] = ACTIONS(649),
    [anon_sym_then] = ACTIONS(649),
    [anon_sym_else] = ACTIONS(649),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_implies] = ACTIONS(649),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_DOT_DOT] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(649),
    [sym_desc] = ACTIONS(649),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(649),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [501] = {
    [sym_classMember] = STATE(496),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(496),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(776),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [502] = {
    [sym_classMember] = STATE(502),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(502),
    [sym__lower_id] = ACTIONS(778),
    [anon_sym_RBRACE] = ACTIONS(781),
    [sym_qldoc] = ACTIONS(783),
    [anon_sym_float] = ACTIONS(786),
    [anon_sym_int] = ACTIONS(786),
    [anon_sym_string] = ACTIONS(786),
    [sym__upper_id] = ACTIONS(789),
    [sym__at_lower_id] = ACTIONS(792),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(786),
    [sym_date] = ACTIONS(786),
    [sym_predicate] = ACTIONS(795),
  },
  [503] = {
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(605),
    [anon_sym_select] = ACTIONS(605),
    [anon_sym_then] = ACTIONS(605),
    [anon_sym_else] = ACTIONS(605),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_implies] = ACTIONS(605),
    [anon_sym_PIPE] = ACTIONS(605),
    [anon_sym_RBRACK] = ACTIONS(605),
    [anon_sym_DOT_DOT] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(605),
    [sym_desc] = ACTIONS(605),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(605),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [504] = {
    [sym_classMember] = STATE(502),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(502),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(798),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [505] = {
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(633),
    [anon_sym_select] = ACTIONS(633),
    [anon_sym_then] = ACTIONS(633),
    [anon_sym_else] = ACTIONS(633),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_implies] = ACTIONS(633),
    [anon_sym_PIPE] = ACTIONS(633),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_DOT_DOT] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(633),
    [sym_desc] = ACTIONS(633),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(633),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [506] = {
    [sym_classMember] = STATE(502),
    [sym_charpred] = STATE(863),
    [sym_memberPredicate] = STATE(863),
    [sym_field] = STATE(863),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(533),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(533),
    [aux_sym_dataclass_repeat2] = STATE(502),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(800),
    [sym_qldoc] = ACTIONS(770),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [507] = {
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_or] = ACTIONS(463),
    [anon_sym_select] = ACTIONS(463),
    [anon_sym_then] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(463),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_implies] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(802),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(463),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [508] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(455),
    [anon_sym_then] = ACTIONS(455),
    [anon_sym_else] = ACTIONS(455),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(455),
    [anon_sym_DOT_DOT] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [509] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_select] = ACTIONS(459),
    [anon_sym_then] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_implies] = ACTIONS(459),
    [anon_sym_RBRACK] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [510] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(425),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(425),
    [anon_sym_RBRACK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [511] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(495),
    [anon_sym_select] = ACTIONS(495),
    [anon_sym_then] = ACTIONS(495),
    [anon_sym_else] = ACTIONS(495),
    [anon_sym_and] = ACTIONS(495),
    [anon_sym_implies] = ACTIONS(495),
    [anon_sym_RBRACK] = ACTIONS(495),
    [anon_sym_DOT_DOT] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [512] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(447),
    [anon_sym_select] = ACTIONS(447),
    [anon_sym_then] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(447),
    [anon_sym_RBRACK] = ACTIONS(447),
    [anon_sym_DOT_DOT] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [513] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(443),
    [anon_sym_then] = ACTIONS(443),
    [anon_sym_else] = ACTIONS(443),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(443),
    [anon_sym_DOT_DOT] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [514] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(437),
    [anon_sym_select] = ACTIONS(437),
    [anon_sym_then] = ACTIONS(437),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_and] = ACTIONS(437),
    [anon_sym_implies] = ACTIONS(437),
    [anon_sym_RBRACK] = ACTIONS(437),
    [anon_sym_DOT_DOT] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [515] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(451),
    [anon_sym_select] = ACTIONS(451),
    [anon_sym_then] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_and] = ACTIONS(451),
    [anon_sym_implies] = ACTIONS(451),
    [anon_sym_RBRACK] = ACTIONS(451),
    [anon_sym_DOT_DOT] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(451),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [516] = {
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(472),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym__upper_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(465),
    [sym_desc] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [517] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_select] = ACTIONS(419),
    [anon_sym_then] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_implies] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(419),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [518] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_select] = ACTIONS(421),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_implies] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(421),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [519] = {
    [sym__lower_id] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(465),
    [anon_sym_implies] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(472),
    [anon_sym_order] = ACTIONS(465),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym__upper_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(465),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(465),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [520] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(459),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_implies] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(459),
    [sym_desc] = ACTIONS(459),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [521] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(495),
    [anon_sym_and] = ACTIONS(495),
    [anon_sym_implies] = ACTIONS(495),
    [anon_sym_PIPE] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(495),
    [sym_desc] = ACTIONS(495),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [522] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(451),
    [anon_sym_and] = ACTIONS(451),
    [anon_sym_implies] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(451),
    [sym_desc] = ACTIONS(451),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(451),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [523] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(437),
    [anon_sym_and] = ACTIONS(437),
    [anon_sym_implies] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(437),
    [sym_desc] = ACTIONS(437),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [524] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_RPAREN] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(443),
    [sym_desc] = ACTIONS(443),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [525] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(447),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(447),
    [anon_sym_PIPE] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(447),
    [sym_desc] = ACTIONS(447),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [526] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(425),
    [anon_sym_PIPE] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(425),
    [sym_desc] = ACTIONS(425),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [527] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_implies] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(419),
    [sym_desc] = ACTIONS(419),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(419),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [528] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [sym_direction] = STATE(1087),
    [anon_sym_COMMA] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(821),
    [sym_desc] = ACTIONS(821),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [529] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_implies] = ACTIONS(421),
    [anon_sym_PIPE] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(421),
    [sym_desc] = ACTIONS(421),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(421),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [530] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_asc] = ACTIONS(455),
    [sym_desc] = ACTIONS(455),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [531] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_RPAREN] = ACTIONS(443),
    [anon_sym_or] = ACTIONS(823),
    [anon_sym_and] = ACTIONS(825),
    [anon_sym_implies] = ACTIONS(827),
    [anon_sym_order] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(443),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [532] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(495),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_or] = ACTIONS(493),
    [anon_sym_and] = ACTIONS(495),
    [anon_sym_implies] = ACTIONS(495),
    [anon_sym_order] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(495),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [533] = {
    [sym_charpred] = STATE(861),
    [sym_memberPredicate] = STATE(861),
    [sym_field] = STATE(861),
    [sym_varDecl] = STATE(1200),
    [sym_annotation] = STATE(750),
    [sym_annotName] = STATE(830),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(1058),
    [sym_dbtype] = STATE(458),
    [sym_returnType] = STATE(1112),
    [sym_typeExpr] = STATE(904),
    [aux_sym_moduleMember_repeat1] = STATE(750),
    [sym__lower_id] = ACTIONS(9),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
    [sym_predicate] = ACTIONS(33),
  },
  [534] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(455),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_or] = ACTIONS(823),
    [anon_sym_and] = ACTIONS(825),
    [anon_sym_implies] = ACTIONS(827),
    [anon_sym_order] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(455),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [535] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_or] = ACTIONS(445),
    [anon_sym_and] = ACTIONS(825),
    [anon_sym_implies] = ACTIONS(447),
    [anon_sym_order] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(447),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [536] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_or] = ACTIONS(449),
    [anon_sym_and] = ACTIONS(451),
    [anon_sym_implies] = ACTIONS(451),
    [anon_sym_order] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(451),
    [sym_in] = ACTIONS(449),
    [sym_instanceof] = ACTIONS(451),
    [sym_lt] = ACTIONS(449),
    [sym_le] = ACTIONS(451),
    [sym_eq] = ACTIONS(451),
    [sym_gt] = ACTIONS(449),
    [sym_ge] = ACTIONS(451),
    [sym_minus] = ACTIONS(451),
    [sym_ne] = ACTIONS(451),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(451),
  },
  [537] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_and] = ACTIONS(419),
    [anon_sym_implies] = ACTIONS(419),
    [anon_sym_order] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(419),
    [sym_in] = ACTIONS(417),
    [sym_instanceof] = ACTIONS(419),
    [sym_lt] = ACTIONS(417),
    [sym_le] = ACTIONS(419),
    [sym_eq] = ACTIONS(419),
    [sym_gt] = ACTIONS(417),
    [sym_ge] = ACTIONS(419),
    [sym_minus] = ACTIONS(419),
    [sym_ne] = ACTIONS(419),
    [sym_slash] = ACTIONS(417),
    [sym_star] = ACTIONS(419),
    [sym_mod] = ACTIONS(419),
    [sym_plus] = ACTIONS(419),
  },
  [538] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(421),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_implies] = ACTIONS(421),
    [anon_sym_order] = ACTIONS(421),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(421),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(421),
    [sym_lt] = ACTIONS(423),
    [sym_le] = ACTIONS(421),
    [sym_eq] = ACTIONS(421),
    [sym_gt] = ACTIONS(423),
    [sym_ge] = ACTIONS(421),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(421),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [539] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(425),
    [anon_sym_RPAREN] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(823),
    [anon_sym_and] = ACTIONS(825),
    [anon_sym_implies] = ACTIONS(425),
    [anon_sym_order] = ACTIONS(425),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(425),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [540] = {
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_or] = ACTIONS(465),
    [anon_sym_and] = ACTIONS(463),
    [anon_sym_implies] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(463),
    [sym_in] = ACTIONS(465),
    [sym_instanceof] = ACTIONS(463),
    [sym_lt] = ACTIONS(465),
    [sym_le] = ACTIONS(463),
    [sym_eq] = ACTIONS(463),
    [sym_gt] = ACTIONS(465),
    [sym_ge] = ACTIONS(463),
    [sym_minus] = ACTIONS(463),
    [sym_ne] = ACTIONS(463),
    [sym_slash] = ACTIONS(465),
    [sym_star] = ACTIONS(469),
    [sym_mod] = ACTIONS(463),
    [sym_plus] = ACTIONS(469),
  },
  [541] = {
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
  },
  [542] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(477),
    [anon_sym_RPAREN] = ACTIONS(477),
    [anon_sym_or] = ACTIONS(823),
    [anon_sym_and] = ACTIONS(825),
    [anon_sym_implies] = ACTIONS(827),
    [anon_sym_order] = ACTIONS(477),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(833),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym__lower_id] = ACTIONS(465),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_from] = ACTIONS(465),
    [anon_sym_where] = ACTIONS(465),
    [anon_sym_select] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(465),
    [sym_qldoc] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(465),
    [anon_sym_int] = ACTIONS(465),
    [anon_sym_string] = ACTIONS(465),
    [sym__upper_id] = ACTIONS(463),
    [sym__at_lower_id] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(465),
    [sym_boolean] = ACTIONS(465),
    [sym_class] = ACTIONS(465),
    [sym_newtype] = ACTIONS(465),
    [sym_date] = ACTIONS(465),
    [sym_import] = ACTIONS(465),
    [sym_predicate] = ACTIONS(465),
  },
  [544] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_or] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(437),
    [anon_sym_implies] = ACTIONS(437),
    [anon_sym_order] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(437),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [545] = {
    [sym_compop] = STATE(166),
    [sym_mulop] = STATE(164),
    [sym_addop] = STATE(163),
    [anon_sym_COMMA] = ACTIONS(459),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_or] = ACTIONS(461),
    [anon_sym_and] = ACTIONS(459),
    [anon_sym_implies] = ACTIONS(459),
    [anon_sym_order] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(459),
    [sym_in] = ACTIONS(829),
    [sym_instanceof] = ACTIONS(831),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [546] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(999),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [547] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(839),
    [sym__lower_id] = ACTIONS(841),
    [anon_sym_module] = ACTIONS(841),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_select] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [sym_qldoc] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(839),
    [anon_sym_float] = ACTIONS(841),
    [anon_sym_int] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [sym__upper_id] = ACTIONS(839),
    [sym__at_lower_id] = ACTIONS(839),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(841),
    [sym_boolean] = ACTIONS(841),
    [sym_class] = ACTIONS(841),
    [sym_newtype] = ACTIONS(841),
    [sym_date] = ACTIONS(841),
    [sym_import] = ACTIONS(841),
    [sym_predicate] = ACTIONS(841),
  },
  [548] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(548),
    [sym__lower_id] = ACTIONS(845),
    [anon_sym_module] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_from] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_select] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(849),
    [sym_qldoc] = ACTIONS(847),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(845),
    [anon_sym_int] = ACTIONS(845),
    [anon_sym_string] = ACTIONS(845),
    [sym__upper_id] = ACTIONS(847),
    [sym__at_lower_id] = ACTIONS(847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(845),
    [sym_boolean] = ACTIONS(845),
    [sym_class] = ACTIONS(845),
    [sym_newtype] = ACTIONS(845),
    [sym_date] = ACTIONS(845),
    [sym_import] = ACTIONS(845),
    [sym_predicate] = ACTIONS(845),
  },
  [549] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(548),
    [sym__lower_id] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_RBRACE] = ACTIONS(854),
    [anon_sym_from] = ACTIONS(852),
    [anon_sym_where] = ACTIONS(852),
    [anon_sym_select] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(856),
    [sym_qldoc] = ACTIONS(854),
    [anon_sym_COLON_COLON] = ACTIONS(854),
    [anon_sym_float] = ACTIONS(852),
    [anon_sym_int] = ACTIONS(852),
    [anon_sym_string] = ACTIONS(852),
    [sym__upper_id] = ACTIONS(854),
    [sym__at_lower_id] = ACTIONS(854),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(852),
    [sym_boolean] = ACTIONS(852),
    [sym_class] = ACTIONS(852),
    [sym_newtype] = ACTIONS(852),
    [sym_date] = ACTIONS(852),
    [sym_import] = ACTIONS(852),
    [sym_predicate] = ACTIONS(852),
  },
  [550] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(1020),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(858),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [551] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(1012),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(860),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [552] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(1041),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(862),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [553] = {
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_or] = ACTIONS(497),
    [anon_sym_and] = ACTIONS(499),
    [anon_sym_implies] = ACTIONS(499),
    [anon_sym_DOT] = ACTIONS(499),
    [anon_sym_order] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(499),
    [sym_in] = ACTIONS(497),
    [sym_instanceof] = ACTIONS(499),
    [sym_lt] = ACTIONS(497),
    [sym_le] = ACTIONS(499),
    [sym_eq] = ACTIONS(499),
    [sym_gt] = ACTIONS(497),
    [sym_ge] = ACTIONS(499),
    [sym_minus] = ACTIONS(499),
    [sym_ne] = ACTIONS(499),
    [sym_slash] = ACTIONS(497),
    [sym_star] = ACTIONS(499),
    [sym_mod] = ACTIONS(499),
    [sym_plus] = ACTIONS(499),
  },
  [554] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(1002),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(864),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [555] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(847),
    [sym__lower_id] = ACTIONS(845),
    [anon_sym_module] = ACTIONS(845),
    [anon_sym_from] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_select] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(866),
    [sym_qldoc] = ACTIONS(847),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(845),
    [anon_sym_int] = ACTIONS(845),
    [anon_sym_string] = ACTIONS(845),
    [sym__upper_id] = ACTIONS(847),
    [sym__at_lower_id] = ACTIONS(847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(845),
    [sym_boolean] = ACTIONS(845),
    [sym_class] = ACTIONS(845),
    [sym_newtype] = ACTIONS(845),
    [sym_date] = ACTIONS(845),
    [sym_import] = ACTIONS(845),
    [sym_predicate] = ACTIONS(845),
  },
  [556] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [aux_sym_aggregate_repeat1] = STATE(976),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [557] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(549),
    [sym__lower_id] = ACTIONS(841),
    [anon_sym_module] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_where] = ACTIONS(841),
    [anon_sym_select] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(856),
    [sym_qldoc] = ACTIONS(839),
    [anon_sym_COLON_COLON] = ACTIONS(839),
    [anon_sym_float] = ACTIONS(841),
    [anon_sym_int] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [sym__upper_id] = ACTIONS(839),
    [sym__at_lower_id] = ACTIONS(839),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(841),
    [sym_boolean] = ACTIONS(841),
    [sym_class] = ACTIONS(841),
    [sym_newtype] = ACTIONS(841),
    [sym_date] = ACTIONS(841),
    [sym_import] = ACTIONS(841),
    [sym_predicate] = ACTIONS(841),
  },
  [558] = {
    [aux_sym_qualModuleExpr_repeat1] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(854),
    [sym__lower_id] = ACTIONS(852),
    [anon_sym_module] = ACTIONS(852),
    [anon_sym_from] = ACTIONS(852),
    [anon_sym_where] = ACTIONS(852),
    [anon_sym_select] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(843),
    [sym_qldoc] = ACTIONS(854),
    [anon_sym_COLON_COLON] = ACTIONS(854),
    [anon_sym_float] = ACTIONS(852),
    [anon_sym_int] = ACTIONS(852),
    [anon_sym_string] = ACTIONS(852),
    [sym__upper_id] = ACTIONS(854),
    [sym__at_lower_id] = ACTIONS(854),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(852),
    [sym_boolean] = ACTIONS(852),
    [sym_class] = ACTIONS(852),
    [sym_newtype] = ACTIONS(852),
    [sym_date] = ACTIONS(852),
    [sym_import] = ACTIONS(852),
    [sym_predicate] = ACTIONS(852),
  },
  [559] = {
    [sym_body] = STATE(748),
    [ts_builtin_sym_end] = ACTIONS(871),
    [sym__lower_id] = ACTIONS(873),
    [anon_sym_module] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_select] = ACTIONS(873),
    [sym_qldoc] = ACTIONS(871),
    [anon_sym_float] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_string] = ACTIONS(873),
    [sym__upper_id] = ACTIONS(871),
    [sym__at_lower_id] = ACTIONS(871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(873),
    [sym_class] = ACTIONS(873),
    [sym_newtype] = ACTIONS(873),
    [sym_date] = ACTIONS(873),
    [sym_import] = ACTIONS(873),
    [sym_predicate] = ACTIONS(873),
  },
  [560] = {
    [sym_body] = STATE(755),
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym__lower_id] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_or] = ACTIONS(879),
    [anon_sym_from] = ACTIONS(879),
    [anon_sym_where] = ACTIONS(879),
    [anon_sym_select] = ACTIONS(879),
    [sym_qldoc] = ACTIONS(877),
    [anon_sym_float] = ACTIONS(879),
    [anon_sym_int] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [sym__upper_id] = ACTIONS(877),
    [sym__at_lower_id] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(879),
    [sym_class] = ACTIONS(879),
    [sym_newtype] = ACTIONS(879),
    [sym_date] = ACTIONS(879),
    [sym_import] = ACTIONS(879),
    [sym_predicate] = ACTIONS(879),
  },
  [561] = {
    [aux_sym_asExprs_repeat1] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym__lower_id] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(885),
    [anon_sym_from] = ACTIONS(883),
    [anon_sym_where] = ACTIONS(883),
    [anon_sym_select] = ACTIONS(883),
    [anon_sym_order] = ACTIONS(883),
    [sym_qldoc] = ACTIONS(881),
    [anon_sym_float] = ACTIONS(883),
    [anon_sym_int] = ACTIONS(883),
    [anon_sym_string] = ACTIONS(883),
    [sym__upper_id] = ACTIONS(881),
    [sym__at_lower_id] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(883),
    [sym_class] = ACTIONS(883),
    [sym_newtype] = ACTIONS(883),
    [sym_date] = ACTIONS(883),
    [sym_import] = ACTIONS(883),
    [sym_predicate] = ACTIONS(883),
  },
  [562] = {
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_RPAREN] = ACTIONS(535),
    [anon_sym_or] = ACTIONS(533),
    [anon_sym_and] = ACTIONS(535),
    [anon_sym_implies] = ACTIONS(535),
    [anon_sym_DOT] = ACTIONS(535),
    [anon_sym_order] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(535),
    [sym_in] = ACTIONS(533),
    [sym_instanceof] = ACTIONS(535),
    [sym_lt] = ACTIONS(533),
    [sym_le] = ACTIONS(535),
    [sym_eq] = ACTIONS(535),
    [sym_gt] = ACTIONS(533),
    [sym_ge] = ACTIONS(535),
    [sym_minus] = ACTIONS(535),
    [sym_ne] = ACTIONS(535),
    [sym_slash] = ACTIONS(533),
    [sym_star] = ACTIONS(535),
    [sym_mod] = ACTIONS(535),
    [sym_plus] = ACTIONS(535),
  },
  [563] = {
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_RPAREN] = ACTIONS(531),
    [anon_sym_or] = ACTIONS(529),
    [anon_sym_and] = ACTIONS(531),
    [anon_sym_implies] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(531),
    [anon_sym_order] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(531),
    [sym_in] = ACTIONS(529),
    [sym_instanceof] = ACTIONS(531),
    [sym_lt] = ACTIONS(529),
    [sym_le] = ACTIONS(531),
    [sym_eq] = ACTIONS(531),
    [sym_gt] = ACTIONS(529),
    [sym_ge] = ACTIONS(531),
    [sym_minus] = ACTIONS(531),
    [sym_ne] = ACTIONS(531),
    [sym_slash] = ACTIONS(529),
    [sym_star] = ACTIONS(531),
    [sym_mod] = ACTIONS(531),
    [sym_plus] = ACTIONS(531),
  },
  [564] = {
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_or] = ACTIONS(525),
    [anon_sym_and] = ACTIONS(527),
    [anon_sym_implies] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_order] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(527),
    [sym_in] = ACTIONS(525),
    [sym_instanceof] = ACTIONS(527),
    [sym_lt] = ACTIONS(525),
    [sym_le] = ACTIONS(527),
    [sym_eq] = ACTIONS(527),
    [sym_gt] = ACTIONS(525),
    [sym_ge] = ACTIONS(527),
    [sym_minus] = ACTIONS(527),
    [sym_ne] = ACTIONS(527),
    [sym_slash] = ACTIONS(525),
    [sym_star] = ACTIONS(527),
    [sym_mod] = ACTIONS(527),
    [sym_plus] = ACTIONS(527),
  },
  [565] = {
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_RPAREN] = ACTIONS(523),
    [anon_sym_or] = ACTIONS(521),
    [anon_sym_and] = ACTIONS(523),
    [anon_sym_implies] = ACTIONS(523),
    [anon_sym_DOT] = ACTIONS(523),
    [anon_sym_order] = ACTIONS(523),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(523),
    [sym_in] = ACTIONS(521),
    [sym_instanceof] = ACTIONS(523),
    [sym_lt] = ACTIONS(521),
    [sym_le] = ACTIONS(523),
    [sym_eq] = ACTIONS(523),
    [sym_gt] = ACTIONS(521),
    [sym_ge] = ACTIONS(523),
    [sym_minus] = ACTIONS(523),
    [sym_ne] = ACTIONS(523),
    [sym_slash] = ACTIONS(521),
    [sym_star] = ACTIONS(523),
    [sym_mod] = ACTIONS(523),
    [sym_plus] = ACTIONS(523),
  },
  [566] = {
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_or] = ACTIONS(515),
    [anon_sym_and] = ACTIONS(517),
    [anon_sym_implies] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_order] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(517),
    [sym_in] = ACTIONS(515),
    [sym_instanceof] = ACTIONS(517),
    [sym_lt] = ACTIONS(515),
    [sym_le] = ACTIONS(517),
    [sym_eq] = ACTIONS(517),
    [sym_gt] = ACTIONS(515),
    [sym_ge] = ACTIONS(517),
    [sym_minus] = ACTIONS(517),
    [sym_ne] = ACTIONS(517),
    [sym_slash] = ACTIONS(515),
    [sym_star] = ACTIONS(517),
    [sym_mod] = ACTIONS(517),
    [sym_plus] = ACTIONS(517),
  },
  [567] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(323),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [568] = {
    [aux_sym_asExprs_repeat1] = STATE(575),
    [sym__lower_id] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(889),
    [anon_sym_from] = ACTIONS(883),
    [anon_sym_where] = ACTIONS(883),
    [anon_sym_select] = ACTIONS(883),
    [anon_sym_order] = ACTIONS(883),
    [sym_qldoc] = ACTIONS(881),
    [anon_sym_float] = ACTIONS(883),
    [anon_sym_int] = ACTIONS(883),
    [anon_sym_string] = ACTIONS(883),
    [sym__upper_id] = ACTIONS(881),
    [sym__at_lower_id] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(883),
    [sym_class] = ACTIONS(883),
    [sym_newtype] = ACTIONS(883),
    [sym_date] = ACTIONS(883),
    [sym_import] = ACTIONS(883),
    [sym_predicate] = ACTIONS(883),
  },
  [569] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(893),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [570] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(897),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [571] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(581),
    [sym__lower_id] = ACTIONS(899),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_from] = ACTIONS(899),
    [anon_sym_where] = ACTIONS(899),
    [anon_sym_select] = ACTIONS(899),
    [sym_qldoc] = ACTIONS(901),
    [anon_sym_COLON_COLON] = ACTIONS(903),
    [anon_sym_float] = ACTIONS(899),
    [anon_sym_int] = ACTIONS(899),
    [anon_sym_string] = ACTIONS(899),
    [sym__upper_id] = ACTIONS(901),
    [sym__at_lower_id] = ACTIONS(901),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(899),
    [sym_boolean] = ACTIONS(899),
    [sym_class] = ACTIONS(899),
    [sym_newtype] = ACTIONS(899),
    [sym_date] = ACTIONS(899),
    [sym_import] = ACTIONS(899),
    [sym_predicate] = ACTIONS(899),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(847),
    [sym__lower_id] = ACTIONS(845),
    [anon_sym_module] = ACTIONS(845),
    [anon_sym_from] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_select] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [sym_qldoc] = ACTIONS(847),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(845),
    [anon_sym_int] = ACTIONS(845),
    [anon_sym_string] = ACTIONS(845),
    [sym__upper_id] = ACTIONS(847),
    [sym__at_lower_id] = ACTIONS(847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(845),
    [sym_boolean] = ACTIONS(845),
    [sym_class] = ACTIONS(845),
    [sym_newtype] = ACTIONS(845),
    [sym_date] = ACTIONS(845),
    [sym_import] = ACTIONS(845),
    [sym_predicate] = ACTIONS(845),
  },
  [573] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(905),
    [sym__lower_id] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_from] = ACTIONS(907),
    [anon_sym_where] = ACTIONS(907),
    [anon_sym_select] = ACTIONS(907),
    [sym_qldoc] = ACTIONS(905),
    [anon_sym_COLON_COLON] = ACTIONS(909),
    [anon_sym_float] = ACTIONS(907),
    [anon_sym_int] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [sym__upper_id] = ACTIONS(905),
    [sym__at_lower_id] = ACTIONS(905),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(907),
    [sym_boolean] = ACTIONS(907),
    [sym_class] = ACTIONS(907),
    [sym_newtype] = ACTIONS(907),
    [sym_date] = ACTIONS(907),
    [sym_import] = ACTIONS(907),
    [sym_predicate] = ACTIONS(907),
  },
  [574] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(913),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [575] = {
    [aux_sym_asExprs_repeat1] = STATE(595),
    [sym__lower_id] = ACTIONS(915),
    [anon_sym_module] = ACTIONS(915),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_COMMA] = ACTIONS(889),
    [anon_sym_from] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_select] = ACTIONS(915),
    [anon_sym_order] = ACTIONS(915),
    [sym_qldoc] = ACTIONS(917),
    [anon_sym_float] = ACTIONS(915),
    [anon_sym_int] = ACTIONS(915),
    [anon_sym_string] = ACTIONS(915),
    [sym__upper_id] = ACTIONS(917),
    [sym__at_lower_id] = ACTIONS(917),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(915),
    [sym_class] = ACTIONS(915),
    [sym_newtype] = ACTIONS(915),
    [sym_date] = ACTIONS(915),
    [sym_import] = ACTIONS(915),
    [sym_predicate] = ACTIONS(915),
  },
  [576] = {
    [sym_body] = STATE(753),
    [sym__lower_id] = ACTIONS(873),
    [anon_sym_module] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_select] = ACTIONS(873),
    [sym_qldoc] = ACTIONS(871),
    [anon_sym_float] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_string] = ACTIONS(873),
    [sym__upper_id] = ACTIONS(871),
    [sym__at_lower_id] = ACTIONS(871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(873),
    [sym_class] = ACTIONS(873),
    [sym_newtype] = ACTIONS(873),
    [sym_date] = ACTIONS(873),
    [sym_import] = ACTIONS(873),
    [sym_predicate] = ACTIONS(873),
  },
  [577] = {
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_RPAREN] = ACTIONS(539),
    [anon_sym_or] = ACTIONS(537),
    [anon_sym_and] = ACTIONS(539),
    [anon_sym_implies] = ACTIONS(539),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_order] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(539),
    [sym_in] = ACTIONS(537),
    [sym_instanceof] = ACTIONS(539),
    [sym_lt] = ACTIONS(537),
    [sym_le] = ACTIONS(539),
    [sym_eq] = ACTIONS(539),
    [sym_gt] = ACTIONS(537),
    [sym_ge] = ACTIONS(539),
    [sym_minus] = ACTIONS(539),
    [sym_ne] = ACTIONS(539),
    [sym_slash] = ACTIONS(537),
    [sym_star] = ACTIONS(539),
    [sym_mod] = ACTIONS(539),
    [sym_plus] = ACTIONS(539),
  },
  [578] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(921),
    [sym__lower_id] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(923),
    [anon_sym_from] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_select] = ACTIONS(923),
    [sym_qldoc] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(925),
    [anon_sym_float] = ACTIONS(923),
    [anon_sym_int] = ACTIONS(923),
    [anon_sym_string] = ACTIONS(923),
    [sym__upper_id] = ACTIONS(921),
    [sym__at_lower_id] = ACTIONS(921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(923),
    [sym_boolean] = ACTIONS(923),
    [sym_class] = ACTIONS(923),
    [sym_newtype] = ACTIONS(923),
    [sym_date] = ACTIONS(923),
    [sym_import] = ACTIONS(923),
    [sym_predicate] = ACTIONS(923),
  },
  [579] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(928),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [580] = {
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(511),
    [anon_sym_or] = ACTIONS(513),
    [anon_sym_and] = ACTIONS(511),
    [anon_sym_implies] = ACTIONS(511),
    [anon_sym_order] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(511),
    [sym_in] = ACTIONS(513),
    [sym_instanceof] = ACTIONS(511),
    [sym_lt] = ACTIONS(513),
    [sym_le] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
    [sym_gt] = ACTIONS(513),
    [sym_ge] = ACTIONS(511),
    [sym_minus] = ACTIONS(511),
    [sym_ne] = ACTIONS(511),
    [sym_slash] = ACTIONS(513),
    [sym_star] = ACTIONS(511),
    [sym_mod] = ACTIONS(511),
    [sym_plus] = ACTIONS(511),
  },
  [581] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(581),
    [sym__lower_id] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_from] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_select] = ACTIONS(923),
    [sym_qldoc] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(932),
    [anon_sym_float] = ACTIONS(923),
    [anon_sym_int] = ACTIONS(923),
    [anon_sym_string] = ACTIONS(923),
    [sym__upper_id] = ACTIONS(921),
    [sym__at_lower_id] = ACTIONS(921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(923),
    [sym_boolean] = ACTIONS(923),
    [sym_class] = ACTIONS(923),
    [sym_newtype] = ACTIONS(923),
    [sym_date] = ACTIONS(923),
    [sym_import] = ACTIONS(923),
    [sym_predicate] = ACTIONS(923),
  },
  [582] = {
    [sym_body] = STATE(754),
    [ts_builtin_sym_end] = ACTIONS(935),
    [sym__lower_id] = ACTIONS(937),
    [anon_sym_module] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_or] = ACTIONS(937),
    [anon_sym_from] = ACTIONS(937),
    [anon_sym_where] = ACTIONS(937),
    [anon_sym_select] = ACTIONS(937),
    [sym_qldoc] = ACTIONS(935),
    [anon_sym_float] = ACTIONS(937),
    [anon_sym_int] = ACTIONS(937),
    [anon_sym_string] = ACTIONS(937),
    [sym__upper_id] = ACTIONS(935),
    [sym__at_lower_id] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(937),
    [sym_class] = ACTIONS(937),
    [sym_newtype] = ACTIONS(937),
    [sym_date] = ACTIONS(937),
    [sym_import] = ACTIONS(937),
    [sym_predicate] = ACTIONS(937),
  },
  [583] = {
    [sym__lower_id] = ACTIONS(845),
    [anon_sym_module] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_from] = ACTIONS(845),
    [anon_sym_where] = ACTIONS(845),
    [anon_sym_select] = ACTIONS(845),
    [anon_sym_DOT] = ACTIONS(847),
    [sym_qldoc] = ACTIONS(847),
    [anon_sym_COLON_COLON] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(845),
    [anon_sym_int] = ACTIONS(845),
    [anon_sym_string] = ACTIONS(845),
    [sym__upper_id] = ACTIONS(847),
    [sym__at_lower_id] = ACTIONS(847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(845),
    [sym_boolean] = ACTIONS(845),
    [sym_class] = ACTIONS(845),
    [sym_newtype] = ACTIONS(845),
    [sym_date] = ACTIONS(845),
    [sym_import] = ACTIONS(845),
    [sym_predicate] = ACTIONS(845),
  },
  [584] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(941),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [585] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(578),
    [ts_builtin_sym_end] = ACTIONS(901),
    [sym__lower_id] = ACTIONS(899),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_from] = ACTIONS(899),
    [anon_sym_where] = ACTIONS(899),
    [anon_sym_select] = ACTIONS(899),
    [sym_qldoc] = ACTIONS(901),
    [anon_sym_COLON_COLON] = ACTIONS(909),
    [anon_sym_float] = ACTIONS(899),
    [anon_sym_int] = ACTIONS(899),
    [anon_sym_string] = ACTIONS(899),
    [sym__upper_id] = ACTIONS(901),
    [sym__at_lower_id] = ACTIONS(901),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(899),
    [sym_boolean] = ACTIONS(899),
    [sym_class] = ACTIONS(899),
    [sym_newtype] = ACTIONS(899),
    [sym_date] = ACTIONS(899),
    [sym_import] = ACTIONS(899),
    [sym_predicate] = ACTIONS(899),
  },
  [586] = {
    [sym_body] = STATE(761),
    [sym__lower_id] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_select] = ACTIONS(943),
    [sym_qldoc] = ACTIONS(945),
    [anon_sym_float] = ACTIONS(943),
    [anon_sym_int] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [sym__upper_id] = ACTIONS(945),
    [sym__at_lower_id] = ACTIONS(945),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(943),
    [sym_class] = ACTIONS(943),
    [sym_newtype] = ACTIONS(943),
    [sym_date] = ACTIONS(943),
    [sym_import] = ACTIONS(943),
    [sym_predicate] = ACTIONS(943),
  },
  [587] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(949),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [588] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(953),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [589] = {
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_RPAREN] = ACTIONS(543),
    [anon_sym_or] = ACTIONS(541),
    [anon_sym_and] = ACTIONS(543),
    [anon_sym_implies] = ACTIONS(543),
    [anon_sym_DOT] = ACTIONS(543),
    [anon_sym_order] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(543),
    [sym_in] = ACTIONS(541),
    [sym_instanceof] = ACTIONS(543),
    [sym_lt] = ACTIONS(541),
    [sym_le] = ACTIONS(543),
    [sym_eq] = ACTIONS(543),
    [sym_gt] = ACTIONS(541),
    [sym_ge] = ACTIONS(543),
    [sym_minus] = ACTIONS(543),
    [sym_ne] = ACTIONS(543),
    [sym_slash] = ACTIONS(541),
    [sym_star] = ACTIONS(543),
    [sym_mod] = ACTIONS(543),
    [sym_plus] = ACTIONS(543),
  },
  [590] = {
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(507),
    [anon_sym_or] = ACTIONS(509),
    [anon_sym_and] = ACTIONS(507),
    [anon_sym_implies] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_order] = ACTIONS(507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(507),
    [sym_in] = ACTIONS(509),
    [sym_instanceof] = ACTIONS(507),
    [sym_lt] = ACTIONS(509),
    [sym_le] = ACTIONS(507),
    [sym_eq] = ACTIONS(507),
    [sym_gt] = ACTIONS(509),
    [sym_ge] = ACTIONS(507),
    [sym_minus] = ACTIONS(507),
    [sym_ne] = ACTIONS(507),
    [sym_slash] = ACTIONS(509),
    [sym_star] = ACTIONS(507),
    [sym_mod] = ACTIONS(507),
    [sym_plus] = ACTIONS(507),
  },
  [591] = {
    [anon_sym_COMMA] = ACTIONS(547),
    [anon_sym_RPAREN] = ACTIONS(547),
    [anon_sym_or] = ACTIONS(545),
    [anon_sym_and] = ACTIONS(547),
    [anon_sym_implies] = ACTIONS(547),
    [anon_sym_DOT] = ACTIONS(547),
    [anon_sym_order] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(547),
    [sym_in] = ACTIONS(545),
    [sym_instanceof] = ACTIONS(547),
    [sym_lt] = ACTIONS(545),
    [sym_le] = ACTIONS(547),
    [sym_eq] = ACTIONS(547),
    [sym_gt] = ACTIONS(545),
    [sym_ge] = ACTIONS(547),
    [sym_minus] = ACTIONS(547),
    [sym_ne] = ACTIONS(547),
    [sym_slash] = ACTIONS(545),
    [sym_star] = ACTIONS(547),
    [sym_mod] = ACTIONS(547),
    [sym_plus] = ACTIONS(547),
  },
  [592] = {
    [anon_sym_COMMA] = ACTIONS(551),
    [anon_sym_RPAREN] = ACTIONS(551),
    [anon_sym_or] = ACTIONS(549),
    [anon_sym_and] = ACTIONS(551),
    [anon_sym_implies] = ACTIONS(551),
    [anon_sym_DOT] = ACTIONS(551),
    [anon_sym_order] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(551),
    [sym_in] = ACTIONS(549),
    [sym_instanceof] = ACTIONS(551),
    [sym_lt] = ACTIONS(549),
    [sym_le] = ACTIONS(551),
    [sym_eq] = ACTIONS(551),
    [sym_gt] = ACTIONS(549),
    [sym_ge] = ACTIONS(551),
    [sym_minus] = ACTIONS(551),
    [sym_ne] = ACTIONS(551),
    [sym_slash] = ACTIONS(549),
    [sym_star] = ACTIONS(551),
    [sym_mod] = ACTIONS(551),
    [sym_plus] = ACTIONS(551),
  },
  [593] = {
    [sym_body] = STATE(757),
    [sym__lower_id] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_from] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_select] = ACTIONS(955),
    [sym_qldoc] = ACTIONS(957),
    [anon_sym_float] = ACTIONS(955),
    [anon_sym_int] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [sym__upper_id] = ACTIONS(957),
    [sym__at_lower_id] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(955),
    [sym_class] = ACTIONS(955),
    [sym_newtype] = ACTIONS(955),
    [sym_date] = ACTIONS(955),
    [sym_import] = ACTIONS(955),
    [sym_predicate] = ACTIONS(955),
  },
  [594] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(961),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [595] = {
    [aux_sym_asExprs_repeat1] = STATE(595),
    [sym__lower_id] = ACTIONS(963),
    [anon_sym_module] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_from] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_select] = ACTIONS(963),
    [anon_sym_order] = ACTIONS(963),
    [sym_qldoc] = ACTIONS(965),
    [anon_sym_float] = ACTIONS(963),
    [anon_sym_int] = ACTIONS(963),
    [anon_sym_string] = ACTIONS(963),
    [sym__upper_id] = ACTIONS(965),
    [sym__at_lower_id] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(963),
    [sym_class] = ACTIONS(963),
    [sym_newtype] = ACTIONS(963),
    [sym_date] = ACTIONS(963),
    [sym_import] = ACTIONS(963),
    [sym_predicate] = ACTIONS(963),
  },
  [596] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(972),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [597] = {
    [aux_sym_asExprs_repeat1] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(917),
    [sym__lower_id] = ACTIONS(915),
    [anon_sym_module] = ACTIONS(915),
    [anon_sym_COMMA] = ACTIONS(885),
    [anon_sym_from] = ACTIONS(915),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_select] = ACTIONS(915),
    [anon_sym_order] = ACTIONS(915),
    [sym_qldoc] = ACTIONS(917),
    [anon_sym_float] = ACTIONS(915),
    [anon_sym_int] = ACTIONS(915),
    [anon_sym_string] = ACTIONS(915),
    [sym__upper_id] = ACTIONS(917),
    [sym__at_lower_id] = ACTIONS(917),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(915),
    [sym_class] = ACTIONS(915),
    [sym_newtype] = ACTIONS(915),
    [sym_date] = ACTIONS(915),
    [sym_import] = ACTIONS(915),
    [sym_predicate] = ACTIONS(915),
  },
  [598] = {
    [anon_sym_COMMA] = ACTIONS(555),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_or] = ACTIONS(553),
    [anon_sym_and] = ACTIONS(555),
    [anon_sym_implies] = ACTIONS(555),
    [anon_sym_DOT] = ACTIONS(555),
    [anon_sym_order] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(555),
    [sym_in] = ACTIONS(553),
    [sym_instanceof] = ACTIONS(555),
    [sym_lt] = ACTIONS(553),
    [sym_le] = ACTIONS(555),
    [sym_eq] = ACTIONS(555),
    [sym_gt] = ACTIONS(553),
    [sym_ge] = ACTIONS(555),
    [sym_minus] = ACTIONS(555),
    [sym_ne] = ACTIONS(555),
    [sym_slash] = ACTIONS(553),
    [sym_star] = ACTIONS(555),
    [sym_mod] = ACTIONS(555),
    [sym_plus] = ACTIONS(555),
  },
  [599] = {
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(557),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_implies] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_order] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(559),
    [sym_in] = ACTIONS(557),
    [sym_instanceof] = ACTIONS(559),
    [sym_lt] = ACTIONS(557),
    [sym_le] = ACTIONS(559),
    [sym_eq] = ACTIONS(559),
    [sym_gt] = ACTIONS(557),
    [sym_ge] = ACTIONS(559),
    [sym_minus] = ACTIONS(559),
    [sym_ne] = ACTIONS(559),
    [sym_slash] = ACTIONS(557),
    [sym_star] = ACTIONS(559),
    [sym_mod] = ACTIONS(559),
    [sym_plus] = ACTIONS(559),
  },
  [600] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(974),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(976),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [601] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(980),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [602] = {
    [aux_sym_importModuleExpr_repeat1] = STATE(571),
    [sym__lower_id] = ACTIONS(907),
    [anon_sym_module] = ACTIONS(907),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_from] = ACTIONS(907),
    [anon_sym_where] = ACTIONS(907),
    [anon_sym_select] = ACTIONS(907),
    [sym_qldoc] = ACTIONS(905),
    [anon_sym_COLON_COLON] = ACTIONS(903),
    [anon_sym_float] = ACTIONS(907),
    [anon_sym_int] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [sym__upper_id] = ACTIONS(905),
    [sym__at_lower_id] = ACTIONS(905),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(907),
    [sym_boolean] = ACTIONS(907),
    [sym_class] = ACTIONS(907),
    [sym_newtype] = ACTIONS(907),
    [sym_date] = ACTIONS(907),
    [sym_import] = ACTIONS(907),
    [sym_predicate] = ACTIONS(907),
  },
  [603] = {
    [anon_sym_COMMA] = ACTIONS(563),
    [anon_sym_RPAREN] = ACTIONS(563),
    [anon_sym_or] = ACTIONS(561),
    [anon_sym_and] = ACTIONS(563),
    [anon_sym_implies] = ACTIONS(563),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_order] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(563),
    [sym_in] = ACTIONS(561),
    [sym_instanceof] = ACTIONS(563),
    [sym_lt] = ACTIONS(561),
    [sym_le] = ACTIONS(563),
    [sym_eq] = ACTIONS(563),
    [sym_gt] = ACTIONS(561),
    [sym_ge] = ACTIONS(563),
    [sym_minus] = ACTIONS(563),
    [sym_ne] = ACTIONS(563),
    [sym_slash] = ACTIONS(561),
    [sym_star] = ACTIONS(563),
    [sym_mod] = ACTIONS(563),
    [sym_plus] = ACTIONS(563),
  },
  [604] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(982),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(984),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [605] = {
    [anon_sym_COMMA] = ACTIONS(567),
    [anon_sym_RPAREN] = ACTIONS(567),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(567),
    [anon_sym_implies] = ACTIONS(567),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_order] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(567),
    [sym_in] = ACTIONS(565),
    [sym_instanceof] = ACTIONS(567),
    [sym_lt] = ACTIONS(565),
    [sym_le] = ACTIONS(567),
    [sym_eq] = ACTIONS(567),
    [sym_gt] = ACTIONS(565),
    [sym_ge] = ACTIONS(567),
    [sym_minus] = ACTIONS(567),
    [sym_ne] = ACTIONS(567),
    [sym_slash] = ACTIONS(565),
    [sym_star] = ACTIONS(567),
    [sym_mod] = ACTIONS(567),
    [sym_plus] = ACTIONS(567),
  },
  [606] = {
    [anon_sym_COMMA] = ACTIONS(571),
    [anon_sym_RPAREN] = ACTIONS(571),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(571),
    [anon_sym_implies] = ACTIONS(571),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_order] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(571),
    [sym_in] = ACTIONS(569),
    [sym_instanceof] = ACTIONS(571),
    [sym_lt] = ACTIONS(569),
    [sym_le] = ACTIONS(571),
    [sym_eq] = ACTIONS(571),
    [sym_gt] = ACTIONS(569),
    [sym_ge] = ACTIONS(571),
    [sym_minus] = ACTIONS(571),
    [sym_ne] = ACTIONS(571),
    [sym_slash] = ACTIONS(569),
    [sym_star] = ACTIONS(571),
    [sym_mod] = ACTIONS(571),
    [sym_plus] = ACTIONS(571),
  },
  [607] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_RPAREN] = ACTIONS(986),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [608] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(990),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [609] = {
    [sym_body] = STATE(756),
    [sym__lower_id] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(879),
    [anon_sym_from] = ACTIONS(879),
    [anon_sym_where] = ACTIONS(879),
    [anon_sym_select] = ACTIONS(879),
    [sym_qldoc] = ACTIONS(877),
    [anon_sym_float] = ACTIONS(879),
    [anon_sym_int] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [sym__upper_id] = ACTIONS(877),
    [sym__at_lower_id] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(879),
    [sym_class] = ACTIONS(879),
    [sym_newtype] = ACTIONS(879),
    [sym_date] = ACTIONS(879),
    [sym_import] = ACTIONS(879),
    [sym_predicate] = ACTIONS(879),
  },
  [610] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(994),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [611] = {
    [sym_body] = STATE(760),
    [ts_builtin_sym_end] = ACTIONS(957),
    [sym__lower_id] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_from] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_select] = ACTIONS(955),
    [sym_qldoc] = ACTIONS(957),
    [anon_sym_float] = ACTIONS(955),
    [anon_sym_int] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [sym__upper_id] = ACTIONS(957),
    [sym__at_lower_id] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(955),
    [sym_class] = ACTIONS(955),
    [sym_newtype] = ACTIONS(955),
    [sym_date] = ACTIONS(955),
    [sym_import] = ACTIONS(955),
    [sym_predicate] = ACTIONS(955),
  },
  [612] = {
    [anon_sym_COMMA] = ACTIONS(505),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_or] = ACTIONS(503),
    [anon_sym_and] = ACTIONS(505),
    [anon_sym_implies] = ACTIONS(505),
    [anon_sym_DOT] = ACTIONS(505),
    [anon_sym_order] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(505),
    [sym_in] = ACTIONS(503),
    [sym_instanceof] = ACTIONS(505),
    [sym_lt] = ACTIONS(503),
    [sym_le] = ACTIONS(505),
    [sym_eq] = ACTIONS(505),
    [sym_gt] = ACTIONS(503),
    [sym_ge] = ACTIONS(505),
    [sym_minus] = ACTIONS(505),
    [sym_ne] = ACTIONS(505),
    [sym_slash] = ACTIONS(503),
    [sym_star] = ACTIONS(505),
    [sym_mod] = ACTIONS(505),
    [sym_plus] = ACTIONS(505),
  },
  [613] = {
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RPAREN] = ACTIONS(575),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(575),
    [anon_sym_implies] = ACTIONS(575),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_order] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(575),
    [sym_in] = ACTIONS(573),
    [sym_instanceof] = ACTIONS(575),
    [sym_lt] = ACTIONS(573),
    [sym_le] = ACTIONS(575),
    [sym_eq] = ACTIONS(575),
    [sym_gt] = ACTIONS(573),
    [sym_ge] = ACTIONS(575),
    [sym_minus] = ACTIONS(575),
    [sym_ne] = ACTIONS(575),
    [sym_slash] = ACTIONS(573),
    [sym_star] = ACTIONS(575),
    [sym_mod] = ACTIONS(575),
    [sym_plus] = ACTIONS(575),
  },
  [614] = {
    [anon_sym_COMMA] = ACTIONS(579),
    [anon_sym_RPAREN] = ACTIONS(579),
    [anon_sym_or] = ACTIONS(577),
    [anon_sym_and] = ACTIONS(579),
    [anon_sym_implies] = ACTIONS(579),
    [anon_sym_DOT] = ACTIONS(579),
    [anon_sym_order] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(579),
    [sym_in] = ACTIONS(577),
    [sym_instanceof] = ACTIONS(579),
    [sym_lt] = ACTIONS(577),
    [sym_le] = ACTIONS(579),
    [sym_eq] = ACTIONS(579),
    [sym_gt] = ACTIONS(577),
    [sym_ge] = ACTIONS(579),
    [sym_minus] = ACTIONS(579),
    [sym_ne] = ACTIONS(579),
    [sym_slash] = ACTIONS(577),
    [sym_star] = ACTIONS(579),
    [sym_mod] = ACTIONS(579),
    [sym_plus] = ACTIONS(579),
  },
  [615] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(996),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [616] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [617] = {
    [sym_body] = STATE(746),
    [sym__lower_id] = ACTIONS(937),
    [anon_sym_module] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(937),
    [anon_sym_from] = ACTIONS(937),
    [anon_sym_where] = ACTIONS(937),
    [anon_sym_select] = ACTIONS(937),
    [sym_qldoc] = ACTIONS(935),
    [anon_sym_float] = ACTIONS(937),
    [anon_sym_int] = ACTIONS(937),
    [anon_sym_string] = ACTIONS(937),
    [sym__upper_id] = ACTIONS(935),
    [sym__at_lower_id] = ACTIONS(935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(937),
    [sym_class] = ACTIONS(937),
    [sym_newtype] = ACTIONS(937),
    [sym_date] = ACTIONS(937),
    [sym_import] = ACTIONS(937),
    [sym_predicate] = ACTIONS(937),
  },
  [618] = {
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_or] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(583),
    [anon_sym_implies] = ACTIONS(583),
    [anon_sym_DOT] = ACTIONS(583),
    [anon_sym_order] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(583),
    [sym_in] = ACTIONS(581),
    [sym_instanceof] = ACTIONS(583),
    [sym_lt] = ACTIONS(581),
    [sym_le] = ACTIONS(583),
    [sym_eq] = ACTIONS(583),
    [sym_gt] = ACTIONS(581),
    [sym_ge] = ACTIONS(583),
    [sym_minus] = ACTIONS(583),
    [sym_ne] = ACTIONS(583),
    [sym_slash] = ACTIONS(581),
    [sym_star] = ACTIONS(583),
    [sym_mod] = ACTIONS(583),
    [sym_plus] = ACTIONS(583),
  },
  [619] = {
    [anon_sym_COMMA] = ACTIONS(595),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_or] = ACTIONS(593),
    [anon_sym_and] = ACTIONS(595),
    [anon_sym_implies] = ACTIONS(595),
    [anon_sym_DOT] = ACTIONS(595),
    [anon_sym_order] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(595),
    [sym_in] = ACTIONS(593),
    [sym_instanceof] = ACTIONS(595),
    [sym_lt] = ACTIONS(593),
    [sym_le] = ACTIONS(595),
    [sym_eq] = ACTIONS(595),
    [sym_gt] = ACTIONS(593),
    [sym_ge] = ACTIONS(595),
    [sym_minus] = ACTIONS(595),
    [sym_ne] = ACTIONS(595),
    [sym_slash] = ACTIONS(593),
    [sym_star] = ACTIONS(595),
    [sym_mod] = ACTIONS(595),
    [sym_plus] = ACTIONS(595),
  },
  [620] = {
    [aux_sym_asExprs_repeat1] = STATE(620),
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym__lower_id] = ACTIONS(963),
    [anon_sym_module] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(1004),
    [anon_sym_from] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_select] = ACTIONS(963),
    [anon_sym_order] = ACTIONS(963),
    [sym_qldoc] = ACTIONS(965),
    [anon_sym_float] = ACTIONS(963),
    [anon_sym_int] = ACTIONS(963),
    [anon_sym_string] = ACTIONS(963),
    [sym__upper_id] = ACTIONS(965),
    [sym__at_lower_id] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(963),
    [sym_class] = ACTIONS(963),
    [sym_newtype] = ACTIONS(963),
    [sym_date] = ACTIONS(963),
    [sym_import] = ACTIONS(963),
    [sym_predicate] = ACTIONS(963),
  },
  [621] = {
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_or] = ACTIONS(591),
    [anon_sym_and] = ACTIONS(589),
    [anon_sym_implies] = ACTIONS(589),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_order] = ACTIONS(589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(589),
    [sym_in] = ACTIONS(591),
    [sym_instanceof] = ACTIONS(589),
    [sym_lt] = ACTIONS(591),
    [sym_le] = ACTIONS(589),
    [sym_eq] = ACTIONS(589),
    [sym_gt] = ACTIONS(591),
    [sym_ge] = ACTIONS(589),
    [sym_minus] = ACTIONS(589),
    [sym_ne] = ACTIONS(589),
    [sym_slash] = ACTIONS(591),
    [sym_star] = ACTIONS(589),
    [sym_mod] = ACTIONS(589),
    [sym_plus] = ACTIONS(589),
  },
  [622] = {
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_or] = ACTIONS(587),
    [anon_sym_and] = ACTIONS(585),
    [anon_sym_implies] = ACTIONS(585),
    [anon_sym_DOT] = ACTIONS(585),
    [anon_sym_order] = ACTIONS(585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(585),
    [sym_in] = ACTIONS(587),
    [sym_instanceof] = ACTIONS(585),
    [sym_lt] = ACTIONS(587),
    [sym_le] = ACTIONS(585),
    [sym_eq] = ACTIONS(585),
    [sym_gt] = ACTIONS(587),
    [sym_ge] = ACTIONS(585),
    [sym_minus] = ACTIONS(585),
    [sym_ne] = ACTIONS(585),
    [sym_slash] = ACTIONS(587),
    [sym_star] = ACTIONS(585),
    [sym_mod] = ACTIONS(585),
    [sym_plus] = ACTIONS(585),
  },
  [623] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(1009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [624] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(1013),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [625] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(319),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [626] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_COMMA] = ACTIONS(1015),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [627] = {
    [sym_body] = STATE(762),
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym__lower_id] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_select] = ACTIONS(943),
    [sym_qldoc] = ACTIONS(945),
    [anon_sym_float] = ACTIONS(943),
    [anon_sym_int] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [sym__upper_id] = ACTIONS(945),
    [sym__at_lower_id] = ACTIONS(945),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(943),
    [sym_class] = ACTIONS(943),
    [sym_newtype] = ACTIONS(943),
    [sym_date] = ACTIONS(943),
    [sym_import] = ACTIONS(943),
    [sym_predicate] = ACTIONS(943),
  },
  [628] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [anon_sym_PIPE] = ACTIONS(1019),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [629] = {
    [anon_sym_COMMA] = ACTIONS(619),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_or] = ACTIONS(621),
    [anon_sym_and] = ACTIONS(619),
    [anon_sym_implies] = ACTIONS(619),
    [anon_sym_order] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(619),
    [sym_in] = ACTIONS(621),
    [sym_instanceof] = ACTIONS(619),
    [sym_lt] = ACTIONS(621),
    [sym_le] = ACTIONS(619),
    [sym_eq] = ACTIONS(619),
    [sym_gt] = ACTIONS(621),
    [sym_ge] = ACTIONS(619),
    [sym_minus] = ACTIONS(619),
    [sym_ne] = ACTIONS(619),
    [sym_slash] = ACTIONS(621),
    [sym_star] = ACTIONS(619),
    [sym_mod] = ACTIONS(619),
    [sym_plus] = ACTIONS(619),
  },
  [630] = {
    [sym_orderBys] = STATE(795),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [sym__lower_id] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_from] = ACTIONS(1023),
    [anon_sym_where] = ACTIONS(1023),
    [anon_sym_select] = ACTIONS(1023),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1021),
    [anon_sym_float] = ACTIONS(1023),
    [anon_sym_int] = ACTIONS(1023),
    [anon_sym_string] = ACTIONS(1023),
    [sym__upper_id] = ACTIONS(1021),
    [sym__at_lower_id] = ACTIONS(1021),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1023),
    [sym_class] = ACTIONS(1023),
    [sym_newtype] = ACTIONS(1023),
    [sym_date] = ACTIONS(1023),
    [sym_import] = ACTIONS(1023),
    [sym_predicate] = ACTIONS(1023),
  },
  [631] = {
    [aux_sym_orderBys_repeat1] = STATE(634),
    [sym__lower_id] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_from] = ACTIONS(1027),
    [anon_sym_where] = ACTIONS(1027),
    [anon_sym_select] = ACTIONS(1027),
    [sym_qldoc] = ACTIONS(1029),
    [anon_sym_float] = ACTIONS(1027),
    [anon_sym_int] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [sym__upper_id] = ACTIONS(1029),
    [sym__at_lower_id] = ACTIONS(1029),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1027),
    [sym_class] = ACTIONS(1027),
    [sym_newtype] = ACTIONS(1027),
    [sym_date] = ACTIONS(1027),
    [sym_import] = ACTIONS(1027),
    [sym_predicate] = ACTIONS(1027),
  },
  [632] = {
    [anon_sym_COMMA] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_or] = ACTIONS(623),
    [anon_sym_and] = ACTIONS(625),
    [anon_sym_implies] = ACTIONS(625),
    [anon_sym_order] = ACTIONS(625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(625),
    [sym_in] = ACTIONS(623),
    [sym_instanceof] = ACTIONS(625),
    [sym_lt] = ACTIONS(623),
    [sym_le] = ACTIONS(625),
    [sym_eq] = ACTIONS(625),
    [sym_gt] = ACTIONS(623),
    [sym_ge] = ACTIONS(625),
    [sym_minus] = ACTIONS(625),
    [sym_ne] = ACTIONS(625),
    [sym_slash] = ACTIONS(623),
    [sym_star] = ACTIONS(625),
    [sym_mod] = ACTIONS(625),
    [sym_plus] = ACTIONS(625),
  },
  [633] = {
    [aux_sym_orderBys_repeat1] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym__lower_id] = ACTIONS(1027),
    [anon_sym_module] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1027),
    [anon_sym_where] = ACTIONS(1027),
    [anon_sym_select] = ACTIONS(1027),
    [sym_qldoc] = ACTIONS(1029),
    [anon_sym_float] = ACTIONS(1027),
    [anon_sym_int] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [sym__upper_id] = ACTIONS(1029),
    [sym__at_lower_id] = ACTIONS(1029),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1027),
    [sym_class] = ACTIONS(1027),
    [sym_newtype] = ACTIONS(1027),
    [sym_date] = ACTIONS(1027),
    [sym_import] = ACTIONS(1027),
    [sym_predicate] = ACTIONS(1027),
  },
  [634] = {
    [aux_sym_orderBys_repeat1] = STATE(634),
    [sym__lower_id] = ACTIONS(1035),
    [anon_sym_module] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_from] = ACTIONS(1035),
    [anon_sym_where] = ACTIONS(1035),
    [anon_sym_select] = ACTIONS(1035),
    [sym_qldoc] = ACTIONS(1037),
    [anon_sym_float] = ACTIONS(1035),
    [anon_sym_int] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [sym__upper_id] = ACTIONS(1037),
    [sym__at_lower_id] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1035),
    [sym_class] = ACTIONS(1035),
    [sym_newtype] = ACTIONS(1035),
    [sym_date] = ACTIONS(1035),
    [sym_import] = ACTIONS(1035),
    [sym_predicate] = ACTIONS(1035),
  },
  [635] = {
    [anon_sym_COMMA] = ACTIONS(639),
    [anon_sym_RPAREN] = ACTIONS(639),
    [anon_sym_or] = ACTIONS(641),
    [anon_sym_and] = ACTIONS(639),
    [anon_sym_implies] = ACTIONS(639),
    [anon_sym_order] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(639),
    [sym_in] = ACTIONS(641),
    [sym_instanceof] = ACTIONS(639),
    [sym_lt] = ACTIONS(641),
    [sym_le] = ACTIONS(639),
    [sym_eq] = ACTIONS(639),
    [sym_gt] = ACTIONS(641),
    [sym_ge] = ACTIONS(639),
    [sym_minus] = ACTIONS(639),
    [sym_ne] = ACTIONS(639),
    [sym_slash] = ACTIONS(641),
    [sym_star] = ACTIONS(639),
    [sym_mod] = ACTIONS(639),
    [sym_plus] = ACTIONS(639),
  },
  [636] = {
    [anon_sym_COMMA] = ACTIONS(649),
    [anon_sym_RPAREN] = ACTIONS(649),
    [anon_sym_or] = ACTIONS(647),
    [anon_sym_and] = ACTIONS(649),
    [anon_sym_implies] = ACTIONS(649),
    [anon_sym_order] = ACTIONS(649),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(649),
    [sym_in] = ACTIONS(647),
    [sym_instanceof] = ACTIONS(649),
    [sym_lt] = ACTIONS(647),
    [sym_le] = ACTIONS(649),
    [sym_eq] = ACTIONS(649),
    [sym_gt] = ACTIONS(647),
    [sym_ge] = ACTIONS(649),
    [sym_minus] = ACTIONS(649),
    [sym_ne] = ACTIONS(649),
    [sym_slash] = ACTIONS(647),
    [sym_star] = ACTIONS(649),
    [sym_mod] = ACTIONS(649),
    [sym_plus] = ACTIONS(649),
  },
  [637] = {
    [anon_sym_COMMA] = ACTIONS(609),
    [anon_sym_RPAREN] = ACTIONS(609),
    [anon_sym_or] = ACTIONS(607),
    [anon_sym_and] = ACTIONS(609),
    [anon_sym_implies] = ACTIONS(609),
    [anon_sym_order] = ACTIONS(609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(609),
    [sym_in] = ACTIONS(607),
    [sym_instanceof] = ACTIONS(609),
    [sym_lt] = ACTIONS(607),
    [sym_le] = ACTIONS(609),
    [sym_eq] = ACTIONS(609),
    [sym_gt] = ACTIONS(607),
    [sym_ge] = ACTIONS(609),
    [sym_minus] = ACTIONS(609),
    [sym_ne] = ACTIONS(609),
    [sym_slash] = ACTIONS(607),
    [sym_star] = ACTIONS(609),
    [sym_mod] = ACTIONS(609),
    [sym_plus] = ACTIONS(609),
  },
  [638] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(739),
    [ts_builtin_sym_end] = ACTIONS(1042),
    [sym__lower_id] = ACTIONS(1044),
    [anon_sym_module] = ACTIONS(1044),
    [anon_sym_or] = ACTIONS(1046),
    [anon_sym_from] = ACTIONS(1044),
    [anon_sym_where] = ACTIONS(1044),
    [anon_sym_select] = ACTIONS(1044),
    [sym_qldoc] = ACTIONS(1042),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_string] = ACTIONS(1044),
    [sym__upper_id] = ACTIONS(1042),
    [sym__at_lower_id] = ACTIONS(1042),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1044),
    [sym_class] = ACTIONS(1044),
    [sym_newtype] = ACTIONS(1044),
    [sym_date] = ACTIONS(1044),
    [sym_import] = ACTIONS(1044),
    [sym_predicate] = ACTIONS(1044),
  },
  [639] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [640] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1050),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [641] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1052),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym__lower_id] = ACTIONS(963),
    [anon_sym_module] = ACTIONS(963),
    [anon_sym_COMMA] = ACTIONS(965),
    [anon_sym_from] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_select] = ACTIONS(963),
    [anon_sym_order] = ACTIONS(963),
    [sym_qldoc] = ACTIONS(965),
    [anon_sym_float] = ACTIONS(963),
    [anon_sym_int] = ACTIONS(963),
    [anon_sym_string] = ACTIONS(963),
    [sym__upper_id] = ACTIONS(965),
    [sym__at_lower_id] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(963),
    [sym_class] = ACTIONS(963),
    [sym_newtype] = ACTIONS(963),
    [sym_date] = ACTIONS(963),
    [sym_import] = ACTIONS(963),
    [sym_predicate] = ACTIONS(963),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym__lower_id] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_COMMA] = ACTIONS(1054),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_where] = ACTIONS(1056),
    [anon_sym_select] = ACTIONS(1056),
    [anon_sym_order] = ACTIONS(1056),
    [sym_qldoc] = ACTIONS(1054),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [sym__upper_id] = ACTIONS(1054),
    [sym__at_lower_id] = ACTIONS(1054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1056),
    [sym_class] = ACTIONS(1056),
    [sym_newtype] = ACTIONS(1056),
    [sym_date] = ACTIONS(1056),
    [sym_import] = ACTIONS(1056),
    [sym_predicate] = ACTIONS(1056),
  },
  [644] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1058),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [645] = {
    [sym_orderBys] = STATE(771),
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym__lower_id] = ACTIONS(1062),
    [anon_sym_module] = ACTIONS(1062),
    [anon_sym_from] = ACTIONS(1062),
    [anon_sym_where] = ACTIONS(1062),
    [anon_sym_select] = ACTIONS(1062),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1062),
    [anon_sym_int] = ACTIONS(1062),
    [anon_sym_string] = ACTIONS(1062),
    [sym__upper_id] = ACTIONS(1060),
    [sym__at_lower_id] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1062),
    [sym_class] = ACTIONS(1062),
    [sym_newtype] = ACTIONS(1062),
    [sym_date] = ACTIONS(1062),
    [sym_import] = ACTIONS(1062),
    [sym_predicate] = ACTIONS(1062),
  },
  [646] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1064),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [647] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [648] = {
    [anon_sym_COMMA] = ACTIONS(655),
    [anon_sym_RPAREN] = ACTIONS(655),
    [anon_sym_or] = ACTIONS(657),
    [anon_sym_and] = ACTIONS(655),
    [anon_sym_implies] = ACTIONS(655),
    [anon_sym_order] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(655),
    [sym_in] = ACTIONS(657),
    [sym_instanceof] = ACTIONS(655),
    [sym_lt] = ACTIONS(657),
    [sym_le] = ACTIONS(655),
    [sym_eq] = ACTIONS(655),
    [sym_gt] = ACTIONS(657),
    [sym_ge] = ACTIONS(655),
    [sym_minus] = ACTIONS(655),
    [sym_ne] = ACTIONS(655),
    [sym_slash] = ACTIONS(657),
    [sym_star] = ACTIONS(655),
    [sym_mod] = ACTIONS(655),
    [sym_plus] = ACTIONS(655),
  },
  [649] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [650] = {
    [aux_sym_orderBys_repeat1] = STATE(631),
    [sym__lower_id] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_where] = ACTIONS(1068),
    [anon_sym_select] = ACTIONS(1068),
    [sym_qldoc] = ACTIONS(1070),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_string] = ACTIONS(1068),
    [sym__upper_id] = ACTIONS(1070),
    [sym__at_lower_id] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1068),
    [sym_class] = ACTIONS(1068),
    [sym_newtype] = ACTIONS(1068),
    [sym_date] = ACTIONS(1068),
    [sym_import] = ACTIONS(1068),
    [sym_predicate] = ACTIONS(1068),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(921),
    [sym__lower_id] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(923),
    [anon_sym_from] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_select] = ACTIONS(923),
    [sym_qldoc] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_float] = ACTIONS(923),
    [anon_sym_int] = ACTIONS(923),
    [anon_sym_string] = ACTIONS(923),
    [sym__upper_id] = ACTIONS(921),
    [sym__at_lower_id] = ACTIONS(921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(923),
    [sym_boolean] = ACTIONS(923),
    [sym_class] = ACTIONS(923),
    [sym_newtype] = ACTIONS(923),
    [sym_date] = ACTIONS(923),
    [sym_import] = ACTIONS(923),
    [sym_predicate] = ACTIONS(923),
  },
  [652] = {
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_or] = ACTIONS(603),
    [anon_sym_and] = ACTIONS(605),
    [anon_sym_implies] = ACTIONS(605),
    [anon_sym_order] = ACTIONS(605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(605),
    [sym_in] = ACTIONS(603),
    [sym_instanceof] = ACTIONS(605),
    [sym_lt] = ACTIONS(603),
    [sym_le] = ACTIONS(605),
    [sym_eq] = ACTIONS(605),
    [sym_gt] = ACTIONS(603),
    [sym_ge] = ACTIONS(605),
    [sym_minus] = ACTIONS(605),
    [sym_ne] = ACTIONS(605),
    [sym_slash] = ACTIONS(603),
    [sym_star] = ACTIONS(605),
    [sym_mod] = ACTIONS(605),
    [sym_plus] = ACTIONS(605),
  },
  [653] = {
    [sym__lower_id] = ACTIONS(963),
    [anon_sym_module] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(965),
    [anon_sym_from] = ACTIONS(963),
    [anon_sym_where] = ACTIONS(963),
    [anon_sym_select] = ACTIONS(963),
    [anon_sym_order] = ACTIONS(963),
    [sym_qldoc] = ACTIONS(965),
    [anon_sym_float] = ACTIONS(963),
    [anon_sym_int] = ACTIONS(963),
    [anon_sym_string] = ACTIONS(963),
    [sym__upper_id] = ACTIONS(965),
    [sym__at_lower_id] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(963),
    [sym_class] = ACTIONS(963),
    [sym_newtype] = ACTIONS(963),
    [sym_date] = ACTIONS(963),
    [sym_import] = ACTIONS(963),
    [sym_predicate] = ACTIONS(963),
  },
  [654] = {
    [sym__lower_id] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_COMMA] = ACTIONS(1054),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_where] = ACTIONS(1056),
    [anon_sym_select] = ACTIONS(1056),
    [anon_sym_order] = ACTIONS(1056),
    [sym_qldoc] = ACTIONS(1054),
    [anon_sym_float] = ACTIONS(1056),
    [anon_sym_int] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [sym__upper_id] = ACTIONS(1054),
    [sym__at_lower_id] = ACTIONS(1054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1056),
    [sym_class] = ACTIONS(1056),
    [sym_newtype] = ACTIONS(1056),
    [sym_date] = ACTIONS(1056),
    [sym_import] = ACTIONS(1056),
    [sym_predicate] = ACTIONS(1056),
  },
  [655] = {
    [anon_sym_COMMA] = ACTIONS(633),
    [anon_sym_RPAREN] = ACTIONS(633),
    [anon_sym_or] = ACTIONS(631),
    [anon_sym_and] = ACTIONS(633),
    [anon_sym_implies] = ACTIONS(633),
    [anon_sym_order] = ACTIONS(633),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(633),
    [sym_in] = ACTIONS(631),
    [sym_instanceof] = ACTIONS(633),
    [sym_lt] = ACTIONS(631),
    [sym_le] = ACTIONS(633),
    [sym_eq] = ACTIONS(633),
    [sym_gt] = ACTIONS(631),
    [sym_ge] = ACTIONS(633),
    [sym_minus] = ACTIONS(633),
    [sym_ne] = ACTIONS(633),
    [sym_slash] = ACTIONS(631),
    [sym_star] = ACTIONS(633),
    [sym_mod] = ACTIONS(633),
    [sym_plus] = ACTIONS(633),
  },
  [656] = {
    [anon_sym_COMMA] = ACTIONS(637),
    [anon_sym_RPAREN] = ACTIONS(637),
    [anon_sym_or] = ACTIONS(635),
    [anon_sym_and] = ACTIONS(637),
    [anon_sym_implies] = ACTIONS(637),
    [anon_sym_order] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(637),
    [sym_in] = ACTIONS(635),
    [sym_instanceof] = ACTIONS(637),
    [sym_lt] = ACTIONS(635),
    [sym_le] = ACTIONS(637),
    [sym_eq] = ACTIONS(637),
    [sym_gt] = ACTIONS(635),
    [sym_ge] = ACTIONS(637),
    [sym_minus] = ACTIONS(637),
    [sym_ne] = ACTIONS(637),
    [sym_slash] = ACTIONS(635),
    [sym_star] = ACTIONS(637),
    [sym_mod] = ACTIONS(637),
    [sym_plus] = ACTIONS(637),
  },
  [657] = {
    [anon_sym_COMMA] = ACTIONS(653),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_or] = ACTIONS(651),
    [anon_sym_and] = ACTIONS(653),
    [anon_sym_implies] = ACTIONS(653),
    [anon_sym_order] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(653),
    [sym_in] = ACTIONS(651),
    [sym_instanceof] = ACTIONS(653),
    [sym_lt] = ACTIONS(651),
    [sym_le] = ACTIONS(653),
    [sym_eq] = ACTIONS(653),
    [sym_gt] = ACTIONS(651),
    [sym_ge] = ACTIONS(653),
    [sym_minus] = ACTIONS(653),
    [sym_ne] = ACTIONS(653),
    [sym_slash] = ACTIONS(651),
    [sym_star] = ACTIONS(653),
    [sym_mod] = ACTIONS(653),
    [sym_plus] = ACTIONS(653),
  },
  [658] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym__lower_id] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1076),
    [anon_sym_from] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_select] = ACTIONS(1074),
    [sym_qldoc] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1074),
    [anon_sym_int] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [sym__upper_id] = ACTIONS(1072),
    [sym__at_lower_id] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1074),
    [sym_class] = ACTIONS(1074),
    [sym_newtype] = ACTIONS(1074),
    [sym_date] = ACTIONS(1074),
    [sym_import] = ACTIONS(1074),
    [sym_predicate] = ACTIONS(1074),
  },
  [659] = {
    [anon_sym_COMMA] = ACTIONS(663),
    [anon_sym_RPAREN] = ACTIONS(663),
    [anon_sym_or] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(663),
    [anon_sym_implies] = ACTIONS(663),
    [anon_sym_order] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(663),
    [sym_in] = ACTIONS(665),
    [sym_instanceof] = ACTIONS(663),
    [sym_lt] = ACTIONS(665),
    [sym_le] = ACTIONS(663),
    [sym_eq] = ACTIONS(663),
    [sym_gt] = ACTIONS(665),
    [sym_ge] = ACTIONS(663),
    [sym_minus] = ACTIONS(663),
    [sym_ne] = ACTIONS(663),
    [sym_slash] = ACTIONS(665),
    [sym_star] = ACTIONS(663),
    [sym_mod] = ACTIONS(663),
    [sym_plus] = ACTIONS(663),
  },
  [660] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [661] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1081),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [662] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1083),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [663] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1085),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [664] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1087),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [665] = {
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_order] = ACTIONS(497),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
  },
  [666] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [667] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [668] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [669] = {
    [sym_orderBys] = STATE(822),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym__lower_id] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_from] = ACTIONS(1097),
    [anon_sym_where] = ACTIONS(1097),
    [anon_sym_select] = ACTIONS(1097),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1095),
    [anon_sym_float] = ACTIONS(1097),
    [anon_sym_int] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [sym__upper_id] = ACTIONS(1095),
    [sym__at_lower_id] = ACTIONS(1095),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1097),
    [sym_class] = ACTIONS(1097),
    [sym_newtype] = ACTIONS(1097),
    [sym_date] = ACTIONS(1097),
    [sym_import] = ACTIONS(1097),
    [sym_predicate] = ACTIONS(1097),
  },
  [670] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [671] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [672] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [673] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [674] = {
    [aux_sym_orderBys_repeat1] = STATE(674),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym__lower_id] = ACTIONS(1035),
    [anon_sym_module] = ACTIONS(1035),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_from] = ACTIONS(1035),
    [anon_sym_where] = ACTIONS(1035),
    [anon_sym_select] = ACTIONS(1035),
    [sym_qldoc] = ACTIONS(1037),
    [anon_sym_float] = ACTIONS(1035),
    [anon_sym_int] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [sym__upper_id] = ACTIONS(1037),
    [sym__at_lower_id] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1035),
    [sym_class] = ACTIONS(1035),
    [sym_newtype] = ACTIONS(1035),
    [sym_date] = ACTIONS(1035),
    [sym_import] = ACTIONS(1035),
    [sym_predicate] = ACTIONS(1035),
  },
  [675] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1108),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [676] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [677] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [678] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1114),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [679] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [680] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [681] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1116),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [682] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1118),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [683] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1120),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [684] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1122),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [685] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1124),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [686] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1126),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [687] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1128),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [688] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1130),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [689] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1132),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [690] = {
    [sym_orderBys] = STATE(808),
    [sym__lower_id] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_from] = ACTIONS(1097),
    [anon_sym_where] = ACTIONS(1097),
    [anon_sym_select] = ACTIONS(1097),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1095),
    [anon_sym_float] = ACTIONS(1097),
    [anon_sym_int] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [sym__upper_id] = ACTIONS(1095),
    [sym__at_lower_id] = ACTIONS(1095),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1097),
    [sym_class] = ACTIONS(1097),
    [sym_newtype] = ACTIONS(1097),
    [sym_date] = ACTIONS(1097),
    [sym_import] = ACTIONS(1097),
    [sym_predicate] = ACTIONS(1097),
  },
  [691] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [692] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1138),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [693] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [694] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(694),
    [sym__lower_id] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_or] = ACTIONS(1142),
    [anon_sym_from] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_select] = ACTIONS(1074),
    [sym_qldoc] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1074),
    [anon_sym_int] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [sym__upper_id] = ACTIONS(1072),
    [sym__at_lower_id] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1074),
    [sym_class] = ACTIONS(1074),
    [sym_newtype] = ACTIONS(1074),
    [sym_date] = ACTIONS(1074),
    [sym_import] = ACTIONS(1074),
    [sym_predicate] = ACTIONS(1074),
  },
  [695] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [696] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1147),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [697] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [698] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1151),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [699] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1153),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [700] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1155),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [701] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [702] = {
    [sym_orderBys] = STATE(827),
    [sym__lower_id] = ACTIONS(1159),
    [anon_sym_module] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_from] = ACTIONS(1159),
    [anon_sym_where] = ACTIONS(1159),
    [anon_sym_select] = ACTIONS(1159),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1161),
    [anon_sym_float] = ACTIONS(1159),
    [anon_sym_int] = ACTIONS(1159),
    [anon_sym_string] = ACTIONS(1159),
    [sym__upper_id] = ACTIONS(1161),
    [sym__at_lower_id] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1159),
    [sym_class] = ACTIONS(1159),
    [sym_newtype] = ACTIONS(1159),
    [sym_date] = ACTIONS(1159),
    [sym_import] = ACTIONS(1159),
    [sym_predicate] = ACTIONS(1159),
  },
  [703] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [704] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [705] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1167),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [706] = {
    [sym_orderBys] = STATE(767),
    [ts_builtin_sym_end] = ACTIONS(1169),
    [sym__lower_id] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_from] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(1171),
    [anon_sym_select] = ACTIONS(1171),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1169),
    [anon_sym_float] = ACTIONS(1171),
    [anon_sym_int] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [sym__upper_id] = ACTIONS(1169),
    [sym__at_lower_id] = ACTIONS(1169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1171),
    [sym_class] = ACTIONS(1171),
    [sym_newtype] = ACTIONS(1171),
    [sym_date] = ACTIONS(1171),
    [sym_import] = ACTIONS(1171),
    [sym_predicate] = ACTIONS(1171),
  },
  [707] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1173),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [708] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1175),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [709] = {
    [sym_orderBys] = STATE(801),
    [ts_builtin_sym_end] = ACTIONS(1177),
    [sym__lower_id] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1179),
    [anon_sym_from] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1179),
    [anon_sym_select] = ACTIONS(1179),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1177),
    [anon_sym_float] = ACTIONS(1179),
    [anon_sym_int] = ACTIONS(1179),
    [anon_sym_string] = ACTIONS(1179),
    [sym__upper_id] = ACTIONS(1177),
    [sym__at_lower_id] = ACTIONS(1177),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1179),
    [sym_class] = ACTIONS(1179),
    [sym_newtype] = ACTIONS(1179),
    [sym_date] = ACTIONS(1179),
    [sym_import] = ACTIONS(1179),
    [sym_predicate] = ACTIONS(1179),
  },
  [710] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [711] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [712] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(694),
    [sym__lower_id] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1187),
    [anon_sym_or] = ACTIONS(1189),
    [anon_sym_from] = ACTIONS(1185),
    [anon_sym_where] = ACTIONS(1185),
    [anon_sym_select] = ACTIONS(1185),
    [sym_qldoc] = ACTIONS(1187),
    [anon_sym_float] = ACTIONS(1185),
    [anon_sym_int] = ACTIONS(1185),
    [anon_sym_string] = ACTIONS(1185),
    [sym__upper_id] = ACTIONS(1187),
    [sym__at_lower_id] = ACTIONS(1187),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1185),
    [sym_class] = ACTIONS(1185),
    [sym_newtype] = ACTIONS(1185),
    [sym_date] = ACTIONS(1185),
    [sym_import] = ACTIONS(1185),
    [sym_predicate] = ACTIONS(1185),
  },
  [713] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [714] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [715] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [716] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [717] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [718] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_RBRACK] = ACTIONS(1197),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [719] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [720] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [721] = {
    [sym_orderBys] = STATE(816),
    [sym__lower_id] = ACTIONS(1062),
    [anon_sym_module] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1062),
    [anon_sym_where] = ACTIONS(1062),
    [anon_sym_select] = ACTIONS(1062),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1062),
    [anon_sym_int] = ACTIONS(1062),
    [anon_sym_string] = ACTIONS(1062),
    [sym__upper_id] = ACTIONS(1060),
    [sym__at_lower_id] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1062),
    [sym_class] = ACTIONS(1062),
    [sym_newtype] = ACTIONS(1062),
    [sym_date] = ACTIONS(1062),
    [sym_import] = ACTIONS(1062),
    [sym_predicate] = ACTIONS(1062),
  },
  [722] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1203),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [723] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [724] = {
    [sym_orderBys] = STATE(781),
    [sym__lower_id] = ACTIONS(1023),
    [anon_sym_module] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_from] = ACTIONS(1023),
    [anon_sym_where] = ACTIONS(1023),
    [anon_sym_select] = ACTIONS(1023),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1021),
    [anon_sym_float] = ACTIONS(1023),
    [anon_sym_int] = ACTIONS(1023),
    [anon_sym_string] = ACTIONS(1023),
    [sym__upper_id] = ACTIONS(1021),
    [sym__at_lower_id] = ACTIONS(1021),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1023),
    [sym_class] = ACTIONS(1023),
    [sym_newtype] = ACTIONS(1023),
    [sym_date] = ACTIONS(1023),
    [sym_import] = ACTIONS(1023),
    [sym_predicate] = ACTIONS(1023),
  },
  [725] = {
    [sym_orderBys] = STATE(796),
    [ts_builtin_sym_end] = ACTIONS(1161),
    [sym__lower_id] = ACTIONS(1159),
    [anon_sym_module] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1159),
    [anon_sym_where] = ACTIONS(1159),
    [anon_sym_select] = ACTIONS(1159),
    [anon_sym_order] = ACTIONS(1025),
    [sym_qldoc] = ACTIONS(1161),
    [anon_sym_float] = ACTIONS(1159),
    [anon_sym_int] = ACTIONS(1159),
    [anon_sym_string] = ACTIONS(1159),
    [sym__upper_id] = ACTIONS(1161),
    [sym__at_lower_id] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1159),
    [sym_class] = ACTIONS(1159),
    [sym_newtype] = ACTIONS(1159),
    [sym_date] = ACTIONS(1159),
    [sym_import] = ACTIONS(1159),
    [sym_predicate] = ACTIONS(1159),
  },
  [726] = {
    [sym__lower_id] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_from] = ACTIONS(923),
    [anon_sym_where] = ACTIONS(923),
    [anon_sym_select] = ACTIONS(923),
    [sym_qldoc] = ACTIONS(921),
    [anon_sym_COLON_COLON] = ACTIONS(921),
    [anon_sym_float] = ACTIONS(923),
    [anon_sym_int] = ACTIONS(923),
    [anon_sym_string] = ACTIONS(923),
    [sym__upper_id] = ACTIONS(921),
    [sym__at_lower_id] = ACTIONS(921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(923),
    [sym_boolean] = ACTIONS(923),
    [sym_class] = ACTIONS(923),
    [sym_newtype] = ACTIONS(923),
    [sym_date] = ACTIONS(923),
    [sym_import] = ACTIONS(923),
    [sym_predicate] = ACTIONS(923),
  },
  [727] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(712),
    [sym__lower_id] = ACTIONS(1044),
    [anon_sym_module] = ACTIONS(1044),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_or] = ACTIONS(1189),
    [anon_sym_from] = ACTIONS(1044),
    [anon_sym_where] = ACTIONS(1044),
    [anon_sym_select] = ACTIONS(1044),
    [sym_qldoc] = ACTIONS(1042),
    [anon_sym_float] = ACTIONS(1044),
    [anon_sym_int] = ACTIONS(1044),
    [anon_sym_string] = ACTIONS(1044),
    [sym__upper_id] = ACTIONS(1042),
    [sym__at_lower_id] = ACTIONS(1042),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1044),
    [sym_class] = ACTIONS(1044),
    [sym_newtype] = ACTIONS(1044),
    [sym_date] = ACTIONS(1044),
    [sym_import] = ACTIONS(1044),
    [sym_predicate] = ACTIONS(1044),
  },
  [728] = {
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_RPAREN] = ACTIONS(661),
    [anon_sym_or] = ACTIONS(659),
    [anon_sym_and] = ACTIONS(661),
    [anon_sym_implies] = ACTIONS(661),
    [anon_sym_order] = ACTIONS(661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(661),
    [sym_in] = ACTIONS(659),
    [sym_instanceof] = ACTIONS(661),
    [sym_lt] = ACTIONS(659),
    [sym_le] = ACTIONS(661),
    [sym_eq] = ACTIONS(661),
    [sym_gt] = ACTIONS(659),
    [sym_ge] = ACTIONS(661),
    [sym_minus] = ACTIONS(661),
    [sym_ne] = ACTIONS(661),
    [sym_slash] = ACTIONS(659),
    [sym_star] = ACTIONS(661),
    [sym_mod] = ACTIONS(661),
    [sym_plus] = ACTIONS(661),
  },
  [729] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [anon_sym_DOT_DOT] = ACTIONS(1207),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [730] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [731] = {
    [aux_sym_orderBys_repeat1] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym__lower_id] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_where] = ACTIONS(1068),
    [anon_sym_select] = ACTIONS(1068),
    [sym_qldoc] = ACTIONS(1070),
    [anon_sym_float] = ACTIONS(1068),
    [anon_sym_int] = ACTIONS(1068),
    [anon_sym_string] = ACTIONS(1068),
    [sym__upper_id] = ACTIONS(1070),
    [sym__at_lower_id] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1068),
    [sym_class] = ACTIONS(1068),
    [sym_newtype] = ACTIONS(1068),
    [sym_date] = ACTIONS(1068),
    [sym_import] = ACTIONS(1068),
    [sym_predicate] = ACTIONS(1068),
  },
  [732] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_then] = ACTIONS(1211),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [733] = {
    [sym_orderBys] = STATE(818),
    [sym__lower_id] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_from] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1179),
    [anon_sym_select] = ACTIONS(1179),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1177),
    [anon_sym_float] = ACTIONS(1179),
    [anon_sym_int] = ACTIONS(1179),
    [anon_sym_string] = ACTIONS(1179),
    [sym__upper_id] = ACTIONS(1177),
    [sym__at_lower_id] = ACTIONS(1177),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1179),
    [sym_class] = ACTIONS(1179),
    [sym_newtype] = ACTIONS(1179),
    [sym_date] = ACTIONS(1179),
    [sym_import] = ACTIONS(1179),
    [sym_predicate] = ACTIONS(1179),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(499),
    [sym__lower_id] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_from] = ACTIONS(497),
    [anon_sym_where] = ACTIONS(497),
    [anon_sym_select] = ACTIONS(497),
    [anon_sym_order] = ACTIONS(497),
    [sym_qldoc] = ACTIONS(499),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [sym__upper_id] = ACTIONS(499),
    [sym__at_lower_id] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(497),
    [sym_class] = ACTIONS(497),
    [sym_newtype] = ACTIONS(497),
    [sym_date] = ACTIONS(497),
    [sym_import] = ACTIONS(497),
    [sym_predicate] = ACTIONS(497),
  },
  [735] = {
    [sym_orderBys] = STATE(789),
    [sym__lower_id] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(1171),
    [anon_sym_select] = ACTIONS(1171),
    [anon_sym_order] = ACTIONS(1134),
    [sym_qldoc] = ACTIONS(1169),
    [anon_sym_float] = ACTIONS(1171),
    [anon_sym_int] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [sym__upper_id] = ACTIONS(1169),
    [sym__at_lower_id] = ACTIONS(1169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1171),
    [sym_class] = ACTIONS(1171),
    [sym_newtype] = ACTIONS(1171),
    [sym_date] = ACTIONS(1171),
    [sym_import] = ACTIONS(1171),
    [sym_predicate] = ACTIONS(1171),
  },
  [736] = {
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_or] = ACTIONS(613),
    [anon_sym_and] = ACTIONS(611),
    [anon_sym_implies] = ACTIONS(611),
    [anon_sym_order] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(611),
    [sym_in] = ACTIONS(613),
    [sym_instanceof] = ACTIONS(611),
    [sym_lt] = ACTIONS(613),
    [sym_le] = ACTIONS(611),
    [sym_eq] = ACTIONS(611),
    [sym_gt] = ACTIONS(613),
    [sym_ge] = ACTIONS(611),
    [sym_minus] = ACTIONS(611),
    [sym_ne] = ACTIONS(611),
    [sym_slash] = ACTIONS(613),
    [sym_star] = ACTIONS(611),
    [sym_mod] = ACTIONS(611),
    [sym_plus] = ACTIONS(611),
  },
  [737] = {
    [sym_compop] = STATE(100),
    [sym_mulop] = STATE(101),
    [sym_addop] = STATE(102),
    [anon_sym_or] = ACTIONS(805),
    [anon_sym_select] = ACTIONS(1213),
    [anon_sym_and] = ACTIONS(807),
    [anon_sym_implies] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [738] = {
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_or] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(617),
    [anon_sym_implies] = ACTIONS(617),
    [anon_sym_order] = ACTIONS(617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_as] = ACTIONS(617),
    [sym_in] = ACTIONS(615),
    [sym_instanceof] = ACTIONS(617),
    [sym_lt] = ACTIONS(615),
    [sym_le] = ACTIONS(617),
    [sym_eq] = ACTIONS(617),
    [sym_gt] = ACTIONS(615),
    [sym_ge] = ACTIONS(617),
    [sym_minus] = ACTIONS(617),
    [sym_ne] = ACTIONS(617),
    [sym_slash] = ACTIONS(615),
    [sym_star] = ACTIONS(617),
    [sym_mod] = ACTIONS(617),
    [sym_plus] = ACTIONS(617),
  },
  [739] = {
    [aux_sym_datatypeBranches_repeat1] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(1187),
    [sym__lower_id] = ACTIONS(1185),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_or] = ACTIONS(1046),
    [anon_sym_from] = ACTIONS(1185),
    [anon_sym_where] = ACTIONS(1185),
    [anon_sym_select] = ACTIONS(1185),
    [sym_qldoc] = ACTIONS(1187),
    [anon_sym_float] = ACTIONS(1185),
    [anon_sym_int] = ACTIONS(1185),
    [anon_sym_string] = ACTIONS(1185),
    [sym__upper_id] = ACTIONS(1187),
    [sym__at_lower_id] = ACTIONS(1187),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1185),
    [sym_class] = ACTIONS(1185),
    [sym_newtype] = ACTIONS(1185),
    [sym_date] = ACTIONS(1185),
    [sym_import] = ACTIONS(1185),
    [sym_predicate] = ACTIONS(1185),
  },
  [740] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [741] = {
    [sym_compop] = STATE(188),
    [sym_mulop] = STATE(187),
    [sym_addop] = STATE(186),
    [anon_sym_RPAREN] = ACTIONS(1217),
    [anon_sym_or] = ACTIONS(815),
    [anon_sym_and] = ACTIONS(817),
    [anon_sym_implies] = ACTIONS(819),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_in] = ACTIONS(811),
    [sym_instanceof] = ACTIONS(813),
    [sym_lt] = ACTIONS(395),
    [sym_le] = ACTIONS(397),
    [sym_eq] = ACTIONS(397),
    [sym_gt] = ACTIONS(395),
    [sym_ge] = ACTIONS(397),
    [sym_minus] = ACTIONS(399),
    [sym_ne] = ACTIONS(397),
    [sym_slash] = ACTIONS(401),
    [sym_star] = ACTIONS(403),
    [sym_mod] = ACTIONS(403),
    [sym_plus] = ACTIONS(399),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(1219),
    [sym__lower_id] = ACTIONS(1221),
    [anon_sym_module] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1219),
    [anon_sym_from] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(1221),
    [anon_sym_select] = ACTIONS(1221),
    [sym_qldoc] = ACTIONS(1219),
    [anon_sym_float] = ACTIONS(1221),
    [anon_sym_int] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [sym__upper_id] = ACTIONS(1219),
    [sym__at_lower_id] = ACTIONS(1219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1221),
    [sym_class] = ACTIONS(1221),
    [sym_newtype] = ACTIONS(1221),
    [sym_date] = ACTIONS(1221),
    [sym_import] = ACTIONS(1221),
    [sym_predicate] = ACTIONS(1221),
  },
  [743] = {
    [sym__lower_id] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_from] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_select] = ACTIONS(1074),
    [sym_qldoc] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1074),
    [anon_sym_int] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [sym__upper_id] = ACTIONS(1072),
    [sym__at_lower_id] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1074),
    [sym_class] = ACTIONS(1074),
    [sym_newtype] = ACTIONS(1074),
    [sym_date] = ACTIONS(1074),
    [sym_import] = ACTIONS(1074),
    [sym_predicate] = ACTIONS(1074),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(1223),
    [sym__lower_id] = ACTIONS(1225),
    [anon_sym_module] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1225),
    [anon_sym_where] = ACTIONS(1225),
    [anon_sym_select] = ACTIONS(1225),
    [sym_qldoc] = ACTIONS(1223),
    [anon_sym_float] = ACTIONS(1225),
    [anon_sym_int] = ACTIONS(1225),
    [anon_sym_string] = ACTIONS(1225),
    [sym__upper_id] = ACTIONS(1223),
    [sym__at_lower_id] = ACTIONS(1223),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(1227),
    [sym_boolean] = ACTIONS(1225),
    [sym_class] = ACTIONS(1225),
    [sym_newtype] = ACTIONS(1225),
    [sym_date] = ACTIONS(1225),
    [sym_import] = ACTIONS(1225),
    [sym_predicate] = ACTIONS(1225),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym__lower_id] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1231),
    [anon_sym_select] = ACTIONS(1231),
    [sym_qldoc] = ACTIONS(1229),
    [anon_sym_float] = ACTIONS(1231),
    [anon_sym_int] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [sym__upper_id] = ACTIONS(1229),
    [sym__at_lower_id] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1231),
    [sym_class] = ACTIONS(1231),
    [sym_newtype] = ACTIONS(1231),
    [sym_date] = ACTIONS(1231),
    [sym_import] = ACTIONS(1231),
    [sym_predicate] = ACTIONS(1231),
  },
  [746] = {
    [sym__lower_id] = ACTIONS(873),
    [anon_sym_module] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_select] = ACTIONS(873),
    [sym_qldoc] = ACTIONS(871),
    [anon_sym_float] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_string] = ACTIONS(873),
    [sym__upper_id] = ACTIONS(871),
    [sym__at_lower_id] = ACTIONS(871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(873),
    [sym_class] = ACTIONS(873),
    [sym_newtype] = ACTIONS(873),
    [sym_date] = ACTIONS(873),
    [sym_import] = ACTIONS(873),
    [sym_predicate] = ACTIONS(873),
  },
  [747] = {
    [sym__lower_id] = ACTIONS(1035),
    [anon_sym_module] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_from] = ACTIONS(1035),
    [anon_sym_where] = ACTIONS(1035),
    [anon_sym_select] = ACTIONS(1035),
    [sym_qldoc] = ACTIONS(1037),
    [anon_sym_float] = ACTIONS(1035),
    [anon_sym_int] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [sym__upper_id] = ACTIONS(1037),
    [sym__at_lower_id] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1035),
    [sym_class] = ACTIONS(1035),
    [sym_newtype] = ACTIONS(1035),
    [sym_date] = ACTIONS(1035),
    [sym_import] = ACTIONS(1035),
    [sym_predicate] = ACTIONS(1035),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym__lower_id] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_or] = ACTIONS(879),
    [anon_sym_from] = ACTIONS(879),
    [anon_sym_where] = ACTIONS(879),
    [anon_sym_select] = ACTIONS(879),
    [sym_qldoc] = ACTIONS(877),
    [anon_sym_float] = ACTIONS(879),
    [anon_sym_int] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [sym__upper_id] = ACTIONS(877),
    [sym__at_lower_id] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(879),
    [sym_class] = ACTIONS(879),
    [sym_newtype] = ACTIONS(879),
    [sym_date] = ACTIONS(879),
    [sym_import] = ACTIONS(879),
    [sym_predicate] = ACTIONS(879),
  },
  [749] = {
    [sym__lower_id] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_from] = ACTIONS(1231),
    [anon_sym_where] = ACTIONS(1231),
    [anon_sym_select] = ACTIONS(1231),
    [sym_qldoc] = ACTIONS(1229),
    [anon_sym_float] = ACTIONS(1231),
    [anon_sym_int] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [sym__upper_id] = ACTIONS(1229),
    [sym__at_lower_id] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1231),
    [sym_class] = ACTIONS(1231),
    [sym_newtype] = ACTIONS(1231),
    [sym_date] = ACTIONS(1231),
    [sym_import] = ACTIONS(1231),
    [sym_predicate] = ACTIONS(1231),
  },
  [750] = {
    [sym_annotation] = STATE(750),
    [sym_annotName] = STATE(830),
    [aux_sym_moduleMember_repeat1] = STATE(750),
    [sym__lower_id] = ACTIONS(1233),
    [anon_sym_module] = ACTIONS(1236),
    [anon_sym_from] = ACTIONS(1236),
    [anon_sym_where] = ACTIONS(1236),
    [anon_sym_select] = ACTIONS(1236),
    [anon_sym_float] = ACTIONS(1236),
    [anon_sym_int] = ACTIONS(1236),
    [anon_sym_string] = ACTIONS(1236),
    [sym__upper_id] = ACTIONS(1238),
    [sym__at_lower_id] = ACTIONS(1238),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1236),
    [sym_class] = ACTIONS(1236),
    [sym_newtype] = ACTIONS(1236),
    [sym_date] = ACTIONS(1236),
    [sym_import] = ACTIONS(1236),
    [sym_predicate] = ACTIONS(1236),
  },
  [751] = {
    [sym__lower_id] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [anon_sym_or] = ACTIONS(1240),
    [anon_sym_from] = ACTIONS(1240),
    [anon_sym_where] = ACTIONS(1240),
    [anon_sym_select] = ACTIONS(1240),
    [sym_qldoc] = ACTIONS(1242),
    [anon_sym_float] = ACTIONS(1240),
    [anon_sym_int] = ACTIONS(1240),
    [anon_sym_string] = ACTIONS(1240),
    [sym__upper_id] = ACTIONS(1242),
    [sym__at_lower_id] = ACTIONS(1242),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1240),
    [sym_class] = ACTIONS(1240),
    [sym_newtype] = ACTIONS(1240),
    [sym_date] = ACTIONS(1240),
    [sym_import] = ACTIONS(1240),
    [sym_predicate] = ACTIONS(1240),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym__lower_id] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [anon_sym_or] = ACTIONS(1240),
    [anon_sym_from] = ACTIONS(1240),
    [anon_sym_where] = ACTIONS(1240),
    [anon_sym_select] = ACTIONS(1240),
    [sym_qldoc] = ACTIONS(1242),
    [anon_sym_float] = ACTIONS(1240),
    [anon_sym_int] = ACTIONS(1240),
    [anon_sym_string] = ACTIONS(1240),
    [sym__upper_id] = ACTIONS(1242),
    [sym__at_lower_id] = ACTIONS(1242),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1240),
    [sym_class] = ACTIONS(1240),
    [sym_newtype] = ACTIONS(1240),
    [sym_date] = ACTIONS(1240),
    [sym_import] = ACTIONS(1240),
    [sym_predicate] = ACTIONS(1240),
  },
  [753] = {
    [sym__lower_id] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_or] = ACTIONS(879),
    [anon_sym_from] = ACTIONS(879),
    [anon_sym_where] = ACTIONS(879),
    [anon_sym_select] = ACTIONS(879),
    [sym_qldoc] = ACTIONS(877),
    [anon_sym_float] = ACTIONS(879),
    [anon_sym_int] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [sym__upper_id] = ACTIONS(877),
    [sym__at_lower_id] = ACTIONS(877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(879),
    [sym_class] = ACTIONS(879),
    [sym_newtype] = ACTIONS(879),
    [sym_date] = ACTIONS(879),
    [sym_import] = ACTIONS(879),
    [sym_predicate] = ACTIONS(879),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(871),
    [sym__lower_id] = ACTIONS(873),
    [anon_sym_module] = ACTIONS(873),
    [anon_sym_or] = ACTIONS(873),
    [anon_sym_from] = ACTIONS(873),
    [anon_sym_where] = ACTIONS(873),
    [anon_sym_select] = ACTIONS(873),
    [sym_qldoc] = ACTIONS(871),
    [anon_sym_float] = ACTIONS(873),
    [anon_sym_int] = ACTIONS(873),
    [anon_sym_string] = ACTIONS(873),
    [sym__upper_id] = ACTIONS(871),
    [sym__at_lower_id] = ACTIONS(871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(873),
    [sym_class] = ACTIONS(873),
    [sym_newtype] = ACTIONS(873),
    [sym_date] = ACTIONS(873),
    [sym_import] = ACTIONS(873),
    [sym_predicate] = ACTIONS(873),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(957),
    [sym__lower_id] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_from] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_select] = ACTIONS(955),
    [sym_qldoc] = ACTIONS(957),
    [anon_sym_float] = ACTIONS(955),
    [anon_sym_int] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [sym__upper_id] = ACTIONS(957),
    [sym__at_lower_id] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(955),
    [sym_class] = ACTIONS(955),
    [sym_newtype] = ACTIONS(955),
    [sym_date] = ACTIONS(955),
    [sym_import] = ACTIONS(955),
    [sym_predicate] = ACTIONS(955),
  },
  [756] = {
    [sym__lower_id] = ACTIONS(955),
    [anon_sym_module] = ACTIONS(955),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_from] = ACTIONS(955),
    [anon_sym_where] = ACTIONS(955),
    [anon_sym_select] = ACTIONS(955),
    [sym_qldoc] = ACTIONS(957),
    [anon_sym_float] = ACTIONS(955),
    [anon_sym_int] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [sym__upper_id] = ACTIONS(957),
    [sym__at_lower_id] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(955),
    [sym_class] = ACTIONS(955),
    [sym_newtype] = ACTIONS(955),
    [sym_date] = ACTIONS(955),
    [sym_import] = ACTIONS(955),
    [sym_predicate] = ACTIONS(955),
  },
  [757] = {
    [sym__lower_id] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_select] = ACTIONS(943),
    [sym_qldoc] = ACTIONS(945),
    [anon_sym_float] = ACTIONS(943),
    [anon_sym_int] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [sym__upper_id] = ACTIONS(945),
    [sym__at_lower_id] = ACTIONS(945),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(943),
    [sym_class] = ACTIONS(943),
    [sym_newtype] = ACTIONS(943),
    [sym_date] = ACTIONS(943),
    [sym_import] = ACTIONS(943),
    [sym_predicate] = ACTIONS(943),
  },
  [758] = {
    [sym__lower_id] = ACTIONS(1221),
    [anon_sym_module] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_COMMA] = ACTIONS(1219),
    [anon_sym_from] = ACTIONS(1221),
    [anon_sym_where] = ACTIONS(1221),
    [anon_sym_select] = ACTIONS(1221),
    [sym_qldoc] = ACTIONS(1219),
    [anon_sym_float] = ACTIONS(1221),
    [anon_sym_int] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [sym__upper_id] = ACTIONS(1219),
    [sym__at_lower_id] = ACTIONS(1219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1221),
    [sym_class] = ACTIONS(1221),
    [sym_newtype] = ACTIONS(1221),
    [sym_date] = ACTIONS(1221),
    [sym_import] = ACTIONS(1221),
    [sym_predicate] = ACTIONS(1221),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym__lower_id] = ACTIONS(1074),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_from] = ACTIONS(1074),
    [anon_sym_where] = ACTIONS(1074),
    [anon_sym_select] = ACTIONS(1074),
    [sym_qldoc] = ACTIONS(1072),
    [anon_sym_float] = ACTIONS(1074),
    [anon_sym_int] = ACTIONS(1074),
    [anon_sym_string] = ACTIONS(1074),
    [sym__upper_id] = ACTIONS(1072),
    [sym__at_lower_id] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1074),
    [sym_class] = ACTIONS(1074),
    [sym_newtype] = ACTIONS(1074),
    [sym_date] = ACTIONS(1074),
    [sym_import] = ACTIONS(1074),
    [sym_predicate] = ACTIONS(1074),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym__lower_id] = ACTIONS(943),
    [anon_sym_module] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_where] = ACTIONS(943),
    [anon_sym_select] = ACTIONS(943),
    [sym_qldoc] = ACTIONS(945),
    [anon_sym_float] = ACTIONS(943),
    [anon_sym_int] = ACTIONS(943),
    [anon_sym_string] = ACTIONS(943),
    [sym__upper_id] = ACTIONS(945),
    [sym__at_lower_id] = ACTIONS(945),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(943),
    [sym_class] = ACTIONS(943),
    [sym_newtype] = ACTIONS(943),
    [sym_date] = ACTIONS(943),
    [sym_import] = ACTIONS(943),
    [sym_predicate] = ACTIONS(943),
  },
  [761] = {
    [sym__lower_id] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [anon_sym_or] = ACTIONS(1244),
    [anon_sym_from] = ACTIONS(1244),
    [anon_sym_where] = ACTIONS(1244),
    [anon_sym_select] = ACTIONS(1244),
    [sym_qldoc] = ACTIONS(1246),
    [anon_sym_float] = ACTIONS(1244),
    [anon_sym_int] = ACTIONS(1244),
    [anon_sym_string] = ACTIONS(1244),
    [sym__upper_id] = ACTIONS(1246),
    [sym__at_lower_id] = ACTIONS(1246),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1244),
    [sym_class] = ACTIONS(1244),
    [sym_newtype] = ACTIONS(1244),
    [sym_date] = ACTIONS(1244),
    [sym_import] = ACTIONS(1244),
    [sym_predicate] = ACTIONS(1244),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym__lower_id] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [anon_sym_or] = ACTIONS(1244),
    [anon_sym_from] = ACTIONS(1244),
    [anon_sym_where] = ACTIONS(1244),
    [anon_sym_select] = ACTIONS(1244),
    [sym_qldoc] = ACTIONS(1246),
    [anon_sym_float] = ACTIONS(1244),
    [anon_sym_int] = ACTIONS(1244),
    [anon_sym_string] = ACTIONS(1244),
    [sym__upper_id] = ACTIONS(1246),
    [sym__at_lower_id] = ACTIONS(1246),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1244),
    [sym_class] = ACTIONS(1244),
    [sym_newtype] = ACTIONS(1244),
    [sym_date] = ACTIONS(1244),
    [sym_import] = ACTIONS(1244),
    [sym_predicate] = ACTIONS(1244),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym__lower_id] = ACTIONS(1035),
    [anon_sym_module] = ACTIONS(1035),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_from] = ACTIONS(1035),
    [anon_sym_where] = ACTIONS(1035),
    [anon_sym_select] = ACTIONS(1035),
    [sym_qldoc] = ACTIONS(1037),
    [anon_sym_float] = ACTIONS(1035),
    [anon_sym_int] = ACTIONS(1035),
    [anon_sym_string] = ACTIONS(1035),
    [sym__upper_id] = ACTIONS(1037),
    [sym__at_lower_id] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1035),
    [sym_class] = ACTIONS(1035),
    [sym_newtype] = ACTIONS(1035),
    [sym_date] = ACTIONS(1035),
    [sym_import] = ACTIONS(1035),
    [sym_predicate] = ACTIONS(1035),
  },
  [764] = {
    [sym__lower_id] = ACTIONS(1225),
    [anon_sym_module] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_from] = ACTIONS(1225),
    [anon_sym_where] = ACTIONS(1225),
    [anon_sym_select] = ACTIONS(1225),
    [sym_qldoc] = ACTIONS(1223),
    [anon_sym_float] = ACTIONS(1225),
    [anon_sym_int] = ACTIONS(1225),
    [anon_sym_string] = ACTIONS(1225),
    [sym__upper_id] = ACTIONS(1223),
    [sym__at_lower_id] = ACTIONS(1223),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_as] = ACTIONS(1248),
    [sym_boolean] = ACTIONS(1225),
    [sym_class] = ACTIONS(1225),
    [sym_newtype] = ACTIONS(1225),
    [sym_date] = ACTIONS(1225),
    [sym_import] = ACTIONS(1225),
    [sym_predicate] = ACTIONS(1225),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym__lower_id] = ACTIONS(1252),
    [anon_sym_module] = ACTIONS(1252),
    [anon_sym_from] = ACTIONS(1252),
    [anon_sym_where] = ACTIONS(1252),
    [anon_sym_select] = ACTIONS(1252),
    [sym_qldoc] = ACTIONS(1250),
    [anon_sym_float] = ACTIONS(1252),
    [anon_sym_int] = ACTIONS(1252),
    [anon_sym_string] = ACTIONS(1252),
    [sym__upper_id] = ACTIONS(1250),
    [sym__at_lower_id] = ACTIONS(1250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1252),
    [sym_class] = ACTIONS(1252),
    [sym_newtype] = ACTIONS(1252),
    [sym_date] = ACTIONS(1252),
    [sym_import] = ACTIONS(1252),
    [sym_predicate] = ACTIONS(1252),
  },
  [766] = {
    [sym__lower_id] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_from] = ACTIONS(1254),
    [anon_sym_where] = ACTIONS(1254),
    [anon_sym_select] = ACTIONS(1254),
    [sym_qldoc] = ACTIONS(1256),
    [anon_sym_float] = ACTIONS(1254),
    [anon_sym_int] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [sym__upper_id] = ACTIONS(1256),
    [sym__at_lower_id] = ACTIONS(1256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1254),
    [sym_class] = ACTIONS(1254),
    [sym_newtype] = ACTIONS(1254),
    [sym_date] = ACTIONS(1254),
    [sym_import] = ACTIONS(1254),
    [sym_predicate] = ACTIONS(1254),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym__lower_id] = ACTIONS(1062),
    [anon_sym_module] = ACTIONS(1062),
    [anon_sym_from] = ACTIONS(1062),
    [anon_sym_where] = ACTIONS(1062),
    [anon_sym_select] = ACTIONS(1062),
    [sym_qldoc] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1062),
    [anon_sym_int] = ACTIONS(1062),
    [anon_sym_string] = ACTIONS(1062),
    [sym__upper_id] = ACTIONS(1060),
    [sym__at_lower_id] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1062),
    [sym_class] = ACTIONS(1062),
    [sym_newtype] = ACTIONS(1062),
    [sym_date] = ACTIONS(1062),
    [sym_import] = ACTIONS(1062),
    [sym_predicate] = ACTIONS(1062),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym__lower_id] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(1260),
    [anon_sym_from] = ACTIONS(1260),
    [anon_sym_where] = ACTIONS(1260),
    [anon_sym_select] = ACTIONS(1260),
    [sym_qldoc] = ACTIONS(1258),
    [anon_sym_float] = ACTIONS(1260),
    [anon_sym_int] = ACTIONS(1260),
    [anon_sym_string] = ACTIONS(1260),
    [sym__upper_id] = ACTIONS(1258),
    [sym__at_lower_id] = ACTIONS(1258),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1260),
    [sym_class] = ACTIONS(1260),
    [sym_newtype] = ACTIONS(1260),
    [sym_date] = ACTIONS(1260),
    [sym_import] = ACTIONS(1260),
    [sym_predicate] = ACTIONS(1260),
  },
  [769] = {
    [sym__lower_id] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_from] = ACTIONS(1262),
    [anon_sym_where] = ACTIONS(1262),
    [anon_sym_select] = ACTIONS(1262),
    [sym_qldoc] = ACTIONS(1264),
    [anon_sym_float] = ACTIONS(1262),
    [anon_sym_int] = ACTIONS(1262),
    [anon_sym_string] = ACTIONS(1262),
    [sym__upper_id] = ACTIONS(1264),
    [sym__at_lower_id] = ACTIONS(1264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1262),
    [sym_class] = ACTIONS(1262),
    [sym_newtype] = ACTIONS(1262),
    [sym_date] = ACTIONS(1262),
    [sym_import] = ACTIONS(1262),
    [sym_predicate] = ACTIONS(1262),
  },
  [770] = {
    [sym__lower_id] = ACTIONS(1266),
    [anon_sym_module] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1268),
    [anon_sym_from] = ACTIONS(1266),
    [anon_sym_where] = ACTIONS(1266),
    [anon_sym_select] = ACTIONS(1266),
    [sym_qldoc] = ACTIONS(1268),
    [anon_sym_float] = ACTIONS(1266),
    [anon_sym_int] = ACTIONS(1266),
    [anon_sym_string] = ACTIONS(1266),
    [sym__upper_id] = ACTIONS(1268),
    [sym__at_lower_id] = ACTIONS(1268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1266),
    [sym_class] = ACTIONS(1266),
    [sym_newtype] = ACTIONS(1266),
    [sym_date] = ACTIONS(1266),
    [sym_import] = ACTIONS(1266),
    [sym_predicate] = ACTIONS(1266),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(1161),
    [sym__lower_id] = ACTIONS(1159),
    [anon_sym_module] = ACTIONS(1159),
    [anon_sym_from] = ACTIONS(1159),
    [anon_sym_where] = ACTIONS(1159),
    [anon_sym_select] = ACTIONS(1159),
    [sym_qldoc] = ACTIONS(1161),
    [anon_sym_float] = ACTIONS(1159),
    [anon_sym_int] = ACTIONS(1159),
    [anon_sym_string] = ACTIONS(1159),
    [sym__upper_id] = ACTIONS(1161),
    [sym__at_lower_id] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1159),
    [sym_class] = ACTIONS(1159),
    [sym_newtype] = ACTIONS(1159),
    [sym_date] = ACTIONS(1159),
    [sym_import] = ACTIONS(1159),
    [sym_predicate] = ACTIONS(1159),
  },
  [772] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym__lower_id] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [anon_sym_from] = ACTIONS(1272),
    [anon_sym_where] = ACTIONS(1272),
    [anon_sym_select] = ACTIONS(1272),
    [sym_qldoc] = ACTIONS(1270),
    [anon_sym_float] = ACTIONS(1272),
    [anon_sym_int] = ACTIONS(1272),
    [anon_sym_string] = ACTIONS(1272),
    [sym__upper_id] = ACTIONS(1270),
    [sym__at_lower_id] = ACTIONS(1270),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1272),
    [sym_class] = ACTIONS(1272),
    [sym_newtype] = ACTIONS(1272),
    [sym_date] = ACTIONS(1272),
    [sym_import] = ACTIONS(1272),
    [sym_predicate] = ACTIONS(1272),
  },
  [773] = {
    [sym__lower_id] = ACTIONS(1274),
    [anon_sym_module] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1276),
    [anon_sym_from] = ACTIONS(1274),
    [anon_sym_where] = ACTIONS(1274),
    [anon_sym_select] = ACTIONS(1274),
    [sym_qldoc] = ACTIONS(1276),
    [anon_sym_float] = ACTIONS(1274),
    [anon_sym_int] = ACTIONS(1274),
    [anon_sym_string] = ACTIONS(1274),
    [sym__upper_id] = ACTIONS(1276),
    [sym__at_lower_id] = ACTIONS(1276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1274),
    [sym_class] = ACTIONS(1274),
    [sym_newtype] = ACTIONS(1274),
    [sym_date] = ACTIONS(1274),
    [sym_import] = ACTIONS(1274),
    [sym_predicate] = ACTIONS(1274),
  },
  [774] = {
    [sym__lower_id] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_from] = ACTIONS(1278),
    [anon_sym_where] = ACTIONS(1278),
    [anon_sym_select] = ACTIONS(1278),
    [sym_qldoc] = ACTIONS(1280),
    [anon_sym_float] = ACTIONS(1278),
    [anon_sym_int] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [sym__upper_id] = ACTIONS(1280),
    [sym__at_lower_id] = ACTIONS(1280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1278),
    [sym_class] = ACTIONS(1278),
    [sym_newtype] = ACTIONS(1278),
    [sym_date] = ACTIONS(1278),
    [sym_import] = ACTIONS(1278),
    [sym_predicate] = ACTIONS(1278),
  },
  [775] = {
    [ts_builtin_sym_end] = ACTIONS(1282),
    [sym__lower_id] = ACTIONS(1284),
    [anon_sym_module] = ACTIONS(1284),
    [anon_sym_from] = ACTIONS(1284),
    [anon_sym_where] = ACTIONS(1284),
    [anon_sym_select] = ACTIONS(1284),
    [sym_qldoc] = ACTIONS(1282),
    [anon_sym_float] = ACTIONS(1284),
    [anon_sym_int] = ACTIONS(1284),
    [anon_sym_string] = ACTIONS(1284),
    [sym__upper_id] = ACTIONS(1282),
    [sym__at_lower_id] = ACTIONS(1282),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1284),
    [sym_class] = ACTIONS(1284),
    [sym_newtype] = ACTIONS(1284),
    [sym_date] = ACTIONS(1284),
    [sym_import] = ACTIONS(1284),
    [sym_predicate] = ACTIONS(1284),
  },
  [776] = {
    [sym__lower_id] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [anon_sym_from] = ACTIONS(1286),
    [anon_sym_where] = ACTIONS(1286),
    [anon_sym_select] = ACTIONS(1286),
    [sym_qldoc] = ACTIONS(1288),
    [anon_sym_float] = ACTIONS(1286),
    [anon_sym_int] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [sym__upper_id] = ACTIONS(1288),
    [sym__at_lower_id] = ACTIONS(1288),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1286),
    [sym_class] = ACTIONS(1286),
    [sym_newtype] = ACTIONS(1286),
    [sym_date] = ACTIONS(1286),
    [sym_import] = ACTIONS(1286),
    [sym_predicate] = ACTIONS(1286),
  },
  [777] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym__lower_id] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1292),
    [anon_sym_from] = ACTIONS(1292),
    [anon_sym_where] = ACTIONS(1292),
    [anon_sym_select] = ACTIONS(1292),
    [sym_qldoc] = ACTIONS(1290),
    [anon_sym_float] = ACTIONS(1292),
    [anon_sym_int] = ACTIONS(1292),
    [anon_sym_string] = ACTIONS(1292),
    [sym__upper_id] = ACTIONS(1290),
    [sym__at_lower_id] = ACTIONS(1290),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1292),
    [sym_class] = ACTIONS(1292),
    [sym_newtype] = ACTIONS(1292),
    [sym_date] = ACTIONS(1292),
    [sym_import] = ACTIONS(1292),
    [sym_predicate] = ACTIONS(1292),
  },
  [778] = {
    [ts_builtin_sym_end] = ACTIONS(1294),
    [sym__lower_id] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1296),
    [anon_sym_from] = ACTIONS(1296),
    [anon_sym_where] = ACTIONS(1296),
    [anon_sym_select] = ACTIONS(1296),
    [sym_qldoc] = ACTIONS(1294),
    [anon_sym_float] = ACTIONS(1296),
    [anon_sym_int] = ACTIONS(1296),
    [anon_sym_string] = ACTIONS(1296),
    [sym__upper_id] = ACTIONS(1294),
    [sym__at_lower_id] = ACTIONS(1294),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1296),
    [sym_class] = ACTIONS(1296),
    [sym_newtype] = ACTIONS(1296),
    [sym_date] = ACTIONS(1296),
    [sym_import] = ACTIONS(1296),
    [sym_predicate] = ACTIONS(1296),
  },
  [779] = {
    [sym__lower_id] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(1260),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [anon_sym_from] = ACTIONS(1260),
    [anon_sym_where] = ACTIONS(1260),
    [anon_sym_select] = ACTIONS(1260),
    [sym_qldoc] = ACTIONS(1258),
    [anon_sym_float] = ACTIONS(1260),
    [anon_sym_int] = ACTIONS(1260),
    [anon_sym_string] = ACTIONS(1260),
    [sym__upper_id] = ACTIONS(1258),
    [sym__at_lower_id] = ACTIONS(1258),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1260),
    [sym_class] = ACTIONS(1260),
    [sym_newtype] = ACTIONS(1260),
    [sym_date] = ACTIONS(1260),
    [sym_import] = ACTIONS(1260),
    [sym_predicate] = ACTIONS(1260),
  },
  [780] = {
    [sym__lower_id] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [anon_sym_from] = ACTIONS(1272),
    [anon_sym_where] = ACTIONS(1272),
    [anon_sym_select] = ACTIONS(1272),
    [sym_qldoc] = ACTIONS(1270),
    [anon_sym_float] = ACTIONS(1272),
    [anon_sym_int] = ACTIONS(1272),
    [anon_sym_string] = ACTIONS(1272),
    [sym__upper_id] = ACTIONS(1270),
    [sym__at_lower_id] = ACTIONS(1270),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1272),
    [sym_class] = ACTIONS(1272),
    [sym_newtype] = ACTIONS(1272),
    [sym_date] = ACTIONS(1272),
    [sym_import] = ACTIONS(1272),
    [sym_predicate] = ACTIONS(1272),
  },
  [781] = {
    [sym__lower_id] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1179),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_from] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1179),
    [anon_sym_select] = ACTIONS(1179),
    [sym_qldoc] = ACTIONS(1177),
    [anon_sym_float] = ACTIONS(1179),
    [anon_sym_int] = ACTIONS(1179),
    [anon_sym_string] = ACTIONS(1179),
    [sym__upper_id] = ACTIONS(1177),
    [sym__at_lower_id] = ACTIONS(1177),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1179),
    [sym_class] = ACTIONS(1179),
    [sym_newtype] = ACTIONS(1179),
    [sym_date] = ACTIONS(1179),
    [sym_import] = ACTIONS(1179),
    [sym_predicate] = ACTIONS(1179),
  },
  [782] = {
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym__lower_id] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1300),
    [anon_sym_from] = ACTIONS(1300),
    [anon_sym_where] = ACTIONS(1300),
    [anon_sym_select] = ACTIONS(1300),
    [sym_qldoc] = ACTIONS(1298),
    [anon_sym_float] = ACTIONS(1300),
    [anon_sym_int] = ACTIONS(1300),
    [anon_sym_string] = ACTIONS(1300),
    [sym__upper_id] = ACTIONS(1298),
    [sym__at_lower_id] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1300),
    [sym_class] = ACTIONS(1300),
    [sym_newtype] = ACTIONS(1300),
    [sym_date] = ACTIONS(1300),
    [sym_import] = ACTIONS(1300),
    [sym_predicate] = ACTIONS(1300),
  },
  [783] = {
    [sym__lower_id] = ACTIONS(1284),
    [anon_sym_module] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_from] = ACTIONS(1284),
    [anon_sym_where] = ACTIONS(1284),
    [anon_sym_select] = ACTIONS(1284),
    [sym_qldoc] = ACTIONS(1282),
    [anon_sym_float] = ACTIONS(1284),
    [anon_sym_int] = ACTIONS(1284),
    [anon_sym_string] = ACTIONS(1284),
    [sym__upper_id] = ACTIONS(1282),
    [sym__at_lower_id] = ACTIONS(1282),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1284),
    [sym_class] = ACTIONS(1284),
    [sym_newtype] = ACTIONS(1284),
    [sym_date] = ACTIONS(1284),
    [sym_import] = ACTIONS(1284),
    [sym_predicate] = ACTIONS(1284),
  },
  [784] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [sym__lower_id] = ACTIONS(1304),
    [anon_sym_module] = ACTIONS(1304),
    [anon_sym_from] = ACTIONS(1304),
    [anon_sym_where] = ACTIONS(1304),
    [anon_sym_select] = ACTIONS(1304),
    [sym_qldoc] = ACTIONS(1302),
    [anon_sym_float] = ACTIONS(1304),
    [anon_sym_int] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1304),
    [sym__upper_id] = ACTIONS(1302),
    [sym__at_lower_id] = ACTIONS(1302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1304),
    [sym_class] = ACTIONS(1304),
    [sym_newtype] = ACTIONS(1304),
    [sym_date] = ACTIONS(1304),
    [sym_import] = ACTIONS(1304),
    [sym_predicate] = ACTIONS(1304),
  },
  [785] = {
    [sym__lower_id] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_from] = ACTIONS(1292),
    [anon_sym_where] = ACTIONS(1292),
    [anon_sym_select] = ACTIONS(1292),
    [sym_qldoc] = ACTIONS(1290),
    [anon_sym_float] = ACTIONS(1292),
    [anon_sym_int] = ACTIONS(1292),
    [anon_sym_string] = ACTIONS(1292),
    [sym__upper_id] = ACTIONS(1290),
    [sym__at_lower_id] = ACTIONS(1290),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1292),
    [sym_class] = ACTIONS(1292),
    [sym_newtype] = ACTIONS(1292),
    [sym_date] = ACTIONS(1292),
    [sym_import] = ACTIONS(1292),
    [sym_predicate] = ACTIONS(1292),
  },
  [786] = {
    [sym__lower_id] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_from] = ACTIONS(1306),
    [anon_sym_where] = ACTIONS(1306),
    [anon_sym_select] = ACTIONS(1306),
    [sym_qldoc] = ACTIONS(1308),
    [anon_sym_float] = ACTIONS(1306),
    [anon_sym_int] = ACTIONS(1306),
    [anon_sym_string] = ACTIONS(1306),
    [sym__upper_id] = ACTIONS(1308),
    [sym__at_lower_id] = ACTIONS(1308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1306),
    [sym_class] = ACTIONS(1306),
    [sym_newtype] = ACTIONS(1306),
    [sym_date] = ACTIONS(1306),
    [sym_import] = ACTIONS(1306),
    [sym_predicate] = ACTIONS(1306),
  },
  [787] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [sym__lower_id] = ACTIONS(1312),
    [anon_sym_module] = ACTIONS(1312),
    [anon_sym_from] = ACTIONS(1312),
    [anon_sym_where] = ACTIONS(1312),
    [anon_sym_select] = ACTIONS(1312),
    [sym_qldoc] = ACTIONS(1310),
    [anon_sym_float] = ACTIONS(1312),
    [anon_sym_int] = ACTIONS(1312),
    [anon_sym_string] = ACTIONS(1312),
    [sym__upper_id] = ACTIONS(1310),
    [sym__at_lower_id] = ACTIONS(1310),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1312),
    [sym_class] = ACTIONS(1312),
    [sym_newtype] = ACTIONS(1312),
    [sym_date] = ACTIONS(1312),
    [sym_import] = ACTIONS(1312),
    [sym_predicate] = ACTIONS(1312),
  },
  [788] = {
    [sym__lower_id] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [anon_sym_from] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_select] = ACTIONS(1314),
    [sym_qldoc] = ACTIONS(1316),
    [anon_sym_float] = ACTIONS(1314),
    [anon_sym_int] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [sym__upper_id] = ACTIONS(1316),
    [sym__at_lower_id] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1314),
    [sym_class] = ACTIONS(1314),
    [sym_newtype] = ACTIONS(1314),
    [sym_date] = ACTIONS(1314),
    [sym_import] = ACTIONS(1314),
    [sym_predicate] = ACTIONS(1314),
  },
  [789] = {
    [sym__lower_id] = ACTIONS(1062),
    [anon_sym_module] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1062),
    [anon_sym_where] = ACTIONS(1062),
    [anon_sym_select] = ACTIONS(1062),
    [sym_qldoc] = ACTIONS(1060),
    [anon_sym_float] = ACTIONS(1062),
    [anon_sym_int] = ACTIONS(1062),
    [anon_sym_string] = ACTIONS(1062),
    [sym__upper_id] = ACTIONS(1060),
    [sym__at_lower_id] = ACTIONS(1060),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1062),
    [sym_class] = ACTIONS(1062),
    [sym_newtype] = ACTIONS(1062),
    [sym_date] = ACTIONS(1062),
    [sym_import] = ACTIONS(1062),
    [sym_predicate] = ACTIONS(1062),
  },
  [790] = {
    [sym__lower_id] = ACTIONS(1296),
    [anon_sym_module] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_from] = ACTIONS(1296),
    [anon_sym_where] = ACTIONS(1296),
    [anon_sym_select] = ACTIONS(1296),
    [sym_qldoc] = ACTIONS(1294),
    [anon_sym_float] = ACTIONS(1296),
    [anon_sym_int] = ACTIONS(1296),
    [anon_sym_string] = ACTIONS(1296),
    [sym__upper_id] = ACTIONS(1294),
    [sym__at_lower_id] = ACTIONS(1294),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1296),
    [sym_class] = ACTIONS(1296),
    [sym_newtype] = ACTIONS(1296),
    [sym_date] = ACTIONS(1296),
    [sym_import] = ACTIONS(1296),
    [sym_predicate] = ACTIONS(1296),
  },
  [791] = {
    [sym__lower_id] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [anon_sym_from] = ACTIONS(1300),
    [anon_sym_where] = ACTIONS(1300),
    [anon_sym_select] = ACTIONS(1300),
    [sym_qldoc] = ACTIONS(1298),
    [anon_sym_float] = ACTIONS(1300),
    [anon_sym_int] = ACTIONS(1300),
    [anon_sym_string] = ACTIONS(1300),
    [sym__upper_id] = ACTIONS(1298),
    [sym__at_lower_id] = ACTIONS(1298),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1300),
    [sym_class] = ACTIONS(1300),
    [sym_newtype] = ACTIONS(1300),
    [sym_date] = ACTIONS(1300),
    [sym_import] = ACTIONS(1300),
    [sym_predicate] = ACTIONS(1300),
  },
  [792] = {
    [sym__lower_id] = ACTIONS(1312),
    [anon_sym_module] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_from] = ACTIONS(1312),
    [anon_sym_where] = ACTIONS(1312),
    [anon_sym_select] = ACTIONS(1312),
    [sym_qldoc] = ACTIONS(1310),
    [anon_sym_float] = ACTIONS(1312),
    [anon_sym_int] = ACTIONS(1312),
    [anon_sym_string] = ACTIONS(1312),
    [sym__upper_id] = ACTIONS(1310),
    [sym__at_lower_id] = ACTIONS(1310),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1312),
    [sym_class] = ACTIONS(1312),
    [sym_newtype] = ACTIONS(1312),
    [sym_date] = ACTIONS(1312),
    [sym_import] = ACTIONS(1312),
    [sym_predicate] = ACTIONS(1312),
  },
  [793] = {
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym__lower_id] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_from] = ACTIONS(1254),
    [anon_sym_where] = ACTIONS(1254),
    [anon_sym_select] = ACTIONS(1254),
    [sym_qldoc] = ACTIONS(1256),
    [anon_sym_float] = ACTIONS(1254),
    [anon_sym_int] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [sym__upper_id] = ACTIONS(1256),
    [sym__at_lower_id] = ACTIONS(1256),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1254),
    [sym_class] = ACTIONS(1254),
    [sym_newtype] = ACTIONS(1254),
    [sym_date] = ACTIONS(1254),
    [sym_import] = ACTIONS(1254),
    [sym_predicate] = ACTIONS(1254),
  },
  [794] = {
    [ts_builtin_sym_end] = ACTIONS(1276),
    [sym__lower_id] = ACTIONS(1274),
    [anon_sym_module] = ACTIONS(1274),
    [anon_sym_from] = ACTIONS(1274),
    [anon_sym_where] = ACTIONS(1274),
    [anon_sym_select] = ACTIONS(1274),
    [sym_qldoc] = ACTIONS(1276),
    [anon_sym_float] = ACTIONS(1274),
    [anon_sym_int] = ACTIONS(1274),
    [anon_sym_string] = ACTIONS(1274),
    [sym__upper_id] = ACTIONS(1276),
    [sym__at_lower_id] = ACTIONS(1276),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1274),
    [sym_class] = ACTIONS(1274),
    [sym_newtype] = ACTIONS(1274),
    [sym_date] = ACTIONS(1274),
    [sym_import] = ACTIONS(1274),
    [sym_predicate] = ACTIONS(1274),
  },
  [795] = {
    [ts_builtin_sym_end] = ACTIONS(1177),
    [sym__lower_id] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1179),
    [anon_sym_from] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(1179),
    [anon_sym_select] = ACTIONS(1179),
    [sym_qldoc] = ACTIONS(1177),
    [anon_sym_float] = ACTIONS(1179),
    [anon_sym_int] = ACTIONS(1179),
    [anon_sym_string] = ACTIONS(1179),
    [sym__upper_id] = ACTIONS(1177),
    [sym__at_lower_id] = ACTIONS(1177),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1179),
    [sym_class] = ACTIONS(1179),
    [sym_newtype] = ACTIONS(1179),
    [sym_date] = ACTIONS(1179),
    [sym_import] = ACTIONS(1179),
    [sym_predicate] = ACTIONS(1179),
  },
  [796] = {
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym__lower_id] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_from] = ACTIONS(1097),
    [anon_sym_where] = ACTIONS(1097),
    [anon_sym_select] = ACTIONS(1097),
    [sym_qldoc] = ACTIONS(1095),
    [anon_sym_float] = ACTIONS(1097),
    [anon_sym_int] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [sym__upper_id] = ACTIONS(1095),
    [sym__at_lower_id] = ACTIONS(1095),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1097),
    [sym_class] = ACTIONS(1097),
    [sym_newtype] = ACTIONS(1097),
    [sym_date] = ACTIONS(1097),
    [sym_import] = ACTIONS(1097),
    [sym_predicate] = ACTIONS(1097),
  },
  [797] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym__lower_id] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [anon_sym_from] = ACTIONS(1314),
    [anon_sym_where] = ACTIONS(1314),
    [anon_sym_select] = ACTIONS(1314),
    [sym_qldoc] = ACTIONS(1316),
    [anon_sym_float] = ACTIONS(1314),
    [anon_sym_int] = ACTIONS(1314),
    [anon_sym_string] = ACTIONS(1314),
    [sym__upper_id] = ACTIONS(1316),
    [sym__at_lower_id] = ACTIONS(1316),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1314),
    [sym_class] = ACTIONS(1314),
    [sym_newtype] = ACTIONS(1314),
    [sym_date] = ACTIONS(1314),
    [sym_import] = ACTIONS(1314),
    [sym_predicate] = ACTIONS(1314),
  },
  [798] = {
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym__lower_id] = ACTIONS(1320),
    [anon_sym_module] = ACTIONS(1320),
    [anon_sym_from] = ACTIONS(1320),
    [anon_sym_where] = ACTIONS(1320),
    [anon_sym_select] = ACTIONS(1320),
    [sym_qldoc] = ACTIONS(1318),
    [anon_sym_float] = ACTIONS(1320),
    [anon_sym_int] = ACTIONS(1320),
    [anon_sym_string] = ACTIONS(1320),
    [sym__upper_id] = ACTIONS(1318),
    [sym__at_lower_id] = ACTIONS(1318),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1320),
    [sym_class] = ACTIONS(1320),
    [sym_newtype] = ACTIONS(1320),
    [sym_date] = ACTIONS(1320),
    [sym_import] = ACTIONS(1320),
    [sym_predicate] = ACTIONS(1320),
  },
  [799] = {
    [sym__lower_id] = ACTIONS(1320),
    [anon_sym_module] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_from] = ACTIONS(1320),
    [anon_sym_where] = ACTIONS(1320),
    [anon_sym_select] = ACTIONS(1320),
    [sym_qldoc] = ACTIONS(1318),
    [anon_sym_float] = ACTIONS(1320),
    [anon_sym_int] = ACTIONS(1320),
    [anon_sym_string] = ACTIONS(1320),
    [sym__upper_id] = ACTIONS(1318),
    [sym__at_lower_id] = ACTIONS(1318),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1320),
    [sym_class] = ACTIONS(1320),
    [sym_newtype] = ACTIONS(1320),
    [sym_date] = ACTIONS(1320),
    [sym_import] = ACTIONS(1320),
    [sym_predicate] = ACTIONS(1320),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym__lower_id] = ACTIONS(1324),
    [anon_sym_module] = ACTIONS(1324),
    [anon_sym_from] = ACTIONS(1324),
    [anon_sym_where] = ACTIONS(1324),
    [anon_sym_select] = ACTIONS(1324),
    [sym_qldoc] = ACTIONS(1322),
    [anon_sym_float] = ACTIONS(1324),
    [anon_sym_int] = ACTIONS(1324),
    [anon_sym_string] = ACTIONS(1324),
    [sym__upper_id] = ACTIONS(1322),
    [sym__at_lower_id] = ACTIONS(1322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1324),
    [sym_class] = ACTIONS(1324),
    [sym_newtype] = ACTIONS(1324),
    [sym_date] = ACTIONS(1324),
    [sym_import] = ACTIONS(1324),
    [sym_predicate] = ACTIONS(1324),
  },
  [801] = {
    [ts_builtin_sym_end] = ACTIONS(1169),
    [sym__lower_id] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_from] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(1171),
    [anon_sym_select] = ACTIONS(1171),
    [sym_qldoc] = ACTIONS(1169),
    [anon_sym_float] = ACTIONS(1171),
    [anon_sym_int] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [sym__upper_id] = ACTIONS(1169),
    [sym__at_lower_id] = ACTIONS(1169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1171),
    [sym_class] = ACTIONS(1171),
    [sym_newtype] = ACTIONS(1171),
    [sym_date] = ACTIONS(1171),
    [sym_import] = ACTIONS(1171),
    [sym_predicate] = ACTIONS(1171),
  },
  [802] = {
    [ts_builtin_sym_end] = ACTIONS(1326),
    [sym__lower_id] = ACTIONS(1328),
    [anon_sym_module] = ACTIONS(1328),
    [anon_sym_from] = ACTIONS(1328),
    [anon_sym_where] = ACTIONS(1328),
    [anon_sym_select] = ACTIONS(1328),
    [sym_qldoc] = ACTIONS(1326),
    [anon_sym_float] = ACTIONS(1328),
    [anon_sym_int] = ACTIONS(1328),
    [anon_sym_string] = ACTIONS(1328),
    [sym__upper_id] = ACTIONS(1326),
    [sym__at_lower_id] = ACTIONS(1326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1328),
    [sym_class] = ACTIONS(1328),
    [sym_newtype] = ACTIONS(1328),
    [sym_date] = ACTIONS(1328),
    [sym_import] = ACTIONS(1328),
    [sym_predicate] = ACTIONS(1328),
  },
  [803] = {
    [sym__lower_id] = ACTIONS(1330),
    [anon_sym_module] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [anon_sym_from] = ACTIONS(1330),
    [anon_sym_where] = ACTIONS(1330),
    [anon_sym_select] = ACTIONS(1330),
    [sym_qldoc] = ACTIONS(1332),
    [anon_sym_float] = ACTIONS(1330),
    [anon_sym_int] = ACTIONS(1330),
    [anon_sym_string] = ACTIONS(1330),
    [sym__upper_id] = ACTIONS(1332),
    [sym__at_lower_id] = ACTIONS(1332),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1330),
    [sym_class] = ACTIONS(1330),
    [sym_newtype] = ACTIONS(1330),
    [sym_date] = ACTIONS(1330),
    [sym_import] = ACTIONS(1330),
    [sym_predicate] = ACTIONS(1330),
  },
  [804] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym__lower_id] = ACTIONS(1336),
    [anon_sym_module] = ACTIONS(1336),
    [anon_sym_from] = ACTIONS(1336),
    [anon_sym_where] = ACTIONS(1336),
    [anon_sym_select] = ACTIONS(1336),
    [sym_qldoc] = ACTIONS(1334),
    [anon_sym_float] = ACTIONS(1336),
    [anon_sym_int] = ACTIONS(1336),
    [anon_sym_string] = ACTIONS(1336),
    [sym__upper_id] = ACTIONS(1334),
    [sym__at_lower_id] = ACTIONS(1334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1336),
    [sym_class] = ACTIONS(1336),
    [sym_newtype] = ACTIONS(1336),
    [sym_date] = ACTIONS(1336),
    [sym_import] = ACTIONS(1336),
    [sym_predicate] = ACTIONS(1336),
  },
  [805] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym__lower_id] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [anon_sym_from] = ACTIONS(1306),
    [anon_sym_where] = ACTIONS(1306),
    [anon_sym_select] = ACTIONS(1306),
    [sym_qldoc] = ACTIONS(1308),
    [anon_sym_float] = ACTIONS(1306),
    [anon_sym_int] = ACTIONS(1306),
    [anon_sym_string] = ACTIONS(1306),
    [sym__upper_id] = ACTIONS(1308),
    [sym__at_lower_id] = ACTIONS(1308),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1306),
    [sym_class] = ACTIONS(1306),
    [sym_newtype] = ACTIONS(1306),
    [sym_date] = ACTIONS(1306),
    [sym_import] = ACTIONS(1306),
    [sym_predicate] = ACTIONS(1306),
  },
  [806] = {
    [ts_builtin_sym_end] = ACTIONS(1338),
    [sym__lower_id] = ACTIONS(1340),
    [anon_sym_module] = ACTIONS(1340),
    [anon_sym_from] = ACTIONS(1340),
    [anon_sym_where] = ACTIONS(1340),
    [anon_sym_select] = ACTIONS(1340),
    [sym_qldoc] = ACTIONS(1338),
    [anon_sym_float] = ACTIONS(1340),
    [anon_sym_int] = ACTIONS(1340),
    [anon_sym_string] = ACTIONS(1340),
    [sym__upper_id] = ACTIONS(1338),
    [sym__at_lower_id] = ACTIONS(1338),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1340),
    [sym_class] = ACTIONS(1340),
    [sym_newtype] = ACTIONS(1340),
    [sym_date] = ACTIONS(1340),
    [sym_import] = ACTIONS(1340),
    [sym_predicate] = ACTIONS(1340),
  },
  [807] = {
    [sym__lower_id] = ACTIONS(1342),
    [anon_sym_module] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_from] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_select] = ACTIONS(1342),
    [sym_qldoc] = ACTIONS(1344),
    [anon_sym_float] = ACTIONS(1342),
    [anon_sym_int] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [sym__upper_id] = ACTIONS(1344),
    [sym__at_lower_id] = ACTIONS(1344),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1342),
    [sym_class] = ACTIONS(1342),
    [sym_newtype] = ACTIONS(1342),
    [sym_date] = ACTIONS(1342),
    [sym_import] = ACTIONS(1342),
    [sym_predicate] = ACTIONS(1342),
  },
  [808] = {
    [sym__lower_id] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [anon_sym_from] = ACTIONS(1346),
    [anon_sym_where] = ACTIONS(1346),
    [anon_sym_select] = ACTIONS(1346),
    [sym_qldoc] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1346),
    [anon_sym_int] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [sym__upper_id] = ACTIONS(1348),
    [sym__at_lower_id] = ACTIONS(1348),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1346),
    [sym_class] = ACTIONS(1346),
    [sym_newtype] = ACTIONS(1346),
    [sym_date] = ACTIONS(1346),
    [sym_import] = ACTIONS(1346),
    [sym_predicate] = ACTIONS(1346),
  },
  [809] = {
    [sym__lower_id] = ACTIONS(1340),
    [anon_sym_module] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_from] = ACTIONS(1340),
    [anon_sym_where] = ACTIONS(1340),
    [anon_sym_select] = ACTIONS(1340),
    [sym_qldoc] = ACTIONS(1338),
    [anon_sym_float] = ACTIONS(1340),
    [anon_sym_int] = ACTIONS(1340),
    [anon_sym_string] = ACTIONS(1340),
    [sym__upper_id] = ACTIONS(1338),
    [sym__at_lower_id] = ACTIONS(1338),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1340),
    [sym_class] = ACTIONS(1340),
    [sym_newtype] = ACTIONS(1340),
    [sym_date] = ACTIONS(1340),
    [sym_import] = ACTIONS(1340),
    [sym_predicate] = ACTIONS(1340),
  },
  [810] = {
    [sym__lower_id] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_from] = ACTIONS(1350),
    [anon_sym_where] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1350),
    [sym_qldoc] = ACTIONS(1352),
    [anon_sym_float] = ACTIONS(1350),
    [anon_sym_int] = ACTIONS(1350),
    [anon_sym_string] = ACTIONS(1350),
    [sym__upper_id] = ACTIONS(1352),
    [sym__at_lower_id] = ACTIONS(1352),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1350),
    [sym_class] = ACTIONS(1350),
    [sym_newtype] = ACTIONS(1350),
    [sym_date] = ACTIONS(1350),
    [sym_import] = ACTIONS(1350),
    [sym_predicate] = ACTIONS(1350),
  },
  [811] = {
    [ts_builtin_sym_end] = ACTIONS(1280),
    [sym__lower_id] = ACTIONS(1278),
    [anon_sym_module] = ACTIONS(1278),
    [anon_sym_from] = ACTIONS(1278),
    [anon_sym_where] = ACTIONS(1278),
    [anon_sym_select] = ACTIONS(1278),
    [sym_qldoc] = ACTIONS(1280),
    [anon_sym_float] = ACTIONS(1278),
    [anon_sym_int] = ACTIONS(1278),
    [anon_sym_string] = ACTIONS(1278),
    [sym__upper_id] = ACTIONS(1280),
    [sym__at_lower_id] = ACTIONS(1280),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1278),
    [sym_class] = ACTIONS(1278),
    [sym_newtype] = ACTIONS(1278),
    [sym_date] = ACTIONS(1278),
    [sym_import] = ACTIONS(1278),
    [sym_predicate] = ACTIONS(1278),
  },
  [812] = {
    [ts_builtin_sym_end] = ACTIONS(1332),
    [sym__lower_id] = ACTIONS(1330),
    [anon_sym_module] = ACTIONS(1330),
    [anon_sym_from] = ACTIONS(1330),
    [anon_sym_where] = ACTIONS(1330),
    [anon_sym_select] = ACTIONS(1330),
    [sym_qldoc] = ACTIONS(1332),
    [anon_sym_float] = ACTIONS(1330),
    [anon_sym_int] = ACTIONS(1330),
    [anon_sym_string] = ACTIONS(1330),
    [sym__upper_id] = ACTIONS(1332),
    [sym__at_lower_id] = ACTIONS(1332),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1330),
    [sym_class] = ACTIONS(1330),
    [sym_newtype] = ACTIONS(1330),
    [sym_date] = ACTIONS(1330),
    [sym_import] = ACTIONS(1330),
    [sym_predicate] = ACTIONS(1330),
  },
  [813] = {
    [sym__lower_id] = ACTIONS(1328),
    [anon_sym_module] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_from] = ACTIONS(1328),
    [anon_sym_where] = ACTIONS(1328),
    [anon_sym_select] = ACTIONS(1328),
    [sym_qldoc] = ACTIONS(1326),
    [anon_sym_float] = ACTIONS(1328),
    [anon_sym_int] = ACTIONS(1328),
    [anon_sym_string] = ACTIONS(1328),
    [sym__upper_id] = ACTIONS(1326),
    [sym__at_lower_id] = ACTIONS(1326),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1328),
    [sym_class] = ACTIONS(1328),
    [sym_newtype] = ACTIONS(1328),
    [sym_date] = ACTIONS(1328),
    [sym_import] = ACTIONS(1328),
    [sym_predicate] = ACTIONS(1328),
  },
  [814] = {
    [ts_builtin_sym_end] = ACTIONS(1268),
    [sym__lower_id] = ACTIONS(1266),
    [anon_sym_module] = ACTIONS(1266),
    [anon_sym_from] = ACTIONS(1266),
    [anon_sym_where] = ACTIONS(1266),
    [anon_sym_select] = ACTIONS(1266),
    [sym_qldoc] = ACTIONS(1268),
    [anon_sym_float] = ACTIONS(1266),
    [anon_sym_int] = ACTIONS(1266),
    [anon_sym_string] = ACTIONS(1266),
    [sym__upper_id] = ACTIONS(1268),
    [sym__at_lower_id] = ACTIONS(1268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1266),
    [sym_class] = ACTIONS(1266),
    [sym_newtype] = ACTIONS(1266),
    [sym_date] = ACTIONS(1266),
    [sym_import] = ACTIONS(1266),
    [sym_predicate] = ACTIONS(1266),
  },
  [815] = {
    [ts_builtin_sym_end] = ACTIONS(1264),
    [sym__lower_id] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [anon_sym_from] = ACTIONS(1262),
    [anon_sym_where] = ACTIONS(1262),
    [anon_sym_select] = ACTIONS(1262),
    [sym_qldoc] = ACTIONS(1264),
    [anon_sym_float] = ACTIONS(1262),
    [anon_sym_int] = ACTIONS(1262),
    [anon_sym_string] = ACTIONS(1262),
    [sym__upper_id] = ACTIONS(1264),
    [sym__at_lower_id] = ACTIONS(1264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1262),
    [sym_class] = ACTIONS(1262),
    [sym_newtype] = ACTIONS(1262),
    [sym_date] = ACTIONS(1262),
    [sym_import] = ACTIONS(1262),
    [sym_predicate] = ACTIONS(1262),
  },
  [816] = {
    [sym__lower_id] = ACTIONS(1159),
    [anon_sym_module] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_from] = ACTIONS(1159),
    [anon_sym_where] = ACTIONS(1159),
    [anon_sym_select] = ACTIONS(1159),
    [sym_qldoc] = ACTIONS(1161),
    [anon_sym_float] = ACTIONS(1159),
    [anon_sym_int] = ACTIONS(1159),
    [anon_sym_string] = ACTIONS(1159),
    [sym__upper_id] = ACTIONS(1161),
    [sym__at_lower_id] = ACTIONS(1161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1159),
    [sym_class] = ACTIONS(1159),
    [sym_newtype] = ACTIONS(1159),
    [sym_date] = ACTIONS(1159),
    [sym_import] = ACTIONS(1159),
    [sym_predicate] = ACTIONS(1159),
  },
  [817] = {
    [sym__lower_id] = ACTIONS(1354),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_from] = ACTIONS(1354),
    [anon_sym_where] = ACTIONS(1354),
    [anon_sym_select] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(1354),
    [anon_sym_int] = ACTIONS(1354),
    [anon_sym_string] = ACTIONS(1354),
    [sym__upper_id] = ACTIONS(1356),
    [sym__at_lower_id] = ACTIONS(1356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1354),
    [sym_class] = ACTIONS(1354),
    [sym_newtype] = ACTIONS(1354),
    [sym_date] = ACTIONS(1354),
    [sym_import] = ACTIONS(1354),
    [sym_predicate] = ACTIONS(1354),
  },
  [818] = {
    [sym__lower_id] = ACTIONS(1171),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_from] = ACTIONS(1171),
    [anon_sym_where] = ACTIONS(1171),
    [anon_sym_select] = ACTIONS(1171),
    [sym_qldoc] = ACTIONS(1169),
    [anon_sym_float] = ACTIONS(1171),
    [anon_sym_int] = ACTIONS(1171),
    [anon_sym_string] = ACTIONS(1171),
    [sym__upper_id] = ACTIONS(1169),
    [sym__at_lower_id] = ACTIONS(1169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1171),
    [sym_class] = ACTIONS(1171),
    [sym_newtype] = ACTIONS(1171),
    [sym_date] = ACTIONS(1171),
    [sym_import] = ACTIONS(1171),
    [sym_predicate] = ACTIONS(1171),
  },
  [819] = {
    [sym__lower_id] = ACTIONS(1324),
    [anon_sym_module] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_from] = ACTIONS(1324),
    [anon_sym_where] = ACTIONS(1324),
    [anon_sym_select] = ACTIONS(1324),
    [sym_qldoc] = ACTIONS(1322),
    [anon_sym_float] = ACTIONS(1324),
    [anon_sym_int] = ACTIONS(1324),
    [anon_sym_string] = ACTIONS(1324),
    [sym__upper_id] = ACTIONS(1322),
    [sym__at_lower_id] = ACTIONS(1322),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1324),
    [sym_class] = ACTIONS(1324),
    [sym_newtype] = ACTIONS(1324),
    [sym_date] = ACTIONS(1324),
    [sym_import] = ACTIONS(1324),
    [sym_predicate] = ACTIONS(1324),
  },
  [820] = {
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym__lower_id] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(1350),
    [anon_sym_from] = ACTIONS(1350),
    [anon_sym_where] = ACTIONS(1350),
    [anon_sym_select] = ACTIONS(1350),
    [sym_qldoc] = ACTIONS(1352),
    [anon_sym_float] = ACTIONS(1350),
    [anon_sym_int] = ACTIONS(1350),
    [anon_sym_string] = ACTIONS(1350),
    [sym__upper_id] = ACTIONS(1352),
    [sym__at_lower_id] = ACTIONS(1352),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1350),
    [sym_class] = ACTIONS(1350),
    [sym_newtype] = ACTIONS(1350),
    [sym_date] = ACTIONS(1350),
    [sym_import] = ACTIONS(1350),
    [sym_predicate] = ACTIONS(1350),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym__lower_id] = ACTIONS(1342),
    [anon_sym_module] = ACTIONS(1342),
    [anon_sym_from] = ACTIONS(1342),
    [anon_sym_where] = ACTIONS(1342),
    [anon_sym_select] = ACTIONS(1342),
    [sym_qldoc] = ACTIONS(1344),
    [anon_sym_float] = ACTIONS(1342),
    [anon_sym_int] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [sym__upper_id] = ACTIONS(1344),
    [sym__at_lower_id] = ACTIONS(1344),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1342),
    [sym_class] = ACTIONS(1342),
    [sym_newtype] = ACTIONS(1342),
    [sym_date] = ACTIONS(1342),
    [sym_import] = ACTIONS(1342),
    [sym_predicate] = ACTIONS(1342),
  },
  [822] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [sym__lower_id] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_from] = ACTIONS(1346),
    [anon_sym_where] = ACTIONS(1346),
    [anon_sym_select] = ACTIONS(1346),
    [sym_qldoc] = ACTIONS(1348),
    [anon_sym_float] = ACTIONS(1346),
    [anon_sym_int] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [sym__upper_id] = ACTIONS(1348),
    [sym__at_lower_id] = ACTIONS(1348),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1346),
    [sym_class] = ACTIONS(1346),
    [sym_newtype] = ACTIONS(1346),
    [sym_date] = ACTIONS(1346),
    [sym_import] = ACTIONS(1346),
    [sym_predicate] = ACTIONS(1346),
  },
  [823] = {
    [sym__lower_id] = ACTIONS(1304),
    [anon_sym_module] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_from] = ACTIONS(1304),
    [anon_sym_where] = ACTIONS(1304),
    [anon_sym_select] = ACTIONS(1304),
    [sym_qldoc] = ACTIONS(1302),
    [anon_sym_float] = ACTIONS(1304),
    [anon_sym_int] = ACTIONS(1304),
    [anon_sym_string] = ACTIONS(1304),
    [sym__upper_id] = ACTIONS(1302),
    [sym__at_lower_id] = ACTIONS(1302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1304),
    [sym_class] = ACTIONS(1304),
    [sym_newtype] = ACTIONS(1304),
    [sym_date] = ACTIONS(1304),
    [sym_import] = ACTIONS(1304),
    [sym_predicate] = ACTIONS(1304),
  },
  [824] = {
    [sym__lower_id] = ACTIONS(1336),
    [anon_sym_module] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_from] = ACTIONS(1336),
    [anon_sym_where] = ACTIONS(1336),
    [anon_sym_select] = ACTIONS(1336),
    [sym_qldoc] = ACTIONS(1334),
    [anon_sym_float] = ACTIONS(1336),
    [anon_sym_int] = ACTIONS(1336),
    [anon_sym_string] = ACTIONS(1336),
    [sym__upper_id] = ACTIONS(1334),
    [sym__at_lower_id] = ACTIONS(1334),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1336),
    [sym_class] = ACTIONS(1336),
    [sym_newtype] = ACTIONS(1336),
    [sym_date] = ACTIONS(1336),
    [sym_import] = ACTIONS(1336),
    [sym_predicate] = ACTIONS(1336),
  },
  [825] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [sym__lower_id] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [anon_sym_from] = ACTIONS(1286),
    [anon_sym_where] = ACTIONS(1286),
    [anon_sym_select] = ACTIONS(1286),
    [sym_qldoc] = ACTIONS(1288),
    [anon_sym_float] = ACTIONS(1286),
    [anon_sym_int] = ACTIONS(1286),
    [anon_sym_string] = ACTIONS(1286),
    [sym__upper_id] = ACTIONS(1288),
    [sym__at_lower_id] = ACTIONS(1288),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1286),
    [sym_class] = ACTIONS(1286),
    [sym_newtype] = ACTIONS(1286),
    [sym_date] = ACTIONS(1286),
    [sym_import] = ACTIONS(1286),
    [sym_predicate] = ACTIONS(1286),
  },
  [826] = {
    [sym__lower_id] = ACTIONS(1252),
    [anon_sym_module] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_from] = ACTIONS(1252),
    [anon_sym_where] = ACTIONS(1252),
    [anon_sym_select] = ACTIONS(1252),
    [sym_qldoc] = ACTIONS(1250),
    [anon_sym_float] = ACTIONS(1252),
    [anon_sym_int] = ACTIONS(1252),
    [anon_sym_string] = ACTIONS(1252),
    [sym__upper_id] = ACTIONS(1250),
    [sym__at_lower_id] = ACTIONS(1250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1252),
    [sym_class] = ACTIONS(1252),
    [sym_newtype] = ACTIONS(1252),
    [sym_date] = ACTIONS(1252),
    [sym_import] = ACTIONS(1252),
    [sym_predicate] = ACTIONS(1252),
  },
  [827] = {
    [sym__lower_id] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_from] = ACTIONS(1097),
    [anon_sym_where] = ACTIONS(1097),
    [anon_sym_select] = ACTIONS(1097),
    [sym_qldoc] = ACTIONS(1095),
    [anon_sym_float] = ACTIONS(1097),
    [anon_sym_int] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [sym__upper_id] = ACTIONS(1095),
    [sym__at_lower_id] = ACTIONS(1095),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1097),
    [sym_class] = ACTIONS(1097),
    [sym_newtype] = ACTIONS(1097),
    [sym_date] = ACTIONS(1097),
    [sym_import] = ACTIONS(1097),
    [sym_predicate] = ACTIONS(1097),
  },
  [828] = {
    [sym_varDecl] = STATE(905),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1360),
    [anon_sym_select] = ACTIONS(1362),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [829] = {
    [sym__lower_id] = ACTIONS(1354),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_from] = ACTIONS(1354),
    [anon_sym_where] = ACTIONS(1354),
    [anon_sym_select] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_float] = ACTIONS(1354),
    [anon_sym_int] = ACTIONS(1354),
    [anon_sym_string] = ACTIONS(1354),
    [sym__upper_id] = ACTIONS(1356),
    [sym__at_lower_id] = ACTIONS(1356),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1354),
    [sym_class] = ACTIONS(1354),
    [sym_newtype] = ACTIONS(1354),
    [sym_date] = ACTIONS(1354),
    [sym_import] = ACTIONS(1354),
    [sym_predicate] = ACTIONS(1354),
  },
  [830] = {
    [sym__lower_id] = ACTIONS(1364),
    [anon_sym_module] = ACTIONS(1364),
    [anon_sym_from] = ACTIONS(1364),
    [anon_sym_where] = ACTIONS(1364),
    [anon_sym_select] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_float] = ACTIONS(1364),
    [anon_sym_int] = ACTIONS(1364),
    [anon_sym_string] = ACTIONS(1364),
    [sym__upper_id] = ACTIONS(1368),
    [sym__at_lower_id] = ACTIONS(1368),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1364),
    [sym_class] = ACTIONS(1364),
    [sym_newtype] = ACTIONS(1364),
    [sym_date] = ACTIONS(1364),
    [sym_import] = ACTIONS(1364),
    [sym_predicate] = ACTIONS(1364),
  },
  [831] = {
    [sym_varDecl] = STATE(924),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1370),
    [anon_sym_select] = ACTIONS(1372),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [832] = {
    [sym_varDecl] = STATE(1009),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [833] = {
    [sym_varDecl] = STATE(1079),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [834] = {
    [sym__lower_id] = ACTIONS(1378),
    [anon_sym_module] = ACTIONS(1378),
    [anon_sym_from] = ACTIONS(1378),
    [anon_sym_where] = ACTIONS(1378),
    [anon_sym_select] = ACTIONS(1378),
    [anon_sym_float] = ACTIONS(1378),
    [anon_sym_int] = ACTIONS(1378),
    [anon_sym_string] = ACTIONS(1378),
    [sym__upper_id] = ACTIONS(1380),
    [sym__at_lower_id] = ACTIONS(1380),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1378),
    [sym_class] = ACTIONS(1378),
    [sym_newtype] = ACTIONS(1378),
    [sym_date] = ACTIONS(1378),
    [sym_import] = ACTIONS(1378),
    [sym_predicate] = ACTIONS(1378),
  },
  [835] = {
    [sym__lower_id] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_from] = ACTIONS(1382),
    [anon_sym_where] = ACTIONS(1382),
    [anon_sym_select] = ACTIONS(1382),
    [anon_sym_float] = ACTIONS(1382),
    [anon_sym_int] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [sym__upper_id] = ACTIONS(1384),
    [sym__at_lower_id] = ACTIONS(1384),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1382),
    [sym_class] = ACTIONS(1382),
    [sym_newtype] = ACTIONS(1382),
    [sym_date] = ACTIONS(1382),
    [sym_import] = ACTIONS(1382),
    [sym_predicate] = ACTIONS(1382),
  },
  [836] = {
    [sym_varDecl] = STATE(996),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1386),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [837] = {
    [sym_varDecl] = STATE(1015),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1388),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [838] = {
    [sym_varDecl] = STATE(1067),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [839] = {
    [sym_varDecl] = STATE(1001),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1392),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [840] = {
    [sym_varDecl] = STATE(1078),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1394),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [841] = {
    [sym_varDecl] = STATE(1040),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1396),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [842] = {
    [sym_varDecl] = STATE(1054),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [843] = {
    [sym_varDecl] = STATE(894),
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(925),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [844] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1180),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [845] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1071),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [846] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1234),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [847] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1254),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [848] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1004),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [849] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(505),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [850] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1226),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [851] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1173),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [852] = {
    [sym_moduleExpr] = STATE(1220),
    [sym_typeLiteral] = STATE(438),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(438),
    [sym_dbtype] = STATE(432),
    [sym_typeExpr] = STATE(435),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(1400),
    [anon_sym_int] = ACTIONS(1400),
    [anon_sym_string] = ACTIONS(1400),
    [sym__upper_id] = ACTIONS(1402),
    [sym__at_lower_id] = ACTIONS(1404),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1400),
    [sym_date] = ACTIONS(1400),
  },
  [853] = {
    [sym_moduleExpr] = STATE(1153),
    [sym_typeLiteral] = STATE(404),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(404),
    [sym_dbtype] = STATE(394),
    [sym_typeExpr] = STATE(399),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(1406),
    [anon_sym_int] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [sym__upper_id] = ACTIONS(1408),
    [sym__at_lower_id] = ACTIONS(1410),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1406),
    [sym_date] = ACTIONS(1406),
  },
  [854] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1111),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [855] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1229),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [856] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1195),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [857] = {
    [sym_moduleExpr] = STATE(1188),
    [sym_typeLiteral] = STATE(393),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(393),
    [sym_dbtype] = STATE(400),
    [sym_typeExpr] = STATE(427),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(1412),
    [anon_sym_int] = ACTIONS(1412),
    [anon_sym_string] = ACTIONS(1412),
    [sym__upper_id] = ACTIONS(1414),
    [sym__at_lower_id] = ACTIONS(1416),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1412),
    [sym_date] = ACTIONS(1412),
  },
  [858] = {
    [sym_moduleExpr] = STATE(1256),
    [sym_typeLiteral] = STATE(736),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(736),
    [sym_dbtype] = STATE(738),
    [sym_typeExpr] = STATE(655),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(1418),
    [anon_sym_int] = ACTIONS(1418),
    [anon_sym_string] = ACTIONS(1418),
    [sym__upper_id] = ACTIONS(1420),
    [sym__at_lower_id] = ACTIONS(1422),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1418),
    [sym_date] = ACTIONS(1418),
  },
  [859] = {
    [sym_moduleExpr] = STATE(1233),
    [sym_typeLiteral] = STATE(406),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(406),
    [sym_dbtype] = STATE(403),
    [sym_typeExpr] = STATE(441),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(1424),
    [anon_sym_int] = ACTIONS(1424),
    [anon_sym_string] = ACTIONS(1424),
    [sym__upper_id] = ACTIONS(1426),
    [sym__at_lower_id] = ACTIONS(1428),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(1424),
    [sym_date] = ACTIONS(1424),
  },
  [860] = {
    [sym_moduleExpr] = STATE(1251),
    [sym_typeLiteral] = STATE(461),
    [sym_simpleId] = STATE(1091),
    [sym_className] = STATE(461),
    [sym_dbtype] = STATE(458),
    [sym_typeExpr] = STATE(1160),
    [sym__lower_id] = ACTIONS(1358),
    [anon_sym_float] = ACTIONS(21),
    [anon_sym_int] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [sym__upper_id] = ACTIONS(23),
    [sym__at_lower_id] = ACTIONS(25),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_boolean] = ACTIONS(21),
    [sym_date] = ACTIONS(21),
  },
  [861] = {
    [sym__lower_id] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [sym_qldoc] = ACTIONS(1432),
    [anon_sym_float] = ACTIONS(1430),
    [anon_sym_int] = ACTIONS(1430),
    [anon_sym_string] = ACTIONS(1430),
    [sym__upper_id] = ACTIONS(1432),
    [sym__at_lower_id] = ACTIONS(1432),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1430),
    [sym_date] = ACTIONS(1430),
    [sym_predicate] = ACTIONS(1430),
  },
  [862] = {
    [sym__lower_id] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [sym_qldoc] = ACTIONS(1436),
    [anon_sym_float] = ACTIONS(1434),
    [anon_sym_int] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [sym__upper_id] = ACTIONS(1436),
    [sym__at_lower_id] = ACTIONS(1436),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1434),
    [sym_date] = ACTIONS(1434),
    [sym_predicate] = ACTIONS(1434),
  },
  [863] = {
    [sym__lower_id] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [sym_qldoc] = ACTIONS(1440),
    [anon_sym_float] = ACTIONS(1438),
    [anon_sym_int] = ACTIONS(1438),
    [anon_sym_string] = ACTIONS(1438),
    [sym__upper_id] = ACTIONS(1440),
    [sym__at_lower_id] = ACTIONS(1440),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1438),
    [sym_date] = ACTIONS(1438),
    [sym_predicate] = ACTIONS(1438),
  },
  [864] = {
    [sym__lower_id] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [sym_qldoc] = ACTIONS(1444),
    [anon_sym_float] = ACTIONS(1442),
    [anon_sym_int] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [sym__upper_id] = ACTIONS(1444),
    [sym__at_lower_id] = ACTIONS(1444),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1442),
    [sym_date] = ACTIONS(1442),
    [sym_predicate] = ACTIONS(1442),
  },
  [865] = {
    [sym__lower_id] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [sym_qldoc] = ACTIONS(1448),
    [anon_sym_float] = ACTIONS(1446),
    [anon_sym_int] = ACTIONS(1446),
    [anon_sym_string] = ACTIONS(1446),
    [sym__upper_id] = ACTIONS(1448),
    [sym__at_lower_id] = ACTIONS(1448),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1446),
    [sym_date] = ACTIONS(1446),
    [sym_predicate] = ACTIONS(1446),
  },
  [866] = {
    [sym__lower_id] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [sym_qldoc] = ACTIONS(1452),
    [anon_sym_float] = ACTIONS(1450),
    [anon_sym_int] = ACTIONS(1450),
    [anon_sym_string] = ACTIONS(1450),
    [sym__upper_id] = ACTIONS(1452),
    [sym__at_lower_id] = ACTIONS(1452),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1450),
    [sym_date] = ACTIONS(1450),
    [sym_predicate] = ACTIONS(1450),
  },
  [867] = {
    [anon_sym_LBRACE] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_where] = ACTIONS(463),
    [anon_sym_select] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_RBRACK] = ACTIONS(463),
    [anon_sym_order] = ACTIONS(463),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(463),
  },
  [868] = {
    [sym__lower_id] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [sym_qldoc] = ACTIONS(1456),
    [anon_sym_float] = ACTIONS(1454),
    [anon_sym_int] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [sym__upper_id] = ACTIONS(1456),
    [sym__at_lower_id] = ACTIONS(1456),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
    [sym_boolean] = ACTIONS(1454),
    [sym_date] = ACTIONS(1454),
    [sym_predicate] = ACTIONS(1454),
  },
  [869] = {
    [sym_datatypeBranches] = STATE(814),
    [sym_datatypeBranch] = STATE(638),
    [sym_annotation] = STATE(1120),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1176),
    [sym__lower_id] = ACTIONS(1458),
    [sym_qldoc] = ACTIONS(1460),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
  },
  [870] = {
    [sym__lower_id] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(511),
    [anon_sym_DOT] = ACTIONS(511),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym__upper_id] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(467),
    [sym_plus] = ACTIONS(467),
  },
  [871] = {
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1172),
    [sym_simpleId] = STATE(1091),
    [sym_aritylessPredicateExpr] = STATE(1171),
    [sym_predicateExpr] = STATE(1048),
    [sym__lower_id] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1466),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [872] = {
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1172),
    [sym_simpleId] = STATE(1091),
    [sym_aritylessPredicateExpr] = STATE(1171),
    [sym_predicateExpr] = STATE(975),
    [sym__lower_id] = ACTIONS(1464),
    [anon_sym_RPAREN] = ACTIONS(1468),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [873] = {
    [sym_datatypeBranches] = STATE(770),
    [sym_datatypeBranch] = STATE(727),
    [sym_annotation] = STATE(1106),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1202),
    [sym__lower_id] = ACTIONS(1458),
    [sym_qldoc] = ACTIONS(1470),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
  },
  [874] = {
    [sym__optbody] = STATE(806),
    [sym_empty] = STATE(806),
    [sym_body] = STATE(806),
    [sym_higherOrderTerm] = STATE(806),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(1472),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1474),
  },
  [875] = {
    [sym__optbody] = STATE(765),
    [sym_empty] = STATE(765),
    [sym_body] = STATE(765),
    [sym_higherOrderTerm] = STATE(765),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(1472),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1474),
  },
  [876] = {
    [sym__optbody] = STATE(826),
    [sym_empty] = STATE(826),
    [sym_body] = STATE(826),
    [sym_higherOrderTerm] = STATE(826),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [877] = {
    [sym_datatypeBranch] = STATE(743),
    [sym_annotation] = STATE(1106),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1202),
    [sym__lower_id] = ACTIONS(1458),
    [sym_qldoc] = ACTIONS(1470),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
  },
  [878] = {
    [sym__optbody] = STATE(862),
    [sym_empty] = STATE(862),
    [sym_body] = STATE(862),
    [sym_higherOrderTerm] = STATE(862),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [879] = {
    [sym_datatypeBranch] = STATE(759),
    [sym_annotation] = STATE(1120),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1176),
    [sym__lower_id] = ACTIONS(1458),
    [sym_qldoc] = ACTIONS(1460),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(5),
  },
  [880] = {
    [sym__optbody] = STATE(864),
    [sym_empty] = STATE(864),
    [sym_body] = STATE(864),
    [sym_higherOrderTerm] = STATE(864),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [881] = {
    [sym__optbody] = STATE(820),
    [sym_empty] = STATE(820),
    [sym_body] = STATE(820),
    [sym_higherOrderTerm] = STATE(820),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(1472),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1474),
  },
  [882] = {
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_where] = ACTIONS(499),
    [anon_sym_select] = ACTIONS(499),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_order] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [883] = {
    [sym__optbody] = STATE(868),
    [sym_empty] = STATE(868),
    [sym_body] = STATE(868),
    [sym_higherOrderTerm] = STATE(868),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [884] = {
    [sym__optbody] = STATE(809),
    [sym_empty] = STATE(809),
    [sym_body] = STATE(809),
    [sym_higherOrderTerm] = STATE(809),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [885] = {
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1172),
    [sym_simpleId] = STATE(1091),
    [sym_aritylessPredicateExpr] = STATE(1171),
    [sym_predicateExpr] = STATE(1230),
    [sym__lower_id] = ACTIONS(1464),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [886] = {
    [sym__optbody] = STATE(810),
    [sym_empty] = STATE(810),
    [sym_body] = STATE(810),
    [sym_higherOrderTerm] = STATE(810),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_SEMI] = ACTIONS(1476),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1478),
  },
  [887] = {
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1172),
    [sym_simpleId] = STATE(1091),
    [sym_aritylessPredicateExpr] = STATE(1171),
    [sym_predicateExpr] = STATE(1123),
    [sym__lower_id] = ACTIONS(1464),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [888] = {
    [sym_literalId] = STATE(926),
    [sym_moduleExpr] = STATE(1172),
    [sym_simpleId] = STATE(1091),
    [sym_aritylessPredicateExpr] = STATE(1171),
    [sym_predicateExpr] = STATE(1164),
    [sym__lower_id] = ACTIONS(1464),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [889] = {
    [sym_annotArg] = STATE(1128),
    [sym_simpleId] = STATE(1110),
    [sym__lower_id] = ACTIONS(1358),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_result] = ACTIONS(1482),
    [sym_this] = ACTIONS(1482),
  },
  [890] = {
    [anon_sym_SEMI] = ACTIONS(1484),
    [anon_sym_COMMA] = ACTIONS(1484),
    [anon_sym_RPAREN] = ACTIONS(1484),
    [anon_sym_where] = ACTIONS(1484),
    [anon_sym_select] = ACTIONS(1484),
    [anon_sym_PIPE] = ACTIONS(1484),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [891] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_where] = ACTIONS(1489),
    [anon_sym_select] = ACTIONS(1489),
    [anon_sym_PIPE] = ACTIONS(1489),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [892] = {
    [sym_annotArg] = STATE(979),
    [sym_simpleId] = STATE(1110),
    [sym__lower_id] = ACTIONS(1358),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_result] = ACTIONS(1482),
    [sym_this] = ACTIONS(1482),
  },
  [893] = {
    [sym_qualModuleExpr] = STATE(602),
    [sym_importModuleExpr] = STATE(764),
    [sym_simpleId] = STATE(557),
    [sym__lower_id] = ACTIONS(1491),
    [sym__upper_id] = ACTIONS(1491),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [894] = {
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_where] = ACTIONS(1489),
    [anon_sym_select] = ACTIONS(1489),
    [anon_sym_PIPE] = ACTIONS(1489),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [895] = {
    [sym_annotation] = STATE(1127),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1140),
    [sym__lower_id] = ACTIONS(1458),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [896] = {
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_slash] = ACTIONS(1493),
    [sym_star] = ACTIONS(467),
    [sym_plus] = ACTIONS(467),
  },
  [897] = {
    [sym_qualModuleExpr] = STATE(573),
    [sym_importModuleExpr] = STATE(744),
    [sym_simpleId] = STATE(547),
    [sym__lower_id] = ACTIONS(1495),
    [sym__upper_id] = ACTIONS(1495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [898] = {
    [sym_simpleId] = STATE(882),
    [sym_varName] = STATE(890),
    [sym__lower_id] = ACTIONS(1480),
    [anon_sym_DOT] = ACTIONS(1497),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [899] = {
    [sym_annotation] = STATE(1103),
    [sym_annotName] = STATE(830),
    [sym_className] = STATE(1189),
    [sym__lower_id] = ACTIONS(1458),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [900] = {
    [sym_literalId] = STATE(943),
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(462),
    [sym__lower_id] = ACTIONS(1464),
    [sym__upper_id] = ACTIONS(1499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [901] = {
    [sym_simpleId] = STATE(882),
    [sym_varName] = STATE(890),
    [sym__lower_id] = ACTIONS(1480),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [902] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(1505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [903] = {
    [sym_qualifiedRhs] = STATE(350),
    [sym_predicateName] = STATE(911),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [904] = {
    [sym_simpleId] = STATE(882),
    [sym_varName] = STATE(890),
    [sym__lower_id] = ACTIONS(1511),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [905] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(908),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1514),
    [anon_sym_select] = ACTIONS(1083),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [906] = {
    [sym_moduleName] = STATE(983),
    [sym_simpleId] = STATE(1094),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [907] = {
    [sym_closure] = STATE(1131),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [908] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1520),
    [anon_sym_select] = ACTIONS(1081),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [909] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_PIPE] = ACTIONS(1522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [910] = {
    [sym_moduleExpr] = STATE(1101),
    [sym_simpleId] = STATE(1091),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [911] = {
    [sym_closure] = STATE(1196),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [912] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(1526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [913] = {
    [sym_closure] = STATE(1213),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [914] = {
    [sym_literalId] = STATE(943),
    [sym_simpleId] = STATE(1114),
    [sym__lower_id] = ACTIONS(1464),
    [sym__upper_id] = ACTIONS(1464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [915] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(912),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1530),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [916] = {
    [sym_closure] = STATE(1137),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [917] = {
    [sym_qualifiedRhs] = STATE(381),
    [sym_predicateName] = STATE(949),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [918] = {
    [sym_closure] = STATE(1150),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [919] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(1538),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [920] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(419),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1414),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [921] = {
    [sym_closure] = STATE(1157),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [922] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(1542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [923] = {
    [sym_closure] = STATE(1170),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [924] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(956),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1546),
    [anon_sym_select] = ACTIONS(1114),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [925] = {
    [sym_simpleId] = STATE(882),
    [sym_varName] = STATE(890),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [926] = {
    [anon_sym_LPAREN] = ACTIONS(1548),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_slash] = ACTIONS(1550),
    [sym_star] = ACTIONS(1548),
    [sym_plus] = ACTIONS(1548),
  },
  [927] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1552),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [928] = {
    [sym_qualifiedRhs] = STATE(589),
    [sym_predicateName] = STATE(916),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [929] = {
    [sym_closure] = STATE(1210),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [930] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(927),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [931] = {
    [aux_sym_asExprs_repeat1] = STATE(937),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_order] = ACTIONS(881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [932] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(446),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1426),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [933] = {
    [sym_qualifiedRhs] = STATE(342),
    [sym_predicateName] = STATE(935),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [934] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(902),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_PIPE] = ACTIONS(1564),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [935] = {
    [sym_closure] = STATE(1177),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [936] = {
    [sym_simpleId] = STATE(882),
    [sym_varName] = STATE(987),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [937] = {
    [aux_sym_asExprs_repeat1] = STATE(942),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_order] = ACTIONS(917),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [938] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(919),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(1568),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [939] = {
    [sym_closure] = STATE(1190),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [940] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(462),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(23),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [941] = {
    [anon_sym_LPAREN] = ACTIONS(1572),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1572),
    [sym_star] = ACTIONS(1572),
    [sym_plus] = ACTIONS(1572),
  },
  [942] = {
    [aux_sym_asExprs_repeat1] = STATE(942),
    [anon_sym_COMMA] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_order] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [943] = {
    [anon_sym_LPAREN] = ACTIONS(1577),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_slash] = ACTIONS(1579),
    [sym_star] = ACTIONS(1577),
    [sym_plus] = ACTIONS(1577),
  },
  [944] = {
    [sym_qualifiedRhs] = STATE(476),
    [sym_predicateName] = STATE(960),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [945] = {
    [sym_simpleId] = STATE(734),
    [sym_varName] = STATE(643),
    [sym__lower_id] = ACTIONS(1495),
    [sym__upper_id] = ACTIONS(1495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [946] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(909),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1112),
    [anon_sym_PIPE] = ACTIONS(1583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [947] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(922),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1585),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [948] = {
    [sym_moduleName] = STATE(794),
    [sym_simpleId] = STATE(775),
    [sym__lower_id] = ACTIONS(1495),
    [sym__upper_id] = ACTIONS(1495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [949] = {
    [sym_closure] = STATE(1197),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [950] = {
    [sym_qualifiedRhs] = STATE(307),
    [sym_predicateName] = STATE(921),
    [sym__lower_id] = ACTIONS(1507),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [951] = {
    [sym_moduleName] = STATE(773),
    [sym_simpleId] = STATE(783),
    [sym__lower_id] = ACTIONS(1491),
    [sym__upper_id] = ACTIONS(1491),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [952] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(437),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1402),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [953] = {
    [sym_moduleName] = STATE(1033),
    [sym_simpleId] = STATE(1094),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [954] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(728),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [955] = {
    [sym_moduleExpr] = STATE(1130),
    [sym_simpleId] = STATE(1091),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [956] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_where] = ACTIONS(1591),
    [anon_sym_select] = ACTIONS(1175),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [957] = {
    [sym_simpleId] = STATE(665),
    [sym_varName] = STATE(654),
    [sym__lower_id] = ACTIONS(1491),
    [sym__upper_id] = ACTIONS(1491),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [958] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_PIPE] = ACTIONS(1593),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [959] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(958),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1140),
    [anon_sym_PIPE] = ACTIONS(1595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [960] = {
    [sym_closure] = STATE(1159),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_star] = ACTIONS(1518),
    [sym_plus] = ACTIONS(1518),
  },
  [961] = {
    [sym_simpleId] = STATE(1114),
    [sym_className] = STATE(414),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1408),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [962] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [963] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1031),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(169),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [964] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1603),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [965] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(968),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1603),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [966] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(971),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(229),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [967] = {
    [sym_predicateAliasBody] = STATE(784),
    [anon_sym_LPAREN] = ACTIONS(1605),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1607),
  },
  [968] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [969] = {
    [sym_simpleId] = STATE(583),
    [sym__lower_id] = ACTIONS(1491),
    [sym__upper_id] = ACTIONS(1491),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [970] = {
    [sym_simpleId] = STATE(726),
    [sym__lower_id] = ACTIONS(1491),
    [sym__upper_id] = ACTIONS(1491),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [971] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [972] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(973),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [973] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [974] = {
    [aux_sym_higherOrderTerm_repeat1] = STATE(1000),
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(1617),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [975] = {
    [aux_sym_higherOrderTerm_repeat1] = STATE(974),
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(1619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [976] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1621),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [977] = {
    [sym_simpleId] = STATE(651),
    [sym__lower_id] = ACTIONS(1495),
    [sym__upper_id] = ACTIONS(1495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [978] = {
    [sym_simpleId] = STATE(572),
    [sym__lower_id] = ACTIONS(1495),
    [sym__upper_id] = ACTIONS(1495),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [979] = {
    [aux_sym_annotation_repeat1] = STATE(1008),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [980] = {
    [sym_predicateAliasBody] = STATE(823),
    [anon_sym_LPAREN] = ACTIONS(1627),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1629),
  },
  [981] = {
    [sym_typeAliasBody] = STATE(786),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_extends] = ACTIONS(1631),
    [sym_eq] = ACTIONS(1633),
  },
  [982] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(985),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [983] = {
    [sym_moduleAliasBody] = STATE(774),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1637),
  },
  [984] = {
    [aux_sym_orderBys_repeat1] = STATE(984),
    [anon_sym_COMMA] = ACTIONS(1639),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [985] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [986] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(990),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [987] = {
    [anon_sym_COMMA] = ACTIONS(1054),
    [anon_sym_RPAREN] = ACTIONS(1054),
    [anon_sym_order] = ACTIONS(1054),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [988] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(993),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(177),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [989] = {
    [aux_sym_orderBys_repeat1] = STATE(984),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1029),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [990] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [991] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [992] = {
    [aux_sym_orderBys_repeat1] = STATE(989),
    [anon_sym_COMMA] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1070),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [993] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [994] = {
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [995] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1030),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(153),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [996] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(991),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1374),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [997] = {
    [anon_sym_COMMA] = ACTIONS(965),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_order] = ACTIONS(965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [998] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [999] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1652),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1000] = {
    [aux_sym_higherOrderTerm_repeat1] = STATE(1000),
    [anon_sym_COMMA] = ACTIONS(1654),
    [anon_sym_RPAREN] = ACTIONS(1657),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1001] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1050),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1659),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1002] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1661),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1003] = {
    [sym_orderBys] = STATE(1152),
    [anon_sym_RPAREN] = ACTIONS(1663),
    [anon_sym_order] = ACTIONS(1665),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1004] = {
    [aux_sym_dataclass_repeat1] = STATE(1042),
    [anon_sym_LBRACE] = ACTIONS(1667),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1005] = {
    [sym_typeAliasBody] = STATE(805),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_extends] = ACTIONS(1671),
    [sym_eq] = ACTIONS(1673),
  },
  [1006] = {
    [anon_sym_LPAREN] = ACTIONS(511),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_extends] = ACTIONS(511),
    [sym_eq] = ACTIONS(511),
  },
  [1007] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(964),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1008] = {
    [aux_sym_annotation_repeat1] = STATE(1044),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_RBRACK] = ACTIONS(1675),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1009] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1075),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1376),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1010] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1037),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(149),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1011] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1012] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1013] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1022),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(209),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1014] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1011),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1015] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1049),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1016] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1017] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1016),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(197),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1018] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(197),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1019] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1068),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1685),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1020] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1687),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1021] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1084),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(265),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1022] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1023] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1027),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1024] = {
    [sym_simpleId] = STATE(1114),
    [sym__lower_id] = ACTIONS(1480),
    [sym__upper_id] = ACTIONS(1480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1025] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1057),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(107),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1026] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1086),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1027] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1693),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1028] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1018),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(245),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1029] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1030] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1031] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1032] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1036),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1033] = {
    [sym_moduleAliasBody] = STATE(811),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1703),
  },
  [1034] = {
    [aux_sym_higherOrderTerm_repeat1] = STATE(1000),
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(1705),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1035] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1085),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1036] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1037] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1038] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1709),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1039] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1711),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1040] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1029),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1041] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_RBRACK] = ACTIONS(1715),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1042] = {
    [aux_sym_dataclass_repeat1] = STATE(1082),
    [anon_sym_LBRACE] = ACTIONS(1717),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1043] = {
    [sym_orderBys] = STATE(1162),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_order] = ACTIONS(1665),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1044] = {
    [aux_sym_annotation_repeat1] = STATE(1044),
    [anon_sym_COMMA] = ACTIONS(1721),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1045] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1039),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1046] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1726),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1047] = {
    [sym_literalId] = STATE(1216),
    [sym__lower_id] = ACTIONS(1728),
    [sym__upper_id] = ACTIONS(1728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1048] = {
    [aux_sym_higherOrderTerm_repeat1] = STATE(1034),
    [anon_sym_COMMA] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(1730),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1049] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1050] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1051] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1060),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(173),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1052] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1053] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1046),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1054] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1038),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1055] = {
    [aux_sym_dataclass_repeat1] = STATE(1082),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1056] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(237),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1057] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1685),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1058] = {
    [sym__lower_id] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [sym__upper_id] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1059] = {
    [sym_orderBys] = STATE(1135),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [anon_sym_order] = ACTIONS(1665),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1060] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1061] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1065),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1062] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1056),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(249),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1063] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1069),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(133),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1064] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1065] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1748),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1066] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1067] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1052),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1068] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1750),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1069] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1070] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1074),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1071] = {
    [aux_sym_dataclass_repeat1] = STATE(1055),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_COMMA] = ACTIONS(1669),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1072] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1073] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1758),
    [anon_sym_RPAREN] = ACTIONS(1761),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1074] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1763),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1075] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(891),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1076] = {
    [sym_orderBys] = STATE(1250),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_order] = ACTIONS(1665),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1077] = {
    [aux_sym_aggregate_repeat1] = STATE(1077),
    [anon_sym_COMMA] = ACTIONS(1767),
    [anon_sym_RBRACK] = ACTIONS(1015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1078] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1066),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1390),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1079] = {
    [aux_sym_classlessPredicate_repeat1] = STATE(1072),
    [anon_sym_COMMA] = ACTIONS(1503),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1080] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1064),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1081] = {
    [sym_orderBys] = STATE(1232),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_order] = ACTIONS(1665),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1082] = {
    [aux_sym_dataclass_repeat1] = STATE(1082),
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1774),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1083] = {
    [sym_literalId] = STATE(1242),
    [sym__lower_id] = ACTIONS(1728),
    [sym__upper_id] = ACTIONS(1728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1084] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1085] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1777),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1086] = {
    [aux_sym_higherOrderTerm_repeat2] = STATE(1073),
    [anon_sym_COMMA] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1779),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1087] = {
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1088] = {
    [sym_range] = STATE(489),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1089] = {
    [sym_className] = STATE(1005),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1090] = {
    [sym_className] = STATE(1228),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1091] = {
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1092] = {
    [sym_predicateName] = STATE(967),
    [sym__lower_id] = ACTIONS(1507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1093] = {
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1094] = {
    [anon_sym_LBRACE] = ACTIONS(1282),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1282),
  },
  [1095] = {
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1096] = {
    [sym_range] = STATE(656),
    [anon_sym_LBRACK] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1097] = {
    [anon_sym_RPAREN] = ACTIONS(1785),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1098] = {
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1789),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1099] = {
    [sym_className] = STATE(981),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1100] = {
    [sym_predicateName] = STATE(980),
    [sym__lower_id] = ACTIONS(1507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1101] = {
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_COLON_COLON] = ACTIONS(1793),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1102] = {
    [anon_sym_RPAREN] = ACTIONS(1795),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1103] = {
    [sym_className] = STATE(1179),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1104] = {
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1105] = {
    [sym_range] = STATE(443),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1106] = {
    [sym_className] = STATE(1189),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1107] = {
    [anon_sym_RPAREN] = ACTIONS(1801),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1108] = {
    [sym_className] = STATE(1217),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1109] = {
    [sym_range] = STATE(434),
    [anon_sym_LBRACK] = ACTIONS(279),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1110] = {
    [anon_sym_COMMA] = ACTIONS(1803),
    [anon_sym_RBRACK] = ACTIONS(1803),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1111] = {
    [anon_sym_LBRACE] = ACTIONS(1772),
    [anon_sym_COMMA] = ACTIONS(1772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1112] = {
    [sym_predicateName] = STATE(1249),
    [sym__lower_id] = ACTIONS(1507),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1113] = {
    [anon_sym_RPAREN] = ACTIONS(1805),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1114] = {
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_COLON_COLON] = ACTIONS(1807),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1115] = {
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1116] = {
    [anon_sym_COMMA] = ACTIONS(1219),
    [anon_sym_RPAREN] = ACTIONS(1219),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1117] = {
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1118] = {
    [anon_sym_RPAREN] = ACTIONS(1813),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1119] = {
    [sym_range] = STATE(426),
    [anon_sym_LBRACK] = ACTIONS(355),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1120] = {
    [sym_className] = STATE(1140),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1121] = {
    [anon_sym_COMMA] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1761),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1122] = {
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1123] = {
    [anon_sym_COMMA] = ACTIONS(1657),
    [anon_sym_RPAREN] = ACTIONS(1657),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1124] = {
    [anon_sym_LPAREN] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1125] = {
    [anon_sym_RPAREN] = ACTIONS(1823),
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1126] = {
    [sym_range] = STATE(401),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1127] = {
    [sym_className] = STATE(1203),
    [sym__upper_id] = ACTIONS(1462),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1128] = {
    [anon_sym_COMMA] = ACTIONS(1724),
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1129] = {
    [anon_sym_LPAREN] = ACTIONS(1825),
    [anon_sym_LBRACK] = ACTIONS(1827),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1130] = {
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_COLON_COLON] = ACTIONS(1793),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1131] = {
    [anon_sym_LPAREN] = ACTIONS(1831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1132] = {
    [anon_sym_LPAREN] = ACTIONS(1833),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1133] = {
    [anon_sym_RPAREN] = ACTIONS(1835),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1134] = {
    [anon_sym_LPAREN] = ACTIONS(1837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1135] = {
    [anon_sym_RPAREN] = ACTIONS(1719),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1136] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(1839),
  },
  [1137] = {
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1138] = {
    [anon_sym_LPAREN] = ACTIONS(1843),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1139] = {
    [anon_sym_DOT] = ACTIONS(1845),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1140] = {
    [anon_sym_LPAREN] = ACTIONS(1847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1141] = {
    [anon_sym_LPAREN] = ACTIONS(1849),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1142] = {
    [anon_sym_LPAREN] = ACTIONS(1851),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1143] = {
    [anon_sym_LPAREN] = ACTIONS(1853),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1144] = {
    [anon_sym_RPAREN] = ACTIONS(1855),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1145] = {
    [anon_sym_LPAREN] = ACTIONS(1857),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1146] = {
    [anon_sym_LPAREN] = ACTIONS(1859),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1147] = {
    [anon_sym_DOT] = ACTIONS(1497),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1148] = {
    [sym_integer] = ACTIONS(1861),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1149] = {
    [anon_sym_LPAREN] = ACTIONS(1863),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1150] = {
    [anon_sym_LPAREN] = ACTIONS(1865),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1151] = {
    [anon_sym_LPAREN] = ACTIONS(1867),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1152] = {
    [anon_sym_RPAREN] = ACTIONS(1869),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1153] = {
    [anon_sym_COLON_COLON] = ACTIONS(1871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1154] = {
    [anon_sym_RPAREN] = ACTIONS(1873),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1155] = {
    [anon_sym_RPAREN] = ACTIONS(1875),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1156] = {
    [anon_sym_RPAREN] = ACTIONS(101),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1157] = {
    [anon_sym_LPAREN] = ACTIONS(1877),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1158] = {
    [anon_sym_LPAREN] = ACTIONS(1879),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1159] = {
    [anon_sym_LPAREN] = ACTIONS(1881),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1160] = {
    [anon_sym_RPAREN] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1161] = {
    [anon_sym_LPAREN] = ACTIONS(1883),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1162] = {
    [anon_sym_RPAREN] = ACTIONS(1885),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1163] = {
    [anon_sym_LPAREN] = ACTIONS(1887),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1164] = {
    [anon_sym_SEMI] = ACTIONS(1889),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1165] = {
    [anon_sym_LPAREN] = ACTIONS(1891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1166] = {
    [anon_sym_LPAREN] = ACTIONS(1893),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1167] = {
    [anon_sym_DOT] = ACTIONS(1895),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1168] = {
    [anon_sym_LPAREN] = ACTIONS(1897),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1169] = {
    [anon_sym_LPAREN] = ACTIONS(1899),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1170] = {
    [anon_sym_LPAREN] = ACTIONS(1901),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1171] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_slash] = ACTIONS(1903),
  },
  [1172] = {
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1173] = {
    [anon_sym_RPAREN] = ACTIONS(137),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1174] = {
    [anon_sym_RPAREN] = ACTIONS(1907),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1175] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(1909),
  },
  [1176] = {
    [anon_sym_LPAREN] = ACTIONS(1911),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1177] = {
    [anon_sym_LPAREN] = ACTIONS(1913),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1178] = {
    [anon_sym_LPAREN] = ACTIONS(1915),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1179] = {
    [anon_sym_LPAREN] = ACTIONS(1917),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1180] = {
    [anon_sym_SEMI] = ACTIONS(1919),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1181] = {
    [anon_sym_LPAREN] = ACTIONS(1921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1182] = {
    [anon_sym_LPAREN] = ACTIONS(1923),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1183] = {
    [anon_sym_RPAREN] = ACTIONS(1925),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1184] = {
    [anon_sym_LPAREN] = ACTIONS(1927),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1185] = {
    [anon_sym_LPAREN] = ACTIONS(1929),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1186] = {
    [anon_sym_LPAREN] = ACTIONS(1931),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1187] = {
    [anon_sym_DOT] = ACTIONS(1933),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1188] = {
    [anon_sym_COLON_COLON] = ACTIONS(1935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1189] = {
    [anon_sym_LPAREN] = ACTIONS(1937),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1190] = {
    [anon_sym_LPAREN] = ACTIONS(1939),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1191] = {
    [anon_sym_RPAREN] = ACTIONS(1941),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1192] = {
    [anon_sym_RPAREN] = ACTIONS(1943),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1193] = {
    [anon_sym_RPAREN] = ACTIONS(75),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1194] = {
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1195] = {
    [anon_sym_RPAREN] = ACTIONS(165),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1196] = {
    [anon_sym_LPAREN] = ACTIONS(1947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1197] = {
    [anon_sym_LPAREN] = ACTIONS(1949),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1198] = {
    [anon_sym_LPAREN] = ACTIONS(1951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1199] = {
    [anon_sym_RPAREN] = ACTIONS(1953),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1200] = {
    [anon_sym_SEMI] = ACTIONS(1955),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1201] = {
    [anon_sym_LPAREN] = ACTIONS(1957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1202] = {
    [anon_sym_LPAREN] = ACTIONS(1959),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1203] = {
    [anon_sym_LPAREN] = ACTIONS(1961),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1204] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(1963),
  },
  [1205] = {
    [anon_sym_LPAREN] = ACTIONS(467),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1206] = {
    [anon_sym_RPAREN] = ACTIONS(1965),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1207] = {
    [anon_sym_by] = ACTIONS(1967),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1208] = {
    [anon_sym_by] = ACTIONS(1969),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1209] = {
    [anon_sym_RPAREN] = ACTIONS(1971),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1210] = {
    [anon_sym_LPAREN] = ACTIONS(1973),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1211] = {
    [anon_sym_LPAREN] = ACTIONS(1975),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1212] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(1977),
  },
  [1213] = {
    [anon_sym_LPAREN] = ACTIONS(1979),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1214] = {
    [anon_sym_LBRACE] = ACTIONS(1981),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1215] = {
    [anon_sym_RPAREN] = ACTIONS(1983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1216] = {
    [anon_sym_LPAREN] = ACTIONS(1985),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1217] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(1987),
  },
  [1218] = {
    [anon_sym_DOT] = ACTIONS(1989),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1219] = {
    [anon_sym_LPAREN] = ACTIONS(1991),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1220] = {
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1221] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(1995),
  },
  [1222] = {
    [anon_sym_RPAREN] = ACTIONS(1997),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1223] = {
    [anon_sym_by] = ACTIONS(1999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1224] = {
    [anon_sym_RPAREN] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1225] = {
    [anon_sym_LPAREN] = ACTIONS(2001),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1226] = {
    [anon_sym_RPAREN] = ACTIONS(217),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1227] = {
    [anon_sym_RPAREN] = ACTIONS(2003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1228] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_eq] = ACTIONS(2005),
  },
  [1229] = {
    [anon_sym_SEMI] = ACTIONS(2007),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1230] = {
    [anon_sym_SEMI] = ACTIONS(2009),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1231] = {
    [anon_sym_RPAREN] = ACTIONS(2011),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1232] = {
    [anon_sym_RPAREN] = ACTIONS(978),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1233] = {
    [anon_sym_COLON_COLON] = ACTIONS(2013),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1234] = {
    [anon_sym_RPAREN] = ACTIONS(185),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1235] = {
    [anon_sym_DOT] = ACTIONS(1501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1236] = {
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1237] = {
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym_super] = ACTIONS(2017),
  },
  [1238] = {
    [anon_sym_RPAREN] = ACTIONS(2019),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1239] = {
    [anon_sym_LPAREN] = ACTIONS(2021),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1240] = {
    [anon_sym_LPAREN] = ACTIONS(2023),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1241] = {
    [anon_sym_LPAREN] = ACTIONS(2025),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1242] = {
    [anon_sym_LPAREN] = ACTIONS(2027),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1243] = {
    [anon_sym_LPAREN] = ACTIONS(2029),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1244] = {
    [anon_sym_RPAREN] = ACTIONS(79),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1245] = {
    [anon_sym_RPAREN] = ACTIONS(95),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1246] = {
    [anon_sym_RPAREN] = ACTIONS(2031),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1247] = {
    [anon_sym_RPAREN] = ACTIONS(2033),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1248] = {
    [anon_sym_RPAREN] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1249] = {
    [anon_sym_LPAREN] = ACTIONS(2035),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1250] = {
    [anon_sym_RPAREN] = ACTIONS(1742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1251] = {
    [anon_sym_COLON_COLON] = ACTIONS(2037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1252] = {
    [ts_builtin_sym_end] = ACTIONS(2039),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1253] = {
    [sym__lower_id] = ACTIONS(2041),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1254] = {
    [anon_sym_RPAREN] = ACTIONS(161),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1255] = {
    [anon_sym_RPAREN] = ACTIONS(2043),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1256] = {
    [anon_sym_COLON_COLON] = ACTIONS(2045),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_ql, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(817),
  [11] = {.count = 1, .reusable = false}, SHIFT(953),
  [13] = {.count = 1, .reusable = false}, SHIFT(831),
  [15] = {.count = 1, .reusable = false}, SHIFT(87),
  [17] = {.count = 1, .reusable = false}, SHIFT(72),
  [19] = {.count = 1, .reusable = true}, SHIFT(825),
  [21] = {.count = 1, .reusable = false}, SHIFT(458),
  [23] = {.count = 1, .reusable = true}, SHIFT(457),
  [25] = {.count = 1, .reusable = true}, SHIFT(460),
  [27] = {.count = 1, .reusable = false}, SHIFT(1089),
  [29] = {.count = 1, .reusable = false}, SHIFT(1090),
  [31] = {.count = 1, .reusable = false}, SHIFT(897),
  [33] = {.count = 1, .reusable = false}, SHIFT(1253),
  [35] = {.count = 1, .reusable = false}, SHIFT(540),
  [37] = {.count = 1, .reusable = true}, SHIFT(226),
  [39] = {.count = 1, .reusable = true}, SHIFT(357),
  [41] = {.count = 1, .reusable = false}, SHIFT(116),
  [43] = {.count = 1, .reusable = true}, SHIFT(56),
  [45] = {.count = 1, .reusable = true}, SHIFT(130),
  [47] = {.count = 1, .reusable = true}, SHIFT(519),
  [49] = {.count = 1, .reusable = false}, SHIFT(562),
  [51] = {.count = 1, .reusable = true}, SHIFT(562),
  [53] = {.count = 1, .reusable = false}, SHIFT(1095),
  [55] = {.count = 1, .reusable = false}, SHIFT(1243),
  [57] = {.count = 1, .reusable = false}, SHIFT(563),
  [59] = {.count = 1, .reusable = false}, SHIFT(181),
  [61] = {.count = 1, .reusable = false}, SHIFT(1241),
  [63] = {.count = 1, .reusable = false}, SHIFT(564),
  [65] = {.count = 1, .reusable = false}, SHIFT(565),
  [67] = {.count = 1, .reusable = true}, SHIFT(397),
  [69] = {.count = 1, .reusable = true}, SHIFT(372),
  [71] = {.count = 1, .reusable = true}, SHIFT(481),
  [73] = {.count = 1, .reusable = true}, SHIFT(318),
  [75] = {.count = 1, .reusable = true}, SHIFT(322),
  [77] = {.count = 1, .reusable = true}, SHIFT(592),
  [79] = {.count = 1, .reusable = true}, SHIFT(468),
  [81] = {.count = 1, .reusable = true}, SHIFT(310),
  [83] = {.count = 1, .reusable = true}, SHIFT(348),
  [85] = {.count = 1, .reusable = true}, SHIFT(619),
  [87] = {.count = 1, .reusable = true}, SHIFT(345),
  [89] = {.count = 1, .reusable = true}, SHIFT(614),
  [91] = {.count = 1, .reusable = true}, SHIFT(328),
  [93] = {.count = 1, .reusable = true}, SHIFT(386),
  [95] = {.count = 1, .reusable = true}, SHIFT(323),
  [97] = {.count = 1, .reusable = true}, SHIFT(378),
  [99] = {.count = 1, .reusable = true}, SHIFT(480),
  [101] = {.count = 1, .reusable = true}, SHIFT(359),
  [103] = {.count = 1, .reusable = false}, SHIFT(464),
  [105] = {.count = 1, .reusable = true}, SHIFT(221),
  [107] = {.count = 1, .reusable = true}, SHIFT(341),
  [109] = {.count = 1, .reusable = false}, SHIFT(152),
  [111] = {.count = 1, .reusable = true}, SHIFT(149),
  [113] = {.count = 1, .reusable = true}, SHIFT(516),
  [115] = {.count = 1, .reusable = false}, SHIFT(483),
  [117] = {.count = 1, .reusable = true}, SHIFT(483),
  [119] = {.count = 1, .reusable = false}, SHIFT(482),
  [121] = {.count = 1, .reusable = false}, SHIFT(199),
  [123] = {.count = 1, .reusable = false}, SHIFT(479),
  [125] = {.count = 1, .reusable = false}, SHIFT(477),
  [127] = {.count = 1, .reusable = true}, SHIFT(1019),
  [129] = {.count = 1, .reusable = true}, SHIFT(448),
  [131] = {.count = 1, .reusable = true}, SHIFT(129),
  [133] = {.count = 1, .reusable = true}, SHIFT(380),
  [135] = {.count = 1, .reusable = true}, SHIFT(1070),
  [137] = {.count = 1, .reusable = true}, SHIFT(352),
  [139] = {.count = 1, .reusable = true}, SHIFT(963),
  [141] = {.count = 1, .reusable = true}, SHIFT(494),
  [143] = {.count = 1, .reusable = true}, SHIFT(147),
  [145] = {.count = 1, .reusable = true}, SHIFT(410),
  [147] = {.count = 1, .reusable = true}, SHIFT(161),
  [149] = {.count = 1, .reusable = true}, SHIFT(330),
  [151] = {.count = 1, .reusable = true}, SHIFT(1026),
  [153] = {.count = 1, .reusable = true}, SHIFT(474),
  [155] = {.count = 1, .reusable = true}, SHIFT(1035),
  [157] = {.count = 1, .reusable = true}, SHIFT(385),
  [159] = {.count = 1, .reusable = true}, SHIFT(1051),
  [161] = {.count = 1, .reusable = true}, SHIFT(384),
  [163] = {.count = 1, .reusable = true}, SHIFT(1063),
  [165] = {.count = 1, .reusable = true}, SHIFT(315),
  [167] = {.count = 1, .reusable = true}, SHIFT(988),
  [169] = {.count = 1, .reusable = true}, SHIFT(355),
  [171] = {.count = 1, .reusable = true}, SHIFT(1032),
  [173] = {.count = 1, .reusable = true}, SHIFT(387),
  [175] = {.count = 1, .reusable = true}, SHIFT(1061),
  [177] = {.count = 1, .reusable = true}, SHIFT(298),
  [179] = {.count = 1, .reusable = true}, SHIFT(962),
  [181] = {.count = 1, .reusable = true}, SHIFT(793),
  [183] = {.count = 1, .reusable = true}, SHIFT(1028),
  [185] = {.count = 1, .reusable = true}, SHIFT(337),
  [187] = {.count = 1, .reusable = true}, SHIFT(1010),
  [189] = {.count = 1, .reusable = true}, SHIFT(591),
  [191] = {.count = 1, .reusable = true}, SHIFT(1007),
  [193] = {.count = 1, .reusable = true}, SHIFT(598),
  [195] = {.count = 1, .reusable = true}, SHIFT(965),
  [197] = {.count = 1, .reusable = true}, SHIFT(782),
  [199] = {.count = 1, .reusable = true}, SHIFT(1014),
  [201] = {.count = 1, .reusable = true}, SHIFT(469),
  [203] = {.count = 1, .reusable = true}, SHIFT(1021),
  [205] = {.count = 1, .reusable = true}, SHIFT(657),
  [207] = {.count = 1, .reusable = true}, SHIFT(230),
  [209] = {.count = 1, .reusable = true}, SHIFT(346),
  [211] = {.count = 1, .reusable = true}, SHIFT(1023),
  [213] = {.count = 1, .reusable = true}, SHIFT(472),
  [215] = {.count = 1, .reusable = true}, SHIFT(995),
  [217] = {.count = 1, .reusable = true}, SHIFT(605),
  [219] = {.count = 1, .reusable = true}, SHIFT(966),
  [221] = {.count = 1, .reusable = true}, SHIFT(418),
  [223] = {.count = 1, .reusable = true}, SHIFT(86),
  [225] = {.count = 1, .reusable = true}, SHIFT(344),
  [227] = {.count = 1, .reusable = true}, SHIFT(1013),
  [229] = {.count = 1, .reusable = true}, SHIFT(612),
  [231] = {.count = 1, .reusable = true}, SHIFT(972),
  [233] = {.count = 1, .reusable = true}, SHIFT(311),
  [235] = {.count = 1, .reusable = true}, SHIFT(986),
  [237] = {.count = 1, .reusable = true}, SHIFT(791),
  [239] = {.count = 1, .reusable = true}, SHIFT(1045),
  [241] = {.count = 1, .reusable = true}, SHIFT(309),
  [243] = {.count = 1, .reusable = true}, SHIFT(982),
  [245] = {.count = 1, .reusable = true}, SHIFT(787),
  [247] = {.count = 1, .reusable = true}, SHIFT(1017),
  [249] = {.count = 1, .reusable = true}, SHIFT(792),
  [251] = {.count = 1, .reusable = true}, SHIFT(1053),
  [253] = {.count = 1, .reusable = true}, SHIFT(349),
  [255] = {.count = 1, .reusable = true}, SHIFT(1025),
  [257] = {.count = 1, .reusable = true}, SHIFT(766),
  [259] = {.count = 1, .reusable = true}, SHIFT(1062),
  [261] = {.count = 1, .reusable = true}, SHIFT(428),
  [263] = {.count = 1, .reusable = true}, SHIFT(218),
  [265] = {.count = 1, .reusable = true}, SHIFT(473),
  [267] = {.count = 1, .reusable = true}, SHIFT(1080),
  [269] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 1),
  [271] = {.count = 1, .reusable = true}, SHIFT(67),
  [273] = {.count = 1, .reusable = false}, SHIFT(274),
  [275] = {.count = 1, .reusable = true}, SHIFT(196),
  [277] = {.count = 1, .reusable = false}, SHIFT(98),
  [279] = {.count = 1, .reusable = true}, SHIFT(113),
  [281] = {.count = 1, .reusable = true}, SHIFT(273),
  [283] = {.count = 1, .reusable = false}, SHIFT(305),
  [285] = {.count = 1, .reusable = true}, SHIFT(305),
  [287] = {.count = 1, .reusable = false}, SHIFT(304),
  [289] = {.count = 1, .reusable = false}, SHIFT(151),
  [291] = {.count = 1, .reusable = false}, SHIFT(303),
  [293] = {.count = 1, .reusable = false}, SHIFT(302),
  [295] = {.count = 1, .reusable = false}, SHIFT(258),
  [297] = {.count = 1, .reusable = true}, SHIFT(148),
  [299] = {.count = 1, .reusable = false}, SHIFT(158),
  [301] = {.count = 1, .reusable = true}, SHIFT(157),
  [303] = {.count = 1, .reusable = true}, SHIFT(260),
  [305] = {.count = 1, .reusable = false}, SHIFT(376),
  [307] = {.count = 1, .reusable = true}, SHIFT(376),
  [309] = {.count = 1, .reusable = false}, SHIFT(375),
  [311] = {.count = 1, .reusable = false}, SHIFT(208),
  [313] = {.count = 1, .reusable = false}, SHIFT(373),
  [315] = {.count = 1, .reusable = false}, SHIFT(371),
  [317] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 3),
  [319] = {.count = 1, .reusable = true}, SHIFT(58),
  [321] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 2),
  [323] = {.count = 1, .reusable = true}, SHIFT(64),
  [325] = {.count = 1, .reusable = true}, SHIFT(1121),
  [327] = {.count = 1, .reusable = false}, SHIFT(259),
  [329] = {.count = 1, .reusable = true}, SHIFT(120),
  [331] = {.count = 1, .reusable = false}, SHIFT(175),
  [333] = {.count = 1, .reusable = true}, SHIFT(89),
  [335] = {.count = 1, .reusable = true}, SHIFT(278),
  [337] = {.count = 1, .reusable = false}, SHIFT(362),
  [339] = {.count = 1, .reusable = true}, SHIFT(362),
  [341] = {.count = 1, .reusable = false}, SHIFT(363),
  [343] = {.count = 1, .reusable = false}, SHIFT(204),
  [345] = {.count = 1, .reusable = false}, SHIFT(364),
  [347] = {.count = 1, .reusable = false}, SHIFT(365),
  [349] = {.count = 1, .reusable = false}, SHIFT(288),
  [351] = {.count = 1, .reusable = true}, SHIFT(170),
  [353] = {.count = 1, .reusable = false}, SHIFT(90),
  [355] = {.count = 1, .reusable = true}, SHIFT(96),
  [357] = {.count = 1, .reusable = true}, SHIFT(272),
  [359] = {.count = 1, .reusable = false}, SHIFT(331),
  [361] = {.count = 1, .reusable = true}, SHIFT(331),
  [363] = {.count = 1, .reusable = false}, SHIFT(332),
  [365] = {.count = 1, .reusable = false}, SHIFT(115),
  [367] = {.count = 1, .reusable = false}, SHIFT(333),
  [369] = {.count = 1, .reusable = false}, SHIFT(334),
  [371] = {.count = 1, .reusable = true}, SHIFT(134),
  [373] = {.count = 1, .reusable = false}, SHIFT(136),
  [375] = {.count = 1, .reusable = true}, SHIFT(507),
  [377] = {.count = 1, .reusable = false}, SHIFT(156),
  [379] = {.count = 1, .reusable = true}, REDUCE(sym_orderBy, 1),
  [381] = {.count = 1, .reusable = false}, REDUCE(sym_orderBy, 1),
  [383] = {.count = 1, .reusable = false}, SHIFT(107),
  [385] = {.count = 1, .reusable = false}, SHIFT(106),
  [387] = {.count = 1, .reusable = false}, SHIFT(105),
  [389] = {.count = 1, .reusable = false}, SHIFT(742),
  [391] = {.count = 1, .reusable = false}, SHIFT(1119),
  [393] = {.count = 1, .reusable = false}, SHIFT(857),
  [395] = {.count = 1, .reusable = false}, SHIFT(408),
  [397] = {.count = 1, .reusable = true}, SHIFT(408),
  [399] = {.count = 1, .reusable = true}, SHIFT(421),
  [401] = {.count = 1, .reusable = false}, SHIFT(425),
  [403] = {.count = 1, .reusable = true}, SHIFT(425),
  [405] = {.count = 1, .reusable = false}, SHIFT(206),
  [407] = {.count = 1, .reusable = false}, SHIFT(209),
  [409] = {.count = 1, .reusable = false}, SHIFT(213),
  [411] = {.count = 1, .reusable = false}, SHIFT(758),
  [413] = {.count = 1, .reusable = false}, SHIFT(1126),
  [415] = {.count = 1, .reusable = false}, SHIFT(853),
  [417] = {.count = 1, .reusable = false}, REDUCE(sym_mul_expr, 3, .production_id = 2),
  [419] = {.count = 1, .reusable = true}, REDUCE(sym_mul_expr, 3, .production_id = 2),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_comp_term, 3, .production_id = 2),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_comp_term, 3, .production_id = 2),
  [425] = {.count = 1, .reusable = true}, REDUCE(sym_implication, 3, .production_id = 2),
  [427] = {.count = 1, .reusable = false}, REDUCE(sym_implication, 3, .production_id = 2),
  [429] = {.count = 1, .reusable = false}, SHIFT(229),
  [431] = {.count = 1, .reusable = false}, SHIFT(231),
  [433] = {.count = 1, .reusable = false}, SHIFT(1105),
  [435] = {.count = 1, .reusable = false}, SHIFT(859),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym_negation, 2),
  [439] = {.count = 1, .reusable = false}, REDUCE(sym_negation, 2),
  [441] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expr, 2),
  [443] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expr, 2),
  [445] = {.count = 1, .reusable = false}, REDUCE(sym_disjunction, 3, .production_id = 2),
  [447] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3, .production_id = 2),
  [449] = {.count = 1, .reusable = false}, REDUCE(sym_add_expr, 3, .production_id = 2),
  [451] = {.count = 1, .reusable = true}, REDUCE(sym_add_expr, 3, .production_id = 2),
  [453] = {.count = 1, .reusable = false}, REDUCE(sym_prefix_cast, 4, .dynamic_precedence = 10),
  [455] = {.count = 1, .reusable = true}, REDUCE(sym_prefix_cast, 4, .dynamic_precedence = 10),
  [457] = {.count = 1, .reusable = false}, SHIFT(241),
  [459] = {.count = 1, .reusable = true}, REDUCE(sym_if_term, 6, .production_id = 6),
  [461] = {.count = 1, .reusable = false}, REDUCE(sym_if_term, 6, .production_id = 6),
  [463] = {.count = 1, .reusable = true}, REDUCE(sym_simpleId, 1),
  [465] = {.count = 1, .reusable = false}, REDUCE(sym_simpleId, 1),
  [467] = {.count = 1, .reusable = true}, REDUCE(sym_literalId, 1),
  [469] = {.count = 2, .reusable = true}, REDUCE(sym_literalId, 1), REDUCE(sym_simpleId, 1),
  [472] = {.count = 2, .reusable = true}, REDUCE(sym_simpleId, 1), REDUCE(sym_className, 1),
  [475] = {.count = 1, .reusable = false}, REDUCE(sym_asExpr, 1),
  [477] = {.count = 1, .reusable = true}, REDUCE(sym_asExpr, 1),
  [479] = {.count = 1, .reusable = false}, SHIFT(146),
  [481] = {.count = 1, .reusable = false}, SHIFT(145),
  [483] = {.count = 1, .reusable = false}, SHIFT(141),
  [485] = {.count = 1, .reusable = false}, SHIFT(957),
  [487] = {.count = 1, .reusable = false}, SHIFT(1109),
  [489] = {.count = 1, .reusable = false}, SHIFT(852),
  [491] = {.count = 1, .reusable = false}, SHIFT(945),
  [493] = {.count = 1, .reusable = false}, REDUCE(sym_conjunction, 3, .production_id = 2),
  [495] = {.count = 1, .reusable = true}, REDUCE(sym_conjunction, 3, .production_id = 2),
  [497] = {.count = 1, .reusable = false}, REDUCE(sym_varName, 1),
  [499] = {.count = 1, .reusable = true}, REDUCE(sym_varName, 1),
  [501] = {.count = 1, .reusable = true}, REDUCE(sym_moduleExpr, 1),
  [503] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 4),
  [505] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 4),
  [507] = {.count = 1, .reusable = true}, REDUCE(sym_super_ref, 3),
  [509] = {.count = 1, .reusable = false}, REDUCE(sym_super_ref, 3),
  [511] = {.count = 1, .reusable = true}, REDUCE(sym_className, 1),
  [513] = {.count = 1, .reusable = false}, REDUCE(sym_className, 1),
  [515] = {.count = 1, .reusable = false}, REDUCE(sym__exprOrTerm, 1),
  [517] = {.count = 1, .reusable = true}, REDUCE(sym__exprOrTerm, 1),
  [519] = {.count = 1, .reusable = true}, SHIFT(950),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym_super_ref, 1),
  [523] = {.count = 1, .reusable = true}, REDUCE(sym_super_ref, 1),
  [525] = {.count = 1, .reusable = false}, REDUCE(sym_variable, 1),
  [527] = {.count = 1, .reusable = true}, REDUCE(sym_variable, 1),
  [529] = {.count = 1, .reusable = false}, REDUCE(sym_bool, 1),
  [531] = {.count = 1, .reusable = true}, REDUCE(sym_bool, 1),
  [533] = {.count = 1, .reusable = false}, REDUCE(sym_literal, 1),
  [535] = {.count = 1, .reusable = true}, REDUCE(sym_literal, 1),
  [537] = {.count = 1, .reusable = false}, REDUCE(sym_par_expr, 3),
  [539] = {.count = 1, .reusable = true}, REDUCE(sym_par_expr, 3),
  [541] = {.count = 1, .reusable = false}, REDUCE(sym_qualified_expr, 3),
  [543] = {.count = 1, .reusable = true}, REDUCE(sym_qualified_expr, 3),
  [545] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 3, .dynamic_precedence = 10),
  [547] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 3, .dynamic_precedence = 10),
  [549] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 3),
  [551] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 3),
  [553] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 4, .dynamic_precedence = 10),
  [555] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 4, .dynamic_precedence = 10),
  [557] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 4),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 4),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym_range, 5, .production_id = 5),
  [563] = {.count = 1, .reusable = true}, REDUCE(sym_range, 5, .production_id = 5),
  [565] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 3),
  [567] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 3),
  [569] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 5, .dynamic_precedence = 10),
  [571] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 5, .dynamic_precedence = 10),
  [573] = {.count = 1, .reusable = false}, REDUCE(sym_classless_predicate_call, 6, .dynamic_precedence = 10),
  [575] = {.count = 1, .reusable = true}, REDUCE(sym_classless_predicate_call, 6, .dynamic_precedence = 10),
  [577] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 6),
  [579] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 6),
  [581] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 5),
  [583] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 5),
  [585] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 8),
  [587] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 8),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_qualifiedRhs, 6),
  [591] = {.count = 1, .reusable = false}, REDUCE(sym_qualifiedRhs, 6),
  [593] = {.count = 1, .reusable = false}, REDUCE(sym_aggregate, 7),
  [595] = {.count = 1, .reusable = true}, REDUCE(sym_aggregate, 7),
  [597] = {.count = 1, .reusable = true}, SHIFT(933),
  [599] = {.count = 1, .reusable = true}, SHIFT(917),
  [601] = {.count = 1, .reusable = true}, SHIFT(903),
  [603] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 4),
  [605] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 4),
  [607] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 9),
  [609] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 9),
  [611] = {.count = 1, .reusable = true}, REDUCE(sym_typeExpr, 1),
  [613] = {.count = 1, .reusable = false}, REDUCE(sym_typeExpr, 1),
  [615] = {.count = 1, .reusable = false}, REDUCE(sym_typeLiteral, 1),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_typeLiteral, 1),
  [619] = {.count = 1, .reusable = true}, REDUCE(sym_dbtype, 1),
  [621] = {.count = 1, .reusable = false}, REDUCE(sym_dbtype, 1),
  [623] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 6),
  [625] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 6),
  [627] = {.count = 1, .reusable = false}, REDUCE(sym_unop, 1),
  [629] = {.count = 1, .reusable = true}, REDUCE(sym_unop, 1),
  [631] = {.count = 1, .reusable = false}, REDUCE(sym_instance_of, 3),
  [633] = {.count = 1, .reusable = true}, REDUCE(sym_instance_of, 3),
  [635] = {.count = 1, .reusable = false}, REDUCE(sym_in_expr, 3, .production_id = 2),
  [637] = {.count = 1, .reusable = true}, REDUCE(sym_in_expr, 3, .production_id = 2),
  [639] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 7),
  [641] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 7),
  [643] = {.count = 1, .reusable = false}, REDUCE(sym_compop, 1),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_compop, 1),
  [647] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 8),
  [649] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 8),
  [651] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 3),
  [653] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 3),
  [655] = {.count = 1, .reusable = true}, REDUCE(sym_quantified, 5),
  [657] = {.count = 1, .reusable = false}, REDUCE(sym_quantified, 5),
  [659] = {.count = 1, .reusable = false}, REDUCE(sym_typeExpr, 3),
  [661] = {.count = 1, .reusable = true}, REDUCE(sym_typeExpr, 3),
  [663] = {.count = 1, .reusable = true}, REDUCE(sym_special_call, 3),
  [665] = {.count = 1, .reusable = false}, REDUCE(sym_special_call, 3),
  [667] = {.count = 1, .reusable = false}, REDUCE(sym_addop, 1),
  [669] = {.count = 1, .reusable = true}, REDUCE(sym_addop, 1),
  [671] = {.count = 1, .reusable = false}, REDUCE(sym_mulop, 1),
  [673] = {.count = 1, .reusable = true}, REDUCE(sym_mulop, 1),
  [675] = {.count = 1, .reusable = false}, SHIFT(906),
  [677] = {.count = 1, .reusable = true}, SHIFT(768),
  [679] = {.count = 1, .reusable = false}, SHIFT(828),
  [681] = {.count = 1, .reusable = false}, SHIFT(111),
  [683] = {.count = 1, .reusable = false}, SHIFT(61),
  [685] = {.count = 1, .reusable = true}, SHIFT(776),
  [687] = {.count = 1, .reusable = false}, SHIFT(1099),
  [689] = {.count = 1, .reusable = false}, SHIFT(1108),
  [691] = {.count = 1, .reusable = false}, SHIFT(893),
  [693] = {.count = 1, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2),
  [695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(817),
  [698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(953),
  [701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(831),
  [704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(87),
  [707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(72),
  [710] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(825),
  [713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(458),
  [716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(457),
  [719] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(460),
  [722] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1089),
  [725] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1090),
  [728] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(897),
  [731] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1253),
  [734] = {.count = 1, .reusable = true}, SHIFT(779),
  [736] = {.count = 1, .reusable = true}, SHIFT(800),
  [738] = {.count = 1, .reusable = true}, REDUCE(sym_ql, 1),
  [740] = {.count = 1, .reusable = true}, SHIFT(819),
  [742] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(906),
  [745] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(828),
  [748] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(111),
  [751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(61),
  [754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(776),
  [757] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1099),
  [760] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(1108),
  [763] = {.count = 2, .reusable = false}, REDUCE(aux_sym_ql_repeat1, 2), SHIFT_REPEAT(893),
  [766] = {.count = 1, .reusable = false}, SHIFT(944),
  [768] = {.count = 1, .reusable = true}, SHIFT(797),
  [770] = {.count = 1, .reusable = true}, SHIFT(863),
  [772] = {.count = 1, .reusable = true}, SHIFT(788),
  [774] = {.count = 1, .reusable = true}, SHIFT(804),
  [776] = {.count = 1, .reusable = true}, SHIFT(824),
  [778] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(817),
  [781] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2),
  [783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(863),
  [786] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(458),
  [789] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(457),
  [792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(460),
  [795] = {.count = 2, .reusable = false}, REDUCE(aux_sym_dataclass_repeat2, 2), SHIFT_REPEAT(1253),
  [798] = {.count = 1, .reusable = true}, SHIFT(807),
  [800] = {.count = 1, .reusable = true}, SHIFT(821),
  [802] = {.count = 2, .reusable = false}, REDUCE(sym_simpleId, 1), REDUCE(sym_className, 1),
  [805] = {.count = 1, .reusable = true}, SHIFT(92),
  [807] = {.count = 1, .reusable = true}, SHIFT(93),
  [809] = {.count = 1, .reusable = true}, SHIFT(94),
  [811] = {.count = 1, .reusable = false}, SHIFT(1088),
  [813] = {.count = 1, .reusable = true}, SHIFT(849),
  [815] = {.count = 1, .reusable = true}, SHIFT(191),
  [817] = {.count = 1, .reusable = true}, SHIFT(190),
  [819] = {.count = 1, .reusable = true}, SHIFT(189),
  [821] = {.count = 1, .reusable = true}, SHIFT(1116),
  [823] = {.count = 1, .reusable = false}, SHIFT(174),
  [825] = {.count = 1, .reusable = true}, SHIFT(173),
  [827] = {.count = 1, .reusable = true}, SHIFT(168),
  [829] = {.count = 1, .reusable = false}, SHIFT(1096),
  [831] = {.count = 1, .reusable = true}, SHIFT(858),
  [833] = {.count = 1, .reusable = true}, SHIFT(936),
  [835] = {.count = 1, .reusable = true}, SHIFT(225),
  [837] = {.count = 1, .reusable = true}, SHIFT(1138),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym_qualModuleExpr, 1),
  [841] = {.count = 1, .reusable = false}, REDUCE(sym_qualModuleExpr, 1),
  [843] = {.count = 1, .reusable = true}, SHIFT(978),
  [845] = {.count = 1, .reusable = false}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2),
  [847] = {.count = 1, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2),
  [849] = {.count = 2, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2), SHIFT_REPEAT(969),
  [852] = {.count = 1, .reusable = false}, REDUCE(sym_qualModuleExpr, 2),
  [854] = {.count = 1, .reusable = true}, REDUCE(sym_qualModuleExpr, 2),
  [856] = {.count = 1, .reusable = true}, SHIFT(969),
  [858] = {.count = 1, .reusable = true}, SHIFT(1198),
  [860] = {.count = 1, .reusable = true}, SHIFT(1178),
  [862] = {.count = 1, .reusable = true}, SHIFT(1151),
  [864] = {.count = 1, .reusable = true}, SHIFT(1158),
  [866] = {.count = 2, .reusable = true}, REDUCE(aux_sym_qualModuleExpr_repeat1, 2), SHIFT_REPEAT(978),
  [869] = {.count = 1, .reusable = true}, SHIFT(1194),
  [871] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 4),
  [873] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 4),
  [875] = {.count = 1, .reusable = true}, SHIFT(236),
  [877] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 5),
  [879] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 5),
  [881] = {.count = 1, .reusable = true}, REDUCE(sym_asExprs, 1),
  [883] = {.count = 1, .reusable = false}, REDUCE(sym_asExprs, 1),
  [885] = {.count = 1, .reusable = true}, SHIFT(83),
  [887] = {.count = 1, .reusable = true}, SHIFT(928),
  [889] = {.count = 1, .reusable = true}, SHIFT(82),
  [891] = {.count = 1, .reusable = true}, SHIFT(396),
  [893] = {.count = 1, .reusable = true}, SHIFT(123),
  [895] = {.count = 1, .reusable = true}, SHIFT(445),
  [897] = {.count = 1, .reusable = true}, SHIFT(125),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym_importModuleExpr, 2),
  [901] = {.count = 1, .reusable = true}, REDUCE(sym_importModuleExpr, 2),
  [903] = {.count = 1, .reusable = true}, SHIFT(970),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_importModuleExpr, 1),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_importModuleExpr, 1),
  [909] = {.count = 1, .reusable = true}, SHIFT(977),
  [911] = {.count = 1, .reusable = true}, SHIFT(440),
  [913] = {.count = 1, .reusable = true}, SHIFT(212),
  [915] = {.count = 1, .reusable = false}, REDUCE(sym_asExprs, 2),
  [917] = {.count = 1, .reusable = true}, REDUCE(sym_asExprs, 2),
  [919] = {.count = 1, .reusable = true}, SHIFT(169),
  [921] = {.count = 1, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2),
  [923] = {.count = 1, .reusable = false}, REDUCE(aux_sym_importModuleExpr_repeat1, 2),
  [925] = {.count = 2, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2), SHIFT_REPEAT(977),
  [928] = {.count = 1, .reusable = true}, SHIFT(398),
  [930] = {.count = 1, .reusable = true}, SHIFT(184),
  [932] = {.count = 2, .reusable = true}, REDUCE(aux_sym_importModuleExpr_repeat1, 2), SHIFT_REPEAT(970),
  [935] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 3),
  [937] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 3),
  [939] = {.count = 1, .reusable = true}, SHIFT(635),
  [941] = {.count = 1, .reusable = true}, SHIFT(227),
  [943] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 7),
  [945] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 7),
  [947] = {.count = 1, .reusable = true}, SHIFT(412),
  [949] = {.count = 1, .reusable = true}, SHIFT(121),
  [951] = {.count = 1, .reusable = true}, SHIFT(492),
  [953] = {.count = 1, .reusable = true}, SHIFT(203),
  [955] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 6),
  [957] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 6),
  [959] = {.count = 1, .reusable = true}, SHIFT(422),
  [961] = {.count = 1, .reusable = true}, SHIFT(197),
  [963] = {.count = 1, .reusable = false}, REDUCE(aux_sym_asExprs_repeat1, 2),
  [965] = {.count = 1, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2),
  [967] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(82),
  [970] = {.count = 1, .reusable = true}, SHIFT(413),
  [972] = {.count = 1, .reusable = true}, SHIFT(176),
  [974] = {.count = 1, .reusable = true}, SHIFT(632),
  [976] = {.count = 1, .reusable = true}, SHIFT(232),
  [978] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 4),
  [980] = {.count = 1, .reusable = true}, SHIFT(57),
  [982] = {.count = 1, .reusable = true}, SHIFT(430),
  [984] = {.count = 1, .reusable = true}, SHIFT(200),
  [986] = {.count = 1, .reusable = true}, REDUCE(sym__call_arg, 1),
  [988] = {.count = 1, .reusable = true}, SHIFT(407),
  [990] = {.count = 1, .reusable = true}, SHIFT(193),
  [992] = {.count = 1, .reusable = true}, SHIFT(648),
  [994] = {.count = 1, .reusable = true}, SHIFT(235),
  [996] = {.count = 1, .reusable = true}, SHIFT(491),
  [998] = {.count = 1, .reusable = true}, SHIFT(119),
  [1000] = {.count = 1, .reusable = true}, SHIFT(442),
  [1002] = {.count = 1, .reusable = true}, SHIFT(171),
  [1004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(83),
  [1007] = {.count = 1, .reusable = true}, SHIFT(444),
  [1009] = {.count = 1, .reusable = true}, SHIFT(179),
  [1011] = {.count = 1, .reusable = true}, SHIFT(495),
  [1013] = {.count = 1, .reusable = true}, SHIFT(131),
  [1015] = {.count = 1, .reusable = true}, REDUCE(aux_sym_aggregate_repeat1, 2),
  [1017] = {.count = 1, .reusable = true}, SHIFT(449),
  [1019] = {.count = 1, .reusable = true}, SHIFT(172),
  [1021] = {.count = 1, .reusable = true}, REDUCE(sym_select, 2),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_select, 2),
  [1025] = {.count = 1, .reusable = false}, SHIFT(1208),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym_orderBys, 4),
  [1029] = {.count = 1, .reusable = true}, REDUCE(sym_orderBys, 4),
  [1031] = {.count = 1, .reusable = true}, SHIFT(84),
  [1033] = {.count = 1, .reusable = true}, SHIFT(78),
  [1035] = {.count = 1, .reusable = false}, REDUCE(aux_sym_orderBys_repeat1, 2),
  [1037] = {.count = 1, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2),
  [1039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(84),
  [1042] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranches, 1),
  [1044] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranches, 1),
  [1046] = {.count = 1, .reusable = false}, SHIFT(879),
  [1048] = {.count = 1, .reusable = true}, SHIFT(577),
  [1050] = {.count = 1, .reusable = true}, SHIFT(416),
  [1052] = {.count = 1, .reusable = true}, SHIFT(155),
  [1054] = {.count = 1, .reusable = true}, REDUCE(sym_asExpr, 3),
  [1056] = {.count = 1, .reusable = false}, REDUCE(sym_asExpr, 3),
  [1058] = {.count = 1, .reusable = true}, SHIFT(411),
  [1060] = {.count = 1, .reusable = true}, REDUCE(sym_select, 5),
  [1062] = {.count = 1, .reusable = false}, REDUCE(sym_select, 5),
  [1064] = {.count = 1, .reusable = true}, SHIFT(71),
  [1066] = {.count = 1, .reusable = true}, SHIFT(751),
  [1068] = {.count = 1, .reusable = false}, REDUCE(sym_orderBys, 3),
  [1070] = {.count = 1, .reusable = true}, REDUCE(sym_orderBys, 3),
  [1072] = {.count = 1, .reusable = true}, REDUCE(aux_sym_datatypeBranches_repeat1, 2),
  [1074] = {.count = 1, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2),
  [1076] = {.count = 2, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2), SHIFT_REPEAT(879),
  [1079] = {.count = 1, .reusable = true}, SHIFT(752),
  [1081] = {.count = 1, .reusable = true}, SHIFT(63),
  [1083] = {.count = 1, .reusable = true}, SHIFT(70),
  [1085] = {.count = 1, .reusable = true}, SHIFT(338),
  [1087] = {.count = 1, .reusable = true}, SHIFT(207),
  [1089] = {.count = 1, .reusable = true}, SHIFT(313),
  [1091] = {.count = 1, .reusable = true}, SHIFT(182),
  [1093] = {.count = 1, .reusable = true}, SHIFT(603),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_select, 7),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym_select, 7),
  [1099] = {.count = 1, .reusable = true}, SHIFT(192),
  [1101] = {.count = 1, .reusable = true}, SHIFT(429),
  [1103] = {.count = 1, .reusable = true}, SHIFT(415),
  [1105] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(78),
  [1108] = {.count = 1, .reusable = true}, SHIFT(118),
  [1110] = {.count = 1, .reusable = true}, SHIFT(652),
  [1112] = {.count = 1, .reusable = true}, SHIFT(423),
  [1114] = {.count = 1, .reusable = true}, SHIFT(75),
  [1116] = {.count = 1, .reusable = true}, SHIFT(162),
  [1118] = {.count = 1, .reusable = true}, SHIFT(165),
  [1120] = {.count = 1, .reusable = true}, SHIFT(636),
  [1122] = {.count = 1, .reusable = true}, SHIFT(637),
  [1124] = {.count = 1, .reusable = true}, SHIFT(194),
  [1126] = {.count = 1, .reusable = true}, SHIFT(306),
  [1128] = {.count = 1, .reusable = true}, SHIFT(354),
  [1130] = {.count = 1, .reusable = true}, SHIFT(195),
  [1132] = {.count = 1, .reusable = true}, SHIFT(62),
  [1134] = {.count = 1, .reusable = false}, SHIFT(1207),
  [1136] = {.count = 1, .reusable = true}, SHIFT(500),
  [1138] = {.count = 1, .reusable = true}, SHIFT(85),
  [1140] = {.count = 1, .reusable = true}, SHIFT(390),
  [1142] = {.count = 2, .reusable = false}, REDUCE(aux_sym_datatypeBranches_repeat1, 2), SHIFT_REPEAT(877),
  [1145] = {.count = 1, .reusable = true}, SHIFT(388),
  [1147] = {.count = 1, .reusable = true}, SHIFT(167),
  [1149] = {.count = 1, .reusable = true}, SHIFT(220),
  [1151] = {.count = 1, .reusable = true}, SHIFT(484),
  [1153] = {.count = 1, .reusable = true}, SHIFT(224),
  [1155] = {.count = 1, .reusable = true}, SHIFT(228),
  [1157] = {.count = 1, .reusable = true}, SHIFT(503),
  [1159] = {.count = 1, .reusable = false}, REDUCE(sym_select, 6),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym_select, 6),
  [1163] = {.count = 1, .reusable = true}, SHIFT(391),
  [1165] = {.count = 1, .reusable = true}, SHIFT(499),
  [1167] = {.count = 1, .reusable = true}, SHIFT(222),
  [1169] = {.count = 1, .reusable = true}, REDUCE(sym_select, 4),
  [1171] = {.count = 1, .reusable = false}, REDUCE(sym_select, 4),
  [1173] = {.count = 1, .reusable = true}, SHIFT(73),
  [1175] = {.count = 1, .reusable = true}, SHIFT(60),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_select, 3),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym_select, 3),
  [1181] = {.count = 1, .reusable = true}, SHIFT(367),
  [1183] = {.count = 1, .reusable = true}, SHIFT(436),
  [1185] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranches, 2),
  [1187] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranches, 2),
  [1189] = {.count = 1, .reusable = false}, SHIFT(877),
  [1191] = {.count = 1, .reusable = true}, SHIFT(439),
  [1193] = {.count = 1, .reusable = true}, SHIFT(866),
  [1195] = {.count = 1, .reusable = true}, SHIFT(485),
  [1197] = {.count = 1, .reusable = true}, SHIFT(351),
  [1199] = {.count = 1, .reusable = true}, SHIFT(122),
  [1201] = {.count = 1, .reusable = true}, SHIFT(431),
  [1203] = {.count = 1, .reusable = true}, SHIFT(143),
  [1205] = {.count = 1, .reusable = true}, SHIFT(144),
  [1207] = {.count = 1, .reusable = true}, SHIFT(128),
  [1209] = {.count = 1, .reusable = true}, SHIFT(409),
  [1211] = {.count = 1, .reusable = true}, SHIFT(127),
  [1213] = {.count = 1, .reusable = true}, SHIFT(68),
  [1215] = {.count = 1, .reusable = true}, SHIFT(392),
  [1217] = {.count = 1, .reusable = true}, SHIFT(339),
  [1219] = {.count = 1, .reusable = true}, REDUCE(sym_direction, 1),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym_direction, 1),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym_imprt, 2),
  [1225] = {.count = 1, .reusable = false}, REDUCE(sym_imprt, 2),
  [1227] = {.count = 1, .reusable = false}, SHIFT(948),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym_orderBy, 2),
  [1231] = {.count = 1, .reusable = false}, REDUCE(sym_orderBy, 2),
  [1233] = {.count = 2, .reusable = false}, REDUCE(aux_sym_moduleMember_repeat1, 2), SHIFT_REPEAT(829),
  [1236] = {.count = 1, .reusable = false}, REDUCE(aux_sym_moduleMember_repeat1, 2),
  [1238] = {.count = 1, .reusable = true}, REDUCE(aux_sym_moduleMember_repeat1, 2),
  [1240] = {.count = 1, .reusable = false}, REDUCE(sym_body, 3),
  [1242] = {.count = 1, .reusable = true}, REDUCE(sym_body, 3),
  [1244] = {.count = 1, .reusable = false}, REDUCE(sym_datatypeBranch, 8),
  [1246] = {.count = 1, .reusable = true}, REDUCE(sym_datatypeBranch, 8),
  [1248] = {.count = 1, .reusable = false}, SHIFT(951),
  [1250] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 6),
  [1252] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 6),
  [1254] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 6, .production_id = 7),
  [1256] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 6, .production_id = 7),
  [1258] = {.count = 1, .reusable = true}, REDUCE(sym_module, 5),
  [1260] = {.count = 1, .reusable = false}, REDUCE(sym_module, 5),
  [1262] = {.count = 1, .reusable = false}, REDUCE(sym_moduleMember, 2),
  [1264] = {.count = 1, .reusable = true}, REDUCE(sym_moduleMember, 2),
  [1266] = {.count = 1, .reusable = false}, REDUCE(sym_datatype, 4),
  [1268] = {.count = 1, .reusable = true}, REDUCE(sym_datatype, 4),
  [1270] = {.count = 1, .reusable = true}, REDUCE(sym_moduleAliasBody, 3),
  [1272] = {.count = 1, .reusable = false}, REDUCE(sym_moduleAliasBody, 3),
  [1274] = {.count = 1, .reusable = false}, REDUCE(sym_imprt, 4),
  [1276] = {.count = 1, .reusable = true}, REDUCE(sym_imprt, 4),
  [1278] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [1280] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [1282] = {.count = 1, .reusable = true}, REDUCE(sym_moduleName, 1),
  [1284] = {.count = 1, .reusable = false}, REDUCE(sym_moduleName, 1),
  [1286] = {.count = 1, .reusable = false}, REDUCE(sym_moduleMember, 1),
  [1288] = {.count = 1, .reusable = true}, REDUCE(sym_moduleMember, 1),
  [1290] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 10, .production_id = 7),
  [1292] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 10, .production_id = 7),
  [1294] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 9, .production_id = 7),
  [1296] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 9, .production_id = 7),
  [1298] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 8, .production_id = 7),
  [1300] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 8, .production_id = 7),
  [1302] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 3),
  [1304] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 3),
  [1306] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 3),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 3),
  [1310] = {.count = 1, .reusable = true}, REDUCE(sym_higherOrderTerm, 7, .production_id = 7),
  [1312] = {.count = 1, .reusable = false}, REDUCE(sym_higherOrderTerm, 7, .production_id = 7),
  [1314] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 7),
  [1316] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 7),
  [1318] = {.count = 1, .reusable = true}, REDUCE(sym_typeAliasBody, 3),
  [1320] = {.count = 1, .reusable = false}, REDUCE(sym_typeAliasBody, 3),
  [1322] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [1324] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [1326] = {.count = 1, .reusable = true}, REDUCE(sym_predicateAliasBody, 3),
  [1328] = {.count = 1, .reusable = false}, REDUCE(sym_predicateAliasBody, 3),
  [1330] = {.count = 1, .reusable = false}, REDUCE(sym_empty, 1),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_empty, 1),
  [1334] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 6),
  [1336] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 6),
  [1338] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 5),
  [1340] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 5),
  [1342] = {.count = 1, .reusable = false}, REDUCE(sym_dataclass, 8),
  [1344] = {.count = 1, .reusable = true}, REDUCE(sym_dataclass, 8),
  [1346] = {.count = 1, .reusable = false}, REDUCE(sym_select, 8),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_select, 8),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_classlessPredicate, 7),
  [1352] = {.count = 1, .reusable = true}, REDUCE(sym_classlessPredicate, 7),
  [1354] = {.count = 1, .reusable = false}, REDUCE(sym_annotName, 1),
  [1356] = {.count = 1, .reusable = true}, REDUCE(sym_annotName, 1),
  [1358] = {.count = 1, .reusable = false}, SHIFT(867),
  [1360] = {.count = 1, .reusable = false}, SHIFT(110),
  [1362] = {.count = 1, .reusable = false}, SHIFT(59),
  [1364] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 1, .production_id = 1),
  [1366] = {.count = 1, .reusable = true}, SHIFT(892),
  [1368] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 1, .production_id = 1),
  [1370] = {.count = 1, .reusable = false}, SHIFT(117),
  [1372] = {.count = 1, .reusable = false}, SHIFT(74),
  [1374] = {.count = 1, .reusable = true}, SHIFT(576),
  [1376] = {.count = 1, .reusable = true}, SHIFT(609),
  [1378] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 5, .production_id = 4),
  [1380] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 5, .production_id = 4),
  [1382] = {.count = 1, .reusable = false}, REDUCE(sym_annotation, 4, .production_id = 3),
  [1384] = {.count = 1, .reusable = true}, REDUCE(sym_annotation, 4, .production_id = 3),
  [1386] = {.count = 1, .reusable = true}, SHIFT(617),
  [1388] = {.count = 1, .reusable = true}, SHIFT(874),
  [1390] = {.count = 1, .reusable = true}, SHIFT(559),
  [1392] = {.count = 1, .reusable = true}, SHIFT(884),
  [1394] = {.count = 1, .reusable = true}, SHIFT(582),
  [1396] = {.count = 1, .reusable = true}, SHIFT(880),
  [1398] = {.count = 1, .reusable = true}, SHIFT(560),
  [1400] = {.count = 1, .reusable = false}, SHIFT(432),
  [1402] = {.count = 1, .reusable = true}, SHIFT(314),
  [1404] = {.count = 1, .reusable = true}, SHIFT(433),
  [1406] = {.count = 1, .reusable = false}, SHIFT(394),
  [1408] = {.count = 1, .reusable = true}, SHIFT(327),
  [1410] = {.count = 1, .reusable = true}, SHIFT(402),
  [1412] = {.count = 1, .reusable = false}, SHIFT(400),
  [1414] = {.count = 1, .reusable = true}, SHIFT(300),
  [1416] = {.count = 1, .reusable = true}, SHIFT(395),
  [1418] = {.count = 1, .reusable = false}, SHIFT(738),
  [1420] = {.count = 1, .reusable = true}, SHIFT(580),
  [1422] = {.count = 1, .reusable = true}, SHIFT(629),
  [1424] = {.count = 1, .reusable = false}, SHIFT(403),
  [1426] = {.count = 1, .reusable = true}, SHIFT(377),
  [1428] = {.count = 1, .reusable = true}, SHIFT(405),
  [1430] = {.count = 1, .reusable = false}, REDUCE(sym_classMember, 2),
  [1432] = {.count = 1, .reusable = true}, REDUCE(sym_classMember, 2),
  [1434] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 7),
  [1436] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 7),
  [1438] = {.count = 1, .reusable = false}, REDUCE(sym_classMember, 1),
  [1440] = {.count = 1, .reusable = true}, REDUCE(sym_classMember, 1),
  [1442] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 5),
  [1444] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 5),
  [1446] = {.count = 1, .reusable = false}, REDUCE(sym_field, 2),
  [1448] = {.count = 1, .reusable = true}, REDUCE(sym_field, 2),
  [1450] = {.count = 1, .reusable = false}, REDUCE(sym_charpred, 6),
  [1452] = {.count = 1, .reusable = true}, REDUCE(sym_charpred, 6),
  [1454] = {.count = 1, .reusable = false}, REDUCE(sym_memberPredicate, 6),
  [1456] = {.count = 1, .reusable = true}, REDUCE(sym_memberPredicate, 6),
  [1458] = {.count = 1, .reusable = true}, SHIFT(829),
  [1460] = {.count = 1, .reusable = true}, SHIFT(895),
  [1462] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1464] = {.count = 1, .reusable = true}, SHIFT(896),
  [1466] = {.count = 1, .reusable = true}, SHIFT(1134),
  [1468] = {.count = 1, .reusable = true}, SHIFT(1169),
  [1470] = {.count = 1, .reusable = true}, SHIFT(899),
  [1472] = {.count = 1, .reusable = true}, SHIFT(812),
  [1474] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1476] = {.count = 1, .reusable = true}, SHIFT(803),
  [1478] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1480] = {.count = 1, .reusable = true}, SHIFT(867),
  [1482] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1484] = {.count = 1, .reusable = true}, REDUCE(sym_varDecl, 2),
  [1486] = {.count = 2, .reusable = true}, REDUCE(aux_sym_classlessPredicate_repeat1, 2), SHIFT_REPEAT(843),
  [1489] = {.count = 1, .reusable = true}, REDUCE(aux_sym_classlessPredicate_repeat1, 2),
  [1491] = {.count = 1, .reusable = true}, SHIFT(541),
  [1493] = {.count = 1, .reusable = false}, REDUCE(sym_literalId, 1),
  [1495] = {.count = 1, .reusable = true}, SHIFT(543),
  [1497] = {.count = 1, .reusable = true}, SHIFT(1237),
  [1499] = {.count = 1, .reusable = true}, SHIFT(870),
  [1501] = {.count = 1, .reusable = true}, SHIFT(1212),
  [1503] = {.count = 1, .reusable = true}, SHIFT(843),
  [1505] = {.count = 1, .reusable = true}, SHIFT(234),
  [1507] = {.count = 1, .reusable = true}, SHIFT(941),
  [1509] = {.count = 1, .reusable = true}, SHIFT(846),
  [1511] = {.count = 2, .reusable = true}, REDUCE(sym_returnType, 1), SHIFT(867),
  [1514] = {.count = 1, .reusable = true}, SHIFT(108),
  [1516] = {.count = 1, .reusable = true}, SHIFT(36),
  [1518] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1520] = {.count = 1, .reusable = true}, SHIFT(95),
  [1522] = {.count = 1, .reusable = true}, SHIFT(177),
  [1524] = {.count = 1, .reusable = true}, SHIFT(35),
  [1526] = {.count = 1, .reusable = true}, SHIFT(124),
  [1528] = {.count = 1, .reusable = true}, SHIFT(52),
  [1530] = {.count = 1, .reusable = true}, SHIFT(133),
  [1532] = {.count = 1, .reusable = true}, SHIFT(43),
  [1534] = {.count = 1, .reusable = true}, SHIFT(847),
  [1536] = {.count = 1, .reusable = true}, SHIFT(49),
  [1538] = {.count = 1, .reusable = true}, SHIFT(65),
  [1540] = {.count = 1, .reusable = true}, SHIFT(30),
  [1542] = {.count = 1, .reusable = true}, SHIFT(202),
  [1544] = {.count = 1, .reusable = true}, SHIFT(45),
  [1546] = {.count = 1, .reusable = true}, SHIFT(201),
  [1548] = {.count = 1, .reusable = true}, REDUCE(sym_aritylessPredicateExpr, 1),
  [1550] = {.count = 1, .reusable = false}, REDUCE(sym_aritylessPredicateExpr, 1),
  [1552] = {.count = 1, .reusable = true}, SHIFT(178),
  [1554] = {.count = 1, .reusable = true}, SHIFT(850),
  [1556] = {.count = 1, .reusable = true}, SHIFT(42),
  [1558] = {.count = 1, .reusable = true}, SHIFT(183),
  [1560] = {.count = 1, .reusable = true}, SHIFT(80),
  [1562] = {.count = 1, .reusable = true}, SHIFT(851),
  [1564] = {.count = 1, .reusable = true}, SHIFT(239),
  [1566] = {.count = 1, .reusable = true}, SHIFT(23),
  [1568] = {.count = 1, .reusable = true}, SHIFT(66),
  [1570] = {.count = 1, .reusable = true}, SHIFT(28),
  [1572] = {.count = 1, .reusable = true}, REDUCE(sym_predicateName, 1),
  [1574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_asExprs_repeat1, 2), SHIFT_REPEAT(80),
  [1577] = {.count = 1, .reusable = true}, REDUCE(sym_aritylessPredicateExpr, 3),
  [1579] = {.count = 1, .reusable = false}, REDUCE(sym_aritylessPredicateExpr, 3),
  [1581] = {.count = 1, .reusable = true}, SHIFT(860),
  [1583] = {.count = 1, .reusable = true}, SHIFT(153),
  [1585] = {.count = 1, .reusable = true}, SHIFT(210),
  [1587] = {.count = 1, .reusable = true}, SHIFT(29),
  [1589] = {.count = 1, .reusable = true}, SHIFT(856),
  [1591] = {.count = 1, .reusable = true}, SHIFT(139),
  [1593] = {.count = 1, .reusable = true}, SHIFT(211),
  [1595] = {.count = 1, .reusable = true}, SHIFT(214),
  [1597] = {.count = 1, .reusable = true}, SHIFT(39),
  [1599] = {.count = 1, .reusable = true}, SHIFT(69),
  [1601] = {.count = 1, .reusable = true}, SHIFT(319),
  [1603] = {.count = 1, .reusable = true}, SHIFT(606),
  [1605] = {.count = 1, .reusable = true}, SHIFT(837),
  [1607] = {.count = 1, .reusable = true}, SHIFT(888),
  [1609] = {.count = 1, .reusable = true}, SHIFT(613),
  [1611] = {.count = 1, .reusable = true}, SHIFT(618),
  [1613] = {.count = 1, .reusable = true}, SHIFT(621),
  [1615] = {.count = 1, .reusable = true}, SHIFT(887),
  [1617] = {.count = 1, .reusable = true}, SHIFT(1149),
  [1619] = {.count = 1, .reusable = true}, SHIFT(1163),
  [1621] = {.count = 1, .reusable = true}, SHIFT(1182),
  [1623] = {.count = 1, .reusable = true}, SHIFT(889),
  [1625] = {.count = 1, .reusable = true}, SHIFT(835),
  [1627] = {.count = 1, .reusable = true}, SHIFT(839),
  [1629] = {.count = 1, .reusable = true}, SHIFT(885),
  [1631] = {.count = 1, .reusable = true}, SHIFT(845),
  [1633] = {.count = 1, .reusable = true}, SHIFT(855),
  [1635] = {.count = 1, .reusable = true}, SHIFT(455),
  [1637] = {.count = 1, .reusable = true}, SHIFT(910),
  [1639] = {.count = 2, .reusable = true}, REDUCE(aux_sym_orderBys_repeat1, 2), SHIFT_REPEAT(79),
  [1642] = {.count = 1, .reusable = true}, SHIFT(316),
  [1644] = {.count = 1, .reusable = true}, SHIFT(79),
  [1646] = {.count = 1, .reusable = true}, SHIFT(317),
  [1648] = {.count = 1, .reusable = true}, REDUCE(sym_predicateExpr, 3),
  [1650] = {.count = 1, .reusable = true}, SHIFT(325),
  [1652] = {.count = 1, .reusable = true}, SHIFT(1141),
  [1654] = {.count = 2, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2), SHIFT_REPEAT(887),
  [1657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat1, 2),
  [1659] = {.count = 1, .reusable = true}, SHIFT(876),
  [1661] = {.count = 1, .reusable = true}, SHIFT(1161),
  [1663] = {.count = 1, .reusable = true}, REDUCE(sym_expr_aggregate_body, 1),
  [1665] = {.count = 1, .reusable = true}, SHIFT(1223),
  [1667] = {.count = 1, .reusable = true}, SHIFT(498),
  [1669] = {.count = 1, .reusable = true}, SHIFT(854),
  [1671] = {.count = 1, .reusable = true}, SHIFT(848),
  [1673] = {.count = 1, .reusable = true}, SHIFT(844),
  [1675] = {.count = 1, .reusable = true}, SHIFT(834),
  [1677] = {.count = 1, .reusable = true}, SHIFT(777),
  [1679] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1681] = {.count = 1, .reusable = true}, SHIFT(778),
  [1683] = {.count = 1, .reusable = true}, SHIFT(875),
  [1685] = {.count = 1, .reusable = true}, SHIFT(336),
  [1687] = {.count = 1, .reusable = true}, SHIFT(1201),
  [1689] = {.count = 1, .reusable = true}, SHIFT(353),
  [1691] = {.count = 1, .reusable = true}, SHIFT(324),
  [1693] = {.count = 1, .reusable = true}, SHIFT(356),
  [1695] = {.count = 1, .reusable = true}, SHIFT(878),
  [1697] = {.count = 1, .reusable = true}, SHIFT(478),
  [1699] = {.count = 1, .reusable = true}, SHIFT(358),
  [1701] = {.count = 1, .reusable = true}, SHIFT(453),
  [1703] = {.count = 1, .reusable = true}, SHIFT(955),
  [1705] = {.count = 1, .reusable = true}, SHIFT(1168),
  [1707] = {.count = 1, .reusable = true}, SHIFT(360),
  [1709] = {.count = 1, .reusable = true}, SHIFT(627),
  [1711] = {.count = 1, .reusable = true}, SHIFT(785),
  [1713] = {.count = 1, .reusable = true}, SHIFT(883),
  [1715] = {.count = 1, .reusable = true}, SHIFT(1184),
  [1717] = {.count = 1, .reusable = true}, SHIFT(490),
  [1719] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 6),
  [1721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(889),
  [1724] = {.count = 1, .reusable = true}, REDUCE(aux_sym_annotation_repeat1, 2),
  [1726] = {.count = 1, .reusable = true}, SHIFT(790),
  [1728] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1730] = {.count = 1, .reusable = true}, SHIFT(1132),
  [1732] = {.count = 1, .reusable = true}, SHIFT(881),
  [1734] = {.count = 1, .reusable = true}, SHIFT(886),
  [1736] = {.count = 1, .reusable = true}, SHIFT(611),
  [1738] = {.count = 1, .reusable = true}, SHIFT(497),
  [1740] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1742] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 5),
  [1744] = {.count = 1, .reusable = true}, SHIFT(382),
  [1746] = {.count = 1, .reusable = true}, SHIFT(486),
  [1748] = {.count = 1, .reusable = true}, SHIFT(379),
  [1750] = {.count = 1, .reusable = true}, SHIFT(329),
  [1752] = {.count = 1, .reusable = true}, SHIFT(374),
  [1754] = {.count = 1, .reusable = true}, SHIFT(501),
  [1756] = {.count = 1, .reusable = true}, SHIFT(586),
  [1758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2), SHIFT_REPEAT(69),
  [1761] = {.count = 1, .reusable = true}, REDUCE(aux_sym_higherOrderTerm_repeat2, 2),
  [1763] = {.count = 1, .reusable = true}, SHIFT(370),
  [1765] = {.count = 1, .reusable = true}, SHIFT(593),
  [1767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_aggregate_repeat1, 2), SHIFT_REPEAT(225),
  [1770] = {.count = 1, .reusable = true}, SHIFT(471),
  [1772] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dataclass_repeat1, 2),
  [1774] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dataclass_repeat1, 2), SHIFT_REPEAT(854),
  [1777] = {.count = 1, .reusable = true}, SHIFT(475),
  [1779] = {.count = 1, .reusable = true}, SHIFT(321),
  [1781] = {.count = 1, .reusable = true}, SHIFT(185),
  [1783] = {.count = 1, .reusable = true}, REDUCE(sym_aggId, 1),
  [1785] = {.count = 1, .reusable = true}, SHIFT(223),
  [1787] = {.count = 1, .reusable = true}, SHIFT(4),
  [1789] = {.count = 1, .reusable = true}, SHIFT(109),
  [1791] = {.count = 1, .reusable = true}, SHIFT(780),
  [1793] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1795] = {.count = 1, .reusable = true}, SHIFT(142),
  [1797] = {.count = 1, .reusable = true}, SHIFT(10),
  [1799] = {.count = 1, .reusable = true}, SHIFT(154),
  [1801] = {.count = 1, .reusable = true}, SHIFT(160),
  [1803] = {.count = 1, .reusable = true}, REDUCE(sym_annotArg, 1),
  [1805] = {.count = 1, .reusable = true}, SHIFT(233),
  [1807] = {.count = 1, .reusable = true}, REDUCE(sym_moduleExpr, 3),
  [1809] = {.count = 1, .reusable = true}, SHIFT(15),
  [1811] = {.count = 1, .reusable = true}, SHIFT(88),
  [1813] = {.count = 1, .reusable = true}, SHIFT(135),
  [1815] = {.count = 1, .reusable = true}, SHIFT(12),
  [1817] = {.count = 1, .reusable = true}, SHIFT(91),
  [1819] = {.count = 1, .reusable = true}, SHIFT(9),
  [1821] = {.count = 1, .reusable = true}, SHIFT(112),
  [1823] = {.count = 1, .reusable = true}, SHIFT(97),
  [1825] = {.count = 1, .reusable = true}, SHIFT(7),
  [1827] = {.count = 1, .reusable = true}, SHIFT(126),
  [1829] = {.count = 1, .reusable = true}, SHIFT(772),
  [1831] = {.count = 1, .reusable = true}, SHIFT(37),
  [1833] = {.count = 1, .reusable = true}, SHIFT(50),
  [1835] = {.count = 1, .reusable = true}, SHIFT(389),
  [1837] = {.count = 1, .reusable = true}, SHIFT(34),
  [1839] = {.count = 1, .reusable = true}, SHIFT(383),
  [1841] = {.count = 1, .reusable = true}, SHIFT(46),
  [1843] = {.count = 1, .reusable = true}, SHIFT(13),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1847] = {.count = 1, .reusable = true}, SHIFT(838),
  [1849] = {.count = 1, .reusable = true}, SHIFT(11),
  [1851] = {.count = 1, .reusable = true}, SHIFT(40),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1855] = {.count = 1, .reusable = true}, SHIFT(420),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1859] = {.count = 1, .reusable = true}, SHIFT(54),
  [1861] = {.count = 1, .reusable = true}, SHIFT(994),
  [1863] = {.count = 1, .reusable = true}, SHIFT(48),
  [1865] = {.count = 1, .reusable = true}, SHIFT(47),
  [1867] = {.count = 1, .reusable = true}, SHIFT(18),
  [1869] = {.count = 1, .reusable = true}, REDUCE(sym_expr_aggregate_body, 2),
  [1871] = {.count = 1, .reusable = true}, SHIFT(961),
  [1873] = {.count = 1, .reusable = true}, SHIFT(361),
  [1875] = {.count = 1, .reusable = true}, SHIFT(320),
  [1877] = {.count = 1, .reusable = true}, SHIFT(33),
  [1879] = {.count = 1, .reusable = true}, SHIFT(5),
  [1881] = {.count = 1, .reusable = true}, SHIFT(55),
  [1883] = {.count = 1, .reusable = true}, SHIFT(6),
  [1885] = {.count = 1, .reusable = true}, REDUCE(sym_full_aggregate_body, 7),
  [1887] = {.count = 1, .reusable = true}, SHIFT(51),
  [1889] = {.count = 1, .reusable = true}, SHIFT(802),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1183),
  [1893] = {.count = 1, .reusable = true}, SHIFT(44),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1897] = {.count = 1, .reusable = true}, SHIFT(38),
  [1899] = {.count = 1, .reusable = true}, SHIFT(53),
  [1901] = {.count = 1, .reusable = true}, SHIFT(41),
  [1903] = {.count = 1, .reusable = false}, SHIFT(1148),
  [1905] = {.count = 1, .reusable = true}, SHIFT(914),
  [1907] = {.count = 1, .reusable = true}, SHIFT(347),
  [1909] = {.count = 1, .reusable = true}, SHIFT(343),
  [1911] = {.count = 1, .reusable = true}, SHIFT(840),
  [1913] = {.count = 1, .reusable = true}, SHIFT(31),
  [1915] = {.count = 1, .reusable = true}, SHIFT(2),
  [1917] = {.count = 1, .reusable = true}, SHIFT(833),
  [1919] = {.count = 1, .reusable = true}, SHIFT(798),
  [1921] = {.count = 1, .reusable = true}, SHIFT(19),
  [1923] = {.count = 1, .reusable = true}, SHIFT(16),
  [1925] = {.count = 1, .reusable = true}, SHIFT(417),
  [1927] = {.count = 1, .reusable = true}, SHIFT(8),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1144),
  [1931] = {.count = 1, .reusable = true}, SHIFT(25),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1136),
  [1935] = {.count = 1, .reusable = true}, SHIFT(920),
  [1937] = {.count = 1, .reusable = true}, SHIFT(832),
  [1939] = {.count = 1, .reusable = true}, SHIFT(32),
  [1941] = {.count = 1, .reusable = true}, SHIFT(470),
  [1943] = {.count = 1, .reusable = true}, SHIFT(326),
  [1945] = {.count = 1, .reusable = true}, SHIFT(14),
  [1947] = {.count = 1, .reusable = true}, SHIFT(26),
  [1949] = {.count = 1, .reusable = true}, SHIFT(22),
  [1951] = {.count = 1, .reusable = true}, SHIFT(17),
  [1953] = {.count = 1, .reusable = true}, SHIFT(312),
  [1955] = {.count = 1, .reusable = true}, SHIFT(865),
  [1957] = {.count = 1, .reusable = true}, SHIFT(3),
  [1959] = {.count = 1, .reusable = true}, SHIFT(836),
  [1961] = {.count = 1, .reusable = true}, SHIFT(842),
  [1963] = {.count = 1, .reusable = true}, SHIFT(308),
  [1965] = {.count = 1, .reusable = true}, SHIFT(447),
  [1967] = {.count = 1, .reusable = true}, SHIFT(76),
  [1969] = {.count = 1, .reusable = true}, SHIFT(77),
  [1971] = {.count = 1, .reusable = true}, SHIFT(424),
  [1973] = {.count = 1, .reusable = true}, SHIFT(27),
  [1975] = {.count = 1, .reusable = true}, REDUCE(sym_closure, 1),
  [1977] = {.count = 1, .reusable = true}, SHIFT(467),
  [1979] = {.count = 1, .reusable = true}, SHIFT(20),
  [1981] = {.count = 1, .reusable = true}, SHIFT(132),
  [1983] = {.count = 1, .reusable = true}, SHIFT(488),
  [1985] = {.count = 1, .reusable = true}, SHIFT(871),
  [1987] = {.count = 1, .reusable = true}, SHIFT(873),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1221),
  [1991] = {.count = 1, .reusable = true}, SHIFT(21),
  [1993] = {.count = 1, .reusable = true}, SHIFT(952),
  [1995] = {.count = 1, .reusable = true}, SHIFT(299),
  [1997] = {.count = 1, .reusable = true}, SHIFT(622),
  [1999] = {.count = 1, .reusable = true}, SHIFT(81),
  [2001] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2003] = {.count = 1, .reusable = true}, SHIFT(340),
  [2005] = {.count = 1, .reusable = true}, SHIFT(869),
  [2007] = {.count = 1, .reusable = true}, SHIFT(799),
  [2009] = {.count = 1, .reusable = true}, SHIFT(813),
  [2011] = {.count = 1, .reusable = true}, SHIFT(599),
  [2013] = {.count = 1, .reusable = true}, SHIFT(932),
  [2015] = {.count = 1, .reusable = true}, SHIFT(900),
  [2017] = {.count = 1, .reusable = true}, SHIFT(590),
  [2019] = {.count = 1, .reusable = true}, SHIFT(368),
  [2021] = {.count = 1, .reusable = true}, SHIFT(24),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2025] = {.count = 1, .reusable = true}, REDUCE(sym_specialId, 1),
  [2027] = {.count = 1, .reusable = true}, SHIFT(872),
  [2029] = {.count = 1, .reusable = true}, REDUCE(sym_quantifier, 1),
  [2031] = {.count = 1, .reusable = true}, SHIFT(659),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2035] = {.count = 1, .reusable = true}, SHIFT(841),
  [2037] = {.count = 1, .reusable = true}, SHIFT(940),
  [2039] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [2041] = {.count = 1, .reusable = true}, REDUCE(sym_returnType, 1),
  [2043] = {.count = 1, .reusable = true}, SHIFT(487),
  [2045] = {.count = 1, .reusable = true}, SHIFT(954),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ql(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__lower_id,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
